# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_building

class Bridge(base_building.BaseBuilding):
    ST_CELL_NONE = 0
    ST_CELL_BRIDGE = 1

    def __init__(self, cdata):
        base_building.BaseBuilding.__init__(self, cdata)
        self.ser_name = 'Bridge'
        self.SetIsHome(False)
        #_curcell = self.get('cell')
        self.enter_cells = []
        for i in range(1,3):    # от 1 до 2
            _cell = self.GetAttrCellFixed('enter' + str(i) + '_cell')
            self.enter_cells.append(_cell)
# ============================================================
    def link_bridge_cells(self):
        for c in self.enter_cells:
            self.SetCellSubtype(c, self.ST_CELL_BRIDGE)
        self.LinkCells( self.enter_cells[0], self.enter_cells[1] )
# ============================================================
    def need_base_resource(self):
        return False
# ============================================================
    # @override
    def create_building_units(self, external_units_count):
        pass    # мосту ничего делать не нужно
# ============================================================
    # @override
    def build_road_on_upgrade(self, prev_status):
        pass    # мосту не нужно
# ============================================================
    # @override
    def _start_resource_generation(self):
        pass
# ============================================================
    def on_create(self):
        base_building.BaseBuilding.on_create(self)
        self.link_bridge_cells()
# #######################################################
# #######################################################
# #######################################################
