# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_building

# ============================================================
# ============================================================
class CampBuilding(base_building.BaseBuilding):
    def __init__(self, cdata):
        base_building.BaseBuilding.__init__(self, cdata)
        self.ser_name = 'CampBuilding'
        self.SetIsHome(True)
# ============================================================
    def take_resource(self, resource):
        '''Вызывается в момент, когда юнит отдает ресурс зданию. Может инициировать процесс генерации зависимого ресурса, либо добавляет ресурс к общим ресурсам'''
        resource = resource.Clone()
        resource.FixFood()
        UStats.AddRes(resource) # добавим ресурсы к ресурсам игры
        TMgr.send_event('resource_stored', None)
        res_count = resource.GetSingleValue()
        res_name = resource.GetSingleName()
        if res_name in self.res_images:
            if self.get('is_loc_active'):
                LBoard.FlyResCount(self, self.res_images[res_name], res_count)
# ============================================================
    def start_task_participation(self, task, sub=''):
        '''Начало участия здания в задании. Но главное здание имеет некоторые исключения'''
        if task.type == "take_res":
            return
        return base_building.BaseBuilding.start_task_participation(self, task, sub)
        pass
# ============================================================
    def stop_task_participation(self, task, sub = ''):
        '''Конец участия здания в задании. Но главное здание имеет некоторые исключения'''
        if task.type == 'take_res':
            return
        return base_building.BaseBuilding.stop_task_participation(self, task, sub)
        pass
# ============================================================
    _take_res__take_resfrom__take_resto = ['take_res', 'take_resfrom', 'take_resto']
    def is_task_participating(self, task_type):
        '''Участвует ли уже здание в данном типе задания. Но главное здание имеет некоторые исключения'''
        if task_type in self._take_res__take_resfrom__take_resto:
            return False
        return base_building.BaseBuilding.is_task_participating(self, task_type)
# ============================================================

    #def on_create(self):
    #    self.Drawer.ShowImages("", False)
    #    self.Drawer.ShowImages("floor", True)
    #    self.Drawer.ShowImages("default", True)
# #######################################################
# #######################################################
# #######################################################
    def is_home(self):  # is home for units
        if self.status == 'normal': # or self.status == "upgrade": - при апгрейде status остается прежним
            return 1        # default, need to override for camp, etc...
        else:
            return 0
# ============================================================
    _worker_inside_text = ('text', 'TIP_WORKER_INSIDE')
    _worker_none_text = ('text', 'TIP_WORKER_NONE')
    #@override
    def _get_tips_extra(self, place, result, by_click):
        if place == 'after_name':
            #_state = self. SM .GetCurrentState()
            #if self.status == 'normal' and _state in ['', 'normal']:
            if self.status == 'normal':
                if self.is_normal_state():
                    _units_in = len(self._building_units)
                    #_none_units = self.max_units_count - _units_in
                    #if _none_units < 0: _none_units = 0
                    result.append( 'newline' )
                    result.append( 'newline' )
                    if _units_in > 0:
                        result.append(self._worker_inside_text)
                    else:
                        result.append(self._worker_none_text)
                    result.append( 'space' )
                    result.append( ('text', 'TIP_WORKERS_X') )
                    result.append( 'space' )
                    result.append( ('digit', _units_in) )
                    #for i in range(_units_in):
                    #    result.append( self._worker_inside_text )
                    #for i in range(_none_units):
                    #    result.append( self._worker_none_text )
        #elif place == 'right_before_upgrade_cost':
        #    if self.status == 'normal':
        #        result.append( 'newline' )
        return True
# ============================================================
    #@override
    def is_main(self):
        return True
# ============================================================
    def DEBUG_b_info(self, r):
        r.append(('debug', self.get('uid')))
        r.append('space')
        r.append(('digit', len(self._building_units)))
        r.append('space')
        r.append(('digit', len(self.walking_home_units)))
        r.append( 'newline' )
# ============================================================