# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_building

class GranitemineBuilding(base_building.BaseBuilding):
    def __init__(self, cdata):
        base_building.BaseBuilding.__init__(self, cdata)
        self.ser_name = 'GranitemineBuilding'
        self.to_building_subtype = "stonecutter"
        self.SetIsHome(False)
# ============================================================
    def need_base_resource(self):
        return False
# ============================================================
    def on_minimal_effectiveness(self):
        _loc_ind = self.get('locind')
        EMgr.AppendLetter([('text','LETTER_EFFECTIVENESS_10')], self.get('uid'), _loc_ind)
        UI.show_top_text2('MSG_EFFECTIVENESS_GRANITEMINE', _loc_ind, self.get('uid'))
# ============================================================
    def on_res_gen_started(self):
        self.PlaySound('SND_GRANITE_MINE_WORK')
        self.Drawer.SetAnimationEvent('unit', 1, 'unit_wheel')
# ============================================================
    def on_message(self, msg_type, msg_param1, msg_param2, msg_dict):
        if msg_type == 'unit_wheel':
            self.PlaySound('SND_GRANITEMINE_WHEEL')
# #######################################################
# #######################################################
# #######################################################
