# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_building

class HouseBuilding(base_building.BaseBuilding):
# ============================================================
    def __init__(self, cdata):
        base_building.BaseBuilding.__init__(self, cdata)
        self.ser_name = 'HouseBuilding'
# ============================================================
    _worker_inside_text = ('text', 'TIP_WORKER_INSIDE')
    _worker_none_text = ('text', 'TIP_WORKER_NONE')
    #@override
    def _get_tips_extra(self, place, result, by_click):
        if place == 'after_name':
            if self.status == 'normal':
                #if self. SM .GetCurrentState() in ['', 'normal']:
                if self.is_normal_state():
                    _units_in = len(self._building_units)
                    if self.is_deactivated: # случай выжившего здания?
                        _units_in = self.GetAttrInt('start_units')
                    #_none_units = self.max_units_count - _units_in
                    #if _none_units < 0: _none_units = 0
                    result.append( 'newline' )
                    result.append( 'newline' )
                    if _units_in > 0:
                        result.append(self._worker_inside_text)
                    else:
                        result.append(self._worker_none_text)
                    result.append( 'space' )
                    result.append( ('text', 'TIP_WORKERS_X') )
                    result.append( 'space' )
                    result.append( ('digit', _units_in) )
                    #for i in range(_units_in):
                    #    result.append( ('text', 'TIP_WORKER_INSIDE') )
                    #for i in range(_none_units):
                    #    result.append( ('text', 'TIP_WORKER_NONE') )
        #elif place == 'right_before_upgrade_cost':
        #    if self.status == 'normal':
        #        result.append( 'newline' )
        return True
# ============================================================
    def on_repair_complete(self):
        base_building.BaseBuilding.on_repair_complete(self)
        LBoard.Core.try_open_help(1,1, 5, self, '4772')
# ============================================================
    def on_signal(self, signal):
        '''Обработчик всех обычных сообщений (которые не были обработаны в on_msg)'''
        if signal == 'free_units_before_demolition':
            self.free_all_units_before_demolition()
        else:
            base_building.BaseBuilding.on_signal(self, signal)
# ============================================================
    def free_all_units_before_demolition(self):
        '''Выпускает юнитов из здания в другте домики, а так же тех, кто бежит к домику'''
        # всех бегущих к зданию - отправить домой
        for u in self.walking_home_units:
            u.is_in_home = False
            u.home_building = None
            u.go_home()
        self.walking_home_units = []

        # отправить всех юнитов в здании по домам
        for u in self._building_units:
            u.is_in_home = False
            u.home_building = None
            u.go_home() # отправим домой
            self._building_units.remove(u)
            _len = len(self._building_units)
            if _len > 0:
                self.Signals.Restart('free_units_before_demolition', 400)
                return
        self._building_units = []
        self.FSM.HandleEvent('removing_event')
# #######################################################
# #######################################################
# #######################################################
    def is_home(self):  # is home for units
        if self.status == 'normal': # or self.status == "upgrade": - при апгрейде status остается прежним
            return 1        # default, need to override for camp, etc...
        else:
            return 0
# ============================================================
    def DEBUG_b_info(self, r):
        r.append(('debug', self.get('uid')))
        r.append('space')
        r.append(('digit', len(self._building_units)))
        r.append('space')
        r.append(('digit', len(self.walking_home_units)))
        r.append( 'newline' )
# ============================================================