# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_building

class Nofog(base_building.BaseBuilding):
    def __init__(self, cdata):
        self.need_show_effect = False
        self.nofog_effect_shown = False
        base_building.BaseBuilding.__init__(self, cdata)
        self.need_deserialize_init_extra= True
        self.ser_name = 'Nofog'
        self.SetIsHome(False)
# ============================================================
    def deserialize_init_extra(self):
        if self.nofog_effect_shown:
            self.Drawer.ShowImages('', False)
# ============================================================
    # @override
    def activate(self):
        if self.is_deactivated:
            if self.is_territory: UStats.AddLevelValue('territory', 1)
        self.is_deactivated = False
        self.add_fog_circle()
        self.need_show_effect = True
        self.Drawer.RestartEffect('effect')
        self.switch_animation()
        #Camera.MoveTo(self)
# ============================================================
    # @override
    def add_fog_circle(self):
        if not self.is_deactivated:
            _name = self.get('name')
            self.AddFogCircle((_name == 'main_no_fog')) # main_no_fog - если этот объект, то он заменяет главное здание в подземельях (открывает видимость)
            _need_unfog_sound = self.GetAttrBool('need_unfog_sound')
            if _need_unfog_sound:
                self.PlaySoundG('SND_NEW_AREA')
# ============================================================
    # @override
    def switch_animation(self):
        if not self.nofog_effect_shown:
            drawer = self.Drawer
            drawer.ShowImages('', False)
            drawer.ShowImages('effect', self.need_show_effect)
            if self.need_show_effect:
                self.nofog_effect_shown = True
# ============================================================
    def update_next_res(self):
        pass    # тут нечего обновлять
# ============================================================
    def update_next_res_partial(self):
        pass
# ============================================================
    def update_res_enough_state(self, check_green = True):
        pass    # тут нечего обновлять
# ============================================================
    def get_next_level_name(self, skipCanRepairCheck = False):
        return None
# ============================================================
    def reset_cache(self):
        pass
# ============================================================
# #######################################################
# #######################################################
# #######################################################
