# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_building
import toolz

class SawmillBuilding(base_building.BaseBuilding):
    def __init__(self, cdata):
        base_building.BaseBuilding.__init__(self, cdata)
        self.ser_name = 'SawmillBuilding'
        self.to_building_subtype = '__store__'
        self.SetIsHome(False)
# ============================================================
    def need_base_resource(self):
        return True
# ============================================================
    #@override
    #def on_worker_in(self, unit):
    #    base_building.BaseBuilding.on_worker_in(self, unit)
# ============================================================
    #@override
    def take_resource(self, resource):
        base_building.BaseBuilding.take_resource(self, resource)
        self.PlaySound('SND_SAWMILL_WORK')
# ============================================================
    def on_res_gen_started(self):
        self.Drawer.SetAnimationEvent('unit', 1, 'unit_saw')
# ============================================================
    def on_message(self, msg_type, msg_param1, msg_param2, msg_dict):
        if msg_type == 'unit_saw':
            self.PlaySound('SND_SAWMILL_SAW')
# ============================================================
    def on_minimal_effectiveness(self):
        _loc_ind = self.get('locind')
        EMgr.AppendLetter([('text','LETTER_EFFECTIVENESS_10')], self.get('uid'), _loc_ind)
        UI.show_top_text2('MSG_EFFECTIVENESS_SAWMILL', _loc_ind, self.get('uid'))
# ============================================================
    def on_repair_complete(self):
        base_building.BaseBuilding.on_repair_complete(self)
        LBoard.Core.try_open_help(1,1, 2, self, '4686')
# ============================================================
# #######################################################
# #######################################################
# #######################################################
