# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_building

class ShoemakerBuilding(base_building.BaseBuilding):
    def __init__(self, cdata):
        base_building.BaseBuilding.__init__(self, cdata)
        self.ser_name = 'ShoemakerBuilding'
        self.SetIsHome(False)
# ============================================================
    #@override
    def extra_init(self):
        base_building.BaseBuilding.extra_init(self)
        self.Drawer.SetAnimationEvent('unit', 9, 'unit_work')
# ============================================================
    def need_base_resource(self):
        return False
# ============================================================
    def on_message(self, msg_type, msg_param1, msg_param2, msg_dict):
        if msg_type == 'unit_work':
            self.PlaySound('SND_SHOEMAKER_MAKE')
# ============================================================
    #@override
    def on_functional(self):
        self.update_shoe_coeff()
        self.Drawer.SetAnimationEvent('unit', 9, 'unit_work')
# ============================================================
    #@override
    def on_non_functional(self):
        self.update_shoe_coeff()
# ============================================================
    def update_shoe_coeff(self):
        sm_buildings = BMgr.get_buildings_raw(-1, 'shoemaker')
        _max_k = 1  #@? не уверен, что должна быть 1, а не 0
        for b in sm_buildings:
            _k = b.GetAttrInt('shoe_coeff')
            if _k > _max_k: _max_k = _k
        UStats.SetLevelValue('SHOE_COEFF', _max_k)
# ============================================================
    #@override
    def need_to_show_unit(self):
        return False
# ============================================================
    #@override
    def need_no_action(self):
        return False
# ============================================================
    #@override
    def need_pers_no_action(self):
        return False
# ============================================================
    def init_anim(self):
        self.Drawer.SetAnimationEvent('unit', 9, 'unit_work')
        settings = []
        settings.append( ['unit', ('random', 2, 4)] )
        settings.append( ['pers_no_action', 5] )
        self.anim_helper.set_animations('default', settings)
# ============================================================
    #@override
    def on_worker_in(self, unit):
        '''Чтобы здание могло отловить когда пришел юнит-работник в здание'''
        base_building.BaseBuilding.on_worker_in(self, unit)
        self.init_anim()
        self.anim_helper.start_group('default')
# ============================================================
    def on_build_complete(self, building_info):
        base_building.BaseBuilding.on_build_complete(self, building_info)
        _has_higher_level = BMgr.has_higher_level_buildings(self.get('stype'), self.get_next_levelnames())
        if _has_higher_level:
            self.FSM.HandleEvent('thrown_event')       # забросим сами себя
# ============================================================
    def on_upgrade_complete(self, building_info):
        base_building.BaseBuilding.on_upgrade_complete(self, building_info)
        _has_higher_level = BMgr.has_higher_level_buildings(self.get('stype'), self.get_next_levelnames())
        if _has_higher_level:
            self.FSM.HandleEvent('thrown_event')       # забросим сами себя
        self.Drawer.SetAnimationEvent('unit', 9, 'unit_work')
# ============================================================
    #@override
    def on_awaiting_action(self):
        self.anim_helper.hide()
        self.anim_helper.stop()
# ============================================================
    # @override
    def _start_resource_generation(self):
        self.anim_helper.start_group('default')
# ============================================================
    # @override
    def on_repair_complete(self):
        base_building.BaseBuilding.on_repair_complete(self)
        BMgr.make_thrown_buildings(self.get('stype'), self.get_prev_levelnames())
        _has_higher_level = BMgr.has_higher_level_buildings(self.get('stype'), self.get_next_levelnames())
        if _has_higher_level:
            self.FSM.HandleEvent('thrown_event')       # забросим сами себя

        LBoard.Core.try_open_help(1,3, 13, self, '4431')
# ============================================================
    # @override
#    def on_message(self, msg_type, msg_param1, msg_param2, msg_dict):
#        if msg_type == 'worker_event':
#            self.PlaySound('SND_WAREHOUSE_LOADER')
# ============================================================

