# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_building

class SmokeryBuilding(base_building.BaseBuilding):
    def __init__(self, cdata):
        base_building.BaseBuilding.__init__(self, cdata)
        self.ser_name = 'SmokeryBuilding'
        self.to_building_subtype = "__store__"
        self.SetIsHome(False)
# ============================================================
    def need_base_resource(self):
        return True
# ============================================================
    def on_res_gen_started(self):
        self.PlaySound('SND_SMOKERY_WORK')
        self.Drawer.SetAnimationEvent('unit', 70, 'unit_smokery')
# ============================================================
    def on_message(self, msg_type, msg_param1, msg_param2, msg_dict):
        if msg_type == 'unit_smokery':
            self.PlaySound('SND_SMOKERY_SMOKER')
# ============================================================
    def on_minimal_effectiveness(self):
        _loc_ind = self.get('locind')
        EMgr.AppendLetter([('text','LETTER_EFFECTIVENESS_10')], self.get('uid'), _loc_ind)
        UI.show_top_text2('MSG_EFFECTIVENESS_SMOKERY', _loc_ind, self.get('uid'))
# ============================================================
    def on_repair_complete(self):
        base_building.BaseBuilding.on_repair_complete(self)
        LBoard.Core.try_open_help(1,2, 10, self, '4902')
# ============================================================