# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_building
import task_upgrade
#import task_classes


class Totem(base_building.BaseBuilding):
    def __init__(self, cdata):
        self.build_task_started = False
        base_building.BaseBuilding.__init__(self, cdata)
        self.ser_name = 'Totem'
        self.SetIsHome(False)
        self.is_indians = True
# ============================================================
    def need_base_resource(self):
        return False
# ============================================================
    def on_click(self, btn_name):
        '''Вызывается при клике по объекту'''
        if not self.HasAccess():
            trace('Cancel click (access)', self.get('name') )
            LBoard.CrossNoToLastClick()
            return
        #if not self.is_active():
        #    trace('Cancel click (inactive)', self.get('name') )
        #    trace('Cancel info:', self.is_deactivated, self.non_selectable, self.get_next_level_name())
        #    LBoard.CrossNoToLastClick()
        #    return
        _fsm_state = self.FSM.GetStateID()
        _is_active = self.is_active()
        if not _is_active:
            if self.has_remove_or_restore(_fsm_state):
                _is_active = True
        if not _is_active:
            trace('Cancel click (inactive)', self.get('name') )
            trace('Cancel info:', self.is_deactivated, self.non_selectable, self.get_next_level_name(), self.is_under_attack)
            #LBoard.MoveCameraToLastClick()
            LBoard.CrossNoToLastClick()
            return
        if _fsm_state in ['wait_unit', 'removing', 'removing_final']:
            trace('Cancel click ('+_fsm_state+')', self.get('name') )
            LBoard.CrossNoToLastClick()
            return
        self.on_mouse_out() # чтобы обновить состояние селекта

        _fsm_state = self.FSM.GetStateID()
        if _fsm_state == 'preremoving':
            if btn_name == 'button':
                self.FSM.HandleEvent('cancel_event')
                trace('Cancel click (cancel remove)', self.get('name') )
                trace('Cancel info:', self.is_deactivated, self.non_selectable, self.get_next_level_name(), self.is_under_attack)
            return
        if self.is_upgrade_units_waiting: # потому что ожидание юнита для апгрейда в события запихнуть проблематично
            if _fsm_state != 'upgrading':
                if btn_name == 'button':
                    task = self.get_participating_task('upgrade_building')
                    if task:    # если отменяем апгрейд
                        task.cancel()
                    self.PlaySoundG('SND_CLICK_TASK_CANCEL')
                    self.is_upgrade_units_waiting = False
                    self.build_task_started = False
                    #self.SM.SetState('normal')
                    return
        elif _fsm_state == 'repair_wait':
            if btn_name == 'button':
                self.build_task_started = False
                self.FSM.HandleEvent('cancel_event')
                return
        elif _fsm_state == 'build_wait':
            if btn_name == 'button':
                _is_fixed_place = self.GetAttrBool('fixed_place')
                if _is_fixed_place:
                    self.FSM.HandleEvent('cancel_mapplace_event')
                else:
                    self.FSM.HandleEvent('cancel_event')
                return
        _buttons_id = self.Get_menu_items_id()
        _buttons_count = len(_buttons_id)
        if _buttons_count > 0:
            self.PlaySoundG('SND_BTN_CLICK_PAPER')
            self.ShowPopupMenu()
            return
# ============================================================
    def is_next_level_possible(self, skipResEnough = False, skipCanRepairCheck = False):
        '''Возможен ли апгрейд/ремонт до следующего уровня'''
        next_var_name = self.get_next_level_name(skipCanRepairCheck)
        if next_var_name:
            res_need = self.GetNeedsRes(next_var_name)
            #if self. SM .GetCurrentState() in self._normal__empty:   # если не в состоянии стройки и т.д.
            #_fsm_state = self.FSM_GetStateID()
            _is_normal_state = self.is_normal_state()
            if _is_normal_state:
                if self.status in self._normal__broken__burning:         # если есть что апгрейдить
                    if res_need:
                        _is_res_enough = True
                        if not skipResEnough:
                            _is_res_enough = UStats.IsResEnough(res_need)
                        if _is_res_enough:          # если ресурсов достаточно
                            return True
                    #else:
                    #    return True
        return False
# ============================================================
    #@override
    def on_repair_complete(self):
        '''Для обработки ситуации окончания repair'''
        base_building.BaseBuilding.on_repair_complete(self)
        if self.is_territory: UStats.AddLevelValue('territory', 1)
# ============================================================
    def scale_bump(self):
        _pos = self.GetAttrPoint('center_item_pos')
        self.Drawer.ScaleBump(self.bump_layers, _pos, 120, 1.05)
        _is_stone = self.GetAttrBool('is_stone')
        if _is_stone:
            self.PlaySound('SND_HAMMER_HIT_ROCK')
        else:
            self.PlaySoundRandom(['SND_HAMMER_HIT_1', 'SND_HAMMER_HIT_2', 'SND_HAMMER_HIT_3'])
# #######################################################
