# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

# ============================================================
# ============================================================
# ============================================================
# ============================================================
class BuildingTips(object):
    def __init__(self, _parent = None):
        self.ser_name = 'BuildingTips'
        self.states = {}
        self.parent = _parent
# ============================================================
    def Get_tip_image(self):
        '''Возвращает ID изображения, которое используется для бэка типса. Может переопределяться у зданий с полями'''
        # чтобы обновить кадр селекта:
        _frame = 0
        _parent = self.parent
        _is_green_state = _parent.is_green_state()
        if not _is_green_state: _frame = 1
        drawer = _parent.Drawer
        drawer.SetFrame('select', _frame)
        drawer.SetSequence('arrow', _frame)    # номер последовательности сейчас совпадает с номером кадра
        # ---
        if not _is_green_state:   # если хватает ресурсов на следующий апгрейд
            return 'IMG_I_TIP_BG_RED'
        return 'IMG_I_TIP_BG'
# ============================================================
    resource_names = ['food', 'bricks', 'boards', 'coins', '_berries', '_fish', '_flour', '_wood', '_ore', '_stones', '_granite']
    _normal__empty = ['normal', '']
    _map_place__place = ['map_place', 'place']
    _yards = ['boatyard']
    _broken_burning = ['broken', 'burning']
    _broken__place__map_place = {'broken':0, 'place':0, 'map_place':0, 'burning':0}
    _color_header = ('text', 'COLOR_HEADER')
    _color_lines = ('text', 'COLOR_LINES')
    _color_red = ('text', 'COLOR_RED')
    _not_enough_text = ('text', 'NOT_ENOUGH')
# ============================================================
    def Get_tip_text(self, by_click = False):
        '''Возвращает LIST, содержащий текстовые ID'''
        result = []
        _parent = self.parent
        if not _parent._get_tips_extra('before_name', result, by_click):   #---
            return result
        item_name = _parent.GetAttrStr('item_name')
        if not item_name:
            return result
        if item_name == 'NO_TIPS':
            return result
        _has_access = _parent.HasAccess()
        _fsm_state = _parent.FSM_GetStateID()
        #state = _parent.SM.GetCurrentState()
        if not by_click:
            _is_cancel_button_mode = _parent.is_cancel_button_mode(_fsm_state) # sloooow method
            if _is_cancel_button_mode:
                if _parent.is_mouse_over_zone == 'button':
                    result.append( self._color_header )
                    result.append( ('text', 'CLICK_TO_CANCEL') )
                    return result
            result.append( self._color_header )
            result.append( ('text', item_name) )
            _is_normal_state = _parent.is_normal_state()
            if _parent.is_deactivated:
                #if state in self._normal__empty:
                if _is_normal_state:
                    return result
            # перенес код для отображения того, что дает здание:
            self._append_text_willgive_with_conditions(result)        #---
            if not _parent._get_tips_extra('after_name', result, by_click):     #---
                return result
            #if state in self._normal__empty:
            if _is_normal_state:
                if _parent.status == 'normal':
                    self._get_gives(result)
            if not _parent._get_tips_extra('after_gives', result, by_click):    #---
                return result
            self._append_effectivness(result)        #---
            self._append_genbar(result)              #---
            self._append_lifebar(result)             #---
            self._append_dependant(result)
            if not _parent.is_active():
                self._append_bonus_info(result)      #---
                return result
            #if state in self._normal__empty:
            if _is_normal_state:
                _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
                if _parent.status in self._broken__place__map_place: _has_barbarians = False # на них варвары не действуют
                if _parent.subtype == 'watchtower': _has_barbarians = False
                if _parent.has_next_level and _parent.status not in self._map_place__place:
                    if not _parent._get_tips_extra('before_upgrade_cost', result, by_click):    #---
                        return result
                    #res = _parent.next_res
                    #if res:
                    #    if not _parent._get_tips_extra('right_before_upgrade_cost', result, by_click):  #---
                    #        return result
                    _name = _parent.get('name')
                    _need_worker = not _parent.GetAttrBool('need_no_worker')
                    map_index = _parent.get('locind')
                    if not BMgr.Is_build_action_possible(map_index, _name, _need_worker, _parent): # если недостаточно юнитов
                        result.append( 'newline' )
                        result.append( self._color_red )
                        result.append( ('text', 'NOT_ENOUGH_UNITS') )
            else:
                self._append_pbar(result)   # добавим прогрессбар, если нужно    #---
            self._append_bonus_info(result)      #---
            if not _parent._get_tips_extra('end', result, by_click):    #---
                return result
            _is_debug = tools.IsDebug()
            if _is_debug: # добавить данные по навешанным на здания таскам
                if _parent.tasks_member:
                    result.append( 'newline' )
                    for tname in _parent.tasks_member:
                        result.append( ('debug', tname) )
                        result.append( ('debug', ', ') )
        else:
            if not _has_access:
                result = []
                result.append( self._color_lines )
                result.append( ('text', 'NO_PATH') )
                return result
            if _parent.is_deactivated:
                _not_accessible = False
                _is_yard = _parent.IsSubTypeOf(self._yards)         #---
                if not _is_yard: _not_accessible = True
                if _parent.status in self._broken_burning: _not_accessible = True
                if _not_accessible:
                    result.append( self._color_lines )
                    #result.append( ('text', ('NOT_NEED_YET','NOT_ACCESSIBLE_YET')[self.status == 'broken']) )
                    result.append( ('text', 'NOT_ACCESSIBLE_YET') )
                    return result
                else:
                    return self.Get_tip_text(False)
            _is_fixed_place = _parent.GetAttrBool('fixed_place')
            if _is_fixed_place:
                if _parent.status == 'map_place':
                    result.append( self._color_lines )
                    result.append( ('text', 'MAP_PLACE') )
                    result.append('newline')
                    result.append( self._color_header )
                    _item_map_name = _parent.GetAttrStr('item_map_name')
                    result.append( ('text', _item_map_name) )
                    return result
            _is_active = _parent.is_active()
            if not _is_active:
                if _parent.non_selectable:
                    return self.Get_tip_text(False) # если по клику нет типса, то вернем его как без клика
                building_cannot_repair_because_of_priority = _parent._cannot_repair_because_of_priority()
                if building_cannot_repair_because_of_priority:
                    result.append( self._color_lines )
                    #result.append( ('text', ('NOT_NEED_YET','NOT_ACCESSIBLE_YET')[self.status == 'broken']) )
                    result.append( ('text', 'NOT_ACCESSIBLE_YET') )
                    return result
                else:
                    return self.Get_tip_text(False) # если по клику нет типса, то вернем его как без клика
            _is_cancel_button_mode = _parent.is_cancel_button_mode(_fsm_state)
            if _is_cancel_button_mode:
                if _parent.is_mouse_over_zone == 'button':
                    result.append( self._color_header )
                    result.append( ('text', 'CLICK_TO_CANCEL') )
                    return result
            #if state in self._normal__empty:
            _is_normal_state = _parent.is_normal_state()
            if _is_normal_state:
                if _parent.has_next_level:
                    _name = _parent.get('name')
                    _need_worker = not _parent.GetAttrBool('need_no_worker')
                    map_index = _parent.get('locind')
                    _is_build_action_possible = BMgr.Is_build_action_possible(map_index, _name, _need_worker, _parent) # если недостаточно юнитов
                    if not _is_build_action_possible:
                        result.append( self._color_red )
                        result.append( ('text', 'NOT_ENOUGH_UNITS') )
                        return result
                    _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
                    if _parent.subtype == 'watchtower': _has_barbarians = False
            if not _parent._get_tips_extra('end_c', result, by_click):          #---
                return result
            if not result:
                return self.Get_tip_text(False) # если по клику нет типса, то вернем его как без клика
        return result
# ============================================================
    def _append_repair_hack_text(self, result, hack_text):
        '''Добавляет специальные строчки к типсу'''
        result.append('newline')
        result.append( self._color_lines )
        result.append( ('text', hack_text) )
# ============================================================
    def _append_text_willgive_with_conditions(self, result):
        _parent = self.parent
        #if state in self._normal__empty:
        _is_normal_state = _parent.is_normal_state()
        if _is_normal_state:
            _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
            if _parent.status in self._broken__place__map_place: _has_barbarians = False # на них варвары не действуют
            if _parent.subtype == 'watchtower': _has_barbarians = False
            if not _has_barbarians:
                if _parent.has_next_level:
                    if _parent.status not in self._map_place__place:
                        res = _parent.next_res
                        if res:
                            self._append_text_willgive(result)
# ============================================================
    willgive_buildings = {'granitemine':0, 'silvermine':0, 'fisherman':0, 'farm':0,\
                                'woodcutter':0, 'quarry':0, 'forester':0}
    _level2_level3 = ['level_2', 'level_3']
    _totem__totem_stone = ['totem', 'totem_stone']
    _hq_list = ['hq', 'hq_small']
    def _append_text_willgive(self, result):
        '''Добавляет к описанию что дает апгрейд/ремонт'''
        _parent = self.parent
        _stype = _parent.get('stype')
        _repair_hack = False
        _repair_hack_text = ''
        if _parent.status == 'broken':
            _repair_hack = _parent.GetAttrBool('repair_tip_hack')
            _repair_hack_text = _parent.GetAttrStr('repair_tip_text')
        # ##
        if _stype in self.willgive_buildings:
            next_var_name = _parent.get_next_level_name()
            if next_var_name in self._level2_level3:
                if not _repair_hack:
                    result.append('newline')
                    result.append( self._color_lines )
                    result.append( ('text', ('UPGRADE_GIVES', 'REPAIR_GIVES')[_parent.status == 'broken']) )
                    result.append('newline')
                    result.append( ('text', ('DOUBLE_PERFORMANCE', 'TRIPLE_PERFORMANCE')[next_var_name == 'level_3']) )
                else:
                    self._append_repair_hack_text(result, _repair_hack_text)
            elif _repair_hack:
                self._append_repair_hack_text(result, _repair_hack_text)
        elif _stype in self._totem__totem_stone:
            next_var_name = _parent.get_next_level_name()
            if next_var_name:
                if not _repair_hack:
                    result.append('newline')
                    result.append( self._color_lines )
                    result.append( ('text', ('UPGRADE_GIVES', 'REPAIR_GIVES')[_parent.status == 'broken']) )
                    result.append('newline')
                    result.append( ('text', 'INCREASE_TERRITORY') )
                else:
                    self._append_repair_hack_text(result, _repair_hack_text)
        elif _stype == 'watchtower':
            next_var_name = _parent.get_next_level_name()
            if next_var_name:
                if not _repair_hack:
                    result.append('newline')
                    result.append( self._color_lines )
                    result.append( ('text', ('UPGRADE_GIVES', 'REPAIR_GIVES')[_parent.status == 'broken']) )
                    result.append('newline')
                    result.append( ('text', 'INCREASE_TERRITORY') )
                    if next_var_name == 'level_2':
                        result.append('newline')
                        result.append( ('text', 'PROTECTION_AGAINST_BARBARIAN') )
                    elif next_var_name == 'level_3':
                        result.append('newline')
                        result.append( ('text', 'FULL_PROTECTION_AGAINST_BARBARIAN') )
                else:
                    self._append_repair_hack_text(result, _repair_hack_text)
        elif _stype == 'warehouse':
            next_var_name = _parent.get_next_level_name()
            if next_var_name:
                if next_var_name in self._level2_level3:
                    if not _repair_hack:
                        result.append('newline')
                        result.append( self._color_lines )
                        result.append( ('text', ('UPGRADE_GIVES', 'REPAIR_GIVES')[_parent.status == 'broken']) )
                        result.append('newline')
                        if next_var_name == 'level_2':
                            result.append( ('text', 'PROTECTION_BARB_1') )
                        elif next_var_name == 'level_3':
                            result.append( ('text', 'PROTECTION_BARB_2') )
                    else:
                        self._append_repair_hack_text(result, _repair_hack_text)
                elif _repair_hack:
                    self._append_repair_hack_text(result, _repair_hack_text)
        elif _stype == 'house':
            next_var_name = _parent.get_next_level_name()
            if next_var_name:
                if _parent.status == 'normal':
                    result.append('newline')
                    result.append( self._color_lines )
                    result.append( ('text', 'UPGRADE_GIVES') )
                    result.append('newline')
                    result.append( ('text', 'ADDITIONAL_UNITS') )
                elif _parent.status == 'broken':
                    if not _repair_hack:
                        result.append('newline')
                        result.append( self._color_lines )
                        result.append( ('text', 'REPAIR_GIVES') )
                        result.append('newline')
                        result.append( ('text', 'ADDITIONAL_UNITS_2') )
                    else:
                        self._append_repair_hack_text(result, _repair_hack_text)
        elif _stype in self._hq_list:
            next_var_name = _parent.get_next_level_name()
            if next_var_name:
                if _parent.status == 'normal':
                    result.append('newline')
                    result.append( self._color_lines )
                    result.append( ('text', 'UPGRADE_GIVES') )
                    result.append('newline')
                    result.append( ('text', 'ADDITIONAL_UNITS') )
        elif _repair_hack:  # если галка установлена и статус сломанного здания
            self._append_repair_hack_text(result, _repair_hack_text)
        elif _parent.status == 'broken':
            _res = _parent._get_willgive_res()
            if _res:
                result.append('newline')
                result.append( self._color_lines )
                result.append( ('text', 'WILL_GIVE') )
                result.append('space')
                _res_numbers = self._append_res_values(_res)
                result.extend( _res_numbers )
# ============================================================
    def _append_res_values(self, resources, need_comma = True):
        '''Для типса. Генерирует список со значениями переданного ресурса, с соответствующими изображениями'''
        _parent = self.parent
        result = []
        if not resources: return result
        first_res = True
        for res_name in self.resource_names:    # выводим значения ресурсов...
            res_val = resources.Get(res_name)
            if res_val > 0:     # на всякий случай
                if not first_res:
                    if need_comma:
                        result.append( 'comma' )
                    result.append( 'space' )
                first_res = False
                result.append( ('digit', resources.Get(res_name)) )
                result.append( ('image', _parent.res_images[res_name]) )
        return result
# ============================================================
    def _get_gives(self, result):
        '''Возвращает текст для части типса GIVES'''
        _parent = self.parent
        _gives = _parent.GetRes('normal_gives_1')
        if _gives:
            if not _gives.Empty():
                _gives = _gives.Clone()
                #_gives.FixFood()        # чтобы еда учитывалась верно
                _need_double = _parent.Signals.Has('bonus_gen_double')
                if not _need_double: _need_double = _parent.is_generated_res_doubled
                if _need_double: _gives.MultiplyValues(2)
                #if not _gives.MainResEmpty():
                result.append( 'newline' )
                result.append( self._color_lines )
                result.append( ('text', 'GIVES') )
                result.append( 'space' )
                res_numbers = self._append_res_values(_gives)
                result.extend( res_numbers )
# ============================================================
    def _append_bar(self, result, _progress, bar_images, _places_count = 10):
        '''Добавляет bar r result по указанным параметрам'''
        _filled_places = _places_count * _progress
        _filled_places = int(_filled_places + 0.5)
        _filled_places = limit_value(_filled_places, 0, _places_count)
        result.append( ('text', bar_images.left) ) #'TIP_BAR_L'
        _bar_full = bar_images.full
        _bar_empty = bar_images.empty
        for i in range(_filled_places):
            result.append( ('text', _bar_full) ) #'TIP_BAR_FULL'
        for i in range(_places_count-_filled_places):
            result.append( ('text', _bar_empty) ) #'TIP_BAR_EMPTY'
        result.append( ('text', bar_images.right) ) #'TIP_BAR_R'
# ============================================================
    _bar_progress_images_dict = {'left':'TIP_BAR_L', 'right':'TIP_BAR_R', 'full':'TIP_BAR_FULL', 'empty':'TIP_BAR_EMPTY'}
    def _append_pbar(self, result):
        _parent = self.parent
        _fsm_state = _parent.FSM_GetStateID()
        if _fsm_state in _parent._workers_acting_fsm:
            result.append('newline')
            if _fsm_state == 'extinguishing':
                result.append( self._color_lines )
                result.append( ('text', 'TIPS_EXTINGUISHING') )
                result.append('newline')
                _progress = _parent.firefight_progress
                if _parent.firefight_time > 0: _progress /= _parent.firefight_time
                else: _progress = 0
                self._append_bar(result, _progress, self._bar_progress_images_dict)
            else:
                if _fsm_state == 'building':
                    result.append( self._color_lines )
                    result.append( ('text', 'TIPS_BUILDING') )
                    result.append('newline')
                elif _fsm_state == 'upgrading' or _fsm_state == 'repairing':
                    if not _parent.IsSubTypeOf(self._yards) or _parent.status == 'broken':
                        result.append( self._color_lines )
                        if not _parent.is_digger_upgrade:
                            result.append( ('text', ('TIPS_UPGRADING', 'TIPS_REPAIRING')[_parent.status == 'broken'] ) )
                        else:
                            result.append( ('text', 'TIPS_ZASYPATING') )
                        result.append('newline')
                _progress = _parent.build_progress
                if _parent.build_time > 0: _progress /= _parent.build_time
                else: _progress = 0
                self._append_bar(result, _progress, self._bar_progress_images_dict)
# ============================================================
    _bar_eff_images_dict = {'left':'TIP_EFFBAR_L', 'right':'TIP_EFFBAR_R', 'full':'TIP_EFFBAR_FULL', 'empty':'TIP_EFFBAR_EMPTY'}
    _fields = ['farm_field', 'forester_field']
    _farm__forester = ['farm', 'forester']
    def _append_effectivness(self, result):
        _parent = self.parent
        stype = _parent.get('stype')
        if _parent.is_deactivated:
            return
        if _parent.is_indians:
            return
        _need_no_worker = _parent.GetAttrBool('need_no_worker')
        if _need_no_worker:
            if stype not in self._fields:
                return
        if _parent.status in self._broken__place__map_place:
            return
        if _parent.is_builders_state():
            return
        if stype in _parent.has_no_effectiveness:
            return
        if stype in self._farm__forester:
            return
        #if state in self._normal__empty:
        if _parent.is_normal_state():
            if _parent.status == 'normal':
                _coeff = _parent.get_effectiveness_coeff()
                result.append('newline')
                result.append( self._color_lines )
                result.append( ('text', 'TIP_EFFECTIVNESS') )
                result.append('newline')
                self._append_bar(result, _coeff, self._bar_eff_images_dict)
# ============================================================
    _bar_life_images_dict = {'left':'TIP_LIFEBAR_L', 'right':'TIP_LIFEBAR_R', 'full':'TIP_LIFEBAR_FULL', 'empty':'TIP_LIFEBAR_EMPTY'}
    def _append_lifebar(self, result):
        _parent = self.parent
        if _parent.energy >= 100 or _parent.energy == 0:
            return
        if _parent.is_indians:
            return
        _need_no_worker = _parent.GetAttrBool('need_no_worker')
        if _need_no_worker:   # эти здания вроде как все нельзя атаковать (но ниже они перечислены)
            return
        stype = _parent.get('stype')
        if stype in _parent.not_for_attack:
            return
        if _parent.status in self._broken__place__map_place:
            return
        if _parent.is_under_attack:
            result.append('newline')
            result.append( self._color_lines )
            result.append( ('text', 'TIPS_BREAKING') )
        result.append('newline')
        result.append( self._color_lines )
        result.append( ('text', 'TIP_LIFE') )
        result.append('newline')
        self._append_bar(result, _parent.energy/100, self._bar_life_images_dict)
# ============================================================
    _bar_gen_images_dict = {'left':'TIP_GENBAR_L', 'right':'TIP_GENBAR_R', 'full':'TIP_GENBAR_FULL', 'empty':'TIP_GENBAR_EMPTY'}
    def _append_genbar(self, result):
        '''Бар производства на типсе'''
        _parent = self.parent
        if _parent.is_indians:
            return
        if not _parent.is_generating_res:
            return
        _progress = _parent.Signals.GetProgress('resource_generated')
        if _progress < 0:
            return
        result.append('newline')
        result.append( self._color_lines )
        result.append( ('text', 'TIP_RES_GENERATION') )
        result.append('newline')
        self._append_bar(result, _progress, self._bar_gen_images_dict)
# ============================================================
    _non_bonus_states_dict = {'prenormal':0, 'normal':0, 'upgrading':0,
                                'generating':0, 'generated':0, 'preremoving':0}
    def _append_bonus_info(self, result):
        '''Для типса. Добавляет подпись о действующих бонусах'''
        _parent = self.parent
        _fsm_state = _parent.FSM_GetStateID()
        if _fsm_state not in self._non_bonus_states_dict:
            return result
        if _parent.Signals.Has('bonus_gen_double'):
            result.append('newline')
            result.append( self._color_lines )
            result.append( ('text', 'UNDER_BONUS_DOUBLE_RES') )
        if _parent.Signals.Has('bonus_restore_eff'):
            result.append('newline')
            result.append( self._color_lines )
            result.append( ('text', 'UNDER_BONUS_EFFECTIVENESS') )
        return result
# ============================================================
    def _append_dependant(self, result):
        '''Добавляет подпись о необходимости зависимого здания'''
        _parent = self.parent
        if _parent.need_processing_flag:
            _text_id = _parent.GetAttrStr('dependant_text')
            if _text_id:
                result.append('newline')
                result.append( self._color_red )
                result.append( ('text', _text_id) )
        return result
# ============================================================
# ============================================================
# ============================================================
