# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import fsm_state
import task_walkg
import task_walkw
import task_doctor
import task_classes
import fsm_methods
import toolz

class UnitQuestDlgTask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'UnitQuestDlgTask'
# ============================================================
    def start_action(self, item):
        self.unit = item
        unit = item
        if unit:
            _is_talking = unit.GetAttrBool('is_talking')
            if _is_talking:
                _uid = self.parent_task.uid
                _dlg_settings = unit.get_dlg_settings(unit.GetAttrStr('talk_text'), _uid)
                #_dlg_settings['quest_name'] = unit.name
                _dlg_settings['is_survived'] = 'true'
                TMgr.cancel_general_tasks()
                Camera.MoveTo(unit)
                dlg.Open('QuestMenuOk', 'dlg_quest', _dlg_settings)
                return True
        return False
# ============================================================
    def on_callback(self, result, extra_dict):
        '''Обработка данных от диалога (диалог у нас в другой VM)'''
        map_index = -1
        if result == 'ok':      # других и быть не должно
            # активировать здания и юнитов из списка,
            # юнитов еще и "по домам" нужно отправить
            if self.unit:
                map_index = self.unit.get('locind')
                self.unit.activate_survived()
                _exit = None
                _exit_uid = self.unit.GetAttrStr('exit_uid')
                if _exit_uid:
                    _exit = BMgr.get_item(_exit_uid, self.unit.get('locind'))
                _gift = self.unit.GetAttrStr('gift')
                if _gift: self.unit.publish_gift( _gift )
                self.unit.send_extra_event()    # если выжившего активировали
                self.unit = self.unit.activate_survived_self(_exit)
                EMgr.send_event( '_survived_saved', self )
                EMgr.send_event( '_worker_added', self )
                self.unit = None
                self.parent_task.complete_task()
            EMgr.SendGlobalMsg('npc_interacted')
            #self.complete()
        # отведем генерала от юнита:
        if map_index >= 0:
            UMgr.step_aside_general(map_index)



#@statemachine
class BaseUnit(Unit):
    res_images = {'food':'IMG_I_TIP_FOOD',
                'boards':'IMG_I_TIP_BOARDS',
                'bricks':'IMG_I_TIP_BRICKS',
                'coins':'IMG_I_TIP_COINS',
                'gold': 'IMG_I_TIP_GOLD',
                '_wood':'IMG_I_TIP_WOOD',
                '_fish':'IMG_I_TIP_FISH',
                '_flour':'IMG_I_TIP_BAG',
                '_ore':'IMG_I_TIP_ORE',
                '_stones':'IMG_I_TIP_STONE',
                '_granite':'IMG_I_TIP_STONE',
                }
# ============================================================
    _color_header = ('text', 'COLOR_HEADER')
    _color_lines = ('text', 'COLOR_LINES')
    _color_red = ('text', 'COLOR_RED')
    _not_enough_text = ('text', 'NOT_ENOUGH')
# ============================================================
    def __init__(self, cdata):
        Unit.__init__(self, cdata)
        self.ser_name = '__none_baseunit__'
        self.uid = -1
        self.subtype = self.get('stype')
        #self.states = {}
        self.fsm_methods = fsm_methods.FsmMethods(self)
        self.current_subtype = 'simple'   # подтип юнита: 'simple', 'builder', 'breaker', ...
        self.resource = None
        self.task = None
        self.task_type = ""
        self.target = None       # unit target - building or another object
        self.unique_name = self.GetAttrStr('unique_name')
        self.is_in_home = False  # в здании ли юнит
        self.home_building = None    # здание, в котором сейчас находится юнит, либо в которое возвращается (только дом!)
        self.res_action_cost = self.get_action_cost_res()
        self.current_action_animation = ''  # анимация при взаимодействии с объектом
        self.is_survived = self.GetAttrBool('is_survived')
        self.is_indian = False
        self.is_mouse_over = False
        self.is_mouse_over_zone = ''
        self.show_talk_sign = False
        self.unit_is_talking = False    # для момента разговора индейца и генерала (возможно не только их)
        self.need_to_show = False   # нужно ли показать юнита?
        self.is_shown = not self.GetAttrBool('hidden_at_start')       # видимый ли данный юнит
        self.arrow_shown = False
        self.has_check = False      # установлена ли галка участия в задании
        self.can_show_uncheck = False   # можно ли показывать иконку отмены (это затрагивает только визуальную часть)
        self.quest = None
        self.need_quest_text = False    # нужно ли тексты для типса брать у квеста
        self.need_to_remove_offscreen = False   # нужно ли удалить юнита при выходе за пределы экрана (используется индейцем после окончания квеста)
        self.is_hidden = not self.is_shown
        self.is_offscreen = True
        self.generated_loot = []
        self.action_item = None     # объект, над которым выполняется некое действие
        self.is_another_quest_started = False
        self.is_another_unit_in_queue = False
        self.is_tip_frozen = self.GetAttrBool('is_tip_frozen')
        self.is_woman = self.GetAttrBool('is_woman')
        self.is_quest_started = False  # для индейцев и лодочника
        self.is_quest_complete = False  # для индейцев и лодочника
        self.is_transition = False  # происходит ли transition (лучше через FSM, но пока вроде не стоит огород городить)
        self.is_deactivated = self.GetAttrBool('deactivated')
        self.non_selectable = self.GetAttrBool('non_selectable')
        self.extra_event = self.GetAttrStr('extra_event')   # нужно в самом начале прочитать эти данные, чтобы вариант не перетер
        self.has_pending_actions = False
        self.prev_coeff = 1
# ============================================================
    def extra_init(self):
        '''Вызывается только при открытии уровня, но НЕ при загрузке сохранения'''
        if self.non_selectable:
            self.SetMouseActive(False)
# ============================================================
    def dispose(self):
        pass
# ============================================================
    def show_arrow(self, show = True):
        self.arrow_shown = show
        self.refresh_arrow_color()
        #self.switch_animation()
# ============================================================
    def show_effect(self, group):
        '''Показать/скрыть эффект'''
        #self.arrow_shown = show
        self.Drawer.ShowImages(group)
        self.Drawer.StartEffectOnce(group)
# ============================================================
    def has_resource(self):
        return self.resource and not self.resource.Empty()
# ============================================================
    def has_access(self):
        _has_access = self.HasGeneralAccess()
        return _has_access
# ============================================================
    def on_msg(self, msg_type, msg_param1="", msg_param2="", msg_dict={}):
        '''Предобработчик сообщений. Отделяет системные сообщения от обычных. И вызывает соответстующие методы обработки.'''
        if msg_type == 'signal_msg':
            self.on_signal(msg_param1)
        elif msg_type == 'action_hit_item':
            # здесь нужно выбирать анимацию действия - зависит от объекта взаимодействия
            if self.current_action_animation:
                self.Drawer.PlayAnimationOnce(self.current_action_animation, 'action_hit_complete', '', 50, 'action_hit_moment')
            if self.current_action_animation == 'magic':
                dir = self.GetDirection()
                dir = int(dir / 2)
                self.Drawer.SetSequence(self.current_action_animation, dir)
        elif msg_type == 'action_hit_complete':
            trace('action_hit_complete')
            self.on_action_hit_complete()
        elif msg_type == 'action_hit_moment':
            trace('action_hit_moment')
            self.on_action_hit_moment()
        elif msg_type == 'click':
            if self.is_shown:
                if not self.is_hidden:
                    _has_access = self.has_access()
                    if _has_access:
                        self.on_click(msg_param1)
                        return
            LBoard.CrossNoToLastClick()
        elif msg_type == 'standup_complete':
            self.FSM.HandleEvent('heal_complete_event', True)
        elif msg_type != 'on_create':
            self.on_message(msg_type, msg_param1, msg_param2, msg_dict)
        elif msg_type == 'on_create':
            self.on_create()
# ============================================================
    def on_msg_now(self, msg_type, msg_param1='', msg_param2='', msg_dict={}):
        if msg_type == 'mouse_in':
            self.on_mouse_in(msg_param1)
        elif msg_type == 'mouse_out':
            self.on_mouse_out()
# ============================================================
    def on_message(self, msg_type, msg_param1, msg_param2, msg_dict):
        '''Обработчик всех обычных сообщений (которые не были обработаны в on_msg'''
        pass
# ============================================================
    def on_signal(self, signal):
        '''Обработчик сигналов'''
        if signal == 'offscreen':
            if self.is_offscreen: return    # чтобы не дублировать
            self.is_offscreen = True
            if self.need_to_remove_offscreen:   # если нужно удалить после выхода за экран
                BMgr.RemoveItemFromMap(self)    # удалим юнита
                return
            elif not self.is_shown:
                if self.need_to_show:
                    self.show_as_possible()
            if self.has_pending_actions:
                self.has_pending_actions = False    # строго до 'try_do_postpoined_action' !
                TMgr.try_do_postpoined_action(self)
                    #self.need_to_show = False
                    #self.is_shown = True
                    #self.switch_animation()
        elif signal == 'onscreen':
            self.is_offscreen = False
        elif signal == 'got_access':
            _seq = 0
            if not self.is_green_state(): _seq = 1
            self.Drawer.SetSequence('arrow', _seq)
            self.switch_animation()
        elif signal == 'no_access':
            self.Drawer.SetSequence('arrow', 1)    # в любом случае красная будет
            self.switch_animation()
        elif signal == 'survived_fly_complete':
            UI.show_chest_text('CHEST_MSG_PART_OF_MISSION')
        elif signal == 'stop_talking':
            #self.FSM.HandleEvent('')
            self.on_talk_complete()
        elif signal == 'stop_magic':
            self.FSM.HandleEvent('stay_event', True)
        elif signal == 'complete_curing':
            self.FSM.HandleEvent('complete_curing_event', True)
        elif signal == 'kill_self':
            BMgr.RemoveItemFromMap(self)    # удаляем себя
            return
# ============================================================
    def refresh_arrow_color(self):
        _seq = 0
        _is_green_state = self.is_green_state()
        if not _is_green_state: _seq = 1
        self.Drawer.SetSequence('arrow', _seq)
        self.switch_animation()
# ============================================================
    def start_talk(self):
        '''Запускает разговор юнита на 2 секунды'''
        self.unit_is_talking = True
        self.FSM.HandleEvent('talk_event', True)
        self.switch_animation()
# ============================================================
    def on_talk_complete(self):
        '''Данный метод вызывается каждым классом отдельно при окончании состояния разговора'''
        #TMgr.cancel_general_tasks()
        # этот метод годится только для индейцев, а для генерала и прочих требует корректив
        if self.unique_name:
            BMgr.SendGlobalMsg('unit_talk', self.unique_name)      # задание "поговорить" выполнено
            self.unique_name = '' # чтобы повторно к нему не подходить
            #self.task.complete_task()
            self.on_quest_complete_all()
        map_index = self.get('locind')
        _general = UMgr.get_cluster(map_index).general
        if _general == self:
            if self.task:
                self.task.complete_task()
            self.cancel_step_aside()
            self.step_aside()
        self.unit_is_talking = False
        trace('on_talk_complete called. Info:', self.get('uid'), self.get('name'))
        self.FSM.HandleEvent('stay_event', True)
        TMgr.send_event('free_general', None)
        self.switch_animation()
# ============================================================
    def cancel_step_aside(self):
        self.Signals.Cancel('step_aside')
        self.RemoveMsg('signal_msg', 'step_aside')
# ============================================================
#    def is_going_to_target(self):
#        _has_msg = self.HasMsg('at_target')
#        return _has_msg
# ============================================================
    def remove_at_target_msg(self):
        self.RemoveMsg('at_target')
# ============================================================
    def show_as_possible(self):
        if self.is_offscreen and not self.is_shown: # если не показаны и уже за экраном
            self.show_now()
            trace('show_as_possible, unit-uid:', self.uid)
        else:
            self.need_to_show = True
# ============================================================
    def show_now(self):
        self.Drawer.Hide(False)
        self.need_to_show = False
        self.is_shown = True
        self.is_hidden = False
        self.switch_animation()
# ============================================================
    def on_sick_click(self):
        if not self.task:
            self.task = task_doctor.DoctorTask(self)
            TMgr.add_task( self.task )
            if self.has_check:
                BMgr.SendGlobalMsg('unit_clicked', self.get('uid'))
        else:
            if self.task.subtask:
                if not self.task.subtask.is_subtask_started:
                    if not self.task.is_complete:
                        self.task.cancel()
                        self.set_check(False)
                    else:
                        LBoard.CrossNoToLastClick()
                else:
                    LBoard.CrossNoToLastClick()
            else:
                LBoard.CrossNoToLastClick()
        self.show_arrow(False)
# ============================================================
    def on_click(self, btn_name):
        '''Вызывается при клике по объекту'''
        _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
        if _has_barbarians:        # если есть варвары, то не даем кликать по индейцам, чтобы ни взять, ни сдать квест
            LBoard.CrossNoToLastClick()
            return
        _is_active = self.is_active()
        if _is_active:
            _is_busy = self.is_busy()
            if not _is_busy:
                if self.FSM.GetStateID() == 'sick':
                    self.on_sick_click()
                else:
                    _is_talking = self.GetAttrBool('is_talking')
                    if _is_talking:
                        _is_general_ok = UMgr.is_general_ok()
                        if not _is_general_ok:
                            LBoard.CrossNoToLastClick()
                            return
                        #if UMgr.general and not UMgr.general.task:
                        self.task = task_walkg.WalkGeneralTask(self)
                        TMgr.add_task( self.task )
                        if self.has_check:      # если галка установилась
                            _skip_queue = False
                            if self.unique_name:
                                _talk_quest_started = UStats.GetLevelValue('talk_quest_was_started') > 0
                                if _talk_quest_started:
                                    _skip_queue = True
                            if not _skip_queue:
                                TMgr.add_quest_unit_to_queue(self.uid)
                            Camera.MoveTo(self) # при установке галки - камеру на индейца
                            BMgr.SendGlobalMsg('unit_clicked', self.get('uid'))
                        self.show_arrow(False)
                        return
            elif self.task:
                self.task.cancel()
                self.task = None
                BMgr.SendGlobalMsg('unit_clicked', self.get('uid'))
                self.show_arrow(False)
                return
        #else:
        #LBoard.MoveCameraToLastClick()
        LBoard.CrossNoToLastClick()
# ============================================================
    def is_enough_params(self):
        '''Метод для переопределения'''
        return True
# ============================================================
    def on_mouse_in(self, over_zone):
        _is_active = self.is_active()
        if _is_active:
            self.is_mouse_over = True
            self.is_mouse_over_zone = over_zone
            drawer = self.Drawer
            drawer.HighlightImages('default', True)
            drawer.ShowImages('select')
            check_frame = 0
            if self.need_show_uncheck(): check_frame = 1
            drawer.SetFrame('check', check_frame)
# ============================================================
    def on_mouse_out(self):
        self.can_show_uncheck = True
        #if self.is_active():
        self.is_mouse_over = False
        self.is_mouse_over_zone = ''
        drawer = self.Drawer
        drawer.HighlightImages('default', False)
        drawer.ShowImages('select', False)
        check_frame = 0
        if self.need_show_uncheck(): check_frame = 1
        drawer.SetFrame('check', check_frame)
# ============================================================
    def on_create(self):
        '''Метод инициализации при создании юнита'''
        self.init_fsm()
        self.arrow_shown = self.GetAttrBool('arrow_shown')
        if UStats.GetLevelValue('talk_quest_was_started') > 0:        # если запущен квест на разговор с юнитом до создания подгружаемого уровня
            self.try_show_talk_sign()
        self.refresh_arrow_color()
        self.switch_animation()
        _is_sick = self.GetAttrBool('is_sick')
        if _is_sick:
            self.FSM.HandleEvent('sick_event', True)
# ============================================================
    def try_show_talk_sign(self, show = True):
        '''Для юнитов, которые говорят (индейцы), показывает значок разговора'''
        if not show:
            self.show_talk_sign = False
        elif self.unique_name:
            self.show_talk_sign = True
        self.switch_animation()
# ============================================================
    def get_action_text(self, for_task_slide = False):
        return ''
# ============================================================
# ============================================================
    def __str__(self):
        '''Выводит полезную информацию о юните'''
        #result = to_str("{name:", self.get("name"), to_str(self.get("cell")), "}")
        task_uid = -1
        if self.task:
            task_uid = self.task.uid
        home_uid = -1
        if self.home_building:
            home_uid = self.home_building.uid
        result = to_str("unit uid:", self.uid, "task.uid:", task_uid, "home_building:", home_uid)
        return result
# #######################################################
# #######################################################
# #######################################################
    _run__shadow = ['run','shadow']
    _talk__shadow = ['talk','shadow']
    def switch_animation(self):
        drawer = self.Drawer
        _ShowImages = drawer.ShowImages
        _is_partial_fog = drawer.IsPartiallyInFog()
        if _is_partial_fog:
            _ShowImages('', False)
            return
        if not self.is_shown:
            _ShowImages('', False)
            return
        if self.is_hidden:
            _ShowImages('', False)
            return
        dir = self.GetDirection()
        _ShowImages('', False)

        _ShowImages('arrow', self.arrow_shown)
        _ShowImages('select', self.is_mouse_over and not self.is_deactivated)
        _ShowImages('check', self.has_check)
        if not self.unit_is_talking:
            _ShowImages(self._run__shadow, True)
            drawer.SetSequence('run', dir)
        else:
            _ShowImages(self._talk__shadow, True)
            drawer.SetSequence('talk', dir)
        _has_access = self.has_access()
        if _has_access:
            if self.is_survived:
                _is_talking = self.GetAttrBool('is_talking')
                if _is_talking:
                    _ShowImages('sign_e', True)
            _ShowImages('sign_talk', (self.unique_name and self.is_active() and not self.unit_is_talking) )   # последнее - чтобы во время разговора не показывать
# ============================================================
    def need_show_uncheck(self):
        return self.is_mouse_over and self.can_show_uncheck
# ============================================================
    def Invalidate(self):
        '''перерисовка объекта, вызывается из C++'''
        self.switch_animation()
# ============================================================
    def hide(self):
        '''Делает юнита невидимым (нужно тогда, когда юнит в здании)'''
        self.Drawer.Hide(True)
        self.is_hidden = True
# ============================================================
    def show(self):
        '''Делает юнита видимым (нужно тогда, когда юнит выходит из здания)'''
        self.Drawer.Hide(False)
        self.is_hidden = False
# ============================================================
    def is_active(self):
        '''Возможны ли действия над объектом в данный момент. Метод может быть переопределен'''
        if not self.is_deactivated and not self.non_selectable and self.is_shown:
            _is_in_sick_states = self.is_in_sick_states()
            if _is_in_sick_states:
                _has_doctor = UMgr.has_doctor()
                if not _has_doctor:
                    return False
                return True
            if self.unit_is_talking:
                return False
            if self.unique_name:        # для ситуации с говорящими индейцами
                return self.show_talk_sign
            else:
                return True
        else:
            return False
    def deactivate(self):
        '''Деактивирует объект - он перестает быть доступным для взаимодействия и соответственно обновляет изображения'''
        self.is_deactivated = True
        self.is_mouse_over = False
        self.switch_animation()
    def activate(self):
        self.is_deactivated = False
        self.switch_animation()
# ============================================================
    def has_sign(self):
        '''Есть ли какой-нить знак над юнитом'''
        _is_talking = self.GetAttrBool('is_talking')
        if self.is_survived:
            if _is_talking:
                return True
        if self.unique_name:
            _is_active = self.is_active()
            if _is_active:
                if not self.unit_is_talking:
                    return True
        return False
# ============================================================
    def is_busy(self):
        if self.task != None or self.unit_is_talking:
            return True
        else:
            return False
# ============================================================
    def set_current_subtype(self, new_subtype):
        self.current_subtype = new_subtype
# ============================================================
    def run_to_target(self, target, override_target = None, cell_shift_name='', going_home = False):
        '''Отправляет юнита к цели.
        target: ячейка или объект.
        override_target: если target - ячейка, но нужно учитывать объект в проходимости, то здесь указываем этот объект
        cell_shift_name: название атрибута-ячейки, в котором содержится смещение относительно позиции объекта-цели
        going_home: отправляется ли юнит домой'''
        trace('run_to_target:', cell_shift_name, going_home, 'unit:', self.get('name'), self.get('uid'))
        #self.FSM.HandleEvent('run_event', True) - вызывается в С++
        if 'col' not in target:
            if 'row' not in target:
                trace('    run_to_target:', target.get('name'), target.get('uid'))
        self.cancel_step_aside()   # чтобы юнит не глючил

        _target_cell = None
        if 'col' not in target:
            if 'row' not in target:
                #_target_cell = target.get('cell')
                #if cell_shift_name:
                _target_cell = target.GetAttrCellFixed(cell_shift_name)
                _is_passable = target.IsCellPassable(_target_cell, self.get('stype') == 'general')
                if not _is_passable:
                    trace('Error: cell is not passable!', self.get('uid'), target.get('name'), target.get('uid'))
                    return False
        else:
            _target_cell = target

        _unit_stype = self.get('stype')
        _pass_unit_type = 1
        if _unit_stype == 'unit_enemy':
            _pass_unit_type = 0
        elif _unit_stype == 'general':
            _pass_unit_type = 2
        result = self.TryRunTo(target, cell_shift_name, _pass_unit_type)
        if result == False:
            if 'col' not in target:
                if 'row' not in target:
                    trace('run_to_target failed', self.get('uid'), self.get('cell'), target.get('name'), target.get('uid'), target.get('cell'))
            else:
                trace('run_to_target failed (cell)', self.get('uid'), self.get('cell'), target)
            return False
        self.show()
        if not going_home:
            self.start_work()
        self.target = target
        if override_target:
            self.target = override_target
        return True
# ============================================================
    def run_by_path(self, target):
        '''Отправляет юнита по переданному пути.
        path: путь, по которому необходимо следовать
        target: к какому объекту направляемся'''
        self.cancel_step_aside()   # чтобы юнит не глючил
        self.RunByPath()
        self.show()
        #if not going_home:
        #    self.start_work()
        self.target = target
# ============================================================
    def start_work(self):
        '''Инициализирует юнита на действие. Т.е. выводит его из домика, если он там был.
        Отменяет бег в домик, если бежал и т.д.'''
        if self.home_building:          # если была привязка к дому
            self.home_building.remove_walking_home_unit(self)   # на всякий случай
            if self.is_in_home:                 # если были в доме
                self.home_building.leave_unit(self) # покинем домик
        self.cancel_step_aside()   # чтобы юнит не глючил
        self.home_building = None   # отвязка от домика
        self.is_in_home = False
# ============================================================
    def set_check(self, visible):
        '''Ставит/убирает галку над объектом'''
        if self.has_check == visible:
            return
        if visible == False:
            TMgr.remove_quest_unit_from_queue(self.uid) # используется только для юнитов с квестами, но наследовать не охота
        self.has_check = visible
        if visible: self.PlaySoundG('SND_CLICK_TASK')
        if self.has_check:
            self.can_show_uncheck = False   # чтобы крестик не показывался, пока курсор не выйдет за пределы объекта
        self.Drawer.ShowImages('check', visible)
        self.Drawer.SetFrame('check', 0)
# ============================================================
    def is_action_complete(self):
        '''Действие над данным объектом уже было выполнено'''
        return True     #! need to override
# ============================================================
    def set_quest(self, quest):
        pass        # need to override
# ============================================================
    def assign_quest(self, quest):
        pass        # need to override
# ============================================================
    def get_subtask(self, parent_task, actor):
        '''Возвращает подзадание для юнита, который будет взаимодействовать с данным объектом'''
        _state = self.FSM.GetStateID()
        if _state == 'sick':
            return task_doctor.HealSubtask(parent_task, actor)
        _is_talking = self.GetAttrBool('is_talking')
        if _is_talking:
            return UnitQuestDlgTask(parent_task, actor)
        return task_classes.Subtask(parent_task, actor)
# ============================================================
    def get_action_cell_name(self):
        '''Метод возвращает название ячейки к которой будет подбегать юнит'''
        return 'action_cell'
# ============================================================
    def get_heal_cell_name(self):
        '''Метод возвращает название ячейки к которой будет подбегать юнит'''
        _cell_names = []
        for i in range(1,9):
            _name = 'heal_cell' + str(i)
            _has_attr = self.HasAttr(_name)
            if _has_attr:
                _cell_names.append(_name)
        _cell_names = self._filter_available_cells(_cell_names)
        _len = len(_cell_names)
        if _len > 0:
            _rnd = tools.Rand(0, _len-1)
            return _cell_names[_rnd]
        else:
            return 'heal_cell'
# ============================================================
    def _filter_available_cells(self, cells_names):
        '''Выбирает из списка имен ячеек-атрибутов те, которые доступны для подхода'''
        _cells_names_result = []
        for _cell_name in cells_names:
            _cell = self.GetAttrCellFixed(_cell_name)
            _is_free = self.IsCellFree(_cell)
            if _is_free:
                _is_accessible = self.IsCellAccessible(_cell)
                if _is_accessible:
                    _cells_names_result.append(_cell_name)
        return _cells_names_result
# ============================================================
    def activate_survived_self(self, exit_target = None):
        self.activate()
        self.is_survived = False
        self.task = None
        self.is_in_home = False
        if exit_target:
            item = UMgr.add_free_unit(self, False) # если это выживший, то он подменяется!
        else:
            item = UMgr.add_free_unit(self) # если это выживший, то он подменяется!
        #item.start_comet('survived_comet', 'survived_fly_complete')
        UI.show_chest_text('CHEST_MSG_PART_OF_MISSION')
        UStats.AddLevelValue('survived', 1) # скажем, что спасли выжившего...
        #EMgr.send_event( '_survived_saved', self )
        if item:
            item.go_to_level_exit(exit_target)
        return item
# ============================================================
    def go_to_level_exit(self, exit_target = None):
        if exit_target:
            if not self.task:
                _stype = self.get('stype')
                if _stype == 'worker':
                    _task = task_walkw.WalkWorkerTask(exit_target, self)
                    _task.non_canceleable = True
                    TMgr.add_task( _task )
# ============================================================
    def apply_stop_task(self, _stop = True):
        if _stop:
            self.stop_walk()
        self.task = None
        self.task_type = ''
# ============================================================
    def activate_survived(self):
        '''Готовит юнита к исчезновению по окончании квеста, если у юнита есть такая необходимость'''
        self.is_survived = False        # себя отметим уже как "приписанного"
        UStats.AddLevelValue('progress', 1) # прогресс по уровню
        _exit_uid = self.GetAttrStr('exit_uid')
        _exit = None
        if _exit_uid:
            _exit = BMgr.get_item(_exit_uid, self.get('locind'))
        survived_items_str = self.GetAttrStr('survived_activate')
        if survived_items_str:
            survived_items = BMgr.get_items(survived_items_str, self.get('locind'))
            if survived_items:
                for item in survived_items:
                    if item:
                        _type = item.get('type')
                        if _type == 'unit':  # если это юнит
                            item.activate_survived_self(_exit)
                            #item.activate()
                            #item.is_survived = False
                            #item.task = None
                            #item.is_in_home = False
                            #item = UMgr.add_free_unit(item) # если это выживший, то он подменяется!
                            # #item.start_comet('survived_comet', 'survived_fly_complete')
                            #UI.show_chest_text('CHEST_MSG_PART_OF_MISSION')
                            #UStats.AddLevelValue('survived', 1) # скажем, что спасли выжившего...
                            #if _exit:
                            #    if item:
                            #        if not item.task:
                            #            trace('--> voilla!')
                            #            _task = task_walkw.WalkWorkerTask(_exit, item)
                            #            #_exit.units_tasks.append(_task)
                            #            TMgr.add_task( _task )
                        elif _type == 'building':
                            item.FSM.HandleEvent('survived_saved_event')
                            _tname = item.get('name')
                            _vname = item.get('variant_name')
                            BMgr.AddRepaired(_tname, _vname)  # чтобы учесть здание в приоритетных и апгрейдах
                            _cur_units_count = item.GetAttrInt('start_units')
                            if _cur_units_count:
                                UStats.AddLevelValue('survived', _cur_units_count) # скажем, что спасли выжившего...
                                #EMgr.send_event( '_survived_saved', self )
                                #for i in range(0, _cur_units_count):
                                #    item.start_comet('survived_comet', '')
# ============================================================
    def get_survived_count(self):
        '''Возвращает кол-во выживших, которые будут переданы игроку, включая самого себя'''
        _count = 1  # себя тоже включаем сюда
        survived_items_str = self.GetAttrStr('survived_activate')
        if survived_items_str:
            survived_items = BMgr.get_items(survived_items_str, self.get('locind'))
            if survived_items:
                for item in survived_items:
                    if item:
                        _type = item.get('type')
                        if _type == 'unit':  # если это юнит
                            _count += 1
                        elif _type == 'building':
                            _cur_units_count = item.GetAttrInt("start_units")
                            if _cur_units_count:
                                _count += _cur_units_count
        return _count
# ============================================================
    def set_face_direction(self):
        '''Установить юнита в одном из двух боковых положений лицом к экрану'''
        _dirs = [1,7]
        _rnd_dir = _dirs[tools.Rand(0,1)]
        self.SetDirection(_rnd_dir)
        dir = self.GetDirection()
        drawer = self.Drawer
        drawer.SetSequence('run', dir)
        drawer.SetSequence('default', dir)
        drawer.SetSequence('talk', dir)
        drawer.SetSequence('magic', dir)
        self.switch_animation()
# ============================================================
    def set_direction_to(self, direction):
        '''Установить юнита в одном из двух боковых положений лицом к экрану'''
        self.SetDirection(direction)
        dir = self.GetDirection()
        drawer = self.Drawer
        drawer.SetSequence('run', dir)
        drawer.SetSequence('default', dir)
        drawer.SetSequence('magic', dir)
        self.switch_animation()
# ============================================================
    def get_gift_cell(self):
        '''Возвращает ячейку, в которую можно выложить подарок'''
        _cell_pos = self.get('cell')
        for i in range(1,6):
            _cell_name = 'gift' + str(i) + '_cell'
            _cell = self.GetAttrCell(_cell_name)
            _cell = self.FixAddCell(_cell_pos, _cell)
            _is_free = self.IsCellFree(_cell)
            if _is_free:
                return _cell
        mbox(to_str("ERROR: all cells are busy. UID:",str(self.uid), 'Name:', self.get('name'), 'Cell:', _cell_pos))
        return None
# ============================================================
    def publish_gift(self, gift_template_name):
        '''Выкладывает на игровое поле подарок от NPC'''
        if not gift_template_name: # если имя шаблона не указано
            return None
        _gift_cell = self.get_gift_cell()       # позиция, в которую будет выложен подарок
        #_cell = self.get('cell')
        #_gift_cell = self.FixAddCell(_cell, _gift_cell)
        variant_name = ''
        if ';' in gift_template_name:
            _parts = gift_template_name.split(';')
            gift_template_name = _parts[0]
            variant_name = _parts[1]
        map_index = self.get('locind')
        trace('Placing Gift:', map_index, gift_template_name, variant_name, _gift_cell)
        _new_item = BMgr.AddItemToMap(map_index, gift_template_name, variant_name, _gift_cell)        # hack - BuildingsManager может добавлять на карту не только здания
        if _new_item:
            trace('Placing gift ok')
            _pos = _new_item.GetAttrPoint('center_item_pos')
            _new_item.Drawer.ResIn(_new_item.item_layers, _pos, 1000)
            _new_item.play_content_sound(self)
            self.generated_loot = [_new_item]
            self.giveaway_general_loot()
            return _new_item
        return None
# ============================================================
# ============================================================
# ВЗАИМОДЕЙСТВИЕ С ОБЪЕКТАМИ
    def action_hit_item(self, item):
        self.action_item = item
        self.FSM.HandleEvent('action_event', True)     #@fixit  здесь нужно еще разобраться какое состояние выставлять
        self.SendMsg('action_hit_item')
# ============================================================
    def action_hit_anim_complete(self):
        '''For overriding'''
        pass    # after INTERACTING animation complete (not animation of current unit, but by general)
# ============================================================
    def cancel_action_hits(self):
        self.action_item = None
        self.StopMove()
        self.FSM.HandleEvent('cancel_action_hits_event', True)
# ============================================================
    def on_action_hit_moment(self):
        if self.action_item:
            self.action_item.action_hit_me()      # удар по объекту
            self.action_item.scale_bump()
            self.action_item.play_hit_sound()
# ============================================================
    def on_action_hit_complete(self):
        if self.action_item:      # проверяем на случай, если отменили задание
            if not self.action_item.is_action_complete():   # объект еще не разрушен
                if self.current_action_animation:
                    self.Drawer.PlayAnimationOnce(self.current_action_animation, 'action_hit_complete', '', 50, 'action_hit_moment')        # ударим еще раз
                if self.current_action_animation == 'magic':
                    dir = self.GetDirection()
                    dir = int(dir / 2)
                    self.Drawer.SetSequence(self.current_action_animation, dir)
            else:
                self.action_item.action_hit_anim_complete()
                self.resource = self.action_item.completeGivesRes    # нужно передать юниту ресурсы
                self.action_item.play_complete_sound()
                self.action_item = None
                if self.task:
                    self.task.subtask.on_action_complete()
                _subtype = self.get('subtype')
                if _subtype != 'worker' and _subtype != 'general':
                    self.go_home()      # для всех, кроме работников - они через free_unit -> TMgr убегают назад
                self.switch_animation()
# ============================================================
# ============================================================
# возможно стоит вынести в отдельные классы... а возможно и не стоит.
    def go_home(self):
        '''Отправляет юнита домой в ближайшее здание. Иницализирует необходимые переменные'''
        if self.home_building:
            if self.is_in_home:  # уже дома
                return
        b = None
        _has_res = self.has_resource()
        if _has_res:
            trace('unit go home with resource')
            buildings = BMgr.get_buildings(self.get('locind'), '__store__', '', ['broken', 'place'])
            res_cell = 'res_cell'
            b = BMgr.find_nearest(buildings, res_cell, self, '') # ищем ближайшее здание, принимающее ресурсы
        else:
            b = BMgr.find_nearest_unit_building(self, '', False, True)
        if b == None:
            b = BMgr.find_nearest_unit_building(self, '', False, False) # ищем тогда любое
            if b == None:
                mbox('building is None')    #@fixit! в релизе убрать, и данный метод переделать в trace("MBOX: ...")
                return
        self.home_building = b
        b.add_walking_home_unit(self)
        #self.is_running_home = True
        self.run_to_target( b.start_cell_pos, b, '', True )
# ============================================================
    def set_home(self, building):
        '''Помещает юнита в здание. Инициализирует необходимые переменные, прячет юнита, выставляет координаты'''
        self.home_building = building
        self.is_in_home = True
        self.task = None        # ? попытка что-то поправить
        self.current_subtype = 'simple' # в домике для упрощения считаем его обычным
        self.set('cell', building.start_cell_pos)   # обязательно поставим координату "выхода юнита" - от нее будет считать расстояние
        self.hide()
        if building:
            trace('set_home::building: ', building.get('name'), self.get('cell'))
            building.remove_walking_home_unit(self)     # еще один "на всякий случай"
        self.give_resource(building)    # отдаем ресурс
# ============================================================
    def give_resource(self, building):
        '''Отдает ресурс зданию'''
        not_empty = self.has_resource()
        if building:
            if not_empty:
                building.take_resource(self.resource)
                self.resource = None
# ============================================================
    def stop_walk(self):
        self.StopMove()     # событие сработает не мгновенно, а остановиться нужно сразу!
        self.FSM.HandleEvent('stay_event', True)    # а может и мгновенно
        #self.switch_animation() # не поломает ли чего? не должно вроде.
# ============================================================
    def show_magic(self):
        pass
# ============================================================
    def get_dlg_settings(self, text, _uid = 0, complete = False):
        if self.GetAttrBool('is_talking'):
            #_tasks = self.quest.get_tasks_text(complete)
            _tasks = []
            _survived_count = self.get_survived_count()
            _tasks = [('text', 'COLOR_TASKS_TEXT')]
            _tasks.append(['text', 'TASK_CHECK'])
            _tasks.append(('text','QUEST_DLG_TASK_SAVE'))
            _tasks.append('space')
            _tasks.append(('text', 'COLOR_TASKS_NUMBER'))
            _tasks.append(('digit', _survived_count))
            _tasks.append('space')
            _tasks.append(('text', 'COLOR_TASKS_TEXT'))
            if _survived_count == 1:    # если кол-во заканчивается на 1, то
                _tasks.append(('text', 'QUEST_DLG_TASK_SURVIVED'))   # выжившего
            elif _survived_count in [2,3,4]:
                _tasks.append(('text', 'QUEST_DLG_TASK_SURVIVED_2'))   # выживших
            else:
                _tasks.append(('text', 'QUEST_DLG_TASK_SURVIVED_5'))   # выживших
            _dlg_settings = {'imageid': self.GetAttrStr('dlg_avatar'),
                            'nameid': self.GetAttrStr('dlg_name'),
                            'textid': text,
                            'tasks_text': _tasks,
                            'task_uid':str(_uid),
                            'single_mode':str(True),
                            'showin_effect':'task_fly_in',
                            'pause':str(400),
                            }
            return _dlg_settings
        else:
            return None
# ============================================================
# ============================================================
# ============================================================
    def is_green_state(self):
        '''Цвет типса/селекта'''
        _has_access = self.has_access()
        if self.is_deactivated:
            if not _has_access:
                return False
            else:
                return True
        if not _has_access:
            return False
        _is_general = self.IsSubTypeOf('general')
        _fsm_state = self.FSM.GetStateID()
        if not _is_general:     # если это не генерал
            _is_barb = self.IsSubTypeOf('barb')
            if _is_barb:    # barbarians are always clickable!
                return True
            _is_general_ok = UMgr.is_general_ok()   # болен ли генерал
            if not _is_general_ok:
                return False
            _is_sick = _fsm_state == 'sick'
            if _is_sick:        # болен ли сам юнит?
                _has_doctor = UMgr.has_doctor() # а есть ли доктор и госпиталь?
                if not _has_doctor:
                    return False
        elif _fsm_state == 'sick':
            _has_doctor = UMgr.has_doctor() # а есть ли доктор и госпиталь?
            if not _has_doctor:
                return False
        _is_active = self.is_active()
        if _is_active:
            return True
        if self.res_action_cost:
            _is_res_enough = UStats.IsResEnough(self.res_action_cost)
            if not _is_res_enough:   # если хватает ресурсов на действие над объектом
                return False
        return True
# ============================================================
    def Get_tip_image(self):
        '''Возвращает ID изображения, которое используется для бэка типса'''
        # чтобы обновить кадр селекта:
        _frame = 0
        _is_green = self.is_green_state()
        if not _is_green: _frame = 1
        self.Drawer.SetFrame('select', _frame)
        # ---
        if not _is_green:   # если хватает ресурсов на следующий апгрейд
            return 'IMG_I_TIP_BG_RED'
        return 'IMG_I_TIP_BG'
# ============================================================
    def Get_tip_text(self, by_click = False):
        '''Возвращает LIST, содержащий текстовые ID'''
        result = []
        if not self.is_shown:
            return result
        if not self._get_tips_extra('before_name', result, by_click): return result
        item_name = self.GetAttrStr('item_name')
        if not item_name or item_name == 'NO_TIPS':
            return result
        _has_access = self.has_access()
        if not by_click:
            result.append( self._color_header )
            result.append( ('text', item_name) )
            if not self._get_tips_extra('after_name', result, by_click): return result

            self._append_lifebar(result)
            if not self._get_tips_extra('after_lifebar', result, by_click): return result

            if not self.is_active():
                return result
            if not self._get_tips_extra('after_name2', result, by_click): return result
            res = self.res_action_cost
            _is_res_empty = True
            if res: _is_res_empty = res.Empty()
            if not _is_res_empty:     # если ресурс не задан, то здесь делать нечего
                result.append( 'newline' )
                result.append( self._color_lines )
                result.append( ('text', 'NEED_FOR_ACTION') )
                result.append( 'space' )
                res_numbers = self._append_res_values(res)
                result.extend( res_numbers )
                if not UStats.IsResEnough(res):
                    diff_res = UStats.GetNotEnoughRes(res)
                    if diff_res:
                        result.append( self._not_enough_text )
                        result.append( 'space' )
                        res_numbers = self._append_res_values(diff_res)
                        result.extend( res_numbers )
            self._append_need_boat_text(result, False)
            if self._append_sick_general(result):
                return result
        else:
            if not self._get_tips_extra('before_access_check_click', result, by_click):
                return result
            if not _has_access:
                result = []
                result.append( self._color_red )
                result.append( ('text', 'NO_PATH') )
                self._append_need_boat_text(result, True)
                return result
            if self._append_sick_general(result, True):
                return result
            if _has_access:
                if self.is_survived:
                    _can_show = True
                    _is_talking = self.GetAttrBool('is_talking')
                    if _is_talking:
                        _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
                        if _has_barbarians:
                            result.append( self._color_lines )
                            result.append( ('text', 'YOU_HAVE_NO_TIME_TO_TALK') )
                            return result
                        _is_active = self.is_active()
                        if _is_active:
                            _can_show = False
                        _is_busy = self.is_busy()
                        if _is_busy:
                            _can_show = False
                    if _can_show:
                        if _is_talking:
                            result.append( self._color_lines )
                            result.append( ('text', ('NOT_READY_TO_TALK','NOT_READY_TO_TALK_W')[self.is_woman == True]) )
                            return result
                        else:
                            result.append( self._color_lines )
                            result.append( ('text', ('NOT_READY_TO_TALK2','NOT_READY_TO_TALK2_W')[self.is_woman == True]) )
                            return result
            if not self.is_active():
                return []
            res = self.res_action_cost
            _is_res_empty = True
            if res: _is_res_empty = res.Empty()
            if not _is_res_empty:     # если ресурс не задан, то здесь делать нечего
                if not UStats.IsResEnough(res):
                    diff_res = UStats.GetNotEnoughRes(res)
                    if diff_res:
                        result.append( self._color_red )
                        result.append( self._not_enough_text )
                        result.append( 'space' )
                        res_numbers = self._append_res_values(diff_res)
                        result.extend( res_numbers )
            if not result:
                return self.Get_tip_text(False) # если по клику нет типса, то вернем его как без клика
            self._append_need_boat_text(result, True)
        return result
# ============================================================
    def _append_sick_general(self, result, onclick = False):
        _is_sick = (self.FSM.GetStateID() == 'sick')
        _get_sick_general_text = UMgr.get_sick_general_text(onclick, _is_sick)
        if _get_sick_general_text:
            if not onclick:
                result.append('newline')
            else:
                del result[:]
            result.extend( _get_sick_general_text )
            return True
        return False
# ============================================================
    def _get_tips_extra(self, place, result, by_click):
        '''Предназначается для переопределения в потомках
        place: метка позиции вставки типса
        result: список значений, в который нужно добавлять данные
        by_click: типс по клику или нет
        returns: False - для завершения типса, т.е. после него ни одной строки не прибавится'''
        return True
# ============================================================
    def get_params_not_enough_text(self, result, extra_text, how_much = False):
        _need_power = self.GetAttrInt('need_power')
        _need_oratory = self.GetAttrInt('need_oratory')
        _need_oratory_d = 0
        _need_power_d = 0
        _cmp_value = 0
        if True:
            _need_power_d = _need_power - 1
            _need_oratory_d = _need_oratory - 1
            _cur_res = UStats.GetCurRes()
            _need_oratory_d = _need_oratory_d - _cur_res.Get('gem_green')
            _need_power_d = _need_power_d - _cur_res.Get('gem_blue')
        if _need_oratory_d > _cmp_value:
            if extra_text: result.extend(extra_text)
            result.append(('text', 'TIPS_ORATORY'))
            result.append( 'space' )
            result.append(('text', 'TIPS_LEV'))
            result.append( 'space' )
            result.append( ('digit', [_need_oratory, _need_oratory_d][how_much == True]) )
        if _need_power_d > _cmp_value:
            if extra_text: result.extend(extra_text)
            result.append(('text', 'TIPS_POWER'))
            result.append( 'space' )
            result.append(('text', 'TIPS_LEV'))
            result.append( 'space' )
            result.append( ('digit', [_need_power, _need_power_d][how_much == True]) )
# ============================================================
    def _append_res_values(self, resources):
        '''Для типса. Генерирует список со значениями переданного ресурса, с соответствующими изображениями'''
        result = []
        first_res = True
        for res_name in self.resource_names:    # выводим значения ресурсов...
            res_val = resources.Get(res_name)
            if res_val > 0:     # на всякий случай
                if not first_res:
                    result.append( ['comma'] )
                    result.append( ['space'] )
                first_res = False
                result.append( ('digit', resources.Get(res_name)) )
                result.append( ('image', self.res_images[res_name]) )
        return result
# ============================================================
    def Get_tip_position(self, tip_size, camera_pos, window_rect, zoom):
        '''Возвращает координаты типса от левого-верхнего угла картинки типса'''
        return toolz.Tools.get_tip_position(self, tip_size, camera_pos, window_rect)
# ============================================================
    def send_extra_event(self):
        if self.extra_event:
            BMgr.SendGlobalMsg('extra_event', self.extra_event)
            self.extra_event = ''
# ============================================================
    def get_action_cost_res(self):
        has_resname = self.HasAttr('acost_res_name')
        acost_res_name = 'action_cost'
        if has_resname:
            acost_res_name = self.GetAttrStr('acost_res_name')
        res = self.GetRes(acost_res_name)
        return res
# ============================================================
    def Force_highlight(self, highlight):
        pass
# ============================================================
    def on_quest_complete_all(self):
        pass        # просто затычка для обычных юнитов
# ============================================================
    def start_comet(self, _name, result_signal = 'comet_fly_complete'):
        '''Запускает комету, если указана в атрибутах, иначе просто дает сигнал на завершение удаления'''
        _comet_effect_name = _name
        if not _comet_effect_name:
            _comet_effect_name = self.GetAttrStr('comet_name')
        if _comet_effect_name:
            LBoard.StartComet(self, _comet_effect_name, result_signal)
            self.PlaySoundG('SND_ITEM_FLIGHT')
        else:
            self.Signals.Restart(result_signal, 1)
# ============================================================
    _tips_FACES_READY_TO_COMPLETE_array = [[('text', 'FACES_READY_TO_COMPLETE')], [('text', 'FACES_READY_TO_COMPLETE_W')]]
    _tips_FACES_READY_TO_SPEAK_array = [[('text', 'FACES_READY_TO_SPEAK')], [('text', 'FACES_READY_TO_SPEAK_W')]]
    _tips_CLICK_TO_CURE_array = [[('text', 'CLICK_TO_CURE')], [('text', 'CLICK_TO_CURE')]]
    _tips_FACES_NOT_ENOGH_TO_SPEAK = ('text', 'FACES_NOT_ENOGH_TO_SPEAK')
    _tips_EMPTY_True = [[], True]

    def get_ui_subtext(self):
        '''Текст, который должен быть написан в типсе возле панели с
        лицом персонажа второй строкой
        returns tuple where first item is text and second one is green-state (if True)'''
        return ([('text', 'FACES_READY_TO_SPEAK')], True)
# ============================================================
    def on_before_action_started(self): # for safe only
        pass
# ============================================================
    def Get_workers_count(self):
        return 0    # затычка
# ============================================================
    def teleport_to_cell(self, cell):
        trace('...teleport_to_cell...')
        self.set('cell', cell)
# ============================================================
    def get_loot(self):
        #return self.generated_loot
        return []
# ============================================================
    def giveaway_general_loot(self):
        _state = self.FSM.GetStateID()
        if _state == 'sick':
            return
        _loots = self.generated_loot
        if _loots:
            _loots = _loots[::-1]   # reverse
            for _loot in _loots:
                if 'no_autoloot' in _loot:
                    if _loot.no_autoloot == True:
                        continue
                    _extra_check_allow = _loot.is_extra_check_allow()
                    if not _extra_check_allow:
                        trace('--> DiffItem (loot) extra check disallow', _loot.get('uid'))
                        continue
                    _loot_task = task_walkg.WalkGeneralTask(_loot, True)
                    TMgr.add_task(_loot_task, True)
# ============================================================
    def do_game_action(self, data, time_shift = 0):
        '''type, txt_param1, txt_param2, int_param1, int_param2, is_offscreen'''
        TMgr.do_game_action(self, data, time_shift)
# ============================================================
    def do_action(self, name):
        _action_done = self._do_action(self, name)  # for overriding
        if not _action_done:
            _parts = name.split(' ')
            name = _parts[0]
            if name == 'show_as_possible':
                self.show_as_possible()
            elif name == 'go_to':
                item = TMgr.get_item(self, _parts[1])
                if item:
                    self.go_to(item)
# ============================================================
    def _do_action(self, name):
        '''For overriding in child classes'''
        return False
# ============================================================
    _need_boat_text = ('text', 'NEED_BOAT')
    _need_tele_text = ('text', 'NEED_TELEPORT')

    def _append_need_boat_text(self, result, _red):
        '''Добавляем строчку, что необходима лодка или телепорт, если это нужно'''
        if self.is_deactivated: # для деактивированных ничего не нужно
            return
        _need_text = False
        _has_access = self.has_access()
        if not _has_access: # если к объекту нет никакого доступа
            _need_tele = self.GetAttrBool('need_teleport')
            _need_boat = self.GetAttrBool('need_boat')
            if _need_boat:
                _need_text = True
            elif _need_tele:
                _need_text = True
            else:
                _has_normal_access = self.HasAccess()
                if _has_normal_access:      # если сейчас объект недоступен, но обычный доступ к нему есть, то значит он на противоположном берегу
                    _need_text = True
                    _last_transport = UMgr.get_cluster( self.get('locind') ).general.last_transport
                    _need_boat = (_last_transport == 'boat')
                    _need_tele = (_last_transport == 'teleport')
        if _need_text:
            if not _red:
                result.append( self._color_lines )
            else:
                result.append( self._color_red )
            result.append('newline')
            if _need_boat:
                result.append(self._need_boat_text)
            elif _need_tele:
                result.append(self._need_tele_text)
# ============================================================
    _unit_lief_images_dict = {'left':'TIP_LIFEBAR_L', 'right':'TIP_LIFEBAR_R', 'full':'TIP_LIFEBAR_FULL', 'empty':'TIP_LIFEBAR_EMPTY'}
    def _append_lifebar(self, result):
        '''Бар жизни раненого на типсе'''
        _is_sick = self.FSM.GetStateID() == 'sick'
        if not _is_sick:
            return
        _progress = self.Signals.GetProgress('curing_process')
        _progress = max(_progress, 0.1)
        result.append('newline')
        result.append( self._color_lines )
        #result.append( ('text', 'TIP_RES_GENERATION') )
        #result.append('newline')
        self._append_bar(result, _progress, self._unit_lief_images_dict)
# ============================================================
    #_bar_progress_images_dict = {'left':'TIP_BAR_L', 'right':'TIP_BAR_R', 'full':'TIP_BAR_FULL', 'empty':'TIP_BAR_EMPTY'}
    def _append_bar(self, result, _progress, bar_images, _places_count = 10):
        '''Добавляет bar r result по указанным параметрам'''
        _filled_places = _places_count * _progress
        _filled_places = int(_filled_places + 0.5)
        _filled_places = limit_value(_filled_places, 0, _places_count)
        result.append( ('text', bar_images.left) ) #'TIP_BAR_L'
        _bar_full = bar_images.full
        _bar_empty = bar_images.empty
        for i in range(_filled_places):
            result.append( ('text', _bar_full) ) #'TIP_BAR_FULL'
        for i in range(_places_count-_filled_places):
            result.append( ('text', _bar_empty) ) #'TIP_BAR_EMPTY'
        result.append( ('text', bar_images.right) ) #'TIP_BAR_R'
# ============================================================
    def refresh_run_animation(self):
        _run_coeff = self.GetRunFinalCoeff()
        if _run_coeff != self.prev_coeff:
            self.prev_coeff = _run_coeff
            self.switch_animation()
# ============================================================
    def switch_variant(self, variant_name):
        self.SwitchVariant(variant_name)
        self.on_variant_change(variant_name)
# ============================================================
    def on_variant_change(self, new_variant_name):
        '''Вызывается после смены варианта в этом же кванте'''
        #self.res_action_cost = self.get_action_cost_res()
        self.is_transition = False
        #if self.is_shaded:
        #    self.Drawer.SetShaded(self.item_layers, True)
        self.non_selectable = self.GetAttrBool('non_selectable')
        if self.non_selectable:
            self.SetMouseActive(False)
        self.switch_animation()
# ============================================================
    def go_to(self, target):
        pass
# ============================================================
    _sick_states = ['sick', 'sick_standup']
    def is_in_sick_states(self):
        _state = self.FSM.GetStateID()
        if _state in self._sick_states:
            return True
        return False
# ============================================================
    def append_self_to_parent_home(self):
        if self.parent_home:
            self.parent_home._internal_free_units.append(self)
# ============================================================
    def remove_faded(self, time):
        self.Signals.Restart('kill_self', time)
        self.Drawer.ShowOut('', time)
        self.deactivate()
        self.SetMouseActive(False)
# ============================================================
    def is_extra_check_allow(self):
        '''For overriding'''
        return True
# ============================================================
    def DEBUG_get_info(self):
        r = []
        r.append(('debug', '^55ff55^'))
        r.append(('debug', self.get('uid')))
        r.append(('space'))
        r.append(('debug', self.get('name')))
        r.append( 'space' )
        _state_name = self.FSM.GetStateID()
        r.append(('debug', 'S:'))
        r.append(('debug', _state_name))
        r.append( 'newline' )
        r.append(('debug', str(self.is_hidden)))
        r.append(('debug', str(self.is_shown)))
        r.append( 'space' )
        r.append(('debug', self.current_subtype))
        return r
# ============================================================
# ============================================================
    def init_fsm(self):
        FSM = self.FSM

        self.UseFSM(True)
        FSM.Init('stay')
        _states = [StateStay, StateTalk, StateAction, StateStay, StateRun, StateHit, StateMagic, StateSick, StateCuring, StateSickStandup]
        #for state in _states: self.states[state.name] = state(self)
        self.fsm_methods.apply_states(_states)

        FSM.AddTransition('talk_event', 'stay', 'talk')
        FSM.AddTransition('talk_event', 'run', 'talk')

        FSM.AddTransition('action_event', 'stay', 'action')
        FSM.AddTransition('action_event', 'run', 'action')

        FSM.AddTransition('stay_event', 'run', 'stay')
        FSM.AddTransition('stay_event', 'talk', 'stay')
        FSM.AddTransition('stay_event', 'action', 'stay')
        FSM.AddTransition('stay_event', 'hit', 'stay')
        FSM.AddTransition('stay_event', 'magic', 'stay')
        FSM.AddTransition('cancel_action_hits_event', 'action', 'stay')
        FSM.AddTransition('cancel_hits_event', 'hit', 'stay')

        FSM.AddTransition('attarget_stay_event', 'run', 'stay')
        FSM.AddTransition('general_attarget_stay_event', 'run', 'stay')
        FSM.AddTransition('general_attarget_stay_event', 'stay', 'stay')

        FSM.AddTransition('run_event', 'run', 'run')    # to handle event
        FSM.AddTransition('run_event', 'stay', 'run')
        FSM.AddTransition('run_event', 'idle', 'run')
        FSM.AddTransition('run_event', 'magic', 'run')
        FSM.AddTransition('run_event', 'talk', 'run')
        FSM.AddTransition('run_event', 'action', 'run')
        FSM.AddTransition('run_event', 'build', 'run')
        FSM.AddTransition('run_event', 'dig', 'run')

        FSM.AddTransition('idle_event', 'run', 'idle')
        FSM.AddTransition('idle_event', 'stay', 'idle')

        FSM.AddTransition('hit_event', 'run', 'hit')
        FSM.AddTransition('hit_event', 'stay', 'hit')

        FSM.AddTransition('magic_event', 'run', 'magic')
        FSM.AddTransition('magic_event', 'stay', 'magic')

        FSM.AddTransition('build_event', 'run', 'build')
        FSM.AddTransition('build_event', 'stay', 'build')

        FSM.AddTransition('dig_event', 'run', 'dig')
        FSM.AddTransition('dig_event', 'stay', 'dig')

        FSM.AddTransition('sick_event', 'idle', 'sick')
        FSM.AddTransition('sick_event', 'stay', 'sick')
        FSM.AddTransition('sick_event', 'hit', 'sick')
        FSM.AddTransition('heal_event', 'sick', 'sick_standup')
        FSM.AddTransition('heal_complete_event', 'sick_standup', 'stay')
        FSM.AddTransition('start_curing_event', 'stay', 'curing')
        FSM.AddTransition('complete_curing_event', 'curing', 'run')

        FSM.AddTransition('unit_extinguishing_event', 'run', 'extinguishing')
        FSM.AddTransition('unit_extinguishing_event', 'stay', 'extinguishing')
        FSM.AddTransition('unit_extinguishing_event', 'idle', 'extinguishing')
        FSM.AddTransition('complete_extinguishing_event', 'extinguishing', 'run')
# ============================================================
# ============================================================
# ============================================================
class StateStay(fsm_state.FSMState):
    name = 'stay'

    def __init__(self, item = None):
        fsm_state.FSMState.__init__(self, item)
        self.ser_name = 'StateBUStay'

    def on_enter(self, evID):
        u = self.item
        u.StopMove()    #@????
        if evID == 'attarget_stay_event':
            u.Signals.Restart('face_to_screen', 250)
        u.switch_animation()

    def on_handle(self, evID):
        pass
# ============================================================
# ============================================================
class StateRun(fsm_state.FSMState):
    name = 'run'

    def __init__(self, item = None):
        fsm_state.FSMState.__init__(self, item)
        self.ser_name = 'StateBURun'

    def on_enter(self, evID):
        u = self.item
        u.UnstopMove()      # чтобы можно было начать движение
        #u.switch_animation()
        u.show()        # на всякий случай, попытка пофиксить невидимок из #555

    def can_exit(self, evID):
        if evID == 'run_event':
            return False
        return True

    def on_handle(self, evID):
        if evID == 'run_event':
            u = self.item
            u.switch_animation()
# ============================================================
# ============================================================
class StateIdle(fsm_state.FSMState):
    name = 'idle'

    def __init__(self, item = None):
        fsm_state.FSMState.__init__(self, item)
        self.ser_name = 'StateBUIdle'

    def on_enter(self, evID):
        u = self.item
        u.Signals.Restart('face_to_screen', 250)
        u.switch_animation()

    def on_handle(self, evID):
        pass
# ============================================================
# ============================================================
class StateAction(fsm_state.FSMState):
    name = 'action'

    def __init__(self, item = None):
        fsm_state.FSMState.__init__(self, item)
        self.ser_name = 'StateBUAction'

    def on_enter(self, evID):
        u = self.item
        u.show()
        u.switch_animation()

    def on_handle(self, evID):
        pass
# ============================================================
# ============================================================
class StateMagic(fsm_state.FSMState):
    name = 'magic'

    def __init__(self, item = None):
        fsm_state.FSMState.__init__(self, item)
        self.ser_name = 'StateBUMagic'

    def on_enter(self, evID):
        u = self.item
        u.need_magic = False
        u.Signals.Restart('stop_magic', 1000)
        u.switch_animation()

    def on_exit(self, next_state):
        u = self.item
        #if u.Signals.Has('stop_magic'):
        u.Signals.Cancel('stop_magic')      # на всякий случай
        TMgr.send_event('free_general', None)   # надеюсь не повредит нигде
# ============================================================
# ============================================================
class StateHit(fsm_state.FSMState):
    name = 'hit'

    def __init__(self, item = None):
        fsm_state.FSMState.__init__(self, item)
        self.ser_name = 'StateBUHit'
        self.is_canceled = False

    def on_enter(self, evID):
        u = self.item
        u.switch_animation()

    def on_exit(self, next_state):
        if self.item.IsSubTypeOf('general'):
            if not self.is_canceled:
                #self.item.SendMsg('action_hit_complete')
                self.item.SendMsg('hit_anim_complete')

    def on_handle(self, evID):
        if evID == 'cancel_hits_event':
            self.is_canceled = True
# ============================================================
# ============================================================
class StateTalk(fsm_state.FSMState):
    name = 'talk'

    def __init__(self, item = None):
        fsm_state.FSMState.__init__(self, item)
        self.ser_name = 'StateBUTalk'

    def on_enter(self, evID):
        u = self.item
        u.Signals.Restart('stop_talking', 2000)
        u.switch_animation()

    def on_handle(self, evID):
        pass
# ============================================================
# ============================================================
class StateBuild(fsm_state.FSMState):
    name = 'build'

    def __init__(self, item = None):
        fsm_state.FSMState.__init__(self, item)
        self.ser_name = 'StateBUBuild'

    def on_enter(self, evID):
        u = self.item
        u.switch_animation()

    def on_handle(self, evID):
        pass

    def on_exit(self, next_state):
        u = self.item
        u.RemoveMsg('build_hit_complete')

# ============================================================
# ============================================================
class StateDig(fsm_state.FSMState):
    name = 'dig'

    def __init__(self, item = None):
        fsm_state.FSMState.__init__(self, item)
        self.ser_name = 'StateBUDig'

    def on_enter(self, evID):
        u = self.item
        u.switch_animation()

    def on_handle(self, evID):
        pass

    def on_exit(self, next_state):
        u = self.item
        u.RemoveMsg('build_hit_complete')

# ============================================================
# ============================================================
class StateSick(fsm_state.FSMState):
    name = 'sick'

    def __init__(self, item = None):
        fsm_state.FSMState.__init__(self, item)
        self.ser_name = 'StateBUSick'

    def on_enter(self, evID):
        u = self.item
        u.switch_animation()
        _stype = u.get('stype')
        if _stype == 'general':
            TMgr.cancel_general_tasks()
            UI.SetGeneralSick(True)
            u.Signals.Restart('try_call_doctor', 250)
            EMgr.send_event('general_sick_event', u)

    def on_handle(self, evID):
        pass

    def on_exit(self, next_state):
        pass
        #u = self.item
        #u.task = None
        #if u.get('stype') != 'general':
        #    EMgr.SendGlobalMsg('unit_recovered', '')
# ============================================================
# ============================================================
class StateSickStandup(fsm_state.FSMState):
    name = 'sick_standup'

    def __init__(self, item = None):
        fsm_state.FSMState.__init__(self, item)
        self.ser_name = 'StateBUSickStandup'

    def on_enter(self, evID):
        u = self.item
        if u.IsSubTypeOf('general'):
            u.Drawer.PlayAnimationOnce(u.states_anim_dict[self.name], 'standup_complete')
        elif u.is_indian:
            u.Drawer.PlayAnimationOnce(u.indian_animation_dict[self.name], 'standup_complete')
        u.switch_animation()

    def on_handle(self, evID):
        pass

    def on_exit(self, next_state):
        u = self.item
        u.task = None
        _stype = u.get('stype')
        if _stype != 'general':
            #EMgr.SendGlobalMsg('unit_recovered', '')
            EMgr.send_event('unit_recovered', u)
        else:
            EMgr.send_event('general_recovered', u)
            UI.SetGeneralSick(False)
# ============================================================
# ============================================================
class StateCuring(fsm_state.FSMState):
    name = 'curing'

    def __init__(self, item = None):
        fsm_state.FSMState.__init__(self, item)
        self.ser_name = 'StateBUCuring'

    def on_enter(self, evID):
        u = self.item
        u.switch_animation()
        u.Signals.Restart('complete_curing', 2000)

    def on_handle(self, evID):
        pass

    def on_exit(self, next_state):
        u = self.item
        if u.task:
            u.task.complete_task()
# ============================================================
