# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_classes


class DigBogSubtask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'DigBogSubtask'
        self.actor_action_animation = 'dig'

    def start_action(self, item):
        item.FSM.HandleEvent('start_event', True)
        item.digg_started = True
        item.switch_animation()
        item.stop_attention_signal()        # не показываем эффект когда закапываем
        self.actor.stop_walk()
        self.actor.action_hit_item(item)
        return True
# ============================================================
# ============================================================
class Bog(base_diff_item.DiffItem):
    '''Болото'''
    digged_variants = {'normal_left':'digged_left',
                    'normal_right':'digged_right'}

    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.ser_name = 'Bog'
        self.task = None
        self.need_attention_effect = False
        self.button_shown = True
        self.digg_started = False
        # dirty hack for arrow color:
        _rnd_time = tools.Rand(450, 550)
        self.Signals.Restart('refresh_state', _rnd_time)
        self.snd_hit = self.GetAttrStr('hit_sound')
        self.snd_complete = self.GetAttrStr('broken_sound')
# ============================================================
    def on_signal(self, signal):
        if signal == 'refresh_state':
            _rnd_time = tools.Rand(450, 550)
            self.Signals.Restart('refresh_state', _rnd_time)
            # нужно обновить состояние кнопок и, возможно, типса
            btn_frame = self.Get_button_frame()
            if btn_frame >= 0:
                self.Drawer.SetFrame('button', btn_frame)
                self.Drawer.ShowImages('button')
            else:
                self.Drawer.ShowImages('button', False)
            # dirty hack for arrow color:
            self.Get_tip_image()
        else:
            base_diff_item.DiffItem.on_signal(self, signal)
# ============================================================
    def _switch_animation_extra(self, place):
        if place == 'end':
            self.Drawer.ShowImages('select', self.is_mouse_over and not self.is_deactivated)
            _need_check = self.GetAttrBool('need_check')
            if not _need_check:
                self.Drawer.ShowImages('check', False)
            #self.Drawer.ShowImages('arrow', self.arrow_shown)
            btn_frame = self.Get_button_frame()
            self.Drawer.SetFrame('button', btn_frame)
            self.Drawer.ShowImages('button', btn_frame >= 0)
# ============================================================
    def get_activity_state(self):
        if self.is_deactivated:
            return 'DEACTIVATED'
        _partial_fog = self.Drawer.IsPartiallyInFog()
        if _partial_fog:
            return 'FOG'
        _has_access = self.has_access()
        if not _has_access:
            return 'ACCESS'
        if self.digg_started:
            return 'ACTION_STARTED'
        result = 'NORMAL'
        #_barb_attack_count = UStats.GetLevelValue('barbarian_attack')
        #if _barb_attack_count > 0:
        #   result = 'ATTACK'
        _has_enemy = UStats.GetLevelValue('enemy_go')
        if _has_enemy > 0:
            result = 'ATTACK'       # просто чтобы что-то было
        _res = self.res_action_cost     # сколько стоит действие
        if _res:
            _is_res_enough = UStats.IsResEnough(_res)
            if not _is_res_enough:    # если ресурсов достаточно
                result = 'NO_RES'
        if self.key_need:
            _has_key = self.has_key()
            if not _has_key:
                result = 'KEY'
        #if QMgr.IsSwitchingLevels():
        #    result = 'SWITCHING'
        return result
# ============================================================
    _ATTACK__ACCESS__KEY__SWITCHING__NO_RES = ['ATTACK', 'ACCESS', 'KEY', 'SWITCHING', 'NO_RES']
    def get_raw_button_frame(self):
        '''Возвращает номер кадра кнопки, без учета положения курсора мыши'''
        if self.is_deactivated:
            return -1
        _partial_fog = self.Drawer.IsPartiallyInFog()
        if _partial_fog:
            return -1
        if not self.button_shown:
            return -1
        frame = 6
        _activity_state = self.get_activity_state()
        if _activity_state == 'ACTION_STARTED':
            return -1
        if _activity_state in self._ATTACK__ACCESS__KEY__SWITCHING__NO_RES:
            frame = self.blocked_frame
        if self.has_check:  # если на объект назначено действие
            frame = 3
        # - проверка на то, что есть атакующие варвары
        # - проверка на запущенные квесты (кроме квеста на артефакт)
        # - еще должна быть проверка на уровень силы/ораторства...
            # - еще нужно, чтобы перед входом в пещеру - была проверка на запрещающие условия (но это уже не здесь)
        return frame
# ============================================================
    button_active_frames = [6,3]
    cancel_action_frame = 3
    blocked_frame = 8

    def is_cancel_button_mode(self):
        if self.is_mouse_over:
            frame = self.get_raw_button_frame()
            if frame in self.button_active_frames: # подсветка кнопки при наведении
                if frame == self.cancel_action_frame:     # если кнопка отмены
                    if self.can_show_uncheck:
                        return True
        return False
# ============================================================
    def Get_button_frame(self):
        frame = self.get_raw_button_frame()
        if frame >= 0:
            if self.is_mouse_over:
                if frame in self.button_active_frames: # подсветка кнопки при наведении
                    if frame == self.cancel_action_frame or self.has_check:     # для отмены подсвечиваем только над кнопкой
                        if self.can_show_uncheck:
                            if self.is_mouse_over_zone == 'button':
                                frame = 4
                    elif frame == 6:
                        frame = 7
        if frame < 0:
            self.Drawer.ShowImages('button', False)
        else:
            self.Drawer.ShowImages('button')
        return frame
# ============================================================
# ============================================================
    def check_button_only_selection(self):
        _is_cancel_button_mode = self.is_cancel_button_mode()
        if _is_cancel_button_mode:
            if self.is_mouse_over_zone != 'button':
                self.Drawer.HighlightImages(self.hlight_layers, False)
                self.Drawer.ShowImages('select', False)
            else:
                self.Drawer.HighlightImages(self.hlight_layers, False)
                self.Drawer.ShowImages('select', False)
# ============================================================
    # @override
    def on_action_hits_me_complete(self):
        content_template_name, variant_name = self.get_content_ex()
        if not content_template_name:
            content_template_name = self.get_content()      # имя шаблона объекта внутри горшка
            variant_name = self.GetAttrStr('contains_variant_name')
        _digged_var = 'digged'
        _cur_var = self.get('variant_name')
        if _cur_var in self.digged_variants:
            _digged_var = self.digged_variants[_cur_var]
        self.switch_variant( _digged_var )
        self.action_hits_last = 0
        bog_info = {'type':self.get('type'), 'subtype':self.get('subtype')}
        EMgr.send_event( 'bog_digged', self, bog_info )
        BMgr.remove_item_uid(self)
        self.deactivate()
        self.SetMouseActive(False)
        self.send_extra_event()
        self.publish_content(content_template_name, variant_name)
        EMgr.send_event( 'do_action_complete', self )
        if self.snd_complete:
            self.PlaySound(self.snd_complete)
# ============================================================
    def get_content_ex(self):
        '''Контент из "content"'''
        _content = self.get_unpacked_content( self.GetAttrStr('content') )  # строго до смены варианта
        if _content:
            _item = _content[0]
            _part0 = _item[0]
            _item_parts = len(_item)
            if _item_parts == 1:
                return _part0, ''
            else:
                return _item
        return (None, None)
# ============================================================
    def get_content(self):
        '''Возвращает имя шаблона содержимого горшка, если в нем что-то есть'''
        content_template_name = self.GetAttrStr('contains_template')
        if not content_template_name:
            if self.GetAttrBool('contains_gold_small'):
                return 'gold_small'
            elif self.GetAttrBool('contains_gold_big'):
                return 'gold_big'
        return content_template_name
# ============================================================
    def publish_content(self, content_template_name, variant_name):
        '''Выкладывает на поле объект'''
        if not content_template_name:
            self.generated_loot = []
            return
        cell_pos = self.GetAttrCellFixed('content_cell')
        # - create item and place item on map in cell_pos
        map_index = self.get('locind')
        _new_item = BMgr.AddItemToMap(map_index, content_template_name, variant_name, cell_pos)        # hack - BuildingsManager может добавлять на карту не только здания...
        if _new_item:
            _pos = _new_item.GetAttrPoint('center_item_pos')
            _new_item.set_shaded(self.is_shaded)
            _new_item.Drawer.ResIn(_new_item.item_layers, _pos, 1000)
            _new_item.play_content_sound(self)
            self.generated_loot = [_new_item]
# ============================================================
    def on_mouse_in(self, over_zone):
        _prev_zone = self.is_mouse_over_zone
        base_diff_item.DiffItem.on_mouse_in(self, over_zone)
        _is_active = self.is_active()
        _has_access = self.has_access()
        if _is_active:
            if _has_access:
                if over_zone != 'button' and _prev_zone == 'button':
                    self.can_show_uncheck = True
                self.check_button_only_selection()
                btn_frame = self.Get_button_frame()
                if btn_frame >= 0:
                    self.Drawer.SetFrame('button', btn_frame)
                self.is_selected = True
                self.Drawer.ShowImages('select')
# ============================================================
    def on_mouse_out(self):
        base_diff_item.DiffItem.on_mouse_out(self)
        self.can_show_uncheck = True
        btn_frame = self.Get_button_frame()
        if btn_frame >= 0:
            self.Drawer.SetFrame('button', btn_frame)
        self.Drawer.ShowImages('select', False)
# ============================================================
    def on_click(self, btn_name):
        if self.is_deactivated:
            return
        _partial_fog = self.Drawer.IsPartiallyInFog()
        if _partial_fog:
            return
        _activity_state = self.get_activity_state()
        if _activity_state != 'NORMAL':
            if not self.has_check:
                return
        if self.has_check:                  # если отображена галка
            #if not self.can_show_uncheck:   # но отменять нельзя
            #    return
            _need_check = self.GetAttrBool('need_check')
            if not _need_check:
                if self.is_mouse_over_zone != 'button':   # или клик не по кнопке
                    return
        base_diff_item.DiffItem.on_click(self, btn_name)
# ============================================================
    #@override
    def Get_tip_image(self):
        '''Возвращает ID изображения, которое используется для бэка типса'''
        # чтобы обновить кадр селекта:
        btn_frame = self.Get_button_frame()
        _frame = 0
        _is_green_state = self.is_green_state()
        if not _is_green_state: _frame = 1
        if btn_frame == self.blocked_frame: # заблокировано
            _frame = 1
        self.Drawer.SetFrame('select', _frame)
        self.Drawer.SetSequence('arrow', _frame)    # номер последовательности сейчас совпадает с номером кадра
        # ---
        if _is_green_state:
            if btn_frame != self.blocked_frame:
                return 'IMG_I_TIP_BG'
        if self.digg_started:
            return 'IMG_I_TIP_BG'
        return 'IMG_I_TIP_BG_RED'
# ============================================================
    def play_hit_sound(self):
        if self.snd_hit:
            self.PlaySound(self.snd_hit)
        else:
            self.PlaySound('SND_WATER_SPADE')
# ============================================================
    def get_subtask(self, parent_task, actor):
        return DigBogSubtask(parent_task, actor)
# ============================================================
    #@override
    def get_action_text(self, for_task_slide = False):
        return 'DLG_TASK_DIG'
# ============================================================
    #@override
    def scale_bump(self):
        pass
# ============================================================
# #######################################################
# #######################################################
# #######################################################
