# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_classes


class BonusAltarSubtask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'BonusAltarSubtask'
        self.actor_action_animation = 'magic'   #'pickup'

    def start_action(self, item):
        item.FSM.HandleEvent('start_event', True)
        item.PlaySoundG('SND_ALTAR_ACTIVATE')
        item.set_unit_direction(self.actor)
        self.actor.stop_walk()
        self.actor.action_hit_item(item)     # генерал сам доломает горшок, BUG: возможен, если отмена произойдет в момент ломания
        self.actor.need_show_magic()
        return True
# ============================================================
# ============================================================
# ============================================================
class BonusAltar(base_diff_item.DiffItem):
    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.ser_name = 'BonusAltar'
        self.task = None
        self.cooldown_time = self.GetAttrInt('cooldown_time')
        self.bonus_time = self.GetAttrInt('bonus_time')
        self.bonus_value = max(self.GetAttrInt('bonus_value'), 1)
        self.bonus_r = self.GetAttrInt('bonus_r')
        self.is_cooldown_complete = True
# ============================================================
    def on_create(self):
        base_diff_item.DiffItem.on_create(self)
# ============================================================
    #def switch_animation(self):
    #    self.Drawer.ShowImages('', False)
    #    self.Drawer.ShowImages('default')
# ============================================================
    # @override
    def on_action_hits_me_complete(self):
        #self.switch_variant( 'complete' )
        #enabler_info = {'type':self.get('type'), 'subtype':self.get('subtype')}
        #EMgr.send_event( 'enabler_action', self, enabler_info )
        EMgr.send_event( 'do_action_complete', self )
        self.send_extra_event()
        #BMgr.remove_item_uid(self)
        #self.PlaySound('SND_STONEDOOR_SWITCH')
        _bonus = self.GetAttrStr('bonus_type')
        BMgr.bonus_mgr.start_bonus(_bonus, self.bonus_time, self.bonus_value)
        if self.bonus_r > 0:
            buildings = BMgr.GetUserBuildingsInRadius(self, '', self.bonus_r)
            if _bonus == 'gen_double':
                for b in buildings: b.apply_bonus_double_generation(self.bonus_time)
            elif _bonus == 'restore_eff':
                for b in buildings:
                    b.apply_bonus_restore_effectiveness(self.bonus_time)
        self.switch_variant(self.GetAttrStr('next_variant'))
        #self.Drawer.ShowImages('started_effect')
        self.Drawer.StartEffectOnce('started_effect')
        self.start_cooldown()
        LBoard.Core.try_open_help(1,2, 9, self, '5147')
# ============================================================
    def get_subtask(self, parent_task, actor):
        if not self.is_action_complete():
            if self.is_active():
                return BonusAltarSubtask(parent_task, actor)
        return None
# ============================================================
    def on_signal(self, signal):
        if signal == 'cooldown_complete':
            self.on_cooldown_complete()
        else:
            base_diff_item.DiffItem.on_signal(self, signal)
# ============================================================
    def start_cooldown(self):
        self.is_cooldown_complete = False
        self.action_hits_last = 0
        self.Signals.Restart('cooldown_complete', self.cooldown_time)
        self.deactivate()
# ============================================================
    def on_cooldown_complete(self):
        self.is_cooldown_complete = True
        self.action_hits_last = 1
        #self.action_was_started = False
        self.FSM.HandleEvent('regenerate_event')
        self.task = None
        self.SetMouseActive(True)
        self.activate()
        self.switch_variant(self.GetAttrStr('next_variant'))
# ============================================================
    def is_active(self):
        _is_not_needed_yet = self._is_not_needed_yet()
        _is_not_needed = self._is_not_needed()
        if _is_not_needed_yet:
            return False
        elif _is_not_needed:
            return False
        return base_diff_item.DiffItem.is_active(self)
# ============================================================
    def _get_tips_extra(self, place, result, by_click):
        if place == 'before_name':
            _is_not_needed_yet = self._is_not_needed_yet()
            if _is_not_needed_yet:
                result.append( ('text', 'COLOR_LINES') )
                result.append( ('text', 'NOT_NEED_YET') )
                return False
            _is_not_needed = self._is_not_needed()
            if _is_not_needed:
                result.append( ('text', 'COLOR_LINES') )
                result.append( ('text', 'NOT_NEED_MORE') )
                return False
        return True
# ============================================================
    def _is_not_needed_yet(self):
        '''Не нужно, потому что есть такой же действующий бонус'''
        if not self.is_cooldown_complete: return False
        _bonus = self.GetAttrStr('bonus_type')
        if _bonus == 'runspeed':
            _cur_runspeed = UStats.GetLevelValue('BONUS_RUN_SPEED')
            if self.bonus_value <= _cur_runspeed:
                return True
        return False
# ============================================================
    def _is_not_needed(self):
        '''Не нужно, потому что уже есть сапожник более высокого уровня'''
        _bonus = self.GetAttrStr('bonus_type')
        if _bonus == 'runspeed':
            _cur_shoe_c = UStats.GetLevelValue('SHOE_COEFF')
            if self.bonus_value <= _cur_shoe_c:
                return True
            # комментируем, т.к. это только на генерала, но не на работников
            #_cur_res = UStats.GetCurRes()
            #_cur_gem_c = _cur_res.Get('gem_red') + 1
            #if self.bonus_value <= _cur_gem_c:
            #    return True
        return False
# ============================================================
    def scale_bump(self):
        pass
# ============================================================
# #######################################################
# #######################################################
# #######################################################
