# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_walkg
import task_classes
# ============================================================
# ============================================================
# ============================================================
class TakeBonusKeySubtask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'TakeBonusKeySubtask'
        self.actor_action_animation = 'pickup'    # просто для проверки
# ============================================================
    # @override
    def start_action(self, item):
        item.FSM.HandleEvent('start_event', True)
        self.actor.stop_walk()
        self.actor.action_hit_item(item)
        return True
# ============================================================
# ============================================================
# ============================================================
class BonusKey(base_diff_item.DiffItem):
    '''Объект инвентаря'''
    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.ser_name = 'BonusKey'
        self.task = None
        self.show_born_effect()
        self.PlaySoundG('SND_FINAL_KEY')
# ============================================================
    def remove_me(self):
        ''' Удаляет объект с поля, считаем его "взятым" '''
        self.PlaySound('SND_ITEM_PICKUP')
        #self.start_comet()
        tools.PlaySound('SND_ARTEFACT_ITEM')
        #dlg.Open('StatsMenu', 'dlg_stats', {'single_mode':'1', 'final':'1'})
        self.send_extra_event()
        EMgr.send_event('game_win', None)   # игру можно завершать
        BMgr.RemoveItemFromMap(self)
# ============================================================
    def get_subtask(self, parent_task, actor):
        return TakeBonusKeySubtask(parent_task, actor)
# ============================================================
    def on_action_hits_me_complete(self):
        self.remove_me()
# ============================================================
    # @override
    def on_create(self):
        base_diff_item.DiffItem.on_create(self)
        self.add_attention_signal()
# ============================================================
# #######################################################
# #######################################################
