# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_classes


class EnablerSubtask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'EnablerSubtask'
        self.actor_action_animation = 'pickup'

    def start_action(self, item):
        item.action_done = False
        item.FSM.HandleEvent('start_event', True)
        self.actor.stop_walk()
        self.actor.action_hit_item(item)     # генерал сам доломает горшок, BUG: возможен, если отмена произойдет в момент ломания
        return True
# ============================================================
# ============================================================
class Enabler(base_diff_item.DiffItem):
    '''Переключатель'''
    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.ser_name = 'Enabler'
        self.action_done = False
        self.task = None
        self.snd_complete = self.GetAttrStr('snd_complete', 'SND_STONEDOOR_SWITCH')
        self.snd_hit = self.GetAttrStr('snd_hit', 'SND_POT_HIT')
        self.is_infinite = self.GetAttrBool('is_infinite')
        self.shear_mode = self.GetAttrBool('shear_mode')
        self.shear_r = self.GetAttrInt('shear_r', 0)
        if self.shear_mode:
            self.Drawer.SetTreeMode('default', self.shear_r)
# ============================================================
    #@override
    def on_create(self):
        base_diff_item.DiffItem.on_create(self)
        self.add_attention_signal()
# ============================================================
    #@override
    def is_action_complete(self):
        '''Действие [юнитом] над данным объектом уже было выполнено'''
        _state = self.FSM.GetStateID()
        #return (_state == 'complete')
        return self.action_done

        #if self.action_hits_last <= 0:
        #    return True
        #elif not self.action_started:
        #    return True
        #return False
# ============================================================
    #@override
    def on_action_hits_me_complete(self):
        self.do_default_action()
# ============================================================
    def do_default_action(self):
        _linked_uids = self.GetAttrStr('linked_uids')
        _cur_variant = self.get('variant_name')
        #self.action_was_started = False
        self.action_done = True
        if self.is_infinite:
            self.FSM.HandleEvent('regenerate_event')
        self.switch_variant( ('default', 'complete')[_cur_variant != 'complete'] )
        #self.action_hits_last = 0
        enabler_info = {'type':self.get('type'), 'subtype':self.get('subtype')}
        EMgr.send_event( 'enabler_action', self, enabler_info )
        #self.PlaySound('SND_POT_CRASH')
        self.send_extra_event()
        #BMgr.remove_item_uid(self)
        _linked_items = BMgr.get_items(_linked_uids, self.get('locind'))
        if _linked_items:
            self.PlaySound(self.snd_complete)
        # открываем двери и прочее:
        self.shear_mode = self.GetAttrBool('shear_mode')
        self.shear_r = self.GetAttrInt('shear_r', 0)
        if self.shear_mode:
            self.Drawer.SetTreeMode('default', self.shear_r)
        for _item in _linked_items:
            try:
                _item.do_action_enable()
            except: pass
        self.try_ufo_actions()
# ============================================================
    def on_signal(self, signal):
        if signal == 'offscreen':
            pass
        elif signal == 'onscreen':
            pass
        base_diff_item.DiffItem.on_signal(self, signal)
# ============================================================
    def try_ufo_actions(self):
        _episode = LBoard.Core.episode
        _level = LBoard.Core.level
        _subindex = BMgr.cur_map_index
        if _episode == 2:
            if _level == 6:
                if _subindex == 3:
                    params = {
                                '75': ['SND_ALIEN_TOMB_POWER_YELLOW', '', ''],
                                '71': ['SND_ALIEN_TOMB_CONTROL_YELLOW', 'SND_ALIEN_TOMB_POWER_YELLOW', ''],
                                '76': ['SND_ALIEN_TOMB_POWER_RED', '', ''],
                                '72': ['SND_ALIEN_TOMB_CONTROL_RED', 'SND_ALIEN_TOMB_POWER_RED', ''],
                                '74': ['SND_ALIEN_TOMB_POWER_BLUE', '', ''],
                                '69': ['SND_ALIEN_TOMB_CONTROL_BLUE', 'SND_ALIEN_TOMB_POWER_BLUE', ''],
                                '77': ['', 'SND_ALIEN_TOMB_CONTROL', 'SND_ALIEN_TOMB_SCEPTER']
                             }
                    if self.action_done:
                        _uid = self.get('uid')
                        if _uid in params:
                            _p = params[_uid]
                            _has_start_snd = len(_p[0]) > 0
                            _has_start_single_snd = len(_p[2]) > 0
                            _has_stop_snd = len(_p[1]) > 0
                            if _has_stop_snd:
                                TMgr.gameHelper.StopSoundCountedSafe('enabler', _p[1], False)
                            if _has_start_snd:
                                TMgr.gameHelper.PlaySoundCountedSafe('enabler', _p[0])
                            if _has_start_single_snd:
                                tools.PlaySound(_p[2])
                            if _uid in ['69', '71', '72']:
                                self.try_all_ufo_complete()
# ============================================================
    def try_all_ufo_complete(self):
        _items = []
        for uid in ['69', '71', '72']:
            _item = BMgr.get_item(uid, BMgr.cur_map_index)
            if not _item:
                return
            _items.append(_item)
        for item in _items:
            if not item.action_done:
                return
        # all items are switched on
        #for snd_id in ['SND_ALIEN_TOMB_CONTROL_YELLOW', 'SND_ALIEN_TOMB_CONTROL_RED', 'SND_ALIEN_TOMB_CONTROL_BLUE']:
        #    TMgr.gameHelper.StopSoundCountedSafe('enabler', snd_id, False)
        TMgr.gameHelper.PlaySoundCountedSafe('enabler', 'SND_ALIEN_TOMB_CONTROL')
# ============================================================
    def get_subtask(self, parent_task, actor):
        if self.action_done and not self.is_infinite:
            return None
        if self.key_need:
            _has_key = self.has_key()
            if _has_key:
                return base_diff_item.OpenKeySubtask(parent_task, actor)
            else: return None
        else:
            return EnablerSubtask(parent_task, actor)
# ============================================================
    def play_hit_sound(self):
        self.PlaySound(self.snd_hit)
# ============================================================
    # #@override
    #def get_action_text(self, for_task_slide = False):
    #    return 'DLG_TASK_BREAK_POT'
# ============================================================
    #@override
    def _do_action(self, name):
        if name == 'default':
            self.do_default_action()
            return True
        return False
# ============================================================
# #######################################################
# #######################################################
# #######################################################
