# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_classes


class HackGateSubtask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'HackGateSubtask'
        self.actor_action_animation = 'hit'

    def start_action(self, item):
        item.FSM.HandleEvent('start_event', True)
        #item.stop_attention_signal()        # не показываем эффект когда закапываем
        self.actor.stop_walk()
        self.actor.action_hit_item(item)
        return True
# ============================================================
# ============================================================
class Gate(base_diff_item.DiffItem):
    '''Ворота какие-то'''

    variants_switch = {
        'b_1': 'broken_1',
        'b_2': 'broken_2',
        'b_3': 'broken_3',
        'b_4': 'broken_4'
    }

    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.ser_name = 'Gate'
        self.task = None
        self.need_attention_effect = False
        self.snd_complete = self.GetAttrStr('snd_complete', 'SND_CELL_CRASH')
        self.snd_hit = self.GetAttrStr('snd_hit', 'SND_CELL_HIT')
# ============================================================
    # @override
    def on_action_hits_me_complete(self):
        _cur_variant = self.get('variant_name')
        if _cur_variant not in self.variants_switch: return
        _next_variant = self.variants_switch[_cur_variant]
        #self.action_hits_last = self.GetAttrInt('action_hits_count')
        self.switch_variant( _next_variant )
        self.action_hits_last = 0
        #self.task.subtask.actor.resource = self.give_resource()
        EMgr.send_event( 'do_action_complete', self )
        self.PlaySound(self.snd_complete)
        self.send_extra_event()
        BMgr.remove_item_uid(self)
# ============================================================
    def get_subtask(self, parent_task, actor):
        if self.key_need:
            _has_key = self.has_key()
            if _has_key:
                return base_diff_item.OpenKeySubtask(parent_task, actor)
            else: return None
        return HackGateSubtask(parent_task, actor)
# ============================================================
    #@override
    def get_action_text(self, for_task_slide = False):
        return 'DLG_TASK_HACK'
# ============================================================
    def give_resource(self):
        '''Вызывается в момент, когда юнит разрушает сталактит и забирает его в виде ресурса'''
        return None
# ============================================================
    def play_hit_sound(self):
        self.PlaySound(self.snd_hit)
# ============================================================
# #######################################################
# #######################################################
# #######################################################
