# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_classes
import toolz


class TakeGoldSubtask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'TakeGoldSubtask'
        self.actor_action_animation = 'pickup'
# ============================================================
    def start_action(self, item):
        item.FSM.HandleEvent('start_event', True)
        self.actor.stop_walk()
        self.actor.action_hit_item(item)     # генерал сам доломает горшок, BUG: возможен, если отмена произойдет в момент ломания
        return True
        #self.actor.stop_walk()
        #item.remove_me()
        #self.on_action_complete()
        #return True
# ============================================================
# ============================================================
class Gold(base_diff_item.DiffItem):
    '''Золото'''
    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.ser_name = 'Gold'
        self.task = None
        self.show_born_effect()
# ============================================================
    def remove_me(self):
        ''' Удаляет золото с поля, считаем его "взятым" '''
        #UStats.AddRes(self.GetRes('gives'))
        self.PlaySound('SND_ITEM_PICKUP')
        self.start_comet()
        BMgr.RemoveItemFromMap(self, True)
# ============================================================
    # @override
    def on_action_hits_me_complete(self):
        self.remove_me()
# ============================================================
    def get_subtask(self, parent_task, actor):
        return TakeGoldSubtask(parent_task, actor)
# ============================================================
    # @override
    def on_create(self):
        base_diff_item.DiffItem.on_create(self)
        self.add_attention_signal()
# ============================================================
    #@override
    def on_signal(self, signal):
        if signal == 'comet_fly_complete':
            res_gives = self.GetRes('gives')
            self.append_letter_resource(res_gives, 'MSG_GOLD')
            UStats.AddRes(res_gives)
            self.PlaySoundG('SND_ITEM_GOLD')
            BMgr.RemoveItemFromArray(self)
        else:
            base_diff_item.DiffItem.on_signal(self, signal)
# ============================================================
    def play_content_sound(self, generator):
        generator.PlaySound('SND_DROP_GOLD')
# ============================================================
# #######################################################
# #######################################################
# #######################################################
