# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_classes


class HackGraniteSubtask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'HackGraniteSubtask'
        self.actor_action_animation = 'action_kirk'

    def start_action(self, item):
        item.FSM.HandleEvent('start_event', True)
        self.actor.stop_walk()
        self.actor.action_hit_item(item)
        return True
# ============================================================
# ============================================================
class Granite(base_diff_item.DiffItem):
    '''Гранит'''

    variants_switch = {
        'normal_100': 'normal_90',
        'normal_90': 'normal_80',
        'normal_80': 'normal_70',
        'normal_70': 'normal_60',
        'normal_60': 'normal_50',
        'normal_50': 'normal_40',
        'normal_40': 'normal_30',
        'normal_30': 'normal_20',
        'normal_20': 'normal_10',
        'normal_10': 'normal_none'
    }

    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.ser_name = 'Granite'
        self.task = None
        self.need_attention_effect = False
# ============================================================
    # @override
    def on_action_hits_me_complete(self):
        _cur_variant = self.get('variant_name')
        if _cur_variant not in self.variants_switch: return
        _next_variant = self.variants_switch[_cur_variant]
        #self.action_hits_last = self.GetAttrInt('action_hits_count')
        self.switch_variant( _next_variant )
        self.task.subtask.actor.resource = self.give_resource()
        self.PlaySound('SND_ROCKS_FALL')
        if _next_variant == 'normal_none':
            self.send_extra_event()
            self.deactivate()       # больше объект не должен быть активным
        EMgr.send_event( 'do_action_complete', self )
# ============================================================
    def get_subtask(self, parent_task, actor):
        return HackGraniteSubtask(parent_task, actor)
# ============================================================
    #@override
    def is_action_complete(self):
        '''Действие [юнитом] над данным объектом уже было выполнено'''
        _state = self.FSM.GetStateID()
        return (_state == 'complete')
# ============================================================
    def action_hit_anim_complete(self):
        _state = self.FSM.GetStateID()
        if _state == 'complete':
            self.FSM.HandleEvent('regenerate_event')
# ============================================================
    #@override
    def get_action_text(self, for_task_slide = False):
        return 'DLG_TASK_HACK'
# ============================================================
    def Is_tree_normal(self):
        '''Название верное, просто для совместимости осталось'''
        #return (self.action_hits_last > 0 and not self.task)
        return (not self.is_action_complete() and not self.task)
# ============================================================
    #@override
    def Force_highlight(self, highlight):
        if self.get('variant_name') != 'normal_none':     # если это не пенек
            self.Drawer.HighlightImages('default', highlight)
        else:
            self.Drawer.HighlightImages('default', False)
# ============================================================
    def Force_colorize(self, color, highlight):
        '''color - without alpha part, only RGB. Alpha always 0xFF'''
        _is_complete = self.get('variant_name') == 'normal_none'
        if not highlight or _is_complete:
            self.Drawer.ColorizeImages(self.hlight_layers, 0xffffff, False)
        else:
            self.Drawer.ColorizeImages(self.hlight_layers, color, False)
# ============================================================
    def give_resource(self):
        '''Вызывается в момент, когда юнит забирает ресурс у куста. Скрывает картинку ягод и начинает новую цепочку производства'''
        self.stop_attention_signal()
        _gives = self.GetRes("gives")
        return _gives
# ============================================================
    def play_hit_sound(self):
        self.PlaySound('SND_STONE_HIT')
# ============================================================
# #######################################################
# #######################################################
# #######################################################
