# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_classes


class HackIndHouseSubtask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'HackIndHouseSubtask'
        self.actor_action_animation = 'build'

    def start_action(self, item):
        item.FSM.HandleEvent('start_event', True)
        #item.stop_attention_signal()        # не показываем эффект когда закапываем
        self.actor.stop_walk()
        self.actor.action_hit_item(item)
        return True
# ============================================================
# ============================================================
class IndHouseBreakable(base_diff_item.DiffItem):
    '''Разрушаемый индейский домик'''

    variants_switch = {
        'b_1': 'broken_1',
        'b_2': 'broken_2',
        'b_3': 'broken_3',
        'b_4': 'broken_4'
    }

    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.ser_name = 'IndHouseBreakable'
        self.task = None
        self.need_attention_effect = False
# ============================================================
    # @override
    def on_action_hits_me_complete(self):
        _cur_variant = self.get('variant_name')
        if _cur_variant not in self.variants_switch: return
        _next_variant = self.variants_switch[_cur_variant]
        #self.action_hits_last = self.GetAttrInt('action_hits_count')
        self.switch_variant( _next_variant )
        self.action_hits_last = 0
        #self.task.subtask.actor.resource = self.give_resource()
        EMgr.send_event( 'do_action_complete', self )
        self.PlaySound('SND_STALACTITE_CRASH')
        self.send_extra_event()
        BMgr.remove_item_uid(self)
# ============================================================
    def get_subtask(self, parent_task, actor):
        return HackIndHouseSubtask(parent_task, actor)
# ============================================================
    #@override
    def get_action_text(self, for_task_slide = False):
        return 'DLG_TASK_HACK'
# ============================================================
    def give_resource(self):
        '''Вызывается в момент, когда юнит разрушает сталактит и забирает его в виде ресурса'''
        return None
# ============================================================
    def play_hit_sound(self):
        self.PlaySound('SND_STALACTITE_HIT')
# ============================================================
    def switch_animation(self):
        base_diff_item.DiffItem.switch_animation(self)
        _fsm_state = self.FSM.GetStateID()
        self.Drawer.ShowImages('repair', (_fsm_state == 'interacting'))
# ============================================================
# #######################################################
# #######################################################
# #######################################################
