# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_walkg
import task_classes
# ============================================================
# ============================================================
# ============================================================
class TakeInventorySubtask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'TakeInventorySubtask'
        self.actor_action_animation = 'pickup'    # просто для проверки
# ============================================================
    # @override
    def start_action(self, item):
        item.FSM.HandleEvent('start_event', True)
        self.actor.stop_walk()
        self.actor.action_hit_item(item)
        return True
# ============================================================
# ============================================================
# ============================================================
class Inventory(base_diff_item.DiffItem):
    '''Объект инвентаря'''
    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.ser_name = 'Inventory'
        self.task = None
# ============================================================
    def remove_me(self):
        ''' Удаляет тестовый объект с поля, считаем его "взятым" '''
        self.PlaySound('SND_ITEM_PICKUP')
        self.start_comet()
        self.send_extra_event()
        BMgr.RemoveItemFromMap(self, True)
# ============================================================
    def get_subtask(self, parent_task, actor):
        return TakeInventorySubtask(parent_task, actor)
        #return BreakTestSubtask(parent_task, actor)
# ============================================================
    def on_action_hits_me_complete(self):
        _name = self.get('name')
        if _name == 'crystal':  # специальная затычка для кристаллов
            self.PlaySoundG('SND_UFO_OFF')
            tools.StopSoundCycled('SND_UFO_AMBIENCE')
            UStats.AddLevelValue('UFO_CRYSTAL_TAKEN', 1)    # чтобы не включать звук в последствии
        self.remove_me()
# ============================================================
    # @override
    def on_create(self):
        base_diff_item.DiffItem.on_create(self)
        self.add_attention_signal()
# ============================================================
    #@override
    def on_signal(self, signal):
        if signal == 'comet_fly_complete':
            inventory_item = {'name':self.get('name'),
                          'image':self.GetAttrStr('inventory_image'),
                          'frame':str(self.GetAttrInt('inventory_frame'))}
            UStats.Inventory.AddQuestItem(inventory_item)
            item_info = {'type':self.get('type'), 'subtype':self.get('subtype')}

            self.PlaySoundG('SND_ITEM_BAG')

            EMgr.send_event( 'do_action_complete', self, item_info )
            BMgr.RemoveItemFromArray(self)
        else:
            base_diff_item.DiffItem.on_signal(self, signal)
# ============================================================
    def _get_tips_extra(self, place, result, by_click):
        if place == 'before_res':
            if self.is_deactivated:
                result.append( ('text', 'COLOR_HEADER') )
                result.append( ('text', 'NOT_NEED_YET') )
                return False
            if self._is_inventory_maximum():
                result.append( ('text', 'COLOR_LINES') )
                result.append( ('text', 'NOT_NEED_YET') )
                return False
        return True
# ============================================================
    def play_content_sound(self, generator):
        self.PlaySound('SND_ARTEFACT_DROP')
# ============================================================
    def _is_inventory_maximum(self):
        '''Здесь нужно проверять - есть ли еще места в сумке'''
        #_name = self.get('name')
        #if _name:
        #    _has_inventory_item = UStats.Inventory.HasQuestItem(_name)
        #    if _has_inventory_item:
        #        return False
        #_count = UStats.Inventory.GetQuestItemsCount()
        #if _count >= 4:
        #    return True
        return False
# ============================================================
    #@override
    def is_extra_check_allow(self):
        '''For overriding'''
        #_inventory_maximum = self._is_inventory_maximum()
        #if _inventory_maximum:
        #    return False
        return True
# ============================================================
# #######################################################
# #######################################################
