# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_classes


class ItemChangerSubtask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'ItemChangerSubtask'
        self.actor_action_animation = 'pickup'

    def start_action(self, item):
        item.FSM.HandleEvent('start_event', True)
        self.actor.stop_walk()
        item.set_unit_direction(self.actor)
        self.actor.action_hit_item(item)     # генерал сам доломает горшок, BUG: возможен, если отмена произойдет в момент ломания
        return True
# ============================================================
# ============================================================
# ============================================================
class ItemChanger(base_diff_item.DiffItem):
    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.ser_name = 'ItemChanger'
        self.task = None
# ============================================================
    def on_create(self):
        base_diff_item.DiffItem.on_create(self)
# ============================================================
    #def switch_animation(self):
    #    self.Drawer.ShowImages('', False)
    #    self.Drawer.ShowImages('default')
# ============================================================
    # @override
    def on_action_hits_me_complete(self):
        _need_item = self.GetAttrStr('item_need_name')
        _to_item = self.GetAttrStr('item_change_to')
        new_inventory_item = {'name':_to_item,
                  'image':BMgr.GetTemplateAttr(_to_item, 'inventory_image'),
                  'frame':str(BMgr.GetTemplateAttr(_to_item, 'inventory_frame'))
                  }
        UStats.Inventory.ChangeQuestItem(_need_item, new_inventory_item)
        # ---
        EMgr.send_event( 'do_action_complete', self )
        self.send_extra_event()
        #BMgr.remove_item_uid(self)
        _snd_complete = self.GetAttrStr('snd_complete')
        if _snd_complete:
            self.PlaySoundG(_snd_complete)
        _next_variant = self.GetAttrStr('next_variant')
        if _next_variant:
            self.switch_variant(_next_variant)
        #self.start_cooldown()
        self.action_hits_last = 0
# ============================================================
    def play_hit_sound(self):
        self.PlaySound(self.GetAttrStr('snd_hit', 'SND_NONE'))
# ============================================================
    def get_subtask(self, parent_task, actor):
        if not self.is_action_complete():
            if self.is_active():
                return ItemChangerSubtask(parent_task, actor)
        return None
# ============================================================
    def is_active(self):
        _has_item = self._has_item()
        if not _has_item:
            return False
        return base_diff_item.DiffItem.is_active(self)
# ============================================================
    def _get_tips_extra(self, place, result, by_click):
        if by_click:
            if place == 'before_name':
                _is_action_complete = self.is_action_complete()
                if _is_action_complete:
                    result.append( ('text', 'COLOR_LINES') )
                    result.append( ('text', 'NOT_NEED_MORE') )
                    return False
                _has_item = self._has_item()
                if not _has_item or self.is_deactivated:
                    result.append( ('text', 'COLOR_LINES') )
                    result.append( ('text', 'NOT_NEED_YET') )
                    return False
        return True
# ============================================================
    def _has_item(self):
        '''Нет необходимого для преобразования объекта'''
        _item_need_name = self.GetAttrStr('item_need_name')
        _has_item = UStats.Inventory.HasQuestItem(_item_need_name)
        return _has_item
# ============================================================
# #######################################################
# #######################################################
# #######################################################
