# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_walkg
import task_classes
# ============================================================
# ============================================================
# ============================================================
class TakeKeySubtask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'TakeKeySubtask'
        self.actor_action_animation = 'pickup'    # просто для проверки
# ============================================================
    # @override
    def start_action(self, item):
        item.FSM.HandleEvent('start_event', True)
        self.actor.stop_walk()
        self.actor.action_hit_item(item)
        return True
# ============================================================
# ============================================================
# ============================================================
class Key(base_diff_item.DiffItem):
    '''Объект инвентаря'''
    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.ser_name = 'Key'
        self.task = None
        self.show_born_effect()
        self.PlaySoundG('SND_FINAL_KEY')
# ============================================================
    def remove_me(self):
        ''' Удаляет объект с поля, считаем его "взятым" '''
        #self.start_comet()
        self.PlaySound('SND_ITEM_PICKUP')
        self.start_comet()
        BMgr.RemoveItemFromMap(self, True)
        #dlg.Open('KeyMenu', 'dlg_key', {'single_mode':'1'})
        #self.send_extra_event()
        #EMgr.send_event('game_win', None)   # игру можно завершать
        #BMgr.RemoveItemFromMap(self)    #, True)
# ============================================================
    def get_subtask(self, parent_task, actor):
        return TakeKeySubtask(parent_task, actor)
        #return BreakTestSubtask(parent_task, actor)
# ============================================================
    def on_action_hits_me_complete(self):
        #inventory_item = {'name':self.get('name'),
        #                  'image':self.GetAttrStr('inventory_image'),
        #                  'frame':str(self.GetAttrInt('inventory_frame'))}
        #UStats.Inventory.AddQuestItem(inventory_item)
        #item_info = {"type":self.get('type'), "subtype":self.get('subtype')}
        self.remove_me()
        #EMgr.send_event( 'do_action_complete', self, item_info )
# ============================================================
    # @override
    def on_create(self):
        base_diff_item.DiffItem.on_create(self)
        self.add_attention_signal()
# ============================================================
    #@override
    def on_signal(self, signal):
        if signal == 'comet_fly_complete':
            tools.PlaySound('SND_ARTEFACT_ITEM')
            dlg.Open('KeyMenu', 'dlg_key', {'single_mode':'1', 'is_final':'1',
                                             'episode':str(LBoard.episode),
                                             'level':str(LBoard.level)})
            self.send_extra_event()
            EMgr.send_event('game_win', None)   # игру можно завершать
            BMgr.RemoveItemFromMap(self)    #, True)
        #    inventory_item = {'name':self.get('name'),
        #                  'image':self.GetAttrStr('inventory_image'),
        #                  'frame':str(self.GetAttrInt('inventory_frame'))}
        #    UStats.Inventory.AddQuestItem(inventory_item)
        #    item_info = {"type":self.get('type'), "subtype":self.get('subtype')}
        #    EMgr.send_event( 'do_action_complete', self, item_info )
        #    BMgr.RemoveItemFromArray(self)
        base_diff_item.DiffItem.on_signal(self, signal)
# ============================================================
# #######################################################
# #######################################################
