# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_classes
import toolz


class TakeLetterSubtask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'TakeLetterSubtask'
        self.actor_action_animation = 'pickup'
# ============================================================
    def start_action(self, item):
        item.FSM.HandleEvent('start_event', True)
        self.actor.stop_walk()
        self.actor.action_hit_item(item)     # генерал сам доломает горшок, BUG: возможен, если отмена произойдет в момент ломания
        return True
        #self.actor.stop_walk()
        #item.remove_me()
        #self.on_action_complete()
        #return True
# ============================================================
# ============================================================
class Letter(base_diff_item.DiffItem):
    '''Письмо-секрет'''
    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.ser_name = 'Letter'
        self.task = None
        self.actor = None
        self.is_combination = self.GetAttrBool('is_combination')
# ============================================================
    def remove_me(self):
        ''' Удаляет ресурс с поля, считаем его "взятым" '''
        self.PlaySound('SND_ITEM_PICKUP')
        self.start_comet()
        BMgr.RemoveItemFromMap(self)
        EMgr.SendGlobalMsg('letter_taken')
# ============================================================
    # @override
    def on_action_hits_me_complete(self):
        self.send_extra_event()
        self.remove_me()
# ============================================================
    def get_subtask(self, parent_task, actor):
        self.actor = actor  # сохраним для случая с камнями - нужно иметь доступ к генералу
        return TakeLetterSubtask(parent_task, actor)
# ============================================================
    # @override
    def on_create(self):
        base_diff_item.DiffItem.on_create(self)
# ============================================================
    #@override
    def on_signal(self, signal):
            base_diff_item.DiffItem.on_signal(self, signal)
# ============================================================
    def show_secret_dialog(self):
        _secret_desc = self.GetAttrStr('secret_desc')
        _secret_name = self.GetAttrStr('secret_name')
        self.PlaySoundG('SND_SECRET_FOUND')
        Camera.MoveTo(self)
        dlg.Open('SecretLetterMenu', 'dlg_secret', {'single_mode':'1', 'text':_secret_desc, 'name':_secret_name, 'pause':str(400)})
        if self.is_combination:
            EMgr.AppendLetter([('text', 'FOUND_COMBINATION')], True, _secret_name, _secret_desc)
        #dlg.Open('SecretLetterMenu', 'dlg_secret', {'text':_secret_desc, 'name':_secret_name, 'showin_effect':'secret_letter_fly_in', 'pause':str(400)})
# #######################################################
# #######################################################
# #######################################################
