# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item

class RandomRes(base_diff_item.DiffItem):
    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.ser_name = 'RandomRes'
        self.time_gen_min = self.GetAttrInt('time_gen_min')
        self.time_gen_max = self.GetAttrInt('time_gen_max')
        self.template = self.GetAttrStr('template')
        self.is_offscreen = False
        self.rgen_uid = ''
        self.Drawer.ShowImages('', False)
# ============================================================
    # @override
    def switch_animation(self):
        pass
# ============================================================
    def on_signal(self, signal):
        if signal == 'generate_res':
            self.generate_res(self)
        elif signal == 'offscreen':
            if self.is_offscreen: return    # чтобы не дублировать
            self.is_offscreen = True
            self.start_generation()
        elif signal == 'onscreen':
            self.is_offscreen = False
            self.Signals.Cancel('generate_res')
        else:
            base_diff_item.DiffItem.on_signal(self, signal)
# ============================================================
    def start_generation(self):
        _is_cell_free = self.is_cell_free()
        if _is_cell_free:
            time = tools.Rand(self.time_gen_min, self.time_gen_max)
            self.Signals.Restart('generate_res', time)
# ============================================================
    def generate_res(self):
        _is_cell_free = self.is_cell_free()
        if _is_cell_free:
            if self.is_offscreen:   # генерация только за экраном
                parts = self.template.split(':')
                parts_len = len(parts)
                if parts_len > 1:
                    cell_pos = self.get('cell')
                    items = self.publish_contents([parts], cell_pos)
                    if items:
                        self.rgen_uid = items[0].get('uid') # на всякий случай сохраним UID
# ============================================================
    def is_cell_free(self):
        cell = self.get('cell')
        return self.IsCellFree( cell )
# ============================================================
# #######################################################
# #######################################################
# #######################################################
