# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_classes


class HackStalactiteSubtask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'HackStalactiteSubtask'
        self.actor_action_animation = 'hit'

    def start_action(self, item):
        item.FSM.HandleEvent('start_event', True)
        #item.stop_attention_signal()        # не показываем эффект когда закапываем
        self.actor.stop_walk()
        self.actor.action_hit_item(item)
        return True
# ============================================================
# ============================================================
class Stalactite(base_diff_item.DiffItem):
    '''Сталактит'''

    variants_switch = {
        'b_1': 'broken_1',
        'b_2': 'broken_2',
        'b_3': 'broken_3',
        'b_4': 'broken_4',
        'b_5': 'broken_5',
        'b_6': 'broken_6',
        'b_7': 'broken_7',
        'b_8': 'broken_8',
        'b_9': 'broken_9',
        'b_10': 'broken_10',
    }

    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.ser_name = 'Stalactite'
        self.task = None
        self.need_attention_effect = False
        self.snd_complete = self.GetAttrStr('snd_complete', 'SND_STALACTITE_CRASH')
        self.snd_hit = self.GetAttrStr('snd_hit', 'SND_STALACTITE_HIT')
# ============================================================
    # @override
    def on_action_hits_me_complete(self):
        _cur_variant = self.get('variant_name')
        if _cur_variant not in self.variants_switch: return
        _next_variant = self.variants_switch[_cur_variant]
        #self.action_hits_last = self.GetAttrInt('action_hits_count')
        self.switch_variant( _next_variant )
        self.action_hits_last = 0
        #self.task.subtask.actor.resource = self.give_resource()
        EMgr.send_event( 'do_action_complete', self )
        EMgr.send_event( 'stalactite_destroyed', self )
        self.PlaySound(self.snd_complete)
        self.send_extra_event()
        BMgr.remove_item_uid(self)
# ============================================================
    def get_subtask(self, parent_task, actor):
        return HackStalactiteSubtask(parent_task, actor)
# ============================================================
    #@override
    def get_action_text(self, for_task_slide = False):
        return 'DLG_TASK_HACK'
# ============================================================
    def give_resource(self):
        '''Вызывается в момент, когда юнит разрушает сталактит и забирает его в виде ресурса'''
        self.stop_attention_signal()
        #self.switch_animation()
        _gives = self.GetRes("gives")
        if not _gives or _gives.Empty():     # если ресурс не задан, то здесь делать нечего
            return None
        return _gives
# ============================================================
    def play_hit_sound(self):
        self.PlaySound(self.snd_hit)
# ============================================================
    #@override
    def scale_bump(self):
        _pos = self.GetAttrPoint('center_item_pos')
        self.Drawer.ScaleBump(self.bump_layers, _pos, 200, 1.10)
# ============================================================
# #######################################################
# #######################################################
# #######################################################
