# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
#import task_classes


# ============================================================
class StoneGate(base_diff_item.DiffItem):
    '''Ворота каменные'''

    def __init__(self, cdata):
        self._shade_layers = self.item_layers[:]
        self._shade_layers.append('anim_gate')
        base_diff_item.DiffItem.__init__(self, cdata)
        self.ser_name = 'StoneGate'
        self.task = None
        self.need_attention_effect = False
        self.animation_started = False
        self.snd_complete = self.GetAttrStr('snd_complete', 'SND_STONEDOOR_OPEN')
# ============================================================
    def shade_me(self, shaded):
        self.Drawer.SetShaded(self._shade_layers, shaded)
# ============================================================
    def give_resource(self):
        '''Вызывается в момент, когда юнит разрушает сталактит и забирает его в виде ресурса'''
        return None
# ============================================================
    def do_action_enable(self):
        if not self.action_enable_complete:
            self.action_enable_complete = True
            self.Signals.Restart('camera_move_complete', 450)   # камера движется 400 ms, 50 - просто подождем
            _move_camera_to_self = self.GetAttrBool('move_camera_to_self')
            if _move_camera_to_self:
                LBoard.MoveCameraToUID(self.get('uid'), True)     # перемещаем камеру на себя, True - блокировка движения камеры пользователем в этот момент
            #self.switch_variant('enabled')
# ============================================================
    def on_message(self, msg_type, msg_param1, msg_param2, msg_dict):
        if msg_type == 'anim_complete':
            self.switch_variant('enabled')
            self.animation_started = False
            self.show_born_effect()
            self.switch_animation()
# ============================================================
    def on_signal(self, signal):
        if signal == 'camera_move_complete':
            self.animation_started = True
            self.switch_animation()
            self.PlaySound(self.snd_complete)
            self.Drawer.PlayAnimationOnce('anim_gate', 'anim_complete')
        else:
            base_diff_item.DiffItem.on_signal(self, signal)
# ============================================================
    def _switch_animation_extra(self, place):
        if place == 'end':
            if self.animation_started:
                self.Drawer.ShowImages('anim_gate')
                self.Drawer.ShowImages('default', False)
# ============================================================
    #@override
    def _do_action(self, name):
        if name in ['default', 'enable']:
            self.do_action_enable()
            return True
        return False
# #######################################################
# #######################################################
# #######################################################
