# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_walkg
import task_classes


# ============================================================
class BreakTestSubtask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'BreakTestSubtask'
        self.actor_action_animation = 'run_fish'    # просто для проверки

    # @override
    def start_action(self, item):
        item.FSM.HandleEvent('start_event', True)
        self.actor.stop_walk()
        self.actor.action_hit_item(item)
        return True
# ============================================================


class TakeTestSubtask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'TakeTestSubtask'
        self.actor_action_animation = 'pickup'    # просто для проверки

    # @override
    def start_action(self, item):
        item.FSM.HandleEvent('start_event', True)
        self.actor.stop_walk()
        self.actor.action_hit_item(item)
        return True
# ============================================================


class Test(base_diff_item.DiffItem):
    '''Тестовый объект'''
    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.ser_name = 'Test'
        self.task = None

    def get_subtask(self, parent_task, actor):
        return TakeTestSubtask(parent_task, actor)
        #return BreakTestSubtask(parent_task, actor)

    def on_action_hits_me_complete(self):
        inventory_item = {'name':self.get('name'),
                          'image':self.GetAttrStr('inventory_image'),
                          'frame':str(self.GetAttrInt('inventory_frame'))}
        UStats.Inventory.AddQuestItem(inventory_item)
        item_info = {"type":self.get('type'), "subtype":self.get('subtype')}
        self.remove_me_later()
        EMgr.send_event( 'do_action_complete', self, item_info )
        #self.switch_variant( self.GetAttrStr('next_variant') )
        #item_info = {"type":self.get('type'), "subtype":self.get('subtype')}
        #EMgr.send_event( 'do_action_complete', self, item_info )

# #######################################################
# #######################################################
# #######################################################
