# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_classes


class TakeUResSubtask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'TakeUResSubtask'
        self.actor_action_animation = 'gather'
        self.actor = actor
# ============================================================
    def start_action(self, item):
        item.FSM.HandleEvent('start_event', True)
        item.actor = self.actor
        self.actor.stop_walk()
        item.on_action_hits_me_complete()
        self.on_action_complete()
        return True
# ============================================================
# ============================================================
class UnitResource(base_diff_item.DiffItem):
    '''Ресурс, который может подобрать генерал'''
    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.ser_name = 'UnitResource'
        self.task = None
        self.actor = None
        #_name = self.GetSingleResName('gives')
        self.show_born_effect()
# ============================================================
    #id_map = {'silver':'MSG_SILVER', 'food':'MSG_FOOD', 'boards':'MSG_WOOD'}
    def remove_me(self):
        ''' Удаляет ресурс с поля'''
        self.PlaySound('SND_ITEM_PICKUP')
        EMgr.send_event('unit_res_taken', self, {'uid':self.get('uid')})
        #_gives_res = self.GetRes('gives')
        #_res_name = _gives_res.GetSingleName()
        #_gives_res = self.GetRes('gives')
        #_rname = _gives_res.GetSingleName()
        #if _rname in self.id_map:
        #    _id = self.id_map[_rname]
        #    self.append_letter_resource(_gives_res, _id)
        #UStats.AddRes(_gives_res)
        BMgr.RemoveItemFromMap(self)#, True)
# ============================================================
    # @override
    def on_action_hits_me_complete(self):
        self.actor.resource = self.completeGivesRes
        self.remove_me()
# ============================================================
    def get_subtask(self, parent_task, actor):
        return TakeUResSubtask(parent_task, actor)
# ============================================================
    #@override
    def _get_gives(self, result):
        '''Возвращает текст для части типса GIVES'''
        base_diff_item.DiffItem._get_gives(self, result)
# ============================================================
    # @override
    def on_create(self):
        base_diff_item.DiffItem.on_create(self)
        self.add_attention_signal()
# ============================================================
    #@override
    def on_signal(self, signal):
        base_diff_item.DiffItem.on_signal(self, signal)
# ============================================================
    #@override
#    def _get_gives(self, result):
#        '''Возвращает текст для части типса GIVES'''
#        _gives = self.completeGivesRes
#        if _gives:
#            if not _gives.Empty():
#                result.append( 'newline' )
#                result.append( ('text', 'COLOR_LINES') )
#                result.append( ('text', 'GIVES') )
#                result.append( 'space' )
#                res_numbers = self._append_res_values(_gives)
#                result.extend( res_numbers )
# #######################################################
# #######################################################
# #######################################################
