# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import toolz


class Dialog(Dialog_class):
# ============================================================
    def __init__(self, cdata, params={}):
        Dialog_class.__init__(self, cdata)
        self.size = 'none'  # 'small', 'big', 'fullscreen'
        self.xml_name = ''
        self.zones = []
        self.showin_effect_name = ''
        self.is_start_paused = False
        if 'pause' in params:
            _pause_ms = int(params['pause'])
            self.Signals.Restart('pause_complete', _pause_ms)
            self.is_start_paused = True
            self.SetVisible(False)
            self.SetHiddenAtStart(True)
        if 'showin_effect' in params:
            self.showin_effect_name = params['showin_effect']
            if self.showin_effect_name:
                #self.AddXmlOverEffect
                if not self.is_start_paused:
                    self.ShowXmlEffect(self.showin_effect_name, {'x':0, 'y':0})
                    self.SetVisible(False)
                    self.SetHiddenAtStart(True)
        # если нужно, то доп. параметры можно вытащить из params
# ============================================================
    def on_msg(self, msg_type, msg_param1='', msg_param2='', msg_dict={}):
        if msg_type == 'state_machine':
            self.on_state_machine(msg_param1, msg_param2, msg_dict)
        elif msg_type == 'signal_msg':
            if msg_param1 in ['pause_complete']:
                self.on_base_signal(msg_param1)
            self.on_signal(msg_param1)
        elif msg_type == 'dlg_command':
            self.on_dlg_command(msg_param1, msg_param2)
        elif msg_type == 'on_key':
            self.on_key(msg_param1)
        elif msg_type == 'on_command':
            self.on_command(msg_param1, msg_param2, msg_dict.param)
        elif msg_type == 'on_button':
            self.on_button(msg_param1)
        elif msg_type == 'on_slider_change':
            self.on_slider_change(msg_param1, int(msg_param2))
        elif msg_type == 'on_edit_clicked':
            self.on_edit_clicked(msg_param1)
        elif msg_type == 'on_checkbox_change':
            self.on_checkbox_change(msg_param1, int(msg_param2))
        elif msg_type == 'on_list_click':
            self.on_list_click(msg_param1, msg_param2, msg_dict.selected_index, msg_dict)
        elif msg_type == 'on_list_dbl_click':
            self.on_list_dbl_click(msg_param1, msg_param2, msg_dict.selected_index, msg_dict)
        elif msg_type == 'on_list_selection_change':
            self.on_list_selection_change(msg_param1, msg_param2, int(msg_dict.selected_index), int(msg_dict.old_index), msg_dict)
        elif msg_type == 'on_effect_complete':
            self.on_effect_complete(msg_param1, msg_param2, msg_dict)
        elif msg_type == 'on_added':
            self.on_added()
        #elif msg_type == 'on_create':
        #    if not self.is_start_paused:
        #        self.on_create()
        elif msg_type == 'on_language_reloaded':
            self.on_language_reloaded()
        else:
            self.on_message(msg_type, msg_param1, msg_param2, msg_dict)
        pass
# ============================================================
    def on_message(self, msg_type, msg_param1, msg_param2, msg_dict):
        pass
# ============================================================
    def on_signal(self, signal):
        pass
# ============================================================
    def on_base_signal(self, signal):
        if signal == 'pause_complete':
            self.is_start_paused = False
            self.on_create()

            if self.showin_effect_name:
                self.ShowXmlEffect(self.showin_effect_name, {'x':0, 'y':0})
            else:
                self.SetVisible(True)
# ============================================================
    def on_language_reloaded(self):
        pass
# ============================================================
    def on_effect_complete(self, name, on_complete, extra):
        action_name = extra.action_name
        if on_complete == 'stop':
            if name == self.showin_effect_name:
                # ЗДЕСЬ НУЖНО ПОКАЗАТЬ САМ ДИАЛОГ!
                self.SetVisible(True)
# ============================================================
    def on_slider_change(self, slider_id, value):
        pass
# ============================================================
    def on_edit_clicked(self, edit_id):
        pass
# ============================================================
    def on_checkbox_change(self, cbox_id, checked):
        pass
# ============================================================
    def on_mouse_move(self, x, y):
        '''Для главного диалога нужно в основном'''
        pass
# ============================================================
    def Get_tip_position(self, cur_pos, tip_size):
        '''Возвращает координаты типса от левого-верхнего угла картинки типса'''
        result = toolz.Tools.get_ui_tip_position(cur_pos, tip_size)
        return result
# ============================================================
    def get_over_item(self, x, y):
        '''Поиск элемента-уровня под курсором'''
        for _item in self.zones:
            if _item.zone:
                _x,_y,_w,_h = _item.zone.x, _item.zone.y, _item.zone.w, _item.zone.h
                if x >= _x:
                    if y >= _y:
                        if x < (_x+_w):
                            if y < (_y+_h):
                                return _item    # курсор над этим элементов
        return None         # курсор не над элементами
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == "enter":
            pass
        elif type == "exit":
            pass
        elif type == "change":
            self.on_state_change(additional.prev_state, additional.next_state)
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_command(self, name, command, param):
        pass
# ============================================================
    def on_button(self, id):
        pass
# ============================================================
    def on_key(self, key):
        pass
# ============================================================
    def on_list_click(self, id, tag, index, extra):
        pass
# ============================================================
    def on_list_dbl_click(self, id, tag, index, extra):
        pass
# ============================================================
    def on_list_selection_change(self, id, new_tag, new_index, old_index, extra):
        pass
# ============================================================
    def on_create_now(self):
        if not self.is_start_paused:
            self.on_create()
# ============================================================
    def on_create(self):
        pass
# ============================================================
    def on_added(self):
        if self.is_start_paused:
            self.SetVisible(False)
        elif self.showin_effect_name: # если есть эффект появления диалога
            self.SetVisible(False)  # то скроем диалог до окончания эффекта
        self.SetFocusSelf()
# ============================================================
    def pre_serialize(self):
        '''Перед сериализацией игры вызывать. Сами диалоги не сериализуются.
           Это хитрая схема для того, чтобы считать диалоги закрытыми на момент сохранения.
           Т.е. мы создаем диалог и закрываем его.'''
        if self.is_start_paused:
            self.on_create()
        self.cancel_dialog()
# ============================================================
    def cancel_dialog(self):
        #DLG.Close_dialog(self)
        pass
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
    def close_me(self):
        #self.ShowFakeBG( False )
        DLG.Close_dialog(self)
# ============================================================
# ============================================================
# ============================================================
# ============================================================
