# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog


class ChestDlg(dialog.Dialog):
    values_controls = ['idGoldNeedV', 'idGoldGatheredV', 'idGemsCountV',\
                        'idSecretsFoundV', 'idSecretsLeftV', 'idSurvivedSavedV']
                        #'idSendGoldV', 'idSurvivedV']
    values_fields = ['gold_need', 'gold', 'total_gems',\
                        'secrets', 'secrets_left', 'survived_found']
                        #'gold_need', 'survived_need']
    st_frame = {'gem_red':'2', 'gem_green':'0', 'gem_blue':'1'}
    eff_name = {'gem_red':'stone_red', 'gem_green':'stone_green', 'gem_blue':'stone_blue'}
    complete_task_eff_pos = [{'x':207, 'y':198},
                            {'x':207, 'y':237},
                            {'x':207, 'y':278}]
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.size = 'big'
        self.stats = {}
        self.need_last_task_effect = False  # заполняется в fill_tasks_info
        self.have_tasks = []
        self.completed_task = ''
        if 'task' in params:
            self.completed_task = params['task']
            self.Signals.Add('task_change', 1000)   # чтобы поменять значок задания
        self.EnableMouseMoveEvents(True)
        self.eff_positions = []
        self.gem_name = ''
        self.close_blocked = True
        # если нужно, то доп. параметры можно вытащить из params
        if 'gem' in params:             # если это показ нового камня
            self.gem_name = params.gem
            self.Signals.Add('gem_effect', 500)
            self.DisableWidget('idOkBtn', True)
        else:
            self.Signals.Add('enable_close', 50)
        self.gems = self.GetTotalGems() # должно возвращать список камней, собранных на данном уровне только!!!
        index = 0
        for _g in self.gems:
            _name = 'idGem' + str(index+1)
            _frame = self.st_frame[_g]
            self.SetImage(_name, 'IMG_I_CHEST_ST,' + _frame)
            index += 1
        pm = DLG.PMgr
        _has_keys = pm.Get_user_setting('has_expert_levels') == 1
        if _has_keys:   # если есть экспертные прохождения
            self.ShowWidget('idKeyBtn', True)
            self.ShowWidget('idKeyBG', True)
        #else:
        #    self.ShiftWidget('idOkBG', 0, 30)
        #    self.ShiftWidget('idOkBtn', 0, 30)
        _prizes = pm.get_cur_user_progress().prizes
        _has_prizes = False
        for p in _prizes:
            if p > 0:
                _has_prizes = True
                break
        if _has_prizes:
            self.ShowWidget('idPrizesBtn', True)
            self.ShowWidget('idPrizesBG', True)
        if _has_prizes != _has_keys:
            # необходимо сдвинуть одну кнопку в центр
            _shift = 90
            if _has_prizes:
                self.ShiftWidget('idPrizesBtn', -_shift, 0)
                self.ShiftWidget('idPrizesBG', -_shift, 0)
            if _has_keys:
                self.ShiftWidget('idKeyBtn', _shift, 0)
                self.ShiftWidget('idKeyBG', _shift, 0)
# ============================================================
    def on_mouse_move(self, x, y):
        _item = self.get_over_item(x,y)
        if _item:
            result = [('text', 'COLOR_HEADER')]
            #result.append( ('debug', _item.type) )
            _text = {'gem_red':'GEM_RED', 'gem_green':'GEM_GREEN', 'gem_blue':'GEM_BLUE'}[_item.type]
            result.append( ('text', _text) )
            result.append( 'newline' )
            result.append( ('text', 'COLOR_LINES') )
            result.append( ('text', _text+'_DESC') )
            self.ShowTips( result, _item.zone.x + 38/2 + 4, _item.zone.y - 36, True )
        else:
            self.HideTips()
# ============================================================
    def on_signal(self, signal):
        if signal == 'gem_effect':
            index = len(self.gems)
            _name = 'idGem' + str(index+1)
            _eff_name = self.eff_name[self.gem_name]
            self.ShowEffect(_eff_name, self.eff_positions[index])
            self.AppendGem(self.gem_name)
            tools.PlaySound('SND_ITEM_LEVELUP')
            _frame = self.st_frame[self.gem_name]
            self.SetImage(_name, 'IMG_I_CHEST_ST,' + _frame)
            self.DisableWidget('idOkBtn', False)
            _r = self.GetWidgetRect(_name)
            _type = self.gem_name
            self.zones.append( {'zone':_r, 'type':_type} )
            self.close_blocked = False
        elif signal == 'enable_close':
            self.close_blocked = False
        elif signal == 'task_change':
            if self.need_last_task_effect:
                self.ShowEffect('stat_explosion_extra', self._get_task_pos(self.completed_task))
                tools.PlaySound('SND_FINAL_TASK')
            else:
                self.ShowEffect('stat_explosion', self._get_task_pos(self.completed_task))
                tools.PlaySound('SND_MAIN_TASK')
            self.completed_task = ''
            self.fill_tasks_info(self.stats)
# ============================================================
    def _get_task_pos(self, task_tag):
        index = 0
        for _tag in self.have_tasks:
            if _tag == task_tag:
                return self.complete_task_eff_pos[index]
            index += 1
        #mbox(str(task_tag))    # сюда доходить не должны
        return {'x':0, 'y':0}
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == 'enter':
            pass
        elif type == 'exit':
            pass
        elif type == 'change':
            self.on_state_change(additional.prev_state, additional.next_state)
        pass
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_command(self, name, command, param):
        if command == 'keycode':
            if param in ['escape', 'enter']:
                if not self.close_blocked:
                    DLG.PauseGame(False)
                    DLG.Close_dialog(self)
            #elif param == 'space':
            #    self.ShowEffect('fog_off', {'x':100, 'y':50})
# ============================================================
    def on_create(self):
        #tools.SetGraphicCursor(False)
        DLG.PauseGame(True)
        tools.PlaySound('SND_CHEST_UI')
        _count = len(self.values_controls)
        stats = self.GetFullStats()
        self.stats = stats
        for i in range(_count):
            _control = self.values_controls[i]
            _field = self.values_fields[i]
            if _field in stats:
                self.SetText( _control, [('digit', stats[_field])] )
            else:
                self.SetText( _control, [('digit', 0)] )

        i = 1
        sx = 496
        sy = 269
        _w = 38
        _h = 36
        dx = 8+_w
        dy = -2+_h
        for r in range(0,4):
            for c in range(0, 6):
                _name = 'idGem' + str(i)
                _x = sx + dx*c
                _y = sy + dy*r
                if self.IsIphone():
                    _x += 69
                self.MoveControl(_name, _x, _y)
                self.eff_positions.append({'x':_x+_w/2, 'y':_y+_h/2})
                i += 1
        self.fill_tasks_info(stats)
        # --- настройка зон для типсов
        i = 0
        _gems_count = len(self.gems)
        for i in range(0, _gems_count):
            _r = self.GetWidgetRect('idGem' + str(i+1))
            _type = self.gems[i]
            self.zones.append( {'zone':_r, 'type':_type} )
# ============================================================
    def fill_tasks_info(self, stats):
        self.need_last_task_effect = True
        self.have_tasks = []
        index = 1
        if 'gold_need' in stats:
            if stats['gold_need'] > 0:
                self.have_tasks.append('GOLD')
                text = []
                #if stats['gold'] >= stats['gold_need']:
                _gold_complete = False
                if 'gold_ship_complete' in stats:
                    if stats.gold_ship_complete > 0:
                        if self.completed_task != 'GOLD':
                            _gold_complete = True
                if _gold_complete:
                    text.append( ['image', 'IMG_MENU_COMICS_STAR,1'] )
                else:
                    text.append( ['image', 'IMG_MENU_COMICS_STAR,0'] )
                    if self.completed_task != 'GOLD':
                        self.need_last_task_effect = False
                #text.append( ['text', 'COLOR_YELLOW2'] )
                text.append( ['text', 'CHEST_DLG_TASK_SEND_GOLD'] )
                self.SetText('idTask'+str(index), text)
                self.SetText('idTaskValue'+str(index), [('digit', stats['gold_need'])])
                index += 1
        # SURVIVED
        if 'survived_total' in stats:
            if stats['survived_total'] > 0:
                self.have_tasks.append('SURVIVED')
                text = []
                _survived_complete = False
                if stats['survived_found'] >= stats['survived_total']:
                    if self.completed_task != 'SURVIVED':
                        _survived_complete = True
                if _survived_complete:
                    text.append( ['image', 'IMG_MENU_COMICS_STAR,1'] )
                else:
                    text.append( ['image', 'IMG_MENU_COMICS_STAR,0'] )
                    if self.completed_task != 'SURVIVED':
                        self.need_last_task_effect = False
                text.append( ['text', 'COLOR_YELLOW2'] )
                text.append( ['text', 'CHEST_DLG_TASK_SAVE_SURVIVED'] )
                self.SetText('idTask'+str(index), text)
                self.SetText('idTaskValue'+str(index), [('digit', stats['survived_total'])])
                index += 1
        text = []
        _territory_complete = False
        if 'territory_complete' in stats:
            if stats.territory_complete > 0:
                self.have_tasks.append('TERRITORY')
                if self.completed_task != 'TERRITORY':
                    _territory_complete = True
        if _territory_complete:
            text.append( ['image', 'IMG_MENU_COMICS_STAR,1'] )
        else:
            text.append( ['image', 'IMG_MENU_COMICS_STAR,0'] )
            if self.completed_task != 'TERRITORY':
                self.need_last_task_effect = False
        text.append( ['text', 'COLOR_YELLOW2'] )
        text.append( ['text', 'CHEST_DLG_TASK_TERRITORY'] )
        self.SetText('idTask'+str(index), text)
# ============================================================
    def on_button(self, id):
        if id == 'idOkBtn':
            if not self.close_blocked:
                DLG.PauseGame(False)
                DLG.Close_dialog(self)
        elif id == 'idKeyBtn':
            DLG.Open_dialog('KeyMenu', 'dlg_key', {'episode':str(self.stats.episode_index),
                                                    'level':str(self.stats.level_index)})
        elif id == 'idPrizesBtn':
            DLG.Open_dialog('PrizesMenu', 'dlg_prizes', {})
# ============================================================
    def cancel_dialog(self):
        if self.close_blocked:
            self.AppendGem(self.gem_name)
        DLG.PauseGame(False)
        DLG.Close_dialog(self)
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
# ============================================================
# ============================================================
# ============================================================
