# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog


class ComicsDlg(dialog.Dialog):
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.size = 'fullscreen'
        # если нужно, то доп. параметры можно вытащить из params
        self.params = params
        self.total_time = 3500
        self.current_time = 0
        self.is_loaded = False
        self.is_ready_to_start = False
        self.is_wait_complete = False
        self.already_pressed = False    # было ли нажатие в конце, где оно или клик требуется
# ============================================================
    def on_signal(self, signal):
        pass
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == 'enter':
            pass
        elif type == 'exit':
            pass
        elif type == 'change':
            self.on_state_change(additional.prev_state, additional.next_state)
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_command(self, name, command, param):
        #if command == 'keycode':
        #    if param == 'escape':
        #        DLG.Close_dialog(self)
        if command == 'comics_event':
            if param == 'comics_complete':
                self.on_comics_complete()
            elif param == 'comics_switched':
                text_id = self.GetComicsTextID('idComics')
                self.SetText('idText', [('text', text_id)])
# ============================================================
    def on_create(self):
        tools.PlaySound('SND_WINDOW_WOOD')
        DLG.PMgr.reload_current_user()  # на всякий случай
        if 'center_comics' in self.params and self.params.center_comics:
            self.SetComics('idComics', 'center_01')
        elif self.params.is_start_comics:
            self.SetComics('idComics', 'start_01')
        else:
            self.SetComics('idComics', 'finish_01')
        self.total_time = self.GetComicsTime('idComics')
        text_id = self.GetComicsTextID('idComics')
        self.SetText('idText', [('text', text_id)])
# ============================================================
    def on_comics_complete(self):
        _pmgr = DLG.PMgr
        if 'center_comics' in self.params and self.params.center_comics:
            _pmgr.cur_user_stat.center_comics_shown = True
        elif self.params.is_start_comics:
            _pmgr.cur_user_stat.start_comics_shown = True
        else:
            _pmgr.cur_user_stat.finish_comics_shown = True
        _pmgr.save_current_user()
        if self.params.is_start_comics:
            DLG.Open_dialog('LoadLevelMenu', 'dlg_loadlevel', self.params)
        else:   # final comics
            DLG.Open_dialog('BookMenu', 'dlg_book')
        DLG.Close_dialog(self)
# ============================================================
    def on_button(self, id):
        if id == 'idSkipBtn':
            self.on_comics_complete()
            DLG.Close_dialog(self)
        elif id == 'idNextBtn':
            _has_next_comics = self.HasNextComics('idComics')
            if _has_next_comics:
                self.SwitchToNextComics('idComics')
            else:
                self.on_comics_complete()
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
# ============================================================
# ============================================================
# ============================================================
