# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog


class EditProfileDlg(dialog.Dialog):
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.size = 'small'
        # если нужно, то доп. параметры можно вытащить из params
        self.tag = params.tag
        self.name = params.name
        self.Edit_SetMaxChars('idEdit', 10)
        self.Edit_SetText('idEdit', self.name)
        self.Keyboard_SetText(self.name)
# ============================================================
    def on_signal(self, signal):
        pass
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == 'enter':
            pass
        elif type == 'exit':
            pass
        elif type == 'change':
            self.on_state_change(additional.prev_state, additional.next_state)
        pass
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_command(self, name, command, param):
        if command == 'keycode':
            if param == 'escape':
                DLG.Close_dialog(self)
                DLG.PauseGame(False)
# ============================================================
    def on_create(self):
        tools.SetGraphicCursor(False)
        tools.PlaySound('SND_WINDOW_WOOD')
        DLG.SendMsg('show_keyboard')
# ============================================================
    def on_added(self):
        self.SetFocus('idEdit')

    def on_edit_clicked(self, id):
        DLG.SendMsg('show_keyboard')
# ============================================================
    def on_button(self, id):
        if id == 'idOkBtn':
            # копируем текст из поля ввода клавиатуры в textedit
            #self.Edit_SetText('idEdit', self.Keyboard_GetText())
            # далее стандартная обработка
            _new_name = self.Edit_GetText('idEdit')
            _user_exist = DLG.PMgr.IsUserExist(_new_name)
            if _user_exist:
                if self.name != _new_name:      # если имя другое (иначе можно - то же самое и останется)
                    DLG.Open_dialog('AnotherNameMenu', 'dlg_msg')
                    return
            if not _new_name:   # если пустое имя
                DLG.Close_dialog(self)
                return
            # если с именем все в порядке:
            _profiles = DLG.get_dialog('ProfilesMenu')
            if _profiles:
                _profiles.rename_profile(_new_name)
                _profiles.reload_users_list()
            DLG.Close_dialog(self)
        elif id == 'idCancelBtn':
            #tools.SetGraphicCursor(True)
            DLG.Close_dialog(self)
        # скрываем клавиатуру
        DLG.SendMsg('hide_keyboard')
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
# ============================================================
# ============================================================
# ============================================================
