# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog

class HelpDlg(dialog.Dialog):
    dlg_next = {}
    dlg_prev = {}

    index_to_dlg = {}
    dlg_to_index = {}

    help_info = {
                    0:(0,1,0),
                    1:(1,1,1),
                    2:(0,1,0),
                    3:(0,1,0),
                    4:(1,1,1),
                    5:(1,0,1),
                    6:(0,1,0),
                    7:(1,0,1),
                    8:(1,0,1),
                    9:(1,1,1),
                    10:(0,1,0),
                    11:(0,1,0),
                    12:(0,1,0),
                    13:(1,0,1),
                    14:(1,0,1),
                    15:(0,1,0),
                    16:(1,1,1),
                    17:(0,1,0),
                    18:(0,1,0),     # 19
                    19:(0,1,0),     # 20+
                    20:(1,1,1),     # 21
                    21:(1,1,1)      # 22
                }
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.size = 'fullscreen'
        self.help_number = int(params.help_number) - 1  # -1 because help_number starts from 1
        # --------------------------
        # Filling HelpMenu's arrays:
        # --------------------------
        _count = 22
        for i in range(0, _count+1):
            if i != _count:
                self.dlg_next[i] = i+1
            else:
                self.dlg_next[i] = 0
        for k in self.dlg_next:
            _val = self.dlg_next[k]
            self.dlg_prev[_val] = k
        self.index_to_dlg[0] = 'HelpMenu'
        for i in range(0, _count):
            self.index_to_dlg[i+1] = 'HelpMenu_' + str(i)
        for k in self.index_to_dlg:
            _val = self.index_to_dlg[k]
            self.dlg_to_index[_val] = k
        # --------------------------
        # если нужно, то доп. параметры можно вытащить из params
# ============================================================
    def on_signal(self, signal):
        pass
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == 'enter':
            pass
        elif type == 'exit':
            pass
        elif type == 'change':
            self.on_state_change(additional.prev_state, additional.next_state)
        pass
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_command(self, name, command, param):
        #if command == 'mouse_up':
        #    DLG.PauseGame(False)
        #    DLG.StartUnfade()
        #    DLG.Close_dialog(self)
        if command == 'keycode':
            if param in ['space', 'enter', 'escape']:
                DLG.PauseGame(False)
                DLG.StartUnfade()
                DLG.Close_dialog(self)
        pass
# ============================================================
    def on_create(self):
        #tools.PlaySound('SND_WINDOW_OPEN')
        DLG.PauseGame(True)
        DLG.PMgr.set_user_setting('help_button_clicked', 1)
        DLG.PMgr.save_current_user()
        self.ShowSpaceHolders()
        max_index = DLG.PMgr.cur_user_stat.help_shown
        if max_index == 0:
            for id in ['idNextBtn', 'idPrevBtn', 'idNextBG', 'idPrevBG']:
                self.ShowWidget(id, False)
        if self.help_number >= 0:
            self.SetImage('idShot', 'IMG_I_HELP_SHOT_' + str(self.help_number))
            self.SetText('idTip1', [('text', 'HELP_DESC_LEFT_SCREEN_'+str(self.help_number))])
            self.SetText('idTip2', [('text', 'HELP_DESC_RIGHT_SCREEN_'+str(self.help_number))])
            info = self.help_info[self.help_number]
            _left = info[0]
            _center = info[1]
            _right = info[2]
            self.ShowWidget('idTipHead21', _left)
            self.ShowWidget('idTip2BG1', _left)
            self.ShowWidget('idTip21', _left)
            # ---
            self.ShowWidget('idTipHead22', _center)
            self.ShowWidget('idTip2BG2', _center)
            self.ShowWidget('idTip22', _center)
            # ---
            self.ShowWidget('idTipHead23', _right)
            self.ShowWidget('idTip2BG3', _right)
            self.ShowWidget('idTip23', _right)
            if _left:
                self.SetText('idTip21', [('text','HELP_HINT_LEFT_SCREEN_'+str(self.help_number))])
            if _center:
                self.SetText('idTip22', [('text','HELP_HINT_SCREEN_'+str(self.help_number))])
            if _right:
                self.SetText('idTip23', [('text','HELP_HINT_RIGHT_SCREEN_'+str(self.help_number))])
            
# ============================================================
    def on_button(self, id):
        if id == 'idOkBtn':
            DLG.PauseGame(False)
            DLG.StartUnfade()
            DLG.Close_dialog(self)
            self.HideSpaceHolders()
        elif id == 'idNextBtn':
            DLG.Close_dialog(self)
            max_index = DLG.PMgr.cur_user_stat.help_shown
            if max_index == 0: return
            #index = self.dlg_to_index[self.xml_name]
            index = self.help_number + 1
            if index >= max_index: index = 22  # чтобы на начало перейти
            next_index = self.dlg_next[index]
            #next_name = self.index_to_dlg[next_index]
            if next_index == 0:
                DLG.Open_dialog('HelpMenu', 'dlg_help', {'single_mode':'1', 'help_number':str(0)})
            else:
                DLG.Open_dialog('HelpMenu_X', 'dlg_help', {'help_number':str(next_index)})
        elif id == 'idPrevBtn':
            DLG.Close_dialog(self)
            max_index = DLG.PMgr.cur_user_stat.help_shown
            if max_index == 0: return
            #index = self.dlg_to_index[self.xml_name]
            index = self.help_number + 1
            prev_index = self.dlg_prev[index]
            if prev_index > max_index: prev_index = max_index
            #prev_name = self.index_to_dlg[prev_index]
            if prev_index == 0:
                DLG.Open_dialog('HelpMenu', 'dlg_help', {'single_mode':'1', 'help_number':str(0)})
            else:
                DLG.Open_dialog('HelpMenu_X', 'dlg_help', {'help_number':str(prev_index)})
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
# ============================================================
# ============================================================
# ============================================================
