# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog


class KeyDlg(dialog.Dialog):
    part_explosion_pos = [
                            {'x':645, 'y':450}, # ZERO level
                            {'x':645, 'y':450}, #First
                            {'x':645, 'y':374}, # 2
                            {'x':645, 'y':310}, # 3
                            {'x':652, 'y':235},
                            {'x':517, 'y':204},
                            {'x':777, 'y':203}, # 6
                            {'x':508, 'y':317},
                            {'x':775, 'y':325}, # 8
                            {'x':527, 'y':459}, # 9
                            {'x':764, 'y':465}, # 10

                            {'x':518, 'y':444}, # bonus level
                            ]
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.size = 'big'
        self.EnableMouseMoveEvents(True)
        # если нужно, то доп. параметры можно вытащить из params
        self.final_part_index = 0   # начинается с 1
        self.episode = int(params.episode)
        self.level = int(params.level)
        self.level_index = DLG.PMgr.get_cur_user_progress().get_level_index(self.episode, self.level)
        self.is_final = False
        if 'is_final' in params:    # если диалог после взятия ключа, а не из сундука открыт
            self.is_final = True
# ============================================================
    def on_signal(self, signal):
        if self.is_final:
            if signal == 'show_effect':
                self.ShowEffect('key_explosion', self.part_explosion_pos[self.level_index])
            elif signal == 'show_part':
                _name = 'idPart0'+str(self.level_index)
                self.ShowWidget(_name, True)
                _r = self.GetWidgetRect(_name)
                self.zones.append( {'zone':_r} )
# ============================================================
    def on_mouse_move(self, x, y):
        _cx = 640
        _cy = 342
        _r = 181*181
        _dx = x - _cx
        _dy = y - _cy
        _square = _dx*_dx + _dy*_dy
        if _square <= _r:
            _item = self.get_over_item(x,y)
            if _item:
                result = [('text', 'COLOR_HEADER')]
                result.append( ('text', 'KEY_DESC') )
                self.ShowTips( result, _item.zone.x + 38/2 + 4, _item.zone.y - 36/2, True )
                return
        self.HideTips()
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == "enter":
            pass
        elif type == "exit":
            pass
        elif type == "change":
            self.on_state_change(additional.prev_state, additional.next_state)
        pass
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_command(self, name, command, param):
        pass
# ============================================================
    def on_create(self):
        tools.PlaySound('SND_WINDOW_OPEN')
        DLG.PauseGame(True)
        # отображаем части по кол-ву экспертных уровней:
        _levels_completeness = DLG.PMgr.Get_user_info('levels_completeness')    # формат 0#2#1#0#...
        _parts = _levels_completeness.split('#')
        index = 0
        #if self.is_final:
        #    mbox(str(self.episode) + '-' + str(self.level))
        for part in _parts:
            if index >= self.level_index:
                break   # дальше текущего уровня не выводим
            if index == 0:
                index += 1
                continue # скипуем нулевой уровень
            value = int(part)
            if value == 2:      # если на золото пройден
                _name = 'idPart0'+str(index)
                self.ShowWidget(_name, True)
                # добавляем область типсов:
                _r = self.GetWidgetRect(_name)
                self.zones.append( {'zone':_r} )
            index += 1
            if index == 11: break   # бонусный уровень скипуем

        if self.is_final:
            tools.StopMusic()
            self.Signals.Add('show_effect', 200)
            self.Signals.Add('show_part', 500)
# ============================================================
    def on_button(self, id):
        if id == 'idOkBtn':
            DLG.PauseGame(False)
            DLG.Close_dialog(self)
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
# ============================================================
# ============================================================
# ============================================================
