# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog


class LetterDlg(dialog.Dialog):
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.size = 'big'
        self.letters = {}
        # если нужно, то доп. параметры можно вытащить из params
# ============================================================
    def on_signal(self, signal):
        pass
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == 'enter':
            pass
        elif type == 'exit':
            pass
        elif type == 'change':
            self.on_state_change(additional.prev_state, additional.next_state)
        pass
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_command(self, name, command, param):
        if command == 'keycode':
            if param == 'escape':
                DLG.PauseGame(False)
                DLG.Close_dialog(self)
# ============================================================
    def on_create(self):
        DLG.PauseGame(True)
        tools.PlaySound('SND_WINDOW_OPEN')
        letters = DLG.GetLettersList()
        for letter in letters:
            is_clickable = letter.is_dlg
            if not is_clickable:
                is_clickable = (len(letter.uid) and letter.cur_location)
            grayed = not letter.cur_location
            self.ListAddLetter('idList', letter.index, is_clickable, grayed)
            self.letters[str(letter.index)] = letter
        DLG.ResetLettersUnread()
# ============================================================
    def on_button(self, id):
        if id == 'idOkBtn':
            DLG.PauseGame(False)
            DLG.Close_dialog(self)
# ============================================================
    def on_list_click(self, id, tag, index, extra):
        '''Вызывается при клике по элементу списка'''
        if tag in self.letters:
            letter = self.letters[tag]
            if letter.is_dlg:
                DLG.PauseGame(False)
                DLG.Close_dialog(self)
                DLG.Open_dialog('SecretLetterMenu', 'dlg_secret', {'single_mode':'1', 'name':letter.secret_header, 'text':letter.secret_body})
            elif letter.cur_location and letter.uid:
                DLG.MoveCameraToUID(letter.uid)
                DLG.PauseGame(False)
                DLG.Close_dialog(self)
        pass
# ============================================================
    def on_list_selection_change(self, id, new_tag, new_index, old_index, extra):
        tools.PlaySound('SND_BTN_OVER_PAPER')
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
# ============================================================
# ============================================================
# ============================================================
