# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog


class LoadLevelDlg(dialog.Dialog):
# ============================================================
    level_settings = {
                        '0_0':{'image':'', 'text':'LEVEL_1_1', 'desc':'LEVEL_1_1_DESC'},
                        '1_1':{'image':'', 'text':'LEVEL_1_1', 'desc':'LEVEL_1_1_DESC'},
                        '1_2':{'image':'', 'text':'LEVEL_1_2', 'desc':'LEVEL_1_2_DESC'},
                        '1_3':{'image':'', 'text':'LEVEL_1_3', 'desc':'LEVEL_1_3_DESC'},
                        '1_4':{'image':'', 'text':'LEVEL_1_4', 'desc':'LEVEL_1_4_DESC'},
                        '1_5':{'image':'', 'text':'LEVEL_1_5', 'desc':'LEVEL_1_5_DESC'},
                        '2_1':{'image':'', 'text':'LEVEL_2_1', 'desc':'LEVEL_2_1_DESC'},
                        '2_2':{'image':'', 'text':'LEVEL_2_2', 'desc':'LEVEL_2_2_DESC'},
                        '2_3':{'image':'', 'text':'LEVEL_2_3', 'desc':'LEVEL_2_3_DESC'},
                        '2_4':{'image':'', 'text':'LEVEL_2_4', 'desc':'LEVEL_2_4_DESC'},
                        '2_5':{'image':'', 'text':'LEVEL_2_5', 'desc':'LEVEL_2_5_DESC'},
                        '2_6':{'image':'', 'text':'LEVEL_2_6', 'desc':'LEVEL_2_6_DESC'},
                    }
# ============================================================
    comics_names = {
                    '0_0':'loading_01',
                    '1_1':'loading_01',
                    '1_2':'loading_02',
                    '1_3':'loading_03',
                    '1_4':'loading_04',
                    '1_5':'loading_05',
                    '2_1':'loading_06',
                    '2_2':'loading_07',
                    '2_3':'loading_08',
                    '2_4':'loading_09',
                    '2_5':'loading_10',
                    '2_6':'loading_11',
                    }
# ============================================================
    blick_pos = [
                    {'x':318, 'y':5},
                    {'x':104, 'y':17},
                    {'x':191, 'y':735},
                    {'x':867, 'y':690},
                    {'x':888, 'y':749},
                    {'x':920, 'y':704},
                ]
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.size = 'fullscreen'
        self.blick_name = 'menu_sparkle'
        # если нужно, то доп. параметры можно вытащить из params
        self.episode = params.episode
        self.level = params.level
        self.load_saved = ('load_saved' in params)
        self.total_time = 3500
        self.current_time = 0
        self.is_loaded = False
        self.is_ready_to_start = False
        self.is_wait_complete = False
        self.already_pressed = False    # было ли нажатие в конце, где оно или клик требуется
        self.is_level_load_started = False
# ============================================================
    def on_signal(self, signal):
        if signal == 'level_loading_complete':
            self.is_loaded = True
            trace('dlg_loadlevel "level_loading_complete" msg')
            #DLG.Close_dialog(self)
            #DLG.StartLoadedGame()
        elif signal == 'blick':
            _time = tools.Rand(400, 800)
            self.Signals.Restart('blick', _time)
            _index = tools.Rand(0, len(self.blick_pos)-1)
            self.ShowEffect( self.blick_name, self.blick_pos[_index] )
# ============================================================
    def on_message(self, msg_type, msg_param1, msg_param2, msg_dict):
        if msg_type == '10th_draw':
            if not self.is_level_load_started:
                #! чтобы отодвинуть запуск загрузки от момента начала отрисовки самого
                #! диалога и избежать перекрывания DirectX методов в разных потоках:
                trace('load_level 10th_draw >>>')
                self.is_level_load_started = True
                DLG.StartLoadGame(self.episode, self.level, self.load_saved)
                trace('load_level 10th_draw <<<')
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == 'enter':
            pass
        elif type == 'exit':
            pass
        elif type == 'change':
            self.on_state_change(additional.prev_state, additional.next_state)
        pass
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_command(self, name, command, param):
        if command in ['mouse_up', 'keycode']:
            if not self.already_pressed:
                if self.is_ready_to_start:
                    trace('LoadLevel: key or mouse pressed')
                    self.already_pressed = True
                    DLG.clear_awaitinig_dialogs()   # на всякий случай почистим ожидающие диалоги
                    DLG.StartLoadedGame()
                    tools.PlayNextMusic()
                    #DLG.StartUnfade()
                    DLG.Close_dialog(self)
# ============================================================
    def on_create(self):
        DLG.AllowSave(False)
        _time = tools.Rand(400, 800)
        self.Signals.Add('blick', _time)
        tools.PlaySound('SND_WINDOW_OPEN')
        DLG.PMgr.reload_current_user()  # на всякий случай
        _img_index = str(self.episode) + '_' + str(self.level)
        trace('LoadingLevelMenu: image index =', _img_index)
        self.SetComics('idLoadComics', self.comics_names[_img_index])
        self.total_time = self.GetComicsTime('idLoadComics')
        if self.IsDebug():
            self.total_time = 500  # чтобы быстрее грузилось
        self.image_name = self.level_settings[_img_index].image
        if self.image_name:
            self.SetImage('idLoadImage', self.image_name)
        txt = self.generate_header_text(_img_index)
        self.SetText('idHeader', txt)
        #DLG.LoadGame(self.episode, self.level)
        #DLG.Close_dialog(self)
        self.fill_tasks_info()
# ============================================================
    def fill_tasks_info(self):
        has_gold = False
        has_survived = False
        settings = DLG.GetLevelSettings(self.episode, self.level)
        text = []
        if 'need_gold' in settings:
            if int(settings['need_gold']) > 0:
                text.append( ['image', 'IMG_MENU_COMICS_STAR,0'] )
                text.append( ['text', 'COLOR_YELLOW2'] )
                text.append( ['text', 'CHEST_DLG_TASK_SEND_GOLD'] )
                text.append('space')
                text.append( ['text', 'COLOR_WHITE'] )
                text.append( ('digit', int(settings['need_gold'])) )
                has_gold = True
        # SURVIVED
        if 'total_survived' in settings:
            if int(settings['total_survived']) > 0:
                if has_gold:
                    text.append('space')
                has_survived = True
                text.append( ['image', 'IMG_MENU_COMICS_STAR,0'] )
                text.append( ['text', 'COLOR_YELLOW2'] )
                text.append( ['text', 'CHEST_DLG_TASK_SAVE_SURVIVED'] )
                text.append('space')
                text.append( ['text', 'COLOR_WHITE'] )
                text.append( ('digit', int(settings['total_survived'])) )
        _has_prev = False
        if has_survived: _has_prev = True
        if has_gold: _has_prev = True
        if _has_prev:
            _need_new_line = has_survived and has_gold
            if _need_new_line:
                text.append('newline')
            else:
                text.append('space')
        text.append( ['image', 'IMG_MENU_COMICS_STAR,0'] )
        text.append( ['text', 'COLOR_YELLOW2'] )
        text.append( ['text', 'CHEST_DLG_TASK_TERRITORY'] )
        #if not text:
        #self.ShowWidget('idMainTargetText', False)
        self.SetText('idTargets', text)
# ============================================================
    def on_button(self, id):
        if id == 'idGames':
            DLG.SendMsg('more_games')
        elif id == 'idFriend':
            DLG.SendMsg('tell_friend')
        elif id == "idOkBtn":
            #DLG.StartLevel(_episode, _level)
            #DLG.Close_dialog(self)
            pass
        pass
# ============================================================
    def on_update(self, ms):
        if self.is_ready_to_start:
            return
        if self.current_time < self.total_time:
            if self.is_level_load_started:
                self.current_time += ms
                if self.current_time >= self.total_time:
                    self.current_time = self.total_time
                    self.is_wait_complete = True
            if self.total_time > 0:
                self.SetProgress( 'idProgressBar', self.current_time / self.total_time )
        if self.is_wait_complete:
            if self.is_loaded:
                self.is_ready_to_start = True
                self.SetText('idProgressBar', [('text', 'LOAD_LEVEL_DLG_CLICK')])
# ============================================================
    def generate_header_text(self, index):
        result = []
        settings = self.level_settings[index]
        #result.append( ('text', settings.text) )
        #result.append( 'space' )
        #result.append( 'space' )
        #result.append( 'space' )
        result.append( ('text', settings.desc) )
        return result
# ============================================================
# ============================================================
# ============================================================
# ============================================================
