# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog


class MainDlg(dialog.Dialog):
# ============================================================
    blick_pos = [
                    {'x':243, 'y':105},
                    {'x':177, 'y':200},
                    {'x':280, 'y':291},
                    {'x':494, 'y':360},
                    {'x':690, 'y':153},
                ]
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.size = 'fullscreen'
        self.blick_name = 'menu_sparkle'
        # если нужно, то доп. параметры можно вытащить из params
        self.EnableMouseMoveEvents(True)
        tools.PlayMenuMusic()
        tools.PlaySoundCycled('SND_FON_MENU')
        trace('MainMenu constructor complete')
# ============================================================
    def on_signal(self, signal):
        if signal == 'blick':
            _time = tools.Rand(600, 1200)
            self.Signals.Restart('blick', _time)
            _index = tools.Rand(0, len(self.blick_pos)-1)
            self.ShowEffect( self.blick_name, self.blick_pos[_index] )
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == 'enter':
            pass
        elif type == 'exit':
            pass
        elif type == 'change':
            self.on_state_change(additional.prev_state, additional.next_state)
        pass
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_mouse_move(self, x, y):
        if x < 0 or x >= 1024:
            return
        if y < 0 or y >= 768:
            return
        rx = x / 1024   # relative X
        ry = y / 768
        img_back_x = -(rx-0.5)*17  #34
        img_x = -rx*34  #34
        img_y = -ry*25
        # [-100..0]
       # self.MoveWidget('idLayer3', img_back_x-25, img_y)
       # self.MoveWidget('idLayer1', -img_x-34, 390-img_y+25)
# ============================================================
    def on_command(self, name, command, param):
        if command == 'keycode':
            if param == 'escape':
                DLG.Open_dialog('ExitMainMenu', 'dlg_exit')
            elif param == 'tab':
                if tools.IsDebug():
                    tools.StopSoundCycled('SND_FON_MENU')
                    DLG.Open_dialog('BookMenu', 'dlg_book')
                    DLG.Close_dialog(self)
# ============================================================
    def on_create(self):
        #tools.PlaySound('SND_WINDOW_OPEN')
        _time = tools.Rand(600, 1200)
        self.Signals.Add('blick', _time)
        self.update_top_texts()
        trace('MainMenu on_create complete')
# ============================================================
    def on_added(self):
        DLG.PMgr.reload_current_user()
        trace('MainMenu on_added complete')
# ============================================================
    def fill_player_name(self):
        result = []
        if len(DLG.PMgr.cur_user_name) > 0:
            result.append(['text', 'WELCOME_PLAYER'])
            result.append('space')
            result.append('playername')
            result.append(['text', 'WELCOME_PLAYER_SIGN'])
        else:
            result.append(['text', 'WELCOME_PLAYER_EMPTY'])
        self.SetText('idTextLeft', result)
# ============================================================\
    mode_text = {'normal': [('text','MODE_NORMAL')],
                'relax': [('text','MODE_RELAX')],
                'hard': [('text','MODE_HARD')],
                'easy': [('text','MODE_EASY')]}
    def update_top_texts(self):
        '''Обновляет верхние тексты про игрока и выбранный режим'''
        _mode = DLG.PMgr.cur_user_stat.mode
        _mode_text_list = self.mode_text[_mode]
        _text = [('text','MODE_RIBBON_COLOR')]
        _text.extend(_mode_text_list)
        self.SetText('idTextRight', _text)
        self.fill_player_name()
# ============================================================
    def on_language_reloaded(self):
        self.update_top_texts()
# ============================================================
    def on_button(self, id):
        if id == 'idStartBtn':
            #self.ApplyLevelStat(False)
            current_mode = DLG.PMgr.cur_user_stat.mode
            saved = DLG.HasSavedGame()
            if saved:
                if current_mode == saved.game_mode:
                    DLG.Open_dialog('SureLoadSaved', 'dlg_asking', {'tag':'continue_saved',
                                                                'caller_dlg_name':self.xml_name, 'extra':saved})
                    return
            self.do_start()
            DLG.Close_dialog(self)
        elif id == 'idGames':
            self.FlurryPromoInMain()
            DLG.SendMsg('more_games')
        elif id == 'idFriend':
            self.FlurrySubscribeInMain()
            DLG.SendMsg('tell_friend')
        elif id == 'idOptionsBtn':
            DLG.Open_dialog('OptionsMenu', 'dlg_options', {'from_main':'1'})
        elif id == 'idModeBtn':
            DLG.Open_dialog('ModeMenu', 'dlg_mode')
        elif id == 'idProfilesBtn':
            DLG.Open_dialog('ProfilesMenu', 'dlg_profiles')
        elif id == 'idHelpBtn':
            DLG.Open_dialog('HelpMenu', 'dlg_help')
        elif id == 'idShareBtn':
            self.FlurryShareBtn()
            if self.Internet() == True:
                DLG.Open_dialog('ShareMenu', 'dlg_share')
            else:
                DLG.Open_dialog('InternetMenu', 'dlg_internet')
        elif id == 'idUpgrade':
            self.FlurryBuyInMainMenu()
            DLG.Open_dialog('UpgradeMenu', 'dlg_upgrade')
            DLG.Close_dialog(self)
# ============================================================
    def on_update(self, ms):
        tools.random()  # for real randomness of first random value
        rx = self.GetParalaxPosX() / 1024       # relative X
        ry = self.GetParalaxPosY() / 768        #ry = y / 768
        img_x = -rx*50
        img_y = -ry*25
        #trace('!!!!',img_x)
        # [-100..0]
        self.MoveWidget('idLayer3', img_x, img_y)
        self.MoveWidget('idLayer4', img_x, img_y+233)
        self.MoveWidget('idLayer1', -img_x-50, 390-img_y+25)
        # Upgrade button visibility
        _showUpgradeButton = 0
        if self.IsUnlocked() == 0:
            _showUpgradeButton = 1
        self.ShowWidget('idUpgrade', _showUpgradeButton)
        pass
# ============================================================
    def do_start(self):
        '''Вызывается при обычном старте по кнопке START (за исключением продолжения по сохраненению)'''
        tools.StopSoundCycled('SND_FON_MENU')
        if not DLG.PMgr.cur_user_stat.start_comics_shown:
            _params = {'episode':1, 'level':1, 'is_start_comics':True, 'center_comics':False}
            DLG.Open_dialog('ComicsMenu', 'dlg_comics', _params)
        else:
            DLG.Open_dialog('BookMenu', 'dlg_book')
# ============================================================
    def on_yesno_result(self, tag, result, extra):
        if tag == 'continue_saved':
            if result == 'yes':
                tools.StopSoundCycled('SND_FON_MENU')
                _params = extra
                _params['load_saved'] = ''
                DLG.Open_dialog('LoadLevelMenu', 'dlg_loadlevel', _params)
            else:
                self.do_start()
            DLG.Close_dialog(self)
# ============================================================
# ============================================================
# ============================================================
# ============================================================
