# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog


class NewProfileDlg(dialog.Dialog):
    checkbox_ids = ['idHardBox', 'idNormalBox', 'idEasyBox', 'idRelaxBox']
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.size = 'small'
        # если нужно, то доп. параметры можно вытащить из params
        self.tag = params.tag
        self.name = ''
        self.Edit_SetMaxChars('idEdit', 11)
        #self.Edit_SetText('idEdit', self.name)
        self.SetCheckboxValue('idNormalBox', True, False)
# ============================================================
    def on_signal(self, signal):
        pass
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == 'enter':
            pass
        elif type == 'exit':
            pass
        elif type == 'change':
            self.on_state_change(additional.prev_state, additional.next_state)
        pass
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_command(self, name, command, param):
        if command == 'keycode':
            if param == 'escape':
                if self.tag not in ['need_profile', 'first_start']:
                    DLG.Close_dialog(self)
# ============================================================
    def on_create(self):
        #tools.SetGraphicCursor(False)
        if self.tag != 'first_start':
            tools.PlaySound('SND_WINDOW_WOOD')
        DLG.SendMsg('show_keyboard')
        if self.tag in ['need_profile', 'first_start']:
            _name = DLG.GlobalGetString('DEFAULT_USER_NAME')
            self.Edit_SetText('idEdit', _name)
        #    self.Keyboard_SetText(_name)
        #else:
        #    self.Keyboard_SetText('')
# ============================================================
    def on_edit_clicked(self, id):
        DLG.SendMsg('show_keyboard')
# ============================================================
    def on_button(self, id):
        if id == 'idOkBtn':
            self.on_ok()
        elif id == 'idCancelBtn':
            DLG.Close_dialog(self)
        # скрываем клавиатуру
        DLG.SendMsg('hide_keyboard')
# ============================================================
    def on_ok(self):
        # копируем текст из поля ввода клавиатуры в textedit
        #self.Edit_SetText('idEdit', self.Keyboard_GetText())
        # далее стандартная обработка        
        _new_name = self.Edit_GetText('idEdit')
        if not _new_name:   # если пустое имя
            return
        # если с именем все в порядке:
        DLG.PMgr.add_user(_new_name)
        DLG.PMgr.set_current_user(_new_name)
        _profiles = DLG.get_dialog('ProfilesMenu')
        for cbox in self.checkbox_ids:
            _is_checked = self.GetCheckboxValue(cbox)
            if _is_checked:
                _mode = 'normal'
                if cbox == 'idNormalBox': _mode = 'normal'
                elif cbox == 'idRelaxBox': _mode = 'relax'
                elif cbox == 'idHardBox': _mode = 'hard'
                elif cbox == 'idEasyBox': _mode = 'easy'
                DLG.PMgr.cur_user_stat.mode = _mode
                DLG.PMgr.save_current_user()
        if _profiles: _profiles.reload_users_list()
        _main = DLG.get_dialog('MainMenu')
        if _main: _main.update_top_texts()
        DLG.Close_dialog(self)
# ============================================================
    def on_added(self):
        self.SetFocus('idEdit')
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
    def on_checkbox_change(self, cbox_id, checked):
        for cbox in self.checkbox_ids:
            self.SetCheckboxValue(cbox, False, False)
        self.SetCheckboxValue(cbox_id, True, False)
# ============================================================
# ============================================================
# ============================================================
