# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog


class OptionsDlg(dialog.Dialog):
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.size = "small"
        self.from_main = False
        if 'from_main' in params:
            self.from_main = int(params.from_main)
        self.is_muted = False
        # если нужно, то доп. параметры можно вытащить из params
# ============================================================
    def on_signal(self, signal):
        pass
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == "enter":
            pass
        elif type == "exit":
            pass
        elif type == "change":
            self.on_state_change(additional.prev_state, additional.next_state)
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_command(self, name, command, param):
        if command == 'keycode':
            if param == 'escape':
                DLG.Close_dialog(self)
                DLG.PauseGame(False)
# ============================================================
    def on_create(self):
        #tools.SetGraphicCursor(False)
        _has_many_l = tools.HasManyLanguages()
        self.ShowWidget('idLanguage', _has_many_l)
        self.ShowWidget('idLanguageBG', _has_many_l)
        if not self.from_main:
            self.ShowWidget('idHighscores', False)
            self.ShowWidget('idHighscoresBG', False)
        tools.PlaySound('SND_WINDOW_WOOD')
        _s = tools.GetSoundVolume()
        _m = tools.GetMusicVolume()
        self.SetSliderValue('idSound', (100-_s)/100)
        self.SetSliderValue('idMusic', (100-_m)/100)
        self.SetCheckboxValue('idCursorBox', tools.IsCustomCursor())
        self.is_muted = tools.IsMuted()
        self.SetCheckboxValue('idMuteSoundBox', tools.IsMuted())
        self.SetCheckboxValue('idFullscreenBox', not tools.IsWindowed())
# ============================================================
    def on_button(self, id):
        if id == 'idOkBtn':
            self.apply_settings()
            DLG.Close_dialog(self)
        elif id == 'idHighscores':
            DLG.Open_dialog('TopScoresMenu', 'dlg_top_scores')
        elif id == 'idLanguage':
            tools.SwitchLanguage()
# ============================================================
    def apply_settings(self):
        tools.SetGraphicCursor( self.GetCheckboxValue('idCursorBox') )
        _is_muted = self.GetCheckboxValue('idMuteSoundBox')
        if _is_muted != self.is_muted:
            tools.Mute(_is_muted)
        tools.SetFullscreen( self.GetCheckboxValue('idFullscreenBox' ))
        tools.SaveSettings()
# ============================================================
    def on_slider_change(self, slider_id, value):
        if slider_id == 'idMusic':
            tools.SetMusicVolume(100-value)
        elif slider_id == 'idSound':
            tools.SetSoundVolume(100-value)
# ============================================================
#    def on_checkbox_change(self, cbox_id, checked):
#        pass
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
# ============================================================
# ============================================================
# ============================================================
