# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog


class PrizesDlg(dialog.Dialog):
    eff_name = {1:'stone_red', 2:'stone_green', 3:'stone_blue'}
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.size = 'big'
        self.eff_positions = []
        self.EnableMouseMoveEvents(True)
        self.close_blocked = True
        self.new_prize_index = -1
        self.new_medal_type = 1
        self.params = params
        # если нужно, то доп. параметры можно вытащить из params
        if 'medal' in params:             # если это показ нового камня
            #self.gem_name = params.gem
            self.Signals.Add('medal_effect', 500)
            self.DisableWidget('idOkBtn', True)
            self.new_prize_index = int(params['medal'])
            self.new_medal_type = int(params['medal_type'])
        else:
            self.Signals.Add('enable_close', 50)
# ============================================================
    def on_signal(self, signal):
        if signal == 'medal_effect':
            index = self.new_prize_index
            _name = 'idPrize' + str(index+1)
            _name_frame = 'idPrizeFrame' + str(index+1)
            _eff_name = self.eff_name[self.new_medal_type]
            self.ShowEffect(_eff_name, self.eff_positions[index])
            # # #self.AppendGem(self.gem_name)
            tools.PlaySound('SND_ITEM_LEVELUP')
            tools.PlaySound('SND_PRIZES_NEW')
            self.ShowWidget(_name, True)
            self.ShowWidget(_name_frame, True)
            self.SetImage(_name_frame, '__skip__,' + str(self.new_medal_type-2))
            self.DisableWidget('idOkBtn', False)
            _r = self.GetWidgetRect(_name_frame)
            self.zones.append( {'zone':_r, 'type':str(index+1), 'medal_type':self.new_medal_type} )
            self.close_blocked = False
        elif signal == 'enable_close':
            self.close_blocked = False
# ============================================================
    def on_mouse_move(self, x, y):
        _item = self.get_over_item(x,y)
        if _item:
            result = [('text', 'COLOR_HEADER')]
            #result.append( ('debug', _item.type) )
            _text = 'PRIZE_' + str(_item.type) + '_DESC_' + {1:'BRONZE', 2:'SILVER', 3:'GOLD'}[_item.medal_type]
            _medal_text = {1:'BRONZE', 2:'SILVER', 3:'GOLD'}[_item.medal_type]
            result.append( ('text', _medal_text + '_MEDAL') )
            result.append( 'newline' )
            result.append( ('text', 'COLOR_LINES') )
            result.append( ('text', _text) )
            self.ShowTips( result, _item.zone.x + 38/2 + 19, _item.zone.y - 34, True )
        else:
            self.HideTips()
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == 'enter':
            pass
        elif type == 'exit':
            pass
        elif type == 'change':
            self.on_state_change(additional.prev_state, additional.next_state)
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_command(self, name, command, param):
        if command == 'keycode':
            if param in ['escape', 'enter']:
                if not self.close_blocked:
                    if 'medal' in self.params:
                        DLG.PauseGame(False)
                    DLG.Close_dialog(self)
# ============================================================
    def on_create(self):
        tools.PlaySound('SND_WINDOW_OPEN')
        if 'medal' in self.params:
            DLG.PauseGame(True)
        # отображаем полученные призы:
        _prizes = DLG.PMgr.get_cur_user_progress().prizes[:]
        #_levels_prizes = DLG.PMgr.Get_user_info('prizes')    # формат 0#2#1#0#...
        #_prizes = _levels_prizes.split('#')
        #index = 0
        # ---
        # ---
        i = 1
        sx = 333+141
        sy = 86+92+46
        _w = 56
        _h = 56
        dx = 36+_w
        dy = 36+_h
        if self.IsIphone():
            sy = sy + 33
        for r in range(0,3):
            for c in range(0, 4):
                _prize = _prizes[i-1]   # т.к. i с 1 начинается
                #_prize = 2
                _name = 'idPrize' + str(i)
                _x = sx + dx*c
                _y = sy + dy*r
                self.MoveControl(_name, _x, _y)
                self.SetImage(_name, '__skip__,' + str(i-1) )
                self.ShowWidget(_name, _prize > 0)
                self.eff_positions.append({'x':_x+_w/2, 'y':_y+_h/2})
                # ---
                _name_frame = 'idPrizeFrame' + str(i)
                _x = sx + dx*c - 10
                _y = sy + dy*r - 10
                self.MoveControl(_name_frame, _x, _y)
                self.ShowWidget(_name_frame, _prize > 0)
                if _prize > 0:
                    self.SetImage(_name_frame, '__skip__,' + str(_prize-2) )
                if self.new_prize_index == (i-1):
                    if self.new_medal_type == 2:
                        self.ShowWidget(_name, False)
                        self.ShowWidget(_name_frame, False)
                    else:
                        self.SetImage(_name_frame, '__skip__,' + str((self.new_medal_type-2)-1))    # dirty-dirty hack чтобы показать предыдущую награду
                i += 1
        # --- настройка зон для типсов
        i = 0
        _prizes_count = 0
        for i in range(12):
            _r = self.GetWidgetRect('idPrizeFrame' + str(i+1))
            _prize = _prizes[i]
            #_prize = 2
            if _prize > 0:
                self.zones.append( {'zone':_r, 'type':str(i+1), 'medal_type':_prize} )
# ============================================================
    def on_button(self, id):
        if id == 'idOkBtn':
            if not self.close_blocked:
                if 'medal' in self.params:
                    DLG.PauseGame(False)
                DLG.Close_dialog(self)
        pass
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
# ============================================================
# ============================================================
# ============================================================
