# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog


class ProfilesDlg(dialog.Dialog):
# ============================================================
    MAX_PROFILES_COUNT = 9
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.size = 'small'
        # если нужно, то доп. параметры можно вытащить из params
        self.profiles = []
# ============================================================
    def on_signal(self, signal):
        pass
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == 'enter':
            pass
        elif type == 'exit':
            pass
        elif type == 'change':
            self.on_state_change(additional.prev_state, additional.next_state)
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_command(self, name, command, param):
        if command == 'keycode':
            if param == 'escape':
                self.on_ok_pressed()
# ============================================================
    def on_create(self):
        #tools.SetGraphicCursor(False)
        tools.PlaySound('SND_WINDOW_WOOD')
        self.reload_users_list()
# ============================================================
    def on_button(self, id):
        if id == 'idOkBtn':
            self.on_ok_pressed()
        elif id == 'idRemoveBtn':
            DLG.Open_dialog('DeleteProfileMenu', 'dlg_asking', {'tag':'delete_profile',
                                                                'caller_dlg_name':self.xml_name})
            #self.delete_profile()
        elif id == 'idNewBtn':
            DLG.Open_dialog('NewProfileMenu', 'dlg_new_profile', {'tag':'new'})
        elif id == 'idEditBtn':
            DLG.Open_dialog('EditProfileMenu', 'dlg_edit_profile', {'tag':'edit', 'name':DLG.PMgr.cur_user_name})
# ============================================================
    def on_yesno_result(self, tag, result, extra):
        if tag == 'delete_profile':
            if result == 'yes':
                self.delete_profile()
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
    def on_list_click(self, id, tag, index, extra):
        '''Вызывается при клике по элементу списка'''
        self.SetListSelectedItem('idList', index)
        DLG.PMgr.set_current_user( self.List_GetSelectedLine('idList') )
        self.update_main_top_texts()
        #tools.PlaySound('SND_BTN_CLICK_PAPER')
# ============================================================
    def update_new_button_state(self):
        _pcount = len(self.profiles)
        if _pcount >= self.MAX_PROFILES_COUNT:
            self.ShowWidget('idNewBtn', False)
            self.ShowWidget('idNewBG', False)
        else:
            self.ShowWidget('idNewBtn', True)
            self.ShowWidget('idNewBG', True)
# ============================================================
    def delete_profile(self):
        _name = DLG.PMgr.cur_user_name
        _index = self.List_GetLineIndex('idList', _name)
        if _index >= 0:
            self.List_RemoveLine('idList', _index)
            self.profiles.pop(_index)   # удаляем итем из списка
            DLG.PMgr.SaveUsersNames(self.profiles)  # косяк, что здесь...
            DLG.PMgr.delete_user(_name)
            new_index = self.List_GetSelectedIndex('idList') # looks like some hack
            if new_index >= 0:
                self.SetListSelectedItem('idList', new_index)
                DLG.PMgr.set_current_user( self.List_GetSelectedLine('idList') )
                self.update_main_top_texts()
        if not self.profiles:   # если больше нет игроков, то нужно ввести одного
            DLG.Open_dialog('NeedProfileMenu', 'dlg_new_profile', {'tag':'need_profile'})
# ============================================================
    def rename_profile(self, new_name):
        _old_name = DLG.PMgr.cur_user_name
        _index = self.List_GetLineIndex('idList', _old_name)
        if _index >= 0:
            self.profiles[_index] = new_name
            self.List_SetUserLine('idList', _index, str(_index), new_name)
            DLG.PMgr.rename_user(_old_name, new_name)
            DLG.PMgr.SaveUsersNames(self.profiles)
# ============================================================
    def select_user_from_list(self, name):
        index = self.List_GetLineIndex('idList', name)
        if index >= 0:
            self.SetListSelectedItem('idList', index)
# ============================================================
    def reload_users_list(self):
        self.ListClear('idList')
        self.profiles = []
        _names = DLG.PMgr.LoadUsersNames()
        _index = 0
        for name in _names:
            self.ListAddUser('idList', str(_index), name)
            self.profiles.append(name)
            _index += 1
        if DLG.PMgr.cur_user_name:
            self.select_user_from_list(DLG.PMgr.cur_user_name)
        else:
            if _index == 1: # всего один элемент
                self.select_user_from_list(self.profiles[0])
        self.update_new_button_state()
# ============================================================
    def on_ok_pressed(self):
        #index = self.List_GetSelectedIndex('idList')
        text = self.List_GetSelectedLine('idList')
        DLG.PMgr.set_current_user(text)
        self.update_main_top_texts()
        DLG.Close_dialog(self)
# ============================================================
    def update_main_top_texts(self):
        _main = DLG.get_dialog('MainMenu')
        if _main:
            _main.update_top_texts()
# ============================================================