# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog

# ### ###############################
# ### Открывать через dlg.Open("QuestMenu", "dlg_quest", {"textid":...} )
# ### ###############################

class QuestDlg(dialog.Dialog):
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.params = params
        self.size = 'small'
        self.is_survived = False
        # если нужно, то доп. параметры можно вытащить из params
# ============================================================
    def on_signal(self, signal):
        pass
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == "enter":
            pass
        elif type == "exit":
            pass
        elif type == "change":
            self.on_state_change(additional.prev_state, additional.next_state)
        pass
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_command(self, name, command, param):
        if command == 'keycode':
            if param == 'enter':
                if self.HasWidget('idOkQuestBtn'):
                    self.on_button('idOkQuestBtn')
                elif self.HasWidget('idStartQuestBtn'):
                    self.on_button('idStartQuestBtn')
            elif param == 'escape':
                if self.HasWidget('idPostponeBtn'):
                    self.on_button('idPostponeBtn')
        pass
# ============================================================
    def on_create(self):
        DLG.PauseGame(True)
        tools.PlaySound('SND_WINDOW_OPEN')
        # выставляем текст диалога:
        nameid = ''
        textid = ''
        tasks_text = ''
        #image_id = ''
        if 'textid' in self.params:
            textid = self.params['textid']
        if 'nameid' in self.params:
            nameid = self.params['nameid']
        if 'tasks_text' in self.params:
            tasks_text = self.params['tasks_text']
        if 'is_survived' in self.params:
            self.is_survived = (self.params['is_survived'] == 'true')
            #self.ShowWidget('idTasksHeader', not self.is_survived)
            self.ShowWidget('idTasksHeader', True)
        self.SetText('idHeader', [('textline', nameid)] )
        self.SetText('idText', [('text', textid)] )
        self.SetText('idTasksBody', tasks_text )
        if 'imageid' in self.params:
            image_id = self.params['imageid']
            self.SetImage('idAvatar', image_id )
        #self.SetText('idText',[('text','YES_BTN')])
        #if self.showin_effect_name:
        #    self.SetVisible(False)
# ============================================================
    def on_added(self):
        dialog.Dialog.on_added(self)
        #self.ShowWidget('idTasksHeader', not self.is_survived)
        if 'hide_complete' in self.params:
            hide_complete = int(self.params['hide_complete'])
            if hide_complete:
                self.ShowWidget('idTasksHeader', False)
                return  # чтобы "ВЫПОЛНЕНО" не показывать
        self.ShowWidget('idTasksHeader', True)
# ============================================================
    def on_button(self, id):
        trace('Quest params:', self.params)
        #_task_uid = ''
        #if 'task_uid' in self.params:
        _task_uid = self.params['task_uid']
        if id == 'idStartQuestBtn':
            #tools.Exit()
            # нужно "разблокировать" генерала
            # нужно запустить квест
            self.SendMsgTasks('task_callback', _task_uid, 'agree')
            if 'need_task_effect' in self.params:
                DLG.AddXmlOverEffect('task_fly', {'x':0, 'y':0})
            DLG.PauseGame(False)
            DLG.Close_dialog(self)
        elif id == 'idPostponeBtn':
            #tools.SetGraphicCursor(True)
            # нужно "разблокировать" генерала
            self.SendMsgTasks('task_callback', _task_uid, 'postpone')
            DLG.PauseGame(False)
            DLG.Close_dialog(self)
        elif id == 'idOkQuestBtn':
            if _task_uid == '0' and 'quest_name' in self.params:
                self.SendMsgTasks('quest_callback', self.params['quest_name'], 'ok')
            else:
                self.SendMsgTasks('task_callback', _task_uid, 'ok')
            if 'need_task_effect' in self.params:
                DLG.AddXmlOverEffect('task_fly_mirror', {'x':0, 'y':0})
            DLG.PauseGame(False)
            DLG.Close_dialog(self)
# ============================================================
    def cancel_dialog(self):
        if self.HasWidget('idPostponeBtn'):
            self.on_button('idPostponeBtn')
        else:
            if self.HasWidget('idOkQuestBtn'):
                self.on_button('idOkQuestBtn')
            elif self.HasWidget('idStartQuestBtn'):
                self.on_button('idStartQuestBtn')
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
# ============================================================
# ============================================================
# ============================================================
