# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog


class StartDlg(dialog.Dialog):
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.size = 'small'
        # если нужно, то доп. параметры можно вытащить из params
# ============================================================
    def on_signal(self, signal):
        pass
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == 'enter':
            pass
        elif type == 'exit':
            pass
        elif type == 'change':
            self.on_state_change(additional.prev_state, additional.next_state)
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_command(self, name, command, param):
        if command == 'keycode':
            if param == 'enter':
                self.close_pressed()
            elif param == 'tab':
                if tools.IsDebug():
                    self.close_pressed()
# ============================================================
    def on_create(self):
        tools.PlaySound('SND_WINDOW_OPEN')
        DLG.PauseGame(True)
        stats = self.GetFullStats()
        self.fill_tasks_info(stats)
# ============================================================
    def fill_tasks_info(self, stats):
        index = 1
        if 'gold_need' in stats:
            if stats['gold_need'] > 0:
                text = []
                #if stats['gold'] >= stats['gold_need']:
                text.append( ['image', 'IMG_MENU_COMICS_STAR,0'] )
                #text.append( ['text', 'COLOR_YELLOW2'] )
                text.append( ['text', 'CHEST_DLG_TASK_SEND_GOLD'] )
                self.SetText('idTask'+str(index), text)
                self.SetText('idTaskValue'+str(index), [('digit', stats['gold_need'])])
                index += 1
        # SURVIVED
        if 'survived_total' in stats:
            if stats['survived_total'] > 0:
                text = []
                text.append( ['image', 'IMG_MENU_COMICS_STAR,0'] )
                text.append( ['text', 'COLOR_YELLOW2'] )
                text.append( ['text', 'CHEST_DLG_TASK_SAVE_SURVIVED'] )
                self.SetText('idTask'+str(index), text)
                self.SetText('idTaskValue'+str(index), [('digit', stats['survived_total'])])
                index += 1
        text = []
        text.append( ['image', 'IMG_MENU_COMICS_STAR,0'] )
        text.append( ['text', 'COLOR_YELLOW2'] )
        text.append( ['text', 'CHEST_DLG_TASK_TERRITORY'] )
        self.SetText('idTask'+str(index), text)
# ============================================================
    def on_button(self, id):
        if id == 'idOkBtn':
            self.close_pressed()
# ============================================================
    def close_pressed(self):
        '''Вызывается для закрытия диалога'''
        DLG.AddXmlOverEffect('start_fly', {'x':0, 'y':0})
        DLG.Close_dialog(self)
        DLG.clear_awaitinig_dialogs()
        DLG.PauseGame(False)
        DLG.SetFocusLB()
        DLG.AllowSave(True)
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
# ============================================================
# ============================================================
# ============================================================
