# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog
import pmgr

class StatsDlg(dialog.Dialog):
    values_controls = ['idSurvivedCountV', 'idGoldSentV', 'idLeftGoldV',
                        'idLeftFoodV', 'idLeftBoardsV', 'idLeftBricksV',
                        'idLeftCoinsV', 'idLeftBaseResV', 'idLeftTimeV', 'idSecretsFoundV',
                        'idSecretsLeftV', 'idTimeV', 'idLevelScoreV',
                        'idGameScoreV' ]
    eff_pre_pos = [ (538,218),
                    (538,252),

                    (538,286),
                    (538,303),
                    (538,320),
                    (538,337),
                    (538,354),
                    (538,371),
                    (538,388),

                    (538,439),
                    (538,456),
                    (538,507),
                    (538,524),
                    (538,541) ]
    values_fields = ['survived', 'gold_need', 'gold',
                        'expert_food', 'expert_boards', 'expert_bricks',
                        'expert_coins', 'base_res_count', 'time_left', 'secrets',
                        'secrets_left', 'time_min', 'score',
                        'score_total']
                        #'gold_need', 'survived_need']
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.size = 'fullscreen'
        # если нужно, то доп. параметры можно вытащить из params
        self.is_final = ('final' in params)
        self.index = 0
        self.stats = None
        self.eff_pos = []
        self.fbPostDone = 0
        for pre_pos in self.eff_pre_pos:
            self.eff_pos.append( {'x':pre_pos[0], 'y':pre_pos[1]} )
# ============================================================
    def on_signal(self, signal):
        if signal == 'next_line':
            _len = len(self.values_controls)
            if self.index < _len:
                if self.values_fields[self.index] == 'time_left':
                    _is_time_left = self.is_time_left()
                    if not _is_time_left:
                        self.index += 1     # пропускаем это поле
                self.ShowEffect('stat_explosion', self.eff_pos[self.index])
                self.Signals.Restart('show_text', 100)
                self.Signals.Restart('next_line', 200)
                #tools.PlaySound('')
            else:
                _is_level_gold = self.is_level_gold()
                if _is_level_gold:
                    self.ShowWidget('idStamp2', True)
                    tools.PlaySound('SND_STAMP')
        elif signal == 'show_text':
            self.ShowWidget(self.values_controls[self.index], True)
            self.index += 1
        elif signal == 'salute':
            #_x = tools.Rand(100, 924)
            #_y = tools.Rand(100, 668)
            _x = 512
            _y = 0
            _pos = {'x':_x, 'y':_y}
            #self.ShowEffect('salute_victory_b', _pos)
            _is_gold = self.is_level_gold()
            if _is_gold:
                self.ShowEffect('statistics_coins', _pos)   # эксперт
            else:
                self.ShowEffect('statistics_coins_silver', _pos)    # обычное прохождение
            tools.PlaySoundRandom(['SND_WIN_SALUTE_1', 'SND_WIN_SALUTE_2', 'SND_WIN_SALUTE_3'])
        elif signal == "done":
            self.ShowWidget('idOkBtn', True)
            self.ShowWidget('idOkBG', True)
            self.ShowWidget('idShareBtn', True)
            self.ShowWidget('idShareBG', True)
            stats = self.GetFullStats()
            askRate = False
            # 2, 5 уровни первого эпизода
            if (stats.episode_index == 1 and (stats.level_index == 2 or stats.level_index == 5)):
                askRate = True
            # 3 уровень второго эпизода (8 от начала)
            if (stats.episode_index == 2 and (stats.level_index == 3)):
                askRate = True;
            # Спрашиваем
            if askRate and self.DoesNeedRate() and self.Internet():
                DLG.Open_dialog('RateMenu', 'dlg_rate')
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == 'enter':
            pass
        elif type == 'exit':
            pass
        elif type == 'change':
            self.on_state_change(additional.prev_state, additional.next_state)
        pass
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_command(self, name, command, param):
        pass
# ============================================================
    def on_create(self):
        self.ShowSpaceHolders()
        for name in self.values_controls:
            self.ShowWidget(name, False)
        DLG.PauseGame(True)
        DLG.clear_awaitinig_dialogs()
        tools.StopMusic()
        tools.PlaySound('SND_WIN')
        UStats.SaveExpertResources()    # если это не экспертное прохождение, то данные метод просто ничего не сделает
        #tools.PlaySound('SND_CHEST_UI')
        _count = len(self.values_controls)
        stats = self.GetFullStats()
        self.stats = stats
        stats.score = self.calc_score(stats)
        stats.score += UStats.GetLevelValue('EXTRA_SCORE')
        # определим как хорошо прошли уровень:
        completion_type = pmgr.LevelStat.COMPLETED_NO
        trace('STATS>', stats.cur_time, stats.level_time)
        trace('STATS>', stats)
        _is_level_gold = self.is_level_gold()
        if _is_level_gold:  # успели, либо первый уровень - тогда золото
            completion_type = pmgr.LevelStat.COMPLETED_GOLD
            self.ShowWidget('idOnExpertTime1', False)
            self.ShowWidget('idOnExpertTime2', False)
        else:
            completion_type = pmgr.LevelStat.COMPLETED_SILVER
            self.SetText('idMissionComplete', [('text', 'STAT_DLG_MISSION_COMPLETE_SILVER')])
        stats['completion_type'] = completion_type  # на что прошли уровень
        p_mgr = DLG.PMgr
        user_progress = p_mgr.get_cur_user_progress()
        lstat = user_progress.get_level(stats.episode_index, stats.level_index)
        _need_update_result = False
        if 'completion_type' not in lstat.values:   # если поля нет, то нужно заполнять
            _need_update_result = True
        elif lstat.values.completion_type < stats.completion_type:  # если улучшили результат по типу прохождения
            _need_update_result = True
        elif lstat.values.completion_type > stats.completion_type: # если результат хуже, то
            _need_update_result = False                            # обновлять не нужно
        elif 'score' not in lstat.values or stats.score >= lstat.values.score:# если очков стало больше
            _need_update_result = True
        elif 'secrets' not in lstat.values or stats.secrets >= lstat.values.secrets:# если очков стало больше
            _need_update_result = True
        elif 'secret_rooms' not in lstat.values or stats.secret_rooms >= lstat.values.secret_rooms:
            _need_update_result = True
        if _need_update_result:         # нужно перезаписать результат
            lstat.append_values(stats)
            self.ApplyLevelStat(True)     # теперь пропишем новые данные уровня
            p_mgr.save_current_user()     # сохраним результат игрока и статистику в файлы
        DLG.RemoveSaveIfLoaded()    # теперь можно удалить старый файл сэйва

        _base_res_list = ['expert_' + name for name in ['wood', 'stones', 'granite', 'flour', 'bread', 'ore', 'berries', 'fish', 'fish_sm']]
        _base_res_count = 0
        for n in _base_res_list: _base_res_count += stats[n]
        stats['base_res_count'] = _base_res_count

        # нужно обновить время, оставшееся при экспертном прохождении:
        _is_time_left = self.is_time_left()
        if _is_time_left:
            self.ShowWidget('idLeftTime', True)
            #self.ShowWidget('idLeftTimeV', True)
            stats['time_left'] = int(stats['time_left']/60)
        # нужно обновить очки за игру:
        _total_score = p_mgr.Get_user_setting('total_game_score')
        stats['score_total'] = _total_score
        self.OnScoresCalc(stats.score)
        #self.SetText('idGameScoreV', [('digit', _total_score)])
        for i in range(_count):
            _control = self.values_controls[i]
            _field = self.values_fields[i]
            if _field in stats:
                self.SetText( _control, [('digit', stats[_field])] )
            else:
                self.SetText( _control, [('digit', 0)] )
        self.Signals.Add('next_line', 200)
        for i in range(0,4):
            self.Signals.Add('salute', i*1000)
        self.Signals.Add('done', 5000)
        self.HideWidget('idOkBtn')
        self.HideWidget('idOkBG')
        self.HideWidget('idShareBtn')
        self.HideWidget('idShareBG')
        part_name_id = 'PART_ONE'
        if stats.episode_index == 2: part_name_id = 'PART_TWO'
        if stats.episode_index == 2 and stats.level_index == 6:
            self.SetText('idPartFirst', [('text', 'LEVEL_2_6')])
            self.SetText('idHeadOne', [('text', '')])
        else:
            self.SetText('idPartFirst', [('text', part_name_id)])
            self.SetText('idHeadOne', [('text','LEVEL_'+str(stats.episode_index) + '_' + str(stats.level_index))])
        #mbox(str(stats['time_min'])+'-'+str(stats['cur_time']))
        DLG.AllowSave(False)
# ============================================================
    def is_level_gold(self):
        '''Пройден ли уровень на золото'''
        if not self.stats:
            return False
        mode = DLG.PMgr.cur_user_stat.mode
        _is_gold = False
        #if self.stats.cur_time <= self.stats.level_time:
        if 'time_is_up' not in self.stats or self.stats.time_is_up == 0:
            _is_gold = True
        if self.stats.episode_index == 1:
            if self.stats.level_index == 1:  # успели, либо первый уровень - золото
                _is_gold = True
        if mode == 'relax': _is_gold = True
        return _is_gold
# ============================================================
    def is_time_left(self):
        '''Уровень пройден быстрее экспертного времени (первый уровень и релакс сюда НЕ входят)'''
        if not self.stats:
            return False
        mode = DLG.PMgr.cur_user_stat.mode
        _is_time_left = False
        if self.stats.cur_time <= self.stats.level_time:
            _is_time_left = True
        if self.stats.episode_index == 1:
            if self.stats.level_index == 1:  # успели, либо первый уровень - золото
                _is_time_left = False
        if mode == 'relax': _is_time_left = False
        return _is_time_left
# ============================================================
    def calc_score(self, stats):
        modes_coeffs = {'normal':1, 'easy':0.5, 'hard':2, 'relax':1}
        mode = DLG.PMgr.cur_user_stat.mode
        mode_c = modes_coeffs[mode]
        n = stats.level_index + (stats.episode_index > 1) * 5
        n_for_res = 1
        k = n - 2
        # # score_1 = n * r + n * t + 100 * n
        # # score_2 = n * r +n * t + 100*(n+k)

        # score_1 = n * r + n * t + 1000 * n
        # score_2 = n * r +n * t + 1000*(n+k)

        # ---
        result = 0
        res_list = ['expert_food', 'expert_bricks', 'expert_boards', 'expert_coins', 'expert_gold']
        _res_list = ['expert_' + name for name in ['wood', 'stones', 'granite', 'flour', 'bread', 'ore', 'berries', 'fish', 'fish_sm']]
        _need_expert_score = False
        _need_nonexpert_res = True
        if stats.cur_time <= stats.level_time:
            _need_expert_score = True
            _need_nonexpert_res = False
        if stats.episode_index == 1 and stats.level_index == 1:
            _need_expert_score = False
            _need_nonexpert_res = True
        if mode == 'relax':
            _need_expert_score = False
            _need_nonexpert_res = True
        if _need_expert_score:
            n_for_res = n
            t = int((stats.level_time - stats.cur_time)/1000)    # секунды
            result += n * t
        # эта часть не зависит от времени:
        result += n * 1000
        if stats.episode_index > 1: # для второго эпизода
            result += 1000 * k
        # учтем ресурсы:
        for name in res_list:
            result += 2 * n_for_res * stats[name]
        for name in _res_list:
            result += 1 * n_for_res * stats[name]
        _extra_score = 0
        return int(result * 100) + _extra_score # умножаем на 100 все очки и приводим к целому
# ============================================================
    def on_button(self, id):
        if id == 'idGames':
            DLG.SendMsg('more_games')
        elif id == 'idShareBtn':
            if self.Internet() == True:
                if self.isFbPostSuccessful() == 0:
                    self.FBpostStats()
            else:
                 DLG.Open_dialog('InternetMenu', 'dlg_internet')
        elif id == 'idFriend':
            DLG.SendMsg('tell_friend')
        elif id == 'idOkBtn':
            self.HideSpaceHolders()
            if self.is_final:
                DLG.StopGame()                  # теперь спокойно стопорим игру
                DLG.clear_awaitinig_dialogs()
            DLG.Close_dialog(self)
            self.ClearPostInfo()
            if self.stats.episode_index == 2:
                if self.stats.level_index == 5:
                    _params = {'episode':self.stats.episode_index,
                                'level':self.stats.level_index,
                                'is_start_comics':False,
                                'center_comics':False}
                    DLG.Open_dialog('ComicsMenu', 'dlg_comics', _params)
                    tools.PlayMenuMusic()
                    return
            elif self.stats.episode_index == 1:
                if self.stats.level_index == 5:
                    _params = {'episode':self.stats.episode_index,
                                'level':self.stats.level_index,
                                'is_start_comics':False,
                                'center_comics':True}
                    DLG.Open_dialog('ComicsMenu', 'dlg_comics', _params)
                    tools.PlayMenuMusic()
                    return
            if self.is_final:
                DLG.Open_dialog('BookMenu', 'dlg_book')
# ============================================================
    def cancel_dialog(self):
        '''Особенное поведение, вообще сохранять тут нечего'''
        if self.is_final:
            DLG.RemoveSaveIfLoaded()
            DLG.StopGame()                  # теперь спокойно стопорим игру
            DLG.clear_awaitinig_dialogs()
        DLG.Close_dialog(self)
# ============================================================
    def on_update(self, ms):
        if self.isFbPostSuccessful() == 1:
            self.ShowWidget('idFbOk', True)
            if self.fbPostDone == 0:
                DLG.Open_dialog('ShareTyMenu', 'dlg_share_ty')
                self.fbPostDone = 1
        else:
            self.ShowWidget('idFbOk', False)
        pass
# ============================================================
# ============================================================
# ============================================================
# ============================================================
