# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog

# ### ###############################
# ### Открывать через dlg.Open("QuestMenu", "dlg_quest", {"textid":...} )
# ### ###############################

class TradeDlg(dialog.Dialog):
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.params = params
        self.size = 'big'
        # если нужно, то доп. параметры можно вытащить из params
# ============================================================
    def on_signal(self, signal):
        pass
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == 'enter':
            pass
        elif type == 'exit':
            pass
        elif type == 'change':
            self.on_state_change(additional.prev_state, additional.next_state)
        pass
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_command(self, name, command, param):
        #if command == 'keycode':
        #    if param == 'enter':
        #        self.on_button('idOkBtn')
        #    elif param == 'escape':
        #        self.on_button('idCancelBtn')
        pass
# ============================================================
    small_image_text_map = {'food':'IMG_I_BUILD_RES,0', 'boards':'IMG_I_BUILD_RES,1',
                            'bricks':'IMG_I_BUILD_RES,2', 'coins':'IMG_I_BUILD_RES,3',
                            '_wood':'IMG_I_TRADING_RES,0',
                            '_fish':'IMG_I_TRADING_RES,3',
                            '_flour':'IMG_I_TRADING_RES,4',
                            '_ore':'IMG_I_TRADING_RES,1',
                            '_stones':'IMG_I_TRADING_RES,2',
                            '_granite':'IMG_I_TRADING_RES,2',
                            'boat':'IMG_I_TRADING_BOAT,0',
                            'teleport':'IMG_I_TRADING_BOAT,1',
                            }
    images_map = {'food':'IMG_I_TRADING_ICONS,4',
                    'boards':'IMG_I_TRADING_ICONS,0',
                    'bricks':'IMG_I_TRADING_ICONS,1',
                    'coins':'IMG_I_TRADING_ICONS,6',
                    'boat':'IMG_I_TRADING_ICONS,8',
                    'teleport':'IMG_I_TRADING_ICONS,9',
                    '_wood':'IMG_I_TRADING_ICONS,7',
                    '_fish':'IMG_I_TRADING_ICONS,3',
                    '_flour':'IMG_I_TRADING_ICONS,2',
                    '_ore':'IMG_I_TRADING_ICONS,6',
                    '_stones':'IMG_I_TRADING_ICONS,5',
                    '_granite':'IMG_I_TRADING_ICONS,5',
                    }

    def on_create(self):
        DLG.PauseGame(True)
        tools.PlaySound('SND_WINDOW_OPEN')
        # выставляем текст диалога:
        res_give = ''
        res_give_count = 0
        res_receive = ''      # can be 'boat' or 'telepor'
        res_receive_count = 0
        nameid = ''
        image_id = ''
        if 'nameid' in self.params:
            nameid = self.params['nameid']
        self.SetText('idIndianText', [('text', nameid)] )
        if 'imageid' in self.params:
            image_id = self.params['imageid']
            self.SetImage('idAvatar', image_id )
        if 'res_give' in self.params:
            res_give = self.params['res_give']
            if 'res_give_count' in self.params:
                res_give_count = int(self.params['res_give_count'])
                _img = self.get_small_image_id_with_frame(res_give)
                self.SetText('idGiveResText', [('image', _img), ('digit', res_give_count)])
                self.SetImage('idGiveImage', self.get_big_image_id_with_frame(res_give))
        if 'res_receive' in self.params:
            res_receive = self.params['res_receive']
            if 'res_receive_count' in self.params:
                res_receive_count = int(self.params['res_receive_count'])
                _img = self.get_small_image_id_with_frame(res_receive)
                self.SetText('idReceiveResText', [('image', _img), ('digit', res_receive_count)])
                if res_receive in ['boat', 'teleport'] or res_receive.startswith('inventory:'):
                    self.SetText('idReceiveResText', [('image', _img)])
                self.SetImage('idReceiveImage', self.get_big_image_id_with_frame(res_receive))
# ============================================================
    def get_small_image_id_with_frame(self, res_name):
        _is_inventory = res_name.startswith('inventory:')
        if _is_inventory:
            _template = res_name[len('inventory:'):]
            _id = DLG.GetTemplateAttr(_template, 'inventory_image')
            _frame = DLG.GetTemplateAttr(_template, 'inventory_frame')
            _id_with_frame = _id + ',' + _frame
            return _id_with_frame
        else:
            _img = self.small_image_text_map[res_name]
            return _img
# ============================================================
    def get_big_image_id_with_frame(self, res_name):
        _is_inventory = res_name.startswith('inventory:')
        if _is_inventory:
            _template = res_name[len('inventory:'):]
            _id = DLG.GetTemplateAttr(_template, 'inventory_big_image')
            _frame = DLG.GetTemplateAttr(_template, 'inventory_big_frame')
            _id_with_frame = _id + ',' + _frame
            return _id_with_frame
        else:
            _img = self.images_map[res_name]
            return _img
# ============================================================
#    def on_added(self):
#        dialog.Dialog.on_added(self)
# ============================================================
    def on_button(self, id):
        trace('Trade params:', self.params)
        _task_uid = self.params['task_uid']
        if id == 'idOkBtn':
            self.SendMsgTasks('task_callback', _task_uid, 'agree')
            DLG.PauseGame(False)
            DLG.Close_dialog(self)
        elif id == 'idCancelBtn':
            self.SendMsgTasks('task_callback', _task_uid, 'cancel')
            DLG.PauseGame(False)
            DLG.Close_dialog(self)
# ============================================================
    def cancel_dialog(self):
        self.SendMsgTasks('task_callback', _task_uid, 'cancel')
        DLG.PauseGame(False)
        DLG.Close_dialog(self)
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
# ============================================================
# ============================================================
# ============================================================
