# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

# ============================================================
# ============================================================
# ============================================================
# ============================================================
class FsmMethods(object):
    def __init__(self, _parent = None):
        self.ser_name = 'FsmMethods'
        self.states = {}
        self.parent = _parent
# ============================================================
    def apply_states(self, states):
        for state in states: self.states[state.name] = state(self.parent)
# ============================================================
    def fsm_on_can_enter(self, next_state, event_id):   # :bool
        if next_state in self.states:
            state = self.states[next_state]
            return state.can_enter(event_id)
        return True
# ============================================================
    def fsm_on_can_exit(self, cur_state, event_id):     # :bool
        if cur_state in self.states:
            state = self.states[cur_state]
            return state.can_exit(event_id)
        return True
# ============================================================
    def fsm_on_enter(self, cur_state, event_id):
        if cur_state in self.states:
            state = self.states[cur_state]
            state.on_enter(event_id)
# ============================================================
    def fsm_on_exit(self, cur_state, next_state):
        if cur_state in self.states:
            state = self.states[cur_state]
            state.on_exit(next_state)
# ============================================================
    def fsm_on_handle(self, cur_state, event_id):
        if cur_state in self.states:
            state = self.states[cur_state]
            state.on_handle(event_id)
# ============================================================
    def fsm_on_state_changed(self):
        cur_state = ''
        if self.parent:
            cur_state = self.parent.FSM_GetStateID()
        if cur_state in self.states:
            state = self.states[cur_state]
            state.on_state_changed()
        if self.parent:
            self.parent.switch_animation()
# ============================================================
# ============================================================
# ============================================================
