# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import task_callworker
import task_upgrade
import task_firefight

# ============================================================
# ============================================================
class FSMState(object):
    def __init__(self, item = None):
        self.item = item
        #self.FSM = item.FSM
        self.ser_name = '__none_fsmstate__'
# ============================================================
    def can_enter(self, event_id):
        return True
# ============================================================
    def can_exit(self, event_id):
        return True
# ============================================================
    def on_enter(self, event_id):
        pass
# ============================================================
    def on_exit(self, next_state):
        pass
# ============================================================
    def on_handle(self, event_id):
        pass
# ============================================================
    def on_state_changed(self):
        pass
# ============================================================
# ============================================================
# ============================================================
# ============================================================
# ============================================================

class StateInit(FSMState):
    name = 'init'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateInit'
    #def on_handle(evID):
    #    if evID == 'load_init_event':
    #        self.item.
# ============================================================
# ============================================================
class StateNormal(FSMState):
    name = 'normal'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateNormal'

    def on_enter(self, evID):
        pass

    def on_handle(self, evID):
        if evID == 'res_unit_in_event': # для штаба (он в normal состоянии)
            self.item.is_wait_res_unit = False
            b = self.item
            _unit = b.res_unit
            if _unit:
                b.take_resource(_unit.resource) # передаем ресурс
                _unit.resource = None
                #mbox(b.get('name'))
# ============================================================
class StateBuilding(FSMState):
    name = 'building'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateBuilding'

    def on_enter(self, evID):
        b = self.item
        b.show_clock(False)  # песочные часы ожидания
        b.on_before_building_complete()
        #b.SM.SetState('build')
        b.on_build_started()
        BMgr.SendGlobalMsg('build_started')
        b.PlaySoundG('SND_BUILDING_LOOP')
        b.Drawer.RestartEffect('build')

    def on_exit(self, next_state):
        b = self.item
        #b.SM.SetState('normal')
        b.switch_level('builded')   # переключаемся на следующий вариант
        # ---
        building_info = {'type':b.get('type'), 'subtype':b.get('subtype'), 'uid':b.get('uid')}
        EMgr.send_event( 'build_building_complete', b, building_info )
        _stype = b.get('stype')
        if _stype != 'bridge':
            EMgr.send_event( 'building_built', b )  # для prizes
        if b.is_priority_building:
            EMgr.send_event('priority_complete', b, building_info)
            b.is_priority_building = False
        b._on_build_complete(building_info)
        BMgr.SendGlobalMsg('build_completed')
        BMgr.SendGlobalMsg('buildings_count_change')
# ============================================================
class StateBuildWait(FSMState):
    name = 'build_wait'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateBuildWait'

    def on_enter(self, evID):
        b = self.item
        b.show_clock()  # песочные часы ожидания
        _is_fixed_place = b.GetAttrBool('fixed_place')
        if _is_fixed_place:
            b.switch_level_to_place()           # переключим здание на шаблон, который можно строить
        #b.SM.SetState('awaiting_action')
        BMgr.dependant_buildings.add_building(b)
        BMgr.SuspendPriority(b.get('name'))
        BMgr.SuspendBuildTemplate(b.get('name'), True)
        b.is_priority_building = True
        b.on_awaiting_action()

    def on_handle(self, evID):
        if evID == 'cancel_event':
            b = self.item
            BMgr.dependant_buildings.remove_building(b)
            b.show_clock(False)  # песочные часы ожидания
            task = b.get_participating_task('build_building')
            if task:    # если строили новое здание, но отменили
                b.PlaySoundG('SND_CLICK_TASK_CANCEL')
                task.cancel()
                #_is_fixed_place = b.GetAttrBool('fixed_place')
                #if not _is_fixed_place:     # потому что предустановленное здание на поле остается!
                BMgr.remove_building(b)
                b.unreserve_action_cells()
                #b.SM.SetState('normal')
            BMgr.UnsuspendPriority(b.get('name'))
            BMgr.SuspendBuildTemplate(b.get('name'), False)
            b.is_priority_building = False
        elif evID == 'cancel_mapplace_event':
            b = self.item
            b.show_clock(False)  # песочные часы ожидания
            task = b.get_participating_task('build_building')
            if task:    # если строили новое здание, но отменили
                b.PlaySoundG('SND_CLICK_TASK_CANCEL')
                task.cancel()
                b.on_mouse_in('button')
                b.unreserve_action_cells()
                #b.SM.SetState('normal')
                b.cancel_switch_level_to_place()
            BMgr.UnsuspendPriority(b.get('name'))
            BMgr.SuspendBuildTemplate(b.get('name'), False)
            b.is_priority_building = False
# ============================================================
# ============================================================
class StateSurvived(FSMState):
    name = 'survived'

    def __init__(self,item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateSurvived'

    def on_exit(self, next_state):
        self.item.activate()
        BMgr.dependant_buildings.add_building(self.item)
        self.item.on_survived_activate()
# ============================================================
class StateThrown(FSMState):
    name = 'thrown'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateThrown'

    def on_enter(self, evID):
        b = self.item
        b.show_lock()  # замок, если нет доступных деревьев
        BMgr.dependant_buildings.remove_building(b)
        # отправить юнита в главное здание, если это допустимо
        task = b.get_participating_task('call_worker_to_building')
        if task:    # если отменяем апгрейд
            task.cancel()
        b.return_worker_home()
        _fsm_state = b.FSM.GetStateID()
        if _fsm_state != 'init':
            b.PlaySound('SND_BUILDING_ABANDONED')
        b.switch_to_blocked_level()  # здание брошено
# ============================================================
# ============================================================
class StateMapPlace(FSMState):
    name = 'map_place'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateMapPlace'
# ============================================================
# ============================================================
class StatePreremoving(FSMState):
    name = 'preremoving'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StatePreremoving'

    def on_enter(self, evID):
        b = self.item
        b.lost_resource()       # ресурс производства теряется
        if b.has_workers():
            _unit = b.get_worker()
            if _unit:
                _unit.show()
                #_unit.Drawer.StopAnimation('')
                _unit.stop_walk()
                #b.worker_units.remove(_unit)
        b.start_final_countdown()
        b.show_arrow(False)

    def on_exit(self, next_state):
        if next_state != 'removing':
            b = self.item
            b.cancel_countdown()
            _has_workers = b.has_workers()
            if _has_workers:
                _unit = b.get_worker()
                if _unit:
                    _unit.hide()
        self.item.StopRoundBar()
# ============================================================
# ============================================================
class StateRemovingHouse(FSMState):
    name = 'removing_house'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateRemovingHouse'

    def on_enter(self, evID):
        b = self.item
        b.is_deactivated = True # чтобы их не включили нигде
        b.non_selectable = True
        b.free_all_units_before_demolition()
        uid = b.get('uid')
        map_index = b.get('locind')
        TMgr.process_removing_item(uid, map_index)  # всеравно здание уже будет уничтожено

    def on_state_changed(self):
        b = self.item
        b.on_non_functional()

    def on_exit(self, next_state):
        b = self.item
# ============================================================
# ============================================================
class StateRemoving(FSMState):
    name = 'removing'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateRemoving'

    def on_enter(self, evID):
        b = self.item
        b.is_deactivated = True # чтобы их не включили нигде
        b.non_selectable = True
        #_show_out_layers = b.shaded_layers[:]
        #_show_out_layers.extend(['bush' + str(i+1) for i in range(0,6)])
        #_show_out_layers.append('icons')
        _show_out_layers = ''
        BMgr.dependant_buildings.remove_building(b)
        b.Drawer.ShowImages('boom')
        b.Drawer.StartEffectOnce('boom')
        b.Drawer.ShowOut(_show_out_layers, 1800)    # плавное гашение здания
        b.Drawer.ShowImages(['anim'], False)
        b.Drawer.StopEffect('anim')
        b.Signals.Restart('building_need_afterdeath', 1000)
        b.Signals.Restart('add_afterdeath_item', 200)
        b.PlaySound('SND_BUILDING_DESTROY')
        uid = b.get('uid')
        map_index = b.get('locind')
        TMgr.process_removing_item(uid, map_index)  # всеравно здание уже будет уничтожено

    def on_state_changed(self):
        b = self.item
        if not b.IsSubTypeOf('house'):
            b.on_non_functional()

    def on_exit(self, next_state):
        b = self.item
# ============================================================
# ============================================================
class StateRemovingFinal(FSMState):
    name = 'removing_final'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateRemovingFinal'

    def on_enter(self, evID):
        b = self.item
        b.Signals.Restart('building_dead', 1000)

    def on_exit(self, next_state):
        b = self.item
        _uid = b.get('uid')
        #if _uid == '4449':
        #    if LBoard.Core.episode == 1 and LBoard.Core.level == 1:
        #        _need_help = LBoard.Core.is_help_needed(1)
        #        if _need_help:
        #            UI.open_help(1)
        _unit = None
        BMgr.RemoveItemFromMap(b)
        b.unreserve_action_cells()
        returning_unit = b.return_worker_home()      # отпускаем работника
        b.drop_cost_items(returning_unit)         # выбрасываем возвратную стоимость на карту
        b.on_non_functional()
        b.on_non_functional_internal()
        #BMgr.remove_building(b)     # удаляем здание с карты
        EMgr.send_event('building_removed', None)
# ============================================================
# ============================================================
class StateRepairing(FSMState):
    name = 'repairing'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateRepairing'

    def on_enter(self, evID):
        b = self.item
        b.on_upgrade_started()  #@ in repair???
        BMgr.SendGlobalMsg( 'repair_started' )
        b.show_clock(False)  # песочные часы ожидания
        #b.SM.SetState('upgrade')
        # ^ upgrade (not working :`( ):
        #self.item.PlaySoundG('SND_BUILDING_LOOP')
        #self.item.Drawer.RestartEffect('repair')
        if b.status == 'normal':
            if b.hack_for_upgrade:
                b.show_unit = True
        if not b.is_digger_upgrade:
            b.PlaySoundG('SND_BUILDING_LOOP')
            b.Drawer.RestartEffect('repair')

    def on_handle(self, evID):
        if evID == 'prenormal_event':
            b = self.item
            #b.SM.SetState('normal')
            b.switch_level('repaired')   # переключаемся на следующий вариант (после того, как состояние здания перевели в normal !)
            trace('Building repair complete')

    def on_exit(self, next_state):
        b = self.item
        building_info = {'type':b.get('type'), 'subtype':b.get('subtype'), 'uid':b.get('uid')}
        EMgr.send_event( 'build_repair_complete', b, building_info )
        #_stype = b.get('stype')
        #if _stype not in {}:#{'bridge':0, 'dam':0, 'totem':0, 'totem_stone':0}:
        EMgr.send_event( 'building_repaired', b )  # для prizes
        if b.is_priority_building:
            EMgr.send_event('priority_complete', b, building_info)
            b.is_priority_building = False
        b._on_repair_complete(building_info)
        BMgr.SendGlobalMsg('repair_completed')
        BMgr.SendGlobalMsg('buildings_count_change')
# ============================================================
# ============================================================
class StateRepairWait(FSMState):
    name = 'repair_wait'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateRepairWait'

    def on_enter(self, evID):
        b = self.item
        BMgr.dependant_buildings.add_building(b)
        TMgr.add_task( task_upgrade.UpgradeTask(b) )
        b.show_arrow(False)
        #b.SM.SetState('awaiting_action')    # added 14 september 2012...
        BMgr.SuspendPriority(b.get('name'))
        BMgr.SuspendBuildTemplate(b.get('name'), True)
        b.is_priority_building = True
        b.on_awaiting_action()

    def on_handle(self, evID):
        if evID == 'cancel_event':
            b = self.item
            BMgr.dependant_buildings.remove_building(b)
            task = b.get_participating_task('upgrade_building')
            if task:    # если отменяем апгрейд
                b.PlaySoundG('SND_CLICK_TASK_CANCEL')
                task.cancel()
                #self.is_upgrade_units_waiting = False
            #b.SM.SetState('normal')
            BMgr.UnsuspendPriority(b.get('name'))
            BMgr.SuspendBuildTemplate(b.get('name'), False)
            self.is_priority_building = False

    def on_exit(self, next_state):
        b = self.item
# ============================================================
# ============================================================
class StateUpgrading(FSMState):
    name = 'upgrading'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateUpgrading'

    def on_enter(self, evID):
        b = self.item
        b.is_upgrade_units_waiting = False
        b.on_upgrade_started()
        BMgr.SendGlobalMsg( 'upgrade_started' )
        b.show_clock(False)  # песочные часы ожидания
        #b.SM.SetState('upgrade')
        if b.status == 'normal':
            if b.hack_for_upgrade:
                b.show_unit = True
        b.PlaySoundG('SND_BUILDING_LOOP')
        b.Drawer.RestartEffect('upgrading')
        #b.lost_resource()     # остановим генерацию ресурса, если здание начало апгрейд

    def on_handle(self, evID):
        if evID == 'prenormal_event':
            b = self.item
            #b.SM.SetState('normal')
            b.switch_level('upgraded')
            trace('Building upgrade complete')   # переключаемся на следующий вариант (после того, как состояние здания перевели в normal !)

    def on_exit(self, next_state):
        b = self.item
        building_info = {'type':b.get('type'), 'subtype':b.get('subtype'), 'uid':b.get('uid')}
        EMgr.send_event( 'build_upgrade_complete', b, building_info )
        #_stype = b.get('stype')
        #if _stype not in {}:#{'bridge':0, 'dam':0, 'totem':0, 'totem_stone':0}:
        EMgr.send_event( 'building_upgraded', b )  # для prizes
        b._on_upgrade_complete(building_info)
        BMgr.SendGlobalMsg('upgrade_completed')
# ============================================================
# ============================================================
class StateGenerated(FSMState):
    name = 'generated'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateGenerated'

    def on_enter(self, evID):
        self.item.generate_resource()

    #def on_exit(self, next_state):
    #    if next_state != '':
    #        self.item.lost_resource()
# ============================================================
# ============================================================
class StateGenerating(FSMState):
    name = 'generating'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateGenerating'

    def on_enter(self, evID):
        self.item._start_resource_generation()

    def on_exit(self, next_state):
        if next_state != 'generated':
            self.item.lost_resource()
        self.item.is_generating_res = False  # при выходе всегда сбрасываем
# ============================================================
# ============================================================
class StateBroken(FSMState):
    name = 'broken'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateBroken'

    def on_broken(self):
        pass
# ============================================================
# ============================================================
class StateAttacked(FSMState):
    name = 'attacked'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateAttacked'

    def on_enter(self, evID):
        b = self.item
        b.on_attack_started()       # начали атаку здания
        b.set_under_attack()
        b.lost_resource()

    def on_exit(self, next_state):
        b = self.item
        b.reset_under_attack()
        b.task = None
        if next_state != 'broken':
            b.on_attack_canceled()
        else:
            BMgr.dependant_buildings.remove_building(b)
# ============================================================
class StateBurning(FSMState):
    name = 'burning'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateBurning'

    def on_enter(self, evID):
        b = self.item

# ============================================================
class StateFirefighterWait(FSMState):
    name = 'firefighter_wait'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateFirefighterWait'

    def on_enter(self, evID):
        b = self.item
        TMgr.add_task( task_firefight.FirefighterTask(b) )
        b.show_arrow(False)
        #b.SM.SetState('awaiting_action')    # added 14 september 2012...
        #BMgr.SuspendPriority(b.get('name'))
        #BMgr.SuspendBuildTemplate(b.get('name'), True)
        #b.is_priority_building = True
        b.on_awaiting_action()

    def on_handle(self, evID):
        if evID == 'cancel_event':
            b = self.item
            task = b.get_participating_task('run_firefighter')
            if task:    # если отменяем апгрейд
                b.PlaySoundG('SND_CLICK_TASK_CANCEL')
                task.cancel()
            #b.SM.SetState('normal')
            #BMgr.UnsuspendPriority(b.get('name'))
            #BMgr.SuspendBuildTemplate(b.get('name'), False)
            #self.is_priority_building = False
# ============================================================
class StateExtinguishing(FSMState):
    name = 'extinguishing'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateExtinguishing'

    def on_enter(self, evID):
        b = self.item
        b.show_clock(False)

    def on_exit(self, next_state):
        b = self.item
        b.switch_level('extinguished')
        b.on_extinguish_complete()
        EMgr.send_event('building_extinguished', b)
        TMgr.gameHelper.StopSoundCountedSafe(b.get('uid'), 'SND_BUILDING_FIRE', False)
# ============================================================
# ============================================================
class StateWaitUnit(FSMState):
    name = 'wait_unit'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StateWaitUnit'

    def on_enter(self, evID):
        #self.item.call_units()
        b = self.item
        _need_call_units = b.need_call_units()
        if _need_call_units:
            TMgr.add_task( task_callworker.CallWorkerTask(b) )   # позовем юнита для начала работ

    def on_handle(self, evID):
        if evID == 'res_unit_in_event':
            self.item.is_wait_res_unit = False
            b = self.item
            _unit = b.res_unit
            if _unit:
                b.take_resource(_unit.resource) # передаем ресурс
                _unit.resource = None
# ============================================================
# ============================================================
# ============================================================
# ============================================================
class StatePrenormal(FSMState):
    name = 'prenormal'

    def __init__(self, item = None):
        FSMState.__init__(self, item)
        self.ser_name = 'StatePrenormal'

    def on_enter(self, evID):
        b = self.item
        if b.is_under_attack:
            trace('>> ScriptFSM: precomplete is_under_attack')
            return    # а что делать-то? Если, конечно мы здесь окажемся
        if evID == 'unit_in_event':
            _workers = len(b.worker_units)
            if _workers == 1:
                b._on_first_unit_in()
        if b.status == 'broken':
            _vname = b.get('variant_name')
            _is_thrown = _vname.startswith('thrown')
            if _is_thrown:
                b.FSM.HandleEvent('thrown_event')
                return
        _last_fsm_event = ''
        _need_worker = False
        if b.need_call_units():
            b.FSM.HandleEvent('wait_unit_event')             # нужно позвать работника в здание
            _last_fsm_event = 'wait_unit_event'
            _need_worker = True     # чтобы "заказать" ресурс до того, как заселится работник
        #else:   # если уже есть работники
        if True:
            _need_base_resource = b.need_base_resource()
            if _need_base_resource:
                _can_generate = b._can_generate_resource()
                if _can_generate:
                    _is_base_res_enough = b._is_base_res_enough()
                    if _is_base_res_enough:
                        b.FSM.HandleEvent('start_generation_event')  # можно начинать генерировать
                        _last_fsm_event = 'start_generation_event'
                    else:
                        #b.FSM.HandleEvent('wait_res_unit_event') # нужно запросить ресурсы
                        if not b.is_wait_res_unit:  # если еще не ждем ресурсов
                            if _need_worker:
                                b.Signals.Restart('call_unit_with_res', 500)
                                _last_fsm_event = 'call_unit_with_res'
                            else:
                                b._call_unit_with_res()
                                _last_fsm_event = 'F call_unit_with_res'
                        else:
                            _last_fsm_event = 'waiting_res_unit'
                else:
                    if not _need_worker:
                        if b.is_generated_res:
                            b.call_take_res_unit()
                            _last_fsm_event = 'F call_take_res_unit'
                        else:
                            b.FSM.HandleEvent('normal_event')    # а что еще можно сделать в этом случае? Пусть лучше уж просто стоит.
                            _last_fsm_event = 'normal_event'
                    else:
                        _last_fsm_event = 'need_worker'
            else:
                if not _need_worker:
                    _can_generate = b._can_generate_resource()
                    if _can_generate:
                        b.FSM.HandleEvent('start_generation_event')  # можно начинать генерировать
                        _last_fsm_event = 'start_generation_event 2'
                    elif b.is_generated_res:
                        b.call_take_res_unit()
                        _last_fsm_event = 'F call_take_res_unit'
                    else:
                        b.FSM.HandleEvent('normal_event')    # а что еще можно сделать в этом случае? Пусть лучше уж просто стоит.
                        _last_fsm_event = 'normal_event'
                else:
                    _last_fsm_event = 'need_worker 2'
        trace('PRENORMAL result =', _last_fsm_event)

    def can_exit(self, evID):
        if evID == 'res_unit_in_event':
            _units_in = len(self.item.worker_units)
            if _units_in > 0:
                return True
            return False
        #elif evID == 'unit_in_event':
        #    return True
        return True

    def on_handle(self, evID):
        if evID == 'res_unit_in_event':
            self.item.is_wait_res_unit = False
            b = self.item
            _unit = b.res_unit
            if _unit:
                b.take_resource(_unit.resource) # передаем ресурс
                _unit.resource = None
                #mbox(b.get('name'))
# ============================================================
# ============================================================