# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *


import base_unit
import unit_worker
import unit_general
import unit_wcutter
import unit_quarry
import unit_indian_sit
import unit_questman_boat
import unit_barb
import unit_trader
import unit_enemy
import unit_doctor
import unit_firefighter

import base_building
import b_bakery
import b_boatyard
import b_bridge
import b_doctor
import b_camp
import b_column
import b_dam
import b_farm
import b_farm_field
import b_fence
import b_fisherman
import b_forester
import b_forester_field
import b_garden
import b_granitemine
import b_house
import b_ind_house
import b_mint
import b_nofog
import b_quarry
import b_sawmill
import b_shoemaker
import b_silvermine
import b_smokery
import b_stonecutter
import b_totem
import b_tower
import b_warehouse
import b_waterpump
import b_well
import b_woodcutter
import b_workshop
import d_barbarian_nest
import d_boards_helper
import d_boat
import d_bog
import d_bonus_altar
import d_bonuskey
import d_bush
import d_chest
import d_crater
import d_dr_tree
import d_enabler
import d_enter
import d_fish
import d_gate
import d_geyser
import d_gold
import d_granite
import d_grave
import d_ind_altar
import d_ind_bridge
import d_ind_house_br
import d_indian_worker
import d_inventory
import d_item_changer
import d_key
import d_lama
import d_lava
import d_letter
import d_mais
import d_none
import d_pot
import d_random_res
import d_res
import d_stalactite
import d_stone
import d_stonegate
import d_task_item
import d_teleport
import d_test
import d_totem_barb
import d_tree
import d_unit_res
import d_waterfall
import mgr_b
import mgr_u
import mgr_t
import mgr_q
import mgr_e
import ui

import base_diff_item
#from unit_worker import UnitWorker     # не работает, потому что encode.py требует __dict__, которого нет

units_uid = 0
buildings_uid = 0
different_uid = 0
current_level_board = None
global_episode = 0
global_level = 0
is_first_barbarian = True
# ============================================================
buildings_classes = {
    '': base_building.BaseBuilding,
    'bakery': b_bakery.BakeryBuilding,
    'boatyard': b_boatyard.BoatyardBuilding,
    'bridge': b_bridge.Bridge,
    'column': b_column.Column,
    'dam': b_dam.DamBuilding,
    'hospital': b_doctor.DoctorBuilding,
    'farm': b_farm.FarmBuilding,
    'farm_field': b_farm_field.FarmField,
    'fence': b_fence.FenceBuilding,
    'forester': b_forester.ForesterBuilding,
    'forester_field': b_forester_field.ForesterField,
    'fisherman': b_fisherman.FishermanBuilding,
    'garden': b_garden.GardenBuilding,
    'granitemine': b_granitemine.GranitemineBuilding,
    'house': b_house.HouseBuilding,
    'hq': b_camp.CampBuilding,
    'hq_small': b_camp.CampBuilding,
    'ind_house_w': b_ind_house.IndBuilding,
    'mint': b_mint.MintBuilding,
    'no_fog': b_nofog.Nofog,
    'quarry': b_quarry.QuarryBuilding,
    'sawmill': b_sawmill.SawmillBuilding,
    'shoemaker': b_shoemaker.ShoemakerBuilding,
    'silvermine': b_silvermine.SilvermineBuilding,
    'smokery': b_smokery.SmokeryBuilding,
    'stonecutter': b_stonecutter.StonecutterBuilding,
    'totem': b_totem.Totem,
    'totem_stone': b_totem.Totem,
    'warehouse': b_warehouse.WarehouseBuilding,
    'waterpump': b_waterpump.Waterpump,
    'watchtower': b_tower.TowerBuilding,
    'well':       b_well.Well,
    'woodcutter': b_woodcutter.WoodcutterBuilding,
    'workshop': b_workshop.WorkshopBuilding,
    }
units_classes = {
    '': base_unit.BaseUnit,
    'survived': unit_worker.UnitWorker,
    'worker': unit_worker.UnitWorker,
    'general': unit_general.UnitGeneral,
    'woodcutter': unit_wcutter.UnitWoodcutter,
    'qman': unit_quarry.UnitQuarry,
    'indian_1': unit_indian_sit.UnitIndianSit,
    'indian_2': unit_indian_sit.UnitIndianSit,
    'questman_boat': unit_questman_boat.UnitQuestmanBoat,
    'indianwarr': unit_indian_sit.UnitIndianSit,
    'barb': unit_barb.UnitBarbarian,
    'trader': unit_trader.UnitTrader,
    'unit_enemy': unit_enemy.UnitEnemy,
    'unit_doctor': unit_doctor.UnitDoctor,
    'unit_firefighter': unit_firefighter.UnitFirefighter,
    }
different_classes = {
    '': base_diff_item.DiffItem,
    'boat': d_boat.Boat,
    'boards_helper': d_boards_helper.BoardsHelper,
    'bonus_altar': d_bonus_altar.BonusAltar,
    'bricks_helper': d_boards_helper.BoardsHelper,
    'bog': d_bog.Bog,
    'bonuskey': d_bonuskey.BonusKey,
    'burrel': d_pot.Pot,
    'bush': d_bush.Bush,
    'chest': d_chest.Chest,
    'crator': d_crater.Crater,
    'dr_tree': d_dr_tree.DrTree,
    'enabler': d_enabler.Enabler,
    'enter': d_enter.Enter,
    'fish': d_fish.Fish,
    'gate': d_gate.Gate,
    'general_res': d_res.GeneralResource,
    'geyser': d_geyser.Geyser,
    'granite': d_granite.Granite,
    'grave_in': d_grave.Grave,
    'indian_bridge': d_ind_bridge.IndBridge,
    'ind_house_br': d_ind_house_br.IndHouseBreakable,
    'indian_worker': d_indian_worker.IndWorker,
    'inventory': d_inventory.Inventory,
    'item_changer': d_item_changer.ItemChanger,
    'key': d_key.Key,
    'indian_lama': d_lama.Lama,
    'lava': d_lava.Lava,
    'letter': d_letter.Letter,
    'mais': d_mais.Mais,
    'pot': d_pot.Pot,
    'gold': d_gold.Gold,
    'nest': d_barbarian_nest.Nest,
    'none': d_none.None,
    'teleport': d_teleport.Teleport,
    'test': d_test.Test,
    'indians_altar': d_ind_altar.IndAltar,
    'random_res': d_random_res.RandomRes,
    'stalactite': d_stalactite.Stalactite,
    'stone': d_stone.Stone,
    'stonegate': d_stonegate.StoneGate,
    'totem_barb': d_totem_barb.BarbarianTotem,
    'tree': d_tree.Tree,
    'unit_res': d_unit_res.UnitResource,
    'task_item': d_task_item.TaskDiffItem,
    'waterfall': d_waterfall.Waterfall,
    }
managers_classes = {
    'buildings_mgr': mgr_b.BuildingsMgr,
    'units_mgr': mgr_u.UnitsMgr,
    'tasks_mgr': mgr_t.TasksMgr,
    'events_mgr': mgr_e.EventsMgr,
    'quests_mgr': mgr_q.QuestsMgr,
    }
# ============================================================
# ============================================================
class LBCore(object):
# ============================================================
    def __init__(self, episode = 0, level = 0, subindex = 0):
        self.ser_name = 'LBCore'
        self.episode = episode
        self.level = level

        self.units_uid = 0
        self.buildings_uid = 0
        self.different_uid = 0
        self.is_first_barbarian = True

        #self.subindex = subindex
        self.levels_settings = {}
        self.exits = {}             # exit points to another sublevels
        self.neighbor_levels = {}   # neighbor levels
        self.doctors = {}
        self.firefighters = {}
        if self.episode == 1 and self.level == 3:
        #if self.episode == 0 and self.level == 0:
            self.is_first_barbarian = True
        else:
            self.is_first_barbarian = False
        #if self.episode == 1 and self.level == 1:
        #    UStats.AddLevelValue('main_tasks_complete', 1)  # затычка просто
# ============================================================
    def need_barbarian_arrow(self):
        if self.episode == 1 and self.level == 3 and self.is_first_barbarian:
        #if self.episode == 0 and self.level == 0 and self.is_first_barbarian:
            self.is_first_barbarian = False
            return True
        else:
            return False
# ============================================================
    def init(self, subindex, settings = None):
        if settings:
            self.levels_settings[subindex] = settings
        self.exits[subindex] = []
        self.neighbor_levels[subindex] = []
        self.doctors[subindex] = []
        self.firefighters[subindex] = []
# ============================================================
    def is_main_level(self):
        map_index = BMgr.GetCurMapIndex()
        return (map_index == 0)
# ============================================================
    def get_setting(self, name, map_index=0):
        _lev_settings = self.levels_settings[map_index]
        if name in _lev_settings:
            return _lev_settings[name]
        else:
            return '0'
# ============================================================
    def is_help_needed(self, index):
        '''Нужно ли показывать экран хэлпа'''
        trace('LB.is_help_needed:', index)
        help_shown = LBoard.GetUserSetting('help_shown')
        trace('     LB.is_help_needed:', help_shown)
        #if index == help_shown + 1:
        if index > help_shown: # first fix
            return True
        return False
# ============================================================
    def try_open_help(self, _episode, _level, help_index, cur_obj, target_uid = ''):
        if self.episode == _episode:
            if self.level == _level:
                _need_help = self.is_help_needed(help_index)
                if _need_help:
                    if target_uid != '':
                        _uid = cur_obj.get('uid')
                        if _uid == target_uid:
                            Camera.MoveTo(cur_obj)
                            UI.open_help(help_index)
                    else:
                        if cur_obj:
                            Camera.MoveTo(cur_obj)
                        UI.open_help(help_index)
# ============================================================
    def on_location_switched(self, subindex):
        global current_level_board
        if subindex != 0:  # подуровень
            _lev_settings = self.levels_settings[subindex]
            _level_type = GetS(_lev_settings, 'level_type')
            if _level_type == 'underlevel':
                BMgr.HideBuildButton()
                if current_level_board:
                    LBoard.DisableClouds(current_level_board)
            elif _level_type == 'sublevel':
                BMgr.ShowBuildButton(False)
        else:   # главный уровень
            BMgr.ShowBuildButton(False)
        # hack for 2_6_3:
        if self.episode == 2:
            if self.level == 6:
                if subindex == 3:
                    TMgr.gameHelper.mute_safe_sounds('enabler', False)
                else:
                    TMgr.gameHelper.mute_safe_sounds('enabler', True)
# ============================================================
    def on_new_location_loading(self, subindex):
        pass
# ============================================================
    def on_global_event(self, event, param):
        if event == 'location_switched':
            subindex = int(param)
            self.on_location_switched(subindex)
        elif event == 'new_location_loading':
            subindex = int(param)
            self.on_new_location_loading(subindex)
        elif event == 'location_loaded':
            subindex = int(param)
            LBoard.Core.init(subindex)
        elif event == 'territory_expanded':
            LBoard.Core.refresh_nighbors_exits()
# ============================================================
    def refresh_nighbors_exits(self):
        _mi = BMgr.GetCurMapIndex()
        _exits = BMgr.get_items_by_subtype(_mi, 'enter', True, True, True)
        _graves = BMgr.get_items_by_subtype(_mi, 'grave_in', True, True, True)
        _exits.extend( _graves )
        self.exits[_mi] = _exits
        _levels = []
        for _e in _exits:   # some can be inaccessible or inactive
            _levels.append(_e.GetAttrInt('sublevel'))
        self.neighbor_levels[_mi] = _levels
        #mbox(to_str(_exits))
# ============================================================
    def append_building(self, building):
        _mi = building.get('locind')
        _stype = building.get('stype')
        if _stype == 'hospital':
            if building not in self.doctors[_mi]:
                self.doctors[_mi].append(building)
        elif _stype == 'waterpump':
            if building not in self.firefighters[_mi]:
                self.firefighters[_mi].append(building)
# ============================================================
    def remove_building(self, building):
        _mi = building.get('locind')
        _stype = building.get('stype')
        if _stype == 'hospital':
            if building in self.doctors[_mi]:
                self.doctors[_mi].remove(building)
        elif _stype == 'waterpump':
            if building in self.firefighters[_mi]:
                self.firefighters[_mi].remove(building)
# ============================================================
    def get_hospitals_skip_levels(self):
        return [(2,3,2), (2,5,3), (2,6,4)]
# ============================================================
    def get_hospitals_skip_only_values(self, cur_mapindex):
        _exclude_levels = self.get_hospitals_skip_levels()
        _skip_mapindex = -1 # если нужно исключить один из подуровней
        _only_mapindex = -1 # если проверять нужно только один подуровень
        for lev in _exclude_levels:
            e = lev[0]
            l = lev[1]
            s = lev[2]
            if e == self.episode:
                if l == self.level:
                    if s == cur_mapindex:
                        _only_mapindex = cur_mapindex
                    else:
                        _skip_mapindex = cur_mapindex
        return (_skip_mapindex, _only_mapindex)
# ============================================================
    def has_doctor(self, map_index, with_neighbors = True):
        return self.get_doctors(map_index, with_neighbors, False)
# ============================================================
    def get_doctors(self, map_index, with_neighbors = True, return_all = True):
        '''Необходимо сделать так, чтобы докторы учитывались на всех подуровнях. Но с учетом исключений!'''
        _exclude_levels = self.get_hospitals_skip_levels()
        _skip_mapindex = -1 # если нужно исключить один из подуровней
        _only_mapindex = -1 # если проверять нужно только один подуровень
        _len = len(self._get_doctors_array(map_index))
        if _len == 0:
            skip_only = self.get_hospitals_skip_only_values(map_index)
            _skip_mapindex = skip_only[0]
            _only_mapindex = skip_only[1]
        if return_all:
            if _len > 0:
                return self.doctors[map_index]  # если есть на данном подуровне, то других и не ищем...
            elif with_neighbors:
                _result = []
                if _only_mapindex >= 0: # значит на данном подуровне нет (т.к. _len == 0)
                    return []
                if map_index in self.neighbor_levels:
                    for _l in self.neighbor_levels[map_index]:
                        if _l != _skip_mapindex:
                            _result.extend(self.get_doctors(_l, False))
                return _result
            return []
        else:
            if _len > 0:
                return True
            elif with_neighbors:
                if _only_mapindex >= 0: # значит на данном подуровне нет (т.к. _len == 0)
                    return False
                if map_index in self.neighbor_levels:
                    for _l in self.neighbor_levels[map_index]:
                        if _l != _skip_mapindex:
                            if self.has_doctor(_l, False):
                                return True
            return False
# ============================================================
    def has_firefighter(self, map_index, with_neighbors = True):
        return self.get_firefighters(map_index, with_neighbors, False)
# ============================================================
    def get_firefighters(self, map_index, with_neighbors = True, return_all = True):
        _ffighters = self._get_firefighters_array(map_index)
        _len = len(_ffighters)
        if return_all:
            if _len > 0:
                return _ffighters
            elif with_neighbors:
                _result = []
                for _l in self.neighbor_levels[map_index]:
                    _result.extend(self.get_firefighters(_l, False))
                return _result
            return []
        else:
            _len = len(self.firefighters[map_index])
            if _len > 0:
                return True
            elif with_neighbors:
                for _l in self.neighbor_levels[map_index]:
                    if self.has_firefighter(_l, False):
                        return True
            return False
# ============================================================
    def _get_doctors_array(self, map_index):
        if map_index in self.doctors:
            return self.doctors[map_index]
        else:
            return []
# ============================================================
    def _get_firefighters_array(self, map_index):
        if map_index in self.firefighters:
            return self.firefighters[map_index]
        else:
            return []
# ============================================================
# ============================================================
def reset():
    BMgr.reset()
    #del mgr_b.BuildingsMgr.all_buildings[:]
    #del mgr_b.BuildingsMgr.all_units[:]
    #del mgr_b.BuildingsMgr.all_items[:]
    #mgr_b.BuildingsMgr.FBC = mgr_b.BuildingsContainer()
    #mgr_b.BuildingsMgr.uids_dict = {}

    # Inventory TEST:
    # item = {'name':'test', 'image':'ITEM_POT2', 'frame':str(0)}
    # UStats.Inventory.AddQuestItem(item)
# ============================================================
def create_unit(type, subtype, cdata):
    # НЕОБХОДИМО РАЗДЕЛЕНИЕ ПО МАССИВАМ, чтобы быстрее работало на каждой из локаций
    trace('create unit')
    unit = None
    if type == 'unit':
        trace('create unit 1')
        if subtype in units_classes:
            trace('create unit 2', subtype)
            classname = units_classes[subtype]
            unit = classname(cdata)
            map_index = unit.get('locind')
            units_cluster = UMgr.get_cluster(map_index)
            if subtype == 'worker':
                trace('create unit 3')
                units_cluster.all_units.append(unit)
                units_cluster.total_workers.append(unit)
    if unit != None:
        trace('create unit 4')
        map_index = unit.get('locind')
        cluster = BMgr.get_cluster(map_index)
        cluster.all_units.append(unit)
        cluster.uids_dict[unit.get('uid')] = unit
        BMgr.all_levels_units.append(unit)
        global units_uid
        unit.uid = units_uid
        units_uid = units_uid + 1
        if unit.IsSubTypeOf('general'):   # if general was created
            trace('create unit 5')
            UMgr.get_cluster(map_index).general = unit         # store him
    trace('create unit 6')
    if unit:
        if 'ser_name' not in unit:
            mbox('No ser_name in unit "' + unit.get('name') + '"')
    return unit
# ============================================================
def create_building(type, subtype, cdata):
    trace('create building')
    result = None
    if type == 'building':
        trace('create building 1')
        if subtype in buildings_classes:
            trace('create building 2', subtype)
            classname = buildings_classes[subtype]
        else:
            trace('create building 3', subtype)
            classname = buildings_classes['']
        result = classname(cdata)
        trace('create building 4')
        map_index = result.get('locind')
        global buildings_uid
        result.uid = buildings_uid
        buildings_uid = buildings_uid + 1
        cluster = BMgr.get_cluster(map_index)
        cluster.all_buildings.append(result)
        cluster.FBC.append(result)
        cluster.uids_dict[result.get('uid')] = result
        BMgr.all_levels_buildings.append(result)
    trace('create building 5')
    if result:
        if 'ser_name' not in result:
            mbox('No ser_name in unit "' + result.get('name') + '"')
    return result
# ============================================================
def create_item(type, subtype, cdata):
    trace('create item')
    if subtype in different_classes:
        trace('create item 1', subtype)
        classname = different_classes[subtype]
    else:
        trace('create item 2', subtype)
        classname = different_classes['']
    result = classname(cdata)
    map_index = result.get('locind')
    cluster = BMgr.get_cluster(map_index)
    cluster.all_items.append(result)
    cluster.uids_dict[result.get('uid')] = result
    BMgr.all_levels_items.append(result)
    #mgr_b.BuildingsMgr.all_items.append(result)
    #mgr_b.BuildingsMgr.uids_dict[result.get('uid')] = result
    global different_uid
    if result:
        result.uid = different_uid
    different_uid = different_uid + 1
    trace('create item 3')
    if result:
        if 'ser_name' not in result:
            mbox('No ser_name in unit "' + result.get('name') + '"')
    return result
# ============================================================
def create_mgr(type, cdata):
    return managers_classes[type](cdata)
# ============================================================
def create_ui(cdata):
    return ui.GameUI(cdata)
# ============================================================
def hide_ui():
    UI.hide()   #@! remove frect link
# ============================================================
def show_ui():
    UI.show()   #@! remove frect link
# ============================================================
def Set_level_board(level_board):
    global current_level_board
    current_level_board = level_board
# ============================================================
def On_init_complete(map_index):
    '''Вызывается после того, как уровень загружен и всё инициализировано'''
    trace("On_init_complete >>")
    _main_buildings = BMgr.get_buildings(map_index, '__main__')
    trace(_main_buildings)
    units_cluster = UMgr.get_cluster(map_index)
    trace(units_cluster.general)
    if units_cluster.general:
        Camera.SetTo(units_cluster.general)
    elif _main_buildings:
        Camera.SetTo(_main_buildings[0])
    trace("<< On_init_complete")
# ============================================================
def Time_is_up():
    global global_episode
    global global_level

    episode = global_episode
    level = global_level
    trace('Call Time_is_up', global_episode, global_level)
    _not_first_level = False
    if episode > 1: _not_first_level = True
    elif level > 1: _not_first_level = True
    if _not_first_level:
        trace('Execute Time_is_up')
        UStats.AddLevelValue('time_is_up', 1)   # запомним, что экспертное время вышло
        tools.PlaySound('SND_NO_EXPERT')
        EMgr.send_event('time_is_up', None)   # чтобы событие могли услышать другие объекты, для которых это важно
        EMgr.SendGlobalMsg('time_event')
        dlg.Open('TimeOffMenu', 'dlg_timeoff', {'single_mode':'1',
                                                'episode': str(episode),
                                                'level': str(level)})
        #letter = [('text', 'CHEST_MSG_TIME_OFF')]
        #EMgr.AppendLetter(letter)
        UI.show_chest_text('CHEST_MSG_TIME_OFF')
# ============================================================
def GetS(settings, setting_name):
    if setting_name in settings:
        return settings[setting_name]
    else:
        return ''
# ============================================================
def serialize(s):
    global units_uid
    global buildings_uid
    global different_uid
    global is_first_barbarian
    LBoard.Core.units_uid = units_uid
    LBoard.Core.buildings_uid = buildings_uid
    LBoard.Core.different_uid = different_uid
    LBoard.Core.is_first_barbarian = is_first_barbarian
    _uiid = s.save_object(LBoard.Core)
    return _uiid
# ============================================================
def deserialize(s, uiid):
    global units_uid
    global buildings_uid
    global different_uid
    global is_first_barbarian
    global global_episode
    global global_level

    LBoard.Core = s.load(uiid)
    global_episode = LBoard.Core.episode
    global_level = LBoard.Core.level
    units_uid = LBoard.Core.units_uid
    buildings_uid = LBoard.Core.buildings_uid
    different_uid = LBoard.Core.different_uid
    is_first_barbarian = LBoard.Core.is_first_barbarian
    LBoard.episode = LBoard.Core.episode
    LBoard.level = LBoard.Core.level
# ============================================================
def Set_awaiting_dlg_info(awaiting_dlg_info):
    LBoard.Core.awaiting_dlg_info = awaiting_dlg_info
# ============================================================
def Get_awaiting_dlg_info():
    return LBoard.Core.awaiting_dlg_info
# ============================================================
def Hardcode_on_start(episode, level_number, settings):
    global global_episode
    global global_level
    trace('Hardcode_on_start >>')
    global_episode = episode
    global_level = level_number

    LBoard.episode = episode
    LBoard.level = level_number

    LBoard.Core = LBCore(episode, level_number, 0)
    LBoard.Core.init(0, settings)

    if episode != 1 or level_number != 1:  # кроме первого пока везде показываем кнопку, на минилокациях ее не будет, если там нечего строить
        BMgr.ShowBuildButton(False)     # False - стрелку над кнопкой не показывать, True - показывать

    EMgr.SendGlobalMsg('location_loaded')
    trace('<< Hardcode_on_start')
# ============================================================
def Hardcode_on_start_sublevel(episode, level_number, subindex, settings):
    trace('Hardcode_on_start_sublevel >>')
    #LBoard.Core.init(subindex, settings)
    LBoard.Core.levels_settings[subindex] = settings
    EMgr.SendGlobalMsg('new_location_loaded', str(subindex))
    EMgr.SendGlobalMsg('location_loaded', str(subindex))
    trace('<< Hardcode_on_start_sublevel')
# ============================================================
# ============================================================
def Cheat_level_complete():
    '''Чит для завершения уровня'''
    tools.PlaySound('SND_ARTEFACT_ITEM')
    dlg.Open('KeyMenu', 'dlg_key', {'single_mode':'1', 'is_final':'1',
                                            'episode':str(LBoard.episode),
                                            'level':str(LBoard.level)})
    EMgr.send_event('game_win', None)   # игру можно завершать
# ============================================================
# ============================================================