# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import game_helper
import tut_helper
import task_walkg

# #######################################################
# - может таски разделять на те, что запущены и те, что нет?
# #######################################################

class TasksMgr(TasksMgr_class):
    '''Обрабатывает таски действий юнитов, а также содержит таски игры, ту их часть, что не в UI'''
    #all_tasks = []
    #postpoined_tasks = []
# ============================================================
    def __init__(self, cdata):
        TasksMgr_class.__init__(self, cdata)
        self.ser_name = 'TasksMgr'
        self.AddSelfToGlobal('TMgr')
        self.events = []
        self.tasks = []
        self.updateable_items = []
        self.quest_unit_in_queue = None
        self.gameHelper = game_helper.GameHelper()
        self.tutHelper = tut_helper.TutHelper()
        self.update_ticks = 0
        self.walker_task_ticks = 0
        self.has_free_unit_events = False
        self.postpoined_actions = {}
        self.time_postpoined_actions = []
# ============================================================
    def Reset_cache(self):
        pass
# ============================================================
    _broken__place = ['broken', 'place']
    _fsm_upgrade_build = ['upgrading', 'repairing', 'building']
    def get_ui_tips_data(self):
        '''Собирает данные о ресурсах, которые могут произвести здания на всех подуровнях'''
        b_dict = {}
        indexes = BMgr.GetLocationsIndexes()
        for index in indexes:
            _is_cave = self.tutHelper.is_cave(index)
            if not _is_cave:        # в пещерах нет зданий
                _buildings = BMgr.get_buildings(index, '__generating__', '', ['map_place'])
                _k = -1
                for b in _buildings:
                    if b.is_indians:
                        continue
                    _has_access = b.HasAccess()
                    if _has_access:
                        _is_passable = b.IsPassable()
                        if _is_passable:
                            res = None
                            _is_res_empty = True
                            if b.status in self._broken__place:
                                _need_check = False
                                _fsm_state = b.FSM_GetStateID()
                                if _fsm_state in self._fsm_upgrade_build:
                                    res = b.GetRes('level_1', 'normal_gives_1') #@?????????
                                if b.clock_shown:
                                    res = b.GetRes('level_1', 'normal_gives_1') #@fix!!!!!!
                            elif b.status == 'normal':
                                res = b.GetRes('normal_gives_1')
                                #_is_res_empty = True
                            if res: _is_res_empty = res.Empty()
                            if not _is_res_empty:     # если ресурс не задан, то здесь делать нечего
                                val = res.GetSingleValue()  # кол-во приносимого ресурса
                                k = -1
                                name = b.get('stype')       # подтип здания
                                if name in b_dict:          # если такое здание уже было
                                    k = b_dict[name]        # возьмем предыдущее значение
                                # --
                                if val < k:                 # если новое меньше - сохраним его
                                    b_dict[name] = val
                                elif k < 0:                 # если предыдущее нулевое, то
                                    b_dict[name] = val      # сохраним новое
        return b_dict
# ============================================================
    def on_msg(self, msg_type, msg_param1='', msg_param2='', msg_dict={}):
        if msg_type == 'state_machine':
            self.on_state_machine(msg_param1, msg_param2, msg_dict)
        elif msg_type == 'signal_msg':
            self.on_signal(msg_param1)
        elif msg_type == 'global_event':
            self.on_global_event(msg_param1, msg_param2)
        elif msg_type == 'task_callback':
            self.on_task_callback(int(msg_param1), msg_param2, msg_dict)
        elif msg_type == 'quest_callback':
            self.on_quest_callback(msg_param1, msg_param2, msg_dict)
        elif msg_type == 'on_create':
            self.on_create()
# ============================================================
    def on_signal(self, signal):
        if signal.startswith('th_'):
            self.tutHelper.on_signal(signal)
            return

        if signal == 'increase_territory':
            _has_territory_complete = UStats.GetLevelValue('territory_complete') > 0
            if not _has_territory_complete:
                _has_territory_places = BMgr.has_territory_places(BMgr.GetCurMapIndex(), ['totem', 'totem_stone', 'watchtower'])
                if _has_territory_places:
                    UI.show_chest_text('CHEST_MSG_INCREASE_TERRITORY')
                    UI.ButtonStartBlink('idChest', 3)
                self.Signals.Restart('increase_territory', 300000)
        elif signal == 'keep_in_mind_tasks':
            UI.show_chest_text('CHEST_MSG_KEEP_IN_MIND_TASKS')
            self.Signals.Restart('keep_in_mind_tasks', 15*60*1000)
# ============================================================
    def on_task_callback(self, task_uid, result, extra_dict):
        '''Для передачи данных из диалога в задание по UID'у задания'''
        if task_uid == -1:  # для диалога генерала
            QMgr.on_dlg_callback(result, extra_dict)
        elif task_uid == 0:
            pass        # ignore callback
        else:
            _task = self.get_task(task_uid)
            if _task != None:
                _task.on_callback(result, extra_dict)
# ============================================================
    def on_quest_callback(self, quest_name, result, extra_dict):
        '''Для передачи данных из диалога в квест по имени'''
        _q = QMgr.get_quest(quest_name)
        if _q:
            _q.on_dlg_callback(result, extra_dict)
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        '''Обработчик стейт-машины'''
        if type == 'enter':
            return
        elif type == 'exit':
            return
        elif type == 'change':
            self.on_state_change(additional.prev_state, additional.next_state)
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_create(self):
        trace('TasksManager on_create')
        EMgr.add_event_listener(self)
        self.gameHelper.on_create()
        self.tutHelper.on_create()
        _skip_levels = ['1_4', '2_4']
        _cur_level = str(LBoard.Core.episode) + '_' + str(LBoard.Core.level)
        if _cur_level not in _skip_levels:  # на 1_4 и 2_4 не показываем
            self.Signals.Restart('increase_territory', 300000)
        self.Signals.Restart('keep_in_mind_tasks', 15*60*1000)
# ============================================================
    def on_global_event(self, event, param):
        self.gameHelper.on_global_event(event, param)     # чтобы передать событие в подсказки
        self.tutHelper.on_global_event(event, param)     # чтобы передать событие в подсказки
# ============================================================
    def on_update(self, ms):                # данный метод должен вызываться из C++ каждый квант
        '''Вызывается каждый второй quant! См. BaseManager.cpp::Update'''
        self.gameHelper.on_update(ms)
        _is_main_level = LBoard.Core.is_main_level()
        self.tutHelper.on_update(ms)
        # ###
        self.update_ticks += 1
        self.walker_task_ticks += 1
        # >>>
        if _is_main_level:  # строго только на главном! Иначе куча окон.
            if not (self.update_ticks%50):  #! каждую секунду (31)
                UI.check_main_tasks()   # обновляем их здесь, потому что UI on_update засыпает при переходе в подуровень
        # <<<
        _need_process = not (self.update_ticks%15)
        if self.has_free_unit_events:
            _need_process = True
        if _need_process:   #! эвенты и обработку заданий сделаем чуть реже (12)
            self.has_free_unit_events = False
            _events = self.events[:]    # копируем эвенты, на случай, если внутри добавляются другие
            for event in _events:     # сгенерим эвенты
                name, obj = event
                self.on_event_local(name, obj)
            for event in _events:     # освободим юнитов, которым не нашлось задания
                name, unit = event
                if name == 'free_unit':
                    _unit_is_busy = unit.is_busy()
                    if not _unit_is_busy:
                        if not unit.is_in_home:     # если задания нет и юнит еще не дома
                            unit.go_home()    # то отправим юнита домой
                    unit.switch_animation() # обновим анимацию юнита на всякий случай
                #elif name == 'try_general_task':
                #    self.start_next_general_task()
            del self.events[:]
            self.start_postpoined_tasks()
        # заодно уберем отыгравшие таски:
        if not (self.update_ticks%10):   #! чуть проредим проверку (0)
            tasks_to_remove = []
            for task in self.tasks:
                if task.is_complete:
                    tasks_to_remove.append(task)
            # удалим завершенные таски:
            if tasks_to_remove:
                #mbox(to_str(self.tasks))
                for rtask in tasks_to_remove:
                    self.tasks.remove(rtask)
                #mbox(to_str(self.tasks))
        self.update_time_postponed(ms)
        # обновляем объекты, которые явно об этом попросили:
        for item in self.updateable_items:
            item.on_update(ms)
        # вызываем апдейты у всех запущенных тасков:
        for task in self.tasks:
            if not task.is_complete:
                if task.is_started:
                    task.on_update(ms)
                elif task.is_loot:
                    task.on_update(ms)
# ============================================================
    def on_rare_update(self, ms):
        pass
# ============================================================
    def has_started_walk_worker_tasks(self):
        for task in self.tasks:
            if task.type == 'walk_worker':
                if not task.is_complete:
                    if task.is_started:
                        return True
        return False
# ============================================================
    def start_postpoined_tasks(self):
        _was_general_task = False
        for task in self.tasks:
            if not task.is_event_task:
                if not task.is_started:
                    if not task.is_complete:     # если таск не запущен и не выполнен, то
                        if task.type == 'walk_general':
                            if _was_general_task: continue
                            _result = task.try_do_action()    # пытаемся запустить
                            if not task.is_canceled:
                                _was_general_task = True
                            if _result:
                                continue
                        trace('Trying task (postpoined):', task.uid)
                        task.try_do_action()    # пытаемся запустить
            elif task.type == 'walk_worker':
                if not task.is_started:
                    if not task.is_complete:
                        _has_started_walk_worker_tasks = self.has_started_walk_worker_tasks()
                        if _has_started_walk_worker_tasks:
                            if self.walker_task_ticks < 15:
                                continue
                        task.try_do_action()
# ============================================================
    def start_next_general_task(self):
        for task in self.tasks:
            if task.type == 'walk_general':
                if not task.is_started:
                    if not task.is_complete:     # если таск не запущен и не выполнен, то
                        _result = task.try_do_action()    # пытаемся запустить
                        if not _result:
                            if task.is_canceled:    # если задание было отменено
                                continue
                        break
# ============================================================
    def on_event(self, event, obj, extra={}):
        trace('TMgr.on_event received:', event)#, obj)
        self.gameHelper.on_event(event, extra)
        #self.tutHelper.on_event(event, extra)     # чтобы передать событие в подсказки
# ============================================================
    def on_event_local(self, event_name, event_obj):
        # проверить Event-Task'и, вдруг кому нужен юнит, если нет, то
        trace('TMgr.on_event_local start:', event_name)#, event_obj)
        _was_general_task = False
        for task in self.tasks:
            _was_not_started = task.was_not_started()
            if _was_not_started:
                if task.is_event_task:
                    _our_trigger = task.is_event_trigger(event_name)
                    if _our_trigger:
                        if task.type == 'walk_general':
                            if _was_general_task: continue
                            _result = task.try_do_action()    # пытаемся запустить
                            if not task.is_canceled:
                                _was_general_task = True
                            if _result:
                                return
                        elif task.type == 'walk_worker':
                            _has_started_walk_worker_tasks = self.has_started_walk_worker_tasks()
                            if _has_started_walk_worker_tasks:
                                if self.walker_task_ticks < 15:
                                    continue
                        trace('Trying task (event):', task.uid)
                        _is_action_ready = task.try_do_action()
                        if _is_action_ready:
                            return              # таск запустили, поэтому дальше делать нечего
        trace('TMgr.on_event_local end')
# #######################################################
    task_uid = 1
# ============================================================
    def add_task(self, task, urgent = False):
        '''Добавляет новую задачу, по возможности - сразу запускает ее'''
        if task.is_unique_task:
            for t in self.tasks:
                if t.is_unique_task:
                    if t.unique_id == task.unique_id:   # схожий уникальный таск есть, поэтому не добавляем
                        return False
        task.uid = self.task_uid
        trace('TASK UID:', task.uid)
        self.task_uid += 1
        if task.do_pre_action():        # возможен ли запуск данного таска в принципе?
            if urgent:
                self.tasks.insert(0, task)  # делаем таск самым первым
            else:
                self._append_task_by_priority(task)
            if task.type != 'walk_general': # генеральские выполняем строго по приоритету
                if task.type == 'walk_worker':
                    _has_started_walk_worker_tasks = self.has_started_walk_worker_tasks()
                    if _has_started_walk_worker_tasks:
                        if self.walker_task_ticks < 15:
                            return False
                trace('Trying task (added):', task.uid)
                task.try_do_action()            # сразу же пытаемся выполнить таск
                if task.type == 'walk_worker':
                    if task.is_started:
                        self.walker_task_ticks = 0
            else:
                self.start_next_general_task()
            return True
            #@(Возможно стоит переделать!
            #@ Иначе в некоторых ситуациях приоритеты не будут действовать)
        else:
            return False
# ============================================================
    def cancel_task_by_uid(self, uid):
        '''Отменяет таск по UID'''
        for task in self.tasks:
            if task.uid == uid:
                self.tasks.remove(task)
                task.cancel(True)
                return
# ============================================================
    def cancel_general_tasks(self):
        '''Отменяет все таски хождения генерала (на всех локациях)'''
        for map_index in UMgr.clusters:
            self.cancel_tasks(map_index, 'walk_general')
# ============================================================
    def cancel_tasks(self, map_index, task_type, is_moving_out_from_tiles = False):
        '''Удаляет задания определенного типа из списка заданий
            Нужно для того, чтобы когда генерал подошел к индейцу -
            отключить все последующие задания'''
        trace('cancel_tasks:', map_index, task_type)
        units_cluster = UMgr.get_cluster(map_index)
        units_cluster.general.cancel_step_aside()   #$ чтобы никуда не отходил дважды...
        _new_tasks = []
        _cancel_tasks = []
        for task in self.tasks:
            if task.type != task_type:
                _new_tasks.append(task)
            else:
                if not task.is_started:    # запущенные НЕ отменяем!
                    _cancel_tasks.append(task)
                else:
                    _new_tasks.append(task)
        self.tasks = _new_tasks
        for _t in _cancel_tasks:
            _t.cancel(True)
        if is_moving_out_from_tiles:
            _g = units_cluster.general
            if _g.task:
                _g.task.cancel(True)
# ============================================================
    def cancel_doctor_tasks(self, doctor):
        '''Отменяет все таски хождения генерала (на всех локациях)'''
        _uid = ''
        if doctor:
            _uid = doctor.get('uid')
        for map_index in UMgr.clusters:
            self._cancel_doctor_tasks_mi(map_index, _uid)
# ============================================================
    def _cancel_doctor_tasks_mi(self, map_index, uid):
        '''Удаляет задания определенного типа из списка заданий
            Нужно для того, чтобы когда генерал подошел к индейцу -
            отключить все последующие задания'''
        task_type = 'run_doctor'
        trace('_cancel_doctor_tasks:', map_index, uid)
        units_cluster = UMgr.get_cluster(map_index)
        _new_tasks = []
        _cancel_tasks = []
        for task in self.tasks:
            if task.type != task_type:
                _new_tasks.append(task)
            else:
                _need_cancel = False
                if not task.is_started:    # запущенные НЕ отменяем!
                    if task.doctor:
                        _d_uid = task.doctor.get('uid')
                        if _d_uid == uid:
                            _need_cancel = True
                if _need_cancel:
                    _cancel_tasks.append(task)
                else:
                    _new_tasks.append(task)
        self.tasks = _new_tasks
        for _t in _cancel_tasks:
            _t.cancel(True)
# ============================================================
    def _append_task_by_priority(self, task):
        '''Добавляет задание в список заданий согласно своему приоритету'''
        #self.tasks.append(task)
        _i = len(self.tasks)
        if _i > 0:      # проверка для случая когда приоритет нового таска выше всех остальных
            _first_p = self.tasks[0].priority
            if task.priority > _first_p:
                self.tasks.insert(0, task)
                return
        while _i > 0:   # пробегаем в обратном порядке
            _i -= 1
            _p = self.tasks[_i].priority
            if task.priority <= _p: # если приоритет нового таска не больше, то
                self.tasks.insert(_i+1, task)   # то добавим наш таск после этого
                return
        self.tasks.insert(0, task)  # если дошли сюда - значит у таска высший приоритет, либо это самый первый таск
# ============================================================
    def get_task(self, uid):
        for t in self.tasks:
            if t.uid == uid:
                return t
        return None
# ============================================================
    def send_event(self, event_name, event_object = None):
        trace('TMgr.send_event:', event_name)#, event_object)
        self.events.append( (event_name, event_object) )
        if event_name == 'free_unit':
            self.has_free_unit_events = True
# ============================================================
    def add_quest_unit_to_queue(self, uid):
        '''Организует очередь квестовых юнитов... Для того, чтобы управлять значками над
        индейцами (еще и собирателем золота)'''
        if self.quest_unit_in_queue:
            return False
        else:
            self.quest_unit_in_queue = uid
            EMgr.send_event( 'quest_unit_added', None, {'uid':uid} )
            return True
# ============================================================
    def remove_quest_unit_from_queue(self, uid):
        _unit_in_queue = False
        if self.quest_unit_in_queue:
            if self.quest_unit_in_queue == uid:
                _unit_in_queue = True
        if _unit_in_queue:
            self.quest_unit_in_queue = None
            EMgr.Send_event('quest_unit_removed')
            return True
        else:
            return False
# ============================================================
    def has_quest_unit_in_queue(self):
        if self.quest_unit_in_queue: return True
        else: return False
# ============================================================
    def get_quest_unit_in_queue_uid(self):
        return self.quest_unit_in_queue
# ============================================================
    def Get_debug_tasks_info(self):
        r = []
        for task in self.tasks:
            if not task.is_complete:     # если таск не запущен и не выполнен, то
                if task.is_event_task:
                    r.append(['text', 'COLOR_YELLOW'])
                if task.is_started:
                    r.append(['debug', '+'])
                r.append(['debug', task.type])
                r.append('space')
                r.append(['digit', task.uid])
                r.append('space')
                r.append(['debug', task.extra])
                r.append('newline')
                r.append(['text', 'COLOR_WHITE'])
        return r
# ============================================================
# ============================================================
# ============================================================
    def add_updateable_item(self, item):
        self.updateable_items.append(item)
# ============================================================
    def remove_updateable_item(self, item):
        self.updateable_items.remove(item)
# ============================================================
    def get_item(self, actor, uid_str):
        parts = uid_str.split(':')
        _len = len(parts)
        _uid = parts[0]
        _map_index = actor.get('locind')
        if _len == 2:
            _mi = parts[1]
            if _mi >= 0:
                _map_index = _mi
        return BMgr.get_item(_uid, _map_index)
# ============================================================
    def process_removing_item(self, removing_uid, map_index):
        for _t in self.tasks:
            _t.process_removing_item(removing_uid, map_index)
# ============================================================
    def cancel_barbarian_tasks(self, map_index):
        for task in self.tasks:
            if task.type == 'walk_barbarian':
                if task.barbarian:
                    if task.barbarian.get('locind') == map_index:
                        task.cancel()
# ============================================================
    def try_do_postpoined_action(self, caller):
        _uid = caller.get('uid')
        _mi = str(caller.get('locind'))
        if _uid+_mi in self.postpoined_actions:
            #_acts_to_remove = []
            actions = self.postpoined_actions[_uid+_mi]
            del self.postpoined_actions[_uid+_mi]    # чтобы можно было добавлять новые отложенные действия
            for act in actions:
                actor, data = act
                self.do_game_action(actor, data)
        else:
            trace('--> ERROR: no actions for uid', _uid)
# ============================================================
    def update_time_postponed(self, ms):
        '''Обновляет время, оставшееся для отложенного по времени запуска действия'''
        def remove_ready_to_start(item):
            return item[0] > 0
        _ready_to_start = []
        for action in self.time_postpoined_actions:
            _time = action[0] - ms
            _time = max(_time, 0)
            action[0] = _time
            if _time <= 0:
                _ready_to_start.append([action[1], action[2]])
        if not LBoard.IsBuildMode():    # если в режиме строительства, то пока ничего не запускаем!
            self.time_postpoined_actions = filter(remove_ready_to_start, self.time_postpoined_actions)
            for action in _ready_to_start:
                self.do_game_action(action[0], action[1])
# ============================================================
    _generate_object__loot = ['generate_object', 'generate_object_loot']

    def do_game_action(self, actor, data, time_shift = 0):
        '''type, txt_param1, txt_param2, int_param1, int_param2, is_offscreen'''
        #@ 1) откладывать действия, если игра в режиме строительства
        # ###@ 2) обеспечить возможность выполнения действия не сразу а через указанный промежуток времени (не забывая про первый пункт)
        #@ 3) обеспечить возможность выполнения действия, когда объект offscreen
        t = data.type
        if time_shift > 0:
            self.time_postpoined_actions.append([time_shift, actor, data])
            return
        if data.is_offscreen:   # если требуется выполнить за экраном
            uids = data.txt_param1.split(',')
            for uid_str in uids:
                item = self.get_item(actor, uid_str)
                if item:
                    _is_offscreen = item.is_offscreen
                    if not _is_offscreen: _is_offscreen = item.Drawer.IsHided()
                    if not _is_offscreen:   # если не за экраном, то отложим, иначе выполним сразу
                        # нужно отложить действие
                        _uid = item.get('uid')
                        _mi = str(item.get('locind'))
                        if _uid+_mi in self.postpoined_actions:
                            self.postpoined_actions[_uid+_mi].append( (actor, data) )
                        else:
                            self.postpoined_actions[_uid+_mi] = [(actor, data)]
                        item.has_pending_actions = True
                        trace('GameAction (offscreen) postponed:', t, data)
                        return
        # ---
        _executed = False
        trace('== do_game_action ==', t)
        trace('   ==', data)
        if t == 'activate_object':
            uids = data.txt_param1.split(',')
            for uid_str in uids:
                item = self.get_item(actor, uid_str)
                if item:
                    if data.int_param1 > 0:
                        item.activate()
                        if item.IsSubTypeOf('teleport'):
                            item.PlaySoundG('SND_TELEPORT_ACTIVATION')
                    else: item.deactivate()
                    _executed = True
        elif t == 'activate_quest':
            if data.int_param1 < 0: data.int_param1 = actor.get('locind')
            QMgr.activate_quest(data.txt_param1, data.int_param1)
            _executed = True
        elif t == 'add_global_variable':
            UStats.AddLevelValue(data.txt_param1, data.int_param1)
            _executed = True
        elif t == 'allow_upgrade':
            BMgr.AddRepaired( data.txt_param1, data.txt_param2 )    # разрешает апгрейды до указанного варианта
            _executed = True
        elif t == 'set_global_variable':
            UStats.SetLevelValue(data.txt_param1, data.int_param1)
            _executed = True
        elif t == 'move_camera':
            item = self.get_item(actor, data.txt_param1)
            if item:
                _cur_mi = actor.get('locind')
                _target_mi = item.get('locind')
                if _cur_mi == _target_mi:
                    Camera.MoveTo(item)
                    _executed = True
        elif t == 'show_arrow':
            uids = data.txt_param1.split(',')
            for uid_str in uids:
                item = self.get_item(actor, uid_str)
                if item:
                    item.refresh_arrow_color()
                    item.show_arrow(data.int_param1 > 0)
                    _executed = True
        elif t == 'show_effect':
            uids = data.txt_param1.split(',')
            for uid_str in uids:
                item = self.get_item(actor, uid_str)
                if item:
                    item.switch_animation()
                    item.show_effect(data.txt_param2)
                    _executed = True
        elif t == 'hide_object':
            uids = data.txt_param1.split(',')
            for uid_str in uids:
                item = self.get_item(actor, uid_str)
                if item:
                    item.Drawer.Hide(data.int_param1 == 1)
                    _type = item.get('type')
                    if _type == 'unit':
                        if data.int_param1 == 0:
                            item.show_now()
                            trace('GAction: item shown ->', item.get('uid'))
                        else:
                            item.is_shown = False
                            trace('GAction: item hidden ->', item.get('uid'))
                    _executed = True
        elif t == 'remove_object':
            uids = data.txt_param1.split(',')
            for uid_str in uids:
                item = self.get_item(actor, uid_str)
                if item:
                    BMgr.RemoveItemFromMap(item)
        elif t == 'remove_fade_object':
            uids = data.txt_param1.split(',')
            for uid_str in uids:
                item = self.get_item(actor, uid_str)
                if item:
                    item.remove_faded(data.int_param1)
        elif t == 'do_action':
            uids = data.txt_param1.split(',')
            for uid_str in uids:
                item = self.get_item(actor, uid_str)
                if item:
                    item.do_action(data.txt_param2)
                    _executed = True
        elif t == 'go_to':
            uids = data.txt_param1.split(',')
            if not uids: return
            to_uid_str = uids[0]
            item = self.get_item(actor, to_uid_str)
            if item:
                actor.do_action('go_to ' + item.get('uid'))
                _executed = True
        elif t == 'switch_variant':
            item = self.get_item(actor, data.txt_param1)
            if item:
                _type = item.get('type')
                if _type == 'building':
                    if data.txt_param2 == '':
                        item.switch_level()
                    else:
                        item.switch_level(data.txt_param2)
                else:
                    item.switch_variant(data.txt_param2)
                _executed = True
        elif t in self._generate_object__loot:
            _map_index = data.int_param1
            if _map_index < 0: _map_index = actor.get('locind')
            templ = ''
            v = ''
            if ':' in data.txt_param1:
                templ,v = data.txt_param1.split(':')
            else:
                templ = data.txt_param1
            _cell_str = data.txt_param2
            col,row = _cell_str.split(';')
            _cell_pos = {'col':int(col), 'row':int(row)}
            _new_item = BMgr.AddItemToMap(_map_index, templ, v, _cell_pos)        # hack - BuildingsManager может добавлять на карту не только здания...
            if _new_item:
                if data.int_param2 > 0: # UseEffect
                    _pos = _new_item.GetAttrPoint('center_item_pos')
                    _new_item.Drawer.ResIn(_new_item.item_layers, _pos, 1000)
                    _executed = True
                if t == 'generate_object_loot':
                    _autoloot = True
                    if 'no_autoloot' in _new_item:
                        if _new_item.no_autoloot == True:
                            _autoloot = False
                    if _autoloot:
                        _loot_task = task_walkg.WalkGeneralTask(_new_item, True)
                        TMgr.add_task(_loot_task, True)
                        _executed = True
        elif t == 'generate_event':
            EMgr.SendGlobalMsg(data.txt_param1)
            _executed = True
        elif t == 'inventory_add':
            _template = data.txt_param2
            inventory_item = {'name':data.txt_param1,
                          'image':BMgr.GetTemplateAttr(_template, 'inventory_image'),
                          'frame':str(BMgr.GetTemplateAttr(_template, 'inventory_frame')),
                          'count':str(data.int_param1)}
            UStats.Inventory.AddQuestItem(inventory_item)
            _executed = True
        elif t == 'inventory_remove':
            UStats.Inventory.RemoveQuestItem(data.txt_param1, data.int_param1)
            _executed = True
        elif t == 'inventory_action':   # для "наполнения" объектов
            _template = data.txt_param3
            new_inventory_item = {'name':data.txt_param2,
                      'image':BMgr.GetTemplateAttr(_template, 'inventory_image'),
                      'frame':str(BMgr.GetTemplateAttr(_template, 'inventory_frame'))
                      }
            UStats.Inventory.ChangeQuestItem(data.txt_param1, new_inventory_item)
            _executed = True
        elif t == 'complete_quest':
            if data.int_param1 < 0: data.int_param1 = actor.get('locind')
            q = QMgr.get_quest(data.txt_param1, data.int_param1)
            if q:
                _npc = q.npc
                QMgr.complete_quest_early(q)
                if _npc: _npc.switch_animation()
                #if actor.get('type') == 'unit':
                #    if actor.quest:
                #        actor.switch_animation()
                #        actor.on_quest_complete_all()
                _executed = True
        elif t == 'complete_quest_tasks':
            if data.int_param1 < 0: data.int_param1 = actor.get('locind')
            q = QMgr.get_quest(data.txt_param1, data.int_param1)
            if q:
                q.complete_quest_tasks()
                _executed = True
        elif t == 'complete_quest_task':    # task, not taskS
            if data.int_param1 < 0: data.int_param1 = actor.get('locind')
            q = QMgr.get_quest(data.txt_param1, data.int_param1)
            if q:
                q.complete_quest_one_task(data.int_param2)
                _executed = True
        elif t == 'play_sound':
            if data.int_param1 > 0: # IsGlobal
                actor.PlaySoundG(data.txt_param1)
            else:
                actor.PlaySound(data.txt_param1)
            _executed = True
        elif t == 'click_on':
            uids = data.txt_param1.split(',')
            for uid_str in uids:
                _object = self.get_item(actor, uid_str)
                if _object:
                    _object.SendMsg('click', 'default') # клик по объекту
                    _executed = True
        elif t == 'enable_clicks_after_time':
            LBoard.EnableClicksAfter(data.int_param1)
            _executed = True
        elif t == 'show_tutorial_text':
            UI.show_tut_text(data.txt_param1, data.int_param1, data.txt_param2)
            _executed = True
        elif t == 'show_top_text':
            UI.show_top_text(data.txt_param1, data.txt_param2, data.int_param1)
            _executed = True
        elif t == 'show_chest_text':
            UI.show_chest_text(data.txt_param1, data.txt_param2, data.int_param1)
            _executed = True
        elif t == 'show_HELP_text':
            pos = data.txt_param2
            x,y = pos.split(';')
            _x = int(x)
            _y = int(y)
            UI.show_help_text(data.txt_param1, _x, _y, data.int_param1)
            _executed = True
        elif t == 'unblock_remove':
            uids = data.txt_param1.split(',')
            for uid_str in uids:
                _object = self.get_item(actor, uid_str)
                if _object:
                    _object.unblock_remove = data.int_param1
                    _executed = True
        elif t == 'unblock_restore_eff':
            uids = data.txt_param1.split(',')
            for uid_str in uids:
                _object = self.get_item(actor, uid_str)
                if _object:
                    _object.unblock_restore_eff = data.int_param1
                    _executed = True
        elif t == 'unit_transition':
            uids = data.txt_param1.split(',')
            for uid_str in uids:
                _object = self.get_item(actor, uid_str)
                if _object:
                    _type = _object.get('type')
                    if _type == 'unit':
                        _object.try_start_transition(True)
                        _executed = True
        elif t == 'block_remove':
            uids = data.txt_param1.split(',')
            for uid_str in uids:
                _object = self.get_item(actor, uid_str)
                if _object:
                    _object.blocked_remove = data.int_param1
                    _executed = True
        elif t == 'test':
            mbox(data.txt_param1)
        # информация для дебага:
        trace('GameAction complete:', t, ['executed','EMPTY'][_executed == False], data)
# ============================================================
    def Inform_pause_state(self, is_enabled):
        self.gameHelper.inform_pause_state(is_enabled)
# ============================================================
