# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *


import quest
import game_task

# ============================================================
# class QuestGiveResTask(game_task.GameTask):
    # '''Задание квеста (у игрока задание отображается в нижнем правом углу)'''
    # def __init__(self, event_name, image_id, frame, items, qtdata):
        # game_task.GameTask.__init__(self, image_id, frame)
        # self.events_count = len(items)     #^ кол-во событий (game_event), необходимое для выполнения задания
        # self.events_remain = self.events_count          #^ сколько событий осталось дождаться (при 0 - задание выполнено)
        # self.game_event = event_name     #^ событие, которое должно быть сгенерировано игрой, чтобы данное задание проверило его выполнение
        # self.items = items

    # def on_event(self, name, obj, extra_dict):
        # '''Обработчик игровых событий'''
        # #mbox(name, self.game_event)
        # if name == self.game_event:     # наше событие завершения
            # if obj in self.items:
                # self.events_remain -= 1
                # if self.events_remain <= 0:      # учитываем, что зданий построено достаточное кол-во
                    # self.set_complete()                     # значит уже все сделали
# ============================================================

class QuestGiveRes(quest.Quest):
    def __init__(self, name = '', data_dict = None, map_index = 0):
        quest.Quest.__init__(self, name, data_dict, map_index)
        self.ser_name = 'QuestGiveRes'
        self.type = 'QuestGiveRes'
        if self.npc:
            self.npc.need_quest_text = True
# ============================================================
    def is_start_possible_precheck(self, skip_ne_cases = False):
        if self.parent_quest_name:
            _parent_q = QMgr.get_quest(self.parent_quest_name)
            if _parent_q:
                if self.after_parent_quest_completed:
                    if not _parent_q.is_complete: return False
                else:
                    if not _parent_q.is_started: return False
            else:
                mbox('Parent quest was not found: ' + self.parent_quest_name)
        elif self.extra_auto_activate:    # если еще не активировали сообщением
            return False
        return True
# ============================================================
    def is_start_possible(self, skip_ne_cases = False):
        '''Проверяет выполнимость стартовых условий'''
        _precheck = self.is_start_possible_precheck(skip_ne_cases)
        if not _precheck: return False
        if not skip_ne_cases:
            # нужно сделать предварительные проверки:
            qtd = self.quest_tasks_datas[0]     # QuestTaskData
            res = UStats.GetCurRes()
            if res.Get(qtd.resName) >= qtd.resCount:
                return True     # ресурсов достаточно
            else:
                return False    # не хватает ресурсов
        return True
# ============================================================
    #@override
    def is_only_res_not_enough_to_start(self):
        _precheck = self.is_start_possible_precheck()
        if not _precheck: return False
        # нужно сделать предварительные проверки:
        qtd = self.quest_tasks_datas[0]     # QuestTaskData
        res = UStats.GetCurRes()
        if res.Get(qtd.resName) >= qtd.resCount:
            return False     # ресурсов достаточно
        else:
            return True    # не хватает ресурсов
# ============================================================
    def start(self):
        '''Запускает квест, генерирует необходимые задания (таски),
        активирует все, что нужно и т.д.'''
        quest.Quest.start(self)
        tools.PlaySound('SND_TASK_GET')
        #self.add_game_tasks()      # для передачи ресурсов таски не генерятся
        qtd = self.quest_tasks_datas[0]     # QuestTaskData
        _need_res = qtd.generate_needed_res()
        UStats.SubRes(_need_res)    #@
        self.is_started = True  #! в конце метода (но здесь хитрая логика квеста)
        #@fixit нужно запустить эффект от наших ресурсов к индейцу (учесть движение карты)
        if self.npc:
            _npc = self.npc
            _dlg_settings = _npc.get_dlg_settings(self.text_complete, 0, True)
            _dlg_settings['quest_name'] = self.name
            TMgr.cancel_general_tasks()
            dlg.Open('QuestMenuOk', 'dlg_quest_ok', _dlg_settings )
        pass
# ============================================================
    def add_game_tasks(self):
        #'''Когда NPC (или кто-то еще) дал задание - он вызывает данный метод (ну или start - позже будет ясно) и
        #игроку даются игровые задания'''
        pass
# ============================================================
    def on_update(self, ms):
        pass    #self.complete()
# ============================================================
    def get_tips_extra_text(self, ui_tips = False):
        '''Возвращает текст для доп. строки типса у индейца'''
        result = []
        ne_result = []
        if not ui_tips:
            result.append( ('text', 'COLOR_LINES') )
            #result.append( ('text', 'NEED_QUEST_RES') )
            qtd = self.quest_tasks_datas[0]     # QuestTaskData
            res = UStats.GetCurRes()
            res_has = res.Get(qtd.resName)
            res_need = qtd.resCount
            if res_need == 0: return ([],[])
            #result.append( 'space' )
            res_numbers = self._append_res_value(res_need, qtd.resName)
            result.extend( res_numbers )
            if res_has < res_need:
                #ne_result.append('newline')
                ne_result.append( ('text', 'COLOR_RED') )
                #ne_result.append( ('text', 'NOT_ENOUGH') )
                #ne_result.append('space')
                res_numbers = self._append_res_value(res_need-res_has, qtd.resName)
                ne_result.extend( res_numbers )
            return (result, ne_result)
        else:
            qtd = self.quest_tasks_datas[0]     # QuestTaskData
            res = UStats.GetCurRes()
            res_has = res.Get(qtd.resName)
            res_need = qtd.resCount
            if res_need == 0: return ([],[])
            #res_numbers = self._append_res_value(res_need, qtd.resName)
            #result.extend( res_numbers )
            if res_has < res_need:
                ne_result.append( ('text', 'COLOR_RED') )
                res_numbers = self._append_res_value(res_need-res_has, qtd.resName)
                ne_result.extend( res_numbers )
            return (result, ne_result)
# ============================================================
    def get_tips_click_text(self):
        '''Возвращает текст для типса у индейца при клике'''
        result = []
        qtd = self.quest_tasks_datas[0]     # QuestTaskData
        res = UStats.GetCurRes()
        res_has = res.Get(qtd.resName)
        res_need = qtd.resCount
        if res_need == 0: return []
        if res_has < res_need:
            #result.append( ('text', 'COLOR_RED') )
            #result.append( ('text', 'NOT_ENOUGH') )
            #result.append('space')
            res_numbers = self._append_res_value(res_need-res_has, qtd.resName)
            result.extend( res_numbers )
        return result
# ============================================================
    resource_names = ['food', 'bricks', 'boards', 'coins']
    res_images = {
        'food': 'IMG_I_TIP_FOOD',
        'bricks': 'IMG_I_TIP_BRICKS',
        'boards': 'IMG_I_TIP_BOARDS',
        'coins': 'IMG_I_TIP_COINS',
        'gold': 'IMG_I_TIP_GOLD',
        '_fish': 'IMG_I_TIP_FISH',
        '_stones': 'IMG_I_TIP_STONE',
        '_granite': 'IMG_I_TIP_STONE',
        '_wood': 'IMG_I_TIP_WOOD',
        '_ore': 'IMG_I_TIP_ORE',
        '_flour': 'IMG_I_TIP_BAG',
        }
# ============================================================
    def _append_res_value(self, res_count, res_name):
        '''Для типса. Генерирует список со значениями переданного ресурса, с соответствующими изображениями'''
        result = []
        result.append( ('digit', res_count) )
        if res_name in self.res_images:
            result.append( ('image', self.res_images[res_name]) )
        return result
# ============================================================
    #@override
    def on_dlg_callback(self, result, extra_dict):
        '''Обработка данных от диалога (диалог у нас в другой VM)'''
        if result == 'ok':      # других и быть не должно
            QMgr.complete_quest_early(self)
            #self.npc.on_quest_complete_all()
            #self.complete()
# ============================================================
    def on_complete_end(self):
        tools.PlaySound('SND_TASK_COMPLETE')
# ============================================================
    #def __str__(self):
    #    extra = to_str("quest: ", self.uid, "is_complete", self.is_complete, "is_started", self.is_started, "is_tut", self.is_tutorial)
    #    return to_str("{", extra, "}", str(self))
# #######################################################
# #######################################################
# #######################################################
# #######################################################
# #######################################################
