# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import unit_quest
import task_qm
import b_dam
import d_crater
import d_gold
import game_task
import d_enabler
import d_mais
#import d_transfer
import d_grave
import d_ind_house_br
import unit_trader
import quest_tut_uni
import d_bonuskey
import d_unit_res
import d_pot
import b_house
import quest
import b_bakery
import d_res
import d_letter
import unit_indian_sit
import d_ind_altar
import d_lama
import b_tower
import b_mint
import b_ind_house
import task_res_store
import smgr_bonus
import task_build_place
import smgr
import unit_general
import task_attack_barb
import d_bush
import d_stone
import b_bridge
import b_waterpump
import level_board
import base_unit
import task_upgrade
import unit_barb
import b_quarry
import d_indian_worker
import b_warehouse
import b_forester_field
import task_wc
import building_helper
import quest_tut_build
import b_sawmill
import quest_normal
import unit_questman_boat
import b_farm_field
import d_geyser
import b_well
import b_column
import task_classes
import b_camp
import quest_giveres
import d_stonegate
import b_smokery
import quest_tut_break
import d_none
import d_random_res
import d_bog
import task_walkg
import d_item_changer
import b_forester
import b_workshop
import b_farm
import b_boatyard
import quest_tut_upgrade
import unit_worker
import tut_helper
import task_walke
import game_helper
import fsm_state
import task_walkw
import b_woodcutter
import d_gate
import d_test
import d_enter
import unit_enemy
import anim_helper
import d_barbarian_nest
import base_building
import ui
import d_ind_bridge
import unit_quarry
import task_build
import b_shoemaker
import b_stonecutter
import quest_tut_sublevel
import b_granitemine
import d_inventory
import task_callworker
import d_boards_helper
import d_tree
import b_nofog
import d_bonus_altar
import base_diff_item
import d_totem_barb
import d_key
import d_chest
import d_task_item
import b_silvermine
import unit_wcutter
import b_garden
import d_granite
import d_boat
import d_teleport
import b_fisherman
import mgr_t
import mgr_u
import mgr_q
import mgr_e
import mgr_b
import b_totem
import d_stalactite
import d_dr_tree
import task_res

import b_doctor
import unit_doctor
import task_doctor
import fsm_methods
import base_building_tips
import unit_firefighter
import task_firefight
import dependant_mgr
import b_fence
import d_fish
import d_waterfall
import d_lava

# ============================================================
# ============================================================
class Serializer(object):
    Instance = None
    def __init__(self):
        self.next_uiid = 1
        self.total_save_items = {}    # <str(object), uiid>
        self.total_save_items_tagged = {}    # <str(object), object>
        self.save_items = {}    # <str(object), uiid>
        self.save_items_tagged = {}    # <str(object), object>
        self.save_uiids = {}    # uiid, cpp_uiid

        self.load_uiids = {}    # uiid, cpp_uiid
        self.offsets = {}       # uiid, offset
        self.loaded_items = {}  # uiid, obj

        self.ser_classes = {}
        self.ser_classes['AnimHelper'] = anim_helper.AnimHelper
        self.ser_classes['__none_basebuilding__'] = base_building.BaseBuilding
        self.ser_classes['StateInit'] = fsm_state.StateInit
        self.ser_classes['StateBroken'] = fsm_state.StateBroken
        self.ser_classes['StatePrenormal'] = fsm_state.StatePrenormal
        self.ser_classes['StateNormal'] = fsm_state.StateNormal
        self.ser_classes['StateWaitUnit'] = fsm_state.StateWaitUnit
        self.ser_classes['StateAttacked'] = fsm_state.StateAttacked
        self.ser_classes['StateGenerating'] = fsm_state.StateGenerating
        self.ser_classes['StateGenerated'] = fsm_state.StateGenerated
        self.ser_classes['StateUpgrading'] = fsm_state.StateUpgrading
        self.ser_classes['StateRepairWait'] = fsm_state.StateRepairWait
        self.ser_classes['StateRepairing'] = fsm_state.StateRepairing
        self.ser_classes['StateBuildWait'] = fsm_state.StateBuildWait
        self.ser_classes['StateBuilding'] = fsm_state.StateBuilding
        self.ser_classes['OpenKeySubtask'] = base_diff_item.OpenKeySubtask
        self.ser_classes['__none_differentitem__'] = base_diff_item.DiffItem
        self.ser_classes['UnitQuestDlgTask'] = base_unit.UnitQuestDlgTask
        self.ser_classes['__none_baseunit__'] = base_unit.BaseUnit
        self.ser_classes['BuildingHelper'] = building_helper.BuildingHelper
        self.ser_classes['BakeryBuilding'] = b_bakery.BakeryBuilding
        self.ser_classes['BoatyardBuilding'] = b_boatyard.BoatyardBuilding
        self.ser_classes['BoatyardStateRepairing'] = b_boatyard.StateRepairing
        self.ser_classes['BoatyardStateUpgrading'] = b_boatyard.StateUpgrading
        self.ser_classes['BoatyardStateBuilding'] = b_boatyard.StateBuilding
        self.ser_classes['Bridge'] = b_bridge.Bridge
        self.ser_classes['CampBuilding'] = b_camp.CampBuilding
        self.ser_classes['DamBuilding'] = b_dam.DamBuilding
        self.ser_classes['DamStateRepairing'] = b_dam.StateRepairing
        self.ser_classes['FarmBuilding'] = b_farm.FarmBuilding
        self.ser_classes['FarmStateRemoving'] = b_farm.StateRemoving
        self.ser_classes['FarmStateRemovingFinal'] = b_farm.StateRemovingFinal
        self.ser_classes['FarmHelperAction'] = b_farm_field.HelperAction
        self.ser_classes['FarmField'] = b_farm_field.FarmField
        self.ser_classes['FishermanBuilding'] = b_fisherman.FishermanBuilding
        self.ser_classes['ForesterBuilding'] = b_forester.ForesterBuilding
        self.ser_classes['ForesterStateRemoving'] = b_forester.StateRemoving
        self.ser_classes['ForesterStateRemovingFinal'] = b_forester.StateRemovingFinal
        self.ser_classes['ForesterHelperAction'] = b_forester_field.HelperAction
        self.ser_classes['ForesterField'] = b_forester_field.ForesterField
        self.ser_classes['GardenHelperAction'] = b_garden.HelperAction
        self.ser_classes['GardenBuilding'] = b_garden.GardenBuilding
        self.ser_classes['GranitemineBuilding'] = b_granitemine.GranitemineBuilding
        self.ser_classes['HouseBuilding'] = b_house.HouseBuilding
        self.ser_classes['IndBuilding'] = b_ind_house.IndBuilding
        self.ser_classes['MintBuilding'] = b_mint.MintBuilding
        self.ser_classes['Nofog'] = b_nofog.Nofog
        self.ser_classes['QuarryBuilding'] = b_quarry.QuarryBuilding
        self.ser_classes['SawmillBuilding'] = b_sawmill.SawmillBuilding
        self.ser_classes['ShoemakerBuilding'] = b_shoemaker.ShoemakerBuilding
        self.ser_classes['SilvermineBuilding'] = b_silvermine.SilvermineBuilding
        self.ser_classes['SmokeryBuilding'] = b_smokery.SmokeryBuilding
        self.ser_classes['StonecutterBuilding'] = b_stonecutter.StonecutterBuilding
        self.ser_classes['Totem'] = b_totem.Totem
        self.ser_classes['TowerBuilding'] = b_tower.TowerBuilding
        self.ser_classes['WarehouseBuilding'] = b_warehouse.WarehouseBuilding
        self.ser_classes['Waterpump'] = b_waterpump.Waterpump
        self.ser_classes['Well'] = b_well.Well
        self.ser_classes['WoodcutterBuilding'] = b_woodcutter.WoodcutterBuilding
        self.ser_classes['WorkshopBuilding'] = b_workshop.WorkshopBuilding
        self.ser_classes['Nest'] = d_barbarian_nest.Nest
        self.ser_classes['BoardsHelper'] = d_boards_helper.BoardsHelper
        self.ser_classes['BoatSubtask'] = d_boat.BoatSubtask
        self.ser_classes['Boat'] = d_boat.Boat
        self.ser_classes['DigBogSubtask'] = d_bog.DigBogSubtask
        self.ser_classes['Bog'] = d_bog.Bog
        self.ser_classes['TakeBonusKeySubtask'] = d_bonuskey.TakeBonusKeySubtask
        self.ser_classes['BonusKey'] = d_bonuskey.BonusKey
        self.ser_classes['BonusAltarSubtask'] = d_bonus_altar.BonusAltarSubtask
        self.ser_classes['BonusAltar'] = d_bonus_altar.BonusAltar
        self.ser_classes['ChopBushSubtask'] = d_bush.ChopBushSubtask
        self.ser_classes['GatherBushSubtask'] = d_bush.GatherBushSubtask
        self.ser_classes['Bush'] = d_bush.Bush
        self.ser_classes['OpenChestSubtask'] = d_chest.OpenChestSubtask
        self.ser_classes['Chest'] = d_chest.Chest
        self.ser_classes['Crater'] = d_crater.Crater
        self.ser_classes['ChopDrTreeSubtask'] = d_dr_tree.ChopDrTreeSubtask
        self.ser_classes['DrTree'] = d_dr_tree.DrTree
        self.ser_classes['EnablerSubtask'] = d_enabler.EnablerSubtask
        self.ser_classes['Enabler'] = d_enabler.Enabler
        self.ser_classes['EnterInSubtask'] = d_enter.EnterInSubtask
        self.ser_classes['EnterTransferUnitsSubtask'] = d_enter.EnterTransferUnitsSubtask
        self.ser_classes['Enter'] = d_enter.Enter
        self.ser_classes['HackGateSubtask'] = d_gate.HackGateSubtask
        self.ser_classes['Gate'] = d_gate.Gate
        self.ser_classes['Geyser'] = d_geyser.Geyser
        self.ser_classes['TakeGoldSubtask'] = d_gold.TakeGoldSubtask
        self.ser_classes['Gold'] = d_gold.Gold
        self.ser_classes['HackGraniteSubtask'] = d_granite.HackGraniteSubtask
        self.ser_classes['Granite'] = d_granite.Granite
        self.ser_classes['OpenGraveSubtask'] = d_grave.OpenGraveSubtask
        self.ser_classes['GraveInSubtask'] = d_grave.GraveInSubtask
        self.ser_classes['GraveTransferUnitsSubtask'] = d_grave.GraveTransferUnitsSubtask
        self.ser_classes['Grave'] = d_grave.Grave
        self.ser_classes['IndWorker'] = d_indian_worker.IndWorker
        self.ser_classes['IndAltar'] = d_ind_altar.IndAltar
        self.ser_classes['HackIndBridgeSubtask'] = d_ind_bridge.HackIndBridgeSubtask
        self.ser_classes['IndBridge'] = d_ind_bridge.IndBridge
        self.ser_classes['HackIndHouseSubtask'] = d_ind_house_br.HackIndHouseSubtask
        self.ser_classes['IndHouseBreakable'] = d_ind_house_br.IndHouseBreakable
        self.ser_classes['TakeInventorySubtask'] = d_inventory.TakeInventorySubtask
        self.ser_classes['Inventory'] = d_inventory.Inventory
        self.ser_classes['ItemChangerSubtask'] = d_item_changer.ItemChangerSubtask
        self.ser_classes['ItemChanger'] = d_item_changer.ItemChanger
        self.ser_classes['TakeKeySubtask'] = d_key.TakeKeySubtask
        self.ser_classes['Key'] = d_key.Key
        self.ser_classes['Lama'] = d_lama.Lama
        self.ser_classes['TakeLetterSubtask'] = d_letter.TakeLetterSubtask
        self.ser_classes['Letter'] = d_letter.Letter
        self.ser_classes['Mais'] = d_mais.Mais
        self.ser_classes['None'] = d_none.None
        self.ser_classes['BreakPotSubtask'] = d_pot.BreakPotSubtask
        self.ser_classes['SkeletonSubtask'] = d_pot.SkeletonSubtask
        self.ser_classes['Pot'] = d_pot.Pot
        self.ser_classes['RandomRes'] = d_random_res.RandomRes
        self.ser_classes['TakeResSubtask'] = d_res.TakeResSubtask
        self.ser_classes['GeneralResource'] = d_res.GeneralResource
        self.ser_classes['HackStalactiteSubtask'] = d_stalactite.HackStalactiteSubtask
        self.ser_classes['Stalactite'] = d_stalactite.Stalactite
        self.ser_classes['HackStoneSubtask'] = d_stone.HackStoneSubtask
        self.ser_classes['Stone'] = d_stone.Stone
        self.ser_classes['StoneGate'] = d_stonegate.StoneGate
        self.ser_classes['TaskItemDlgTask'] = d_task_item.TaskItemDlgTask
        self.ser_classes['TaskDiffItem'] = d_task_item.TaskDiffItem
        self.ser_classes['BreakTestSubtask'] = d_test.BreakTestSubtask
        self.ser_classes['TakeTestSubtask'] = d_test.TakeTestSubtask
        self.ser_classes['Test'] = d_test.Test
        self.ser_classes['HackTotemSubtask'] = d_totem_barb.HackTotemSubtask
        self.ser_classes['BarbarianTotem'] = d_totem_barb.BarbarianTotem
#        self.ser_classes['Transfer'] = d_transfer.Transfer
        self.ser_classes['ChopSubtask'] = d_tree.ChopSubtask
        self.ser_classes['Tree'] = d_tree.Tree
        self.ser_classes['TakeUResSubtask'] = d_unit_res.TakeUResSubtask
        self.ser_classes['UnitResource'] = d_unit_res.UnitResource
        self.ser_classes['__none_fsmstate__'] = fsm_state.FSMState
        self.ser_classes['StateSurvived'] = fsm_state.StateSurvived
        self.ser_classes['StateThrown'] = fsm_state.StateThrown
        self.ser_classes['StateMapPlace'] = fsm_state.StateMapPlace
        self.ser_classes['StatePreremoving'] = fsm_state.StatePreremoving
        self.ser_classes['StateRemoving'] = fsm_state.StateRemoving
        self.ser_classes['StateRemovingFinal'] = fsm_state.StateRemovingFinal
        self.ser_classes['GameHelper'] = game_helper.GameHelper
        self.ser_classes['GameTask'] = game_task.GameTask
        self.ser_classes['LBCore'] = level_board.LBCore
        self.ser_classes['BActionsHistory'] = mgr_b.BActionsHistory
        self.ser_classes['BuildingsContainer'] = mgr_b.BuildingsContainer
        self.ser_classes['LevelCluster'] = mgr_b.LevelCluster
        self.ser_classes['BuildingsMgr'] = mgr_b.BuildingsMgr
        self.ser_classes['SignalItem'] = mgr_e.SignalItem
        self.ser_classes['EventsMgr'] = mgr_e.EventsMgr
        self.ser_classes['QuestsCluster'] = mgr_q.QuestsCluster
        self.ser_classes['QuestsMgr'] = mgr_q.QuestsMgr
        self.ser_classes['TasksMgr'] = mgr_t.TasksMgr
        self.ser_classes['UnitsCluster'] = mgr_u.UnitsCluster
        self.ser_classes['UnitsMgr'] = mgr_u.UnitsMgr
        self.ser_classes['QuestTaskData'] = quest.QuestTaskData
        self.ser_classes['Quest'] = quest.Quest
        self.ser_classes['QuestGiveRes'] = quest_giveres.QuestGiveRes
        self.ser_classes['QuestUniversalTask'] = quest_normal.QuestUniversalTask
        self.ser_classes['QuestBuildTask'] = quest_normal.QuestBuildTask
        self.ser_classes['QuestDoActionTask'] = quest_normal.QuestDoActionTask
        self.ser_classes['QuestInventoryTask'] = quest_normal.QuestInventoryTask
        self.ser_classes['QuestTalkTask'] = quest_normal.QuestTalkTask
        self.ser_classes['QuestNormal'] = quest_normal.QuestNormal
        self.ser_classes['TutBreakTask'] = quest_tut_break.TutBreakTask
        self.ser_classes['QuestTutBreak'] = quest_tut_break.QuestTutBreak
        self.ser_classes['TutBuildingTask'] = quest_tut_build.TutBuildingTask
        self.ser_classes['QuestTutBuild'] = quest_tut_build.QuestTutBuild
        self.ser_classes['TutSublevelTask'] = quest_tut_sublevel.TutSublevelTask
        self.ser_classes['QuestTutSublevel'] = quest_tut_sublevel.QuestTutSublevel
        self.ser_classes['TutUniversalTask'] = quest_tut_uni.TutUniversalTask
        self.ser_classes['QuestTutUniversal'] = quest_tut_uni.QuestTutUniversal
        self.ser_classes['TutUpgradingTask'] = quest_tut_upgrade.TutUpgradingTask
        self.ser_classes['QuestTutUpgrade'] = quest_tut_upgrade.QuestTutUpgrade
        self.ser_classes['__none_submgr__'] = smgr.SubMgr
        self.ser_classes['BonusMgr'] = smgr_bonus.BonusMgr
        self.ser_classes['BarbHitSubtask'] = task_attack_barb.BarbHitSubtask
        self.ser_classes['AttackBarbarianTask'] = task_attack_barb.AttackBarbarianTask
        self.ser_classes['BuildingTask'] = task_build.BuildingTask
        self.ser_classes['BuildingPlaceTask'] = task_build_place.BuildingPlaceTask
        self.ser_classes['CallWorkerTask'] = task_callworker.CallWorkerTask
        self.ser_classes['__none_subtask__'] = task_classes.Subtask
        self.ser_classes['__none_task__'] = task_classes.Task
        self.ser_classes['QuarryManTask'] = task_qm.QuarryManTask
        self.ser_classes['TakeResTask'] = task_res.TakeResTask
        self.ser_classes['TakeResStoreTask'] = task_res_store.TakeResStoreTask
        self.ser_classes['UpgradeTask'] = task_upgrade.UpgradeTask
        self.ser_classes['WalkEnemyTask'] = task_walke.WalkEnemyTask
        self.ser_classes['WalkGeneralTask'] = task_walkg.WalkGeneralTask
        self.ser_classes['WalkWorkerTask'] = task_walkw.WalkWorkerTask
        self.ser_classes['WoodCutterTask'] = task_wc.WoodCutterTask
        self.ser_classes['BInfo'] = tut_helper.BInfo
        self.ser_classes['GameInfoContainer'] = tut_helper.GameInfoContainer
        self.ser_classes['EventsContainer'] = tut_helper.EventsContainer
        self.ser_classes['TutHelper'] = tut_helper.TutHelper
        self.ser_classes['PanelItem'] = ui.PanelItem
        self.ser_classes['TipsZone'] = ui.TipsZone
        self.ser_classes['GameUI'] = ui.GameUI
        self.ser_classes['UnitBarbarian'] = unit_barb.UnitBarbarian
        self.ser_classes['UnitEnemy'] = unit_enemy.UnitEnemy
        self.ser_classes['UnitGeneral'] = unit_general.UnitGeneral
        self.ser_classes['IndianQuestDlgTask'] = unit_indian_sit.IndianQuestDlgTask
        self.ser_classes['IndianCompleteQuestDlgTask'] = unit_indian_sit.IndianCompleteQuestDlgTask
        self.ser_classes['IndianQuestTalkTask'] = unit_indian_sit.IndianQuestTalkTask
        self.ser_classes['UnitIndianSit'] = unit_indian_sit.UnitIndianSit
        self.ser_classes['UnitQuarry'] = unit_quarry.UnitQuarry
        self.ser_classes['UnitQuest'] = unit_quest.UnitQuest
        self.ser_classes['QuestmanQuestDlgTask'] = unit_questman_boat.QuestmanQuestDlgTask
        self.ser_classes['QuestmanCompleteQuestDlgTask'] = unit_questman_boat.QuestmanCompleteQuestDlgTask
        self.ser_classes['UnitQuestmanBoat'] = unit_questman_boat.UnitQuestmanBoat
        self.ser_classes['TradingDlgTask'] = unit_trader.TradingDlgTask
        self.ser_classes['UnitTrader'] = unit_trader.UnitTrader
        self.ser_classes['UnitWoodcutter'] = unit_wcutter.UnitWoodcutter
        self.ser_classes['UnitWorker'] = unit_worker.UnitWorker

        # part three:
        self.ser_classes['TeleportSubtask'] = d_teleport.TeleportSubtask
        self.ser_classes['Teleport'] = d_teleport.Teleport
        self.ser_classes['Event'] = mgr_e.Event
        self.ser_classes['StateDINormal'] = base_diff_item.StateNormal
        self.ser_classes['StateDIInteracting'] = base_diff_item.StateInteracting
        self.ser_classes['StateDIComplete'] = base_diff_item.StateComplete
        self.ser_classes['DoctorBuilding'] = b_doctor.DoctorBuilding
        self.ser_classes['UnitDoctor'] = unit_doctor.UnitDoctor
        self.ser_classes['DoctorTask'] = task_doctor.DoctorTask
        self.ser_classes['StateBUStay'] = base_unit.StateStay
        self.ser_classes['StateBURun'] = base_unit.StateRun
        self.ser_classes['StateBUIdle'] = base_unit.StateIdle
        self.ser_classes['StateBUTalk'] = base_unit.StateTalk
        self.ser_classes['StateBUMagic'] = base_unit.StateMagic
        self.ser_classes['StateBUAction'] = base_unit.StateAction
        self.ser_classes['StateBUHit'] = base_unit.StateHit
        self.ser_classes['StateBUBuild'] = base_unit.StateBuild
        self.ser_classes['StateBUDig'] = base_unit.StateDig
        self.ser_classes['StateBUSick'] = base_unit.StateSick
        self.ser_classes['StateBUSickStandup'] = base_unit.StateSickStandup
        self.ser_classes['StateBUCuring'] = base_unit.StateCuring
        self.ser_classes['StateGeneralStay'] = unit_general.StateGeneralStay
        self.ser_classes['FsmMethods'] = fsm_methods.FsmMethods
        self.ser_classes['StateBurning'] = fsm_state.StateBurning
        self.ser_classes['StateFirefighterWait'] = fsm_state.StateFirefighterWait
        self.ser_classes['StateExtinguishing'] = fsm_state.StateExtinguishing
        self.ser_classes['StateRemovingHouse'] = fsm_state.StateRemovingHouse
        self.ser_classes['BuildingTips'] = base_building_tips.BuildingTips
        self.ser_classes['FarmTips'] = b_farm.FarmTips
        self.ser_classes['ForesterTips'] = b_forester.ForesterTips
        self.ser_classes['FarmFieldTips'] = b_farm_field.FarmFieldTips
        self.ser_classes['ForesterFieldTips'] = b_forester_field.ForesterFieldTips
        self.ser_classes['UnitFirefighter'] = unit_firefighter.UnitFirefighter
        self.ser_classes['FirefighterTask'] = task_firefight.FirefighterTask
        self.ser_classes['Column'] = b_column.Column
        self.ser_classes['FenceBuilding'] = b_fence.FenceBuilding
        self.ser_classes['Fish'] = d_fish.Fish
        self.ser_classes['Waterfall'] = d_waterfall.Waterfall
        self.ser_classes['Lava'] = d_lava.Lava
        self.ser_classes['ImmediateSubtask'] = d_pot.ImmediateSubtask
        self.ser_classes['HealSubtask'] = task_doctor.HealSubtask
        self.ser_classes['QuestCureTask'] = quest_normal.QuestCureTask

        #self.ser_classes['StateBurning'] = fsm_state.StateBurning
        #self.ser_classes['StateExtinguishing'] = fsm_state.StateExtinguishing
        self.ser_classes['DependantBuildingMgr'] = dependant_mgr.DependantBuildingMgr
# ============================================================
    types = {'int':4, 'spec':8, 'simple':16, 'list':32, 'uiid':64}
    t_int = 4
    t_spec = 8
    t_simple = 16
    t_list = 32
    t_uiid = 64
# ============================================================
    def get_next_uiid(self):
        uiid = self.next_uiid
        self.next_uiid = self.next_uiid + 1
        return uiid
# ============================================================
    def serialize(self):
        level_board.serialize(self)
# ============================================================
    def deserialize(self):
        level_board.deserialize(self)
# ============================================================
    def save(self, obj, ser_name = ''):
        _count = 0
        if obj == None:
            LBoard.SaveClassname('__None__')
            return
        elif ser_name != '':
            LBoard.SaveClassname(ser_name)
        elif 'ser_name' in obj:
            LBoard.SaveClassname(obj['ser_name'])
        else:
            LBoard.SaveClassname('__undefined__')
            mbox('Erroneous object! No ser_name.')
        for field_name in obj:
            if gettype(field_name) == 'string':
                if field_name in self.skip_fields:
                    continue
                if field_name.startswith('cache'):  # для закешированных значений
                    continue
            _val = obj[field_name]
            _t = gettype(_val)
            if _t == 'fnc':
                continue
            elif _t == 'method':
                continue
            elif _t == 'data':
                continue
            else:
                _count += 1
        LBoard.SaveCount(_count)
        _test_count = 0
        for field_name in obj:
            if field_name in self.skip_fields:
                continue
            _val = obj[field_name]
            _t = gettype(_val)
            if _t == 'fnc':
                continue
            elif _t == 'method':
                continue
            elif _t == 'data':
                continue

            if field_name in self.res_fields:
                LBoard.AppendByte(3)  # field string
                LBoard.WriteStr(field_name)
                if not _val:
                    LBoard.AppendByte(0)
                else:
                    LBoard.AppendByte(1)
                    LBoard.DoRes(_val)
                _test_count += 1
                continue
            else:
                _is_number = (gettype(field_name) == 'number')
                if _is_number:
                    LBoard.AppendByte(1)  # field number
                    LBoard.AppendInt(field_name)
                else:
                    if field_name.startswith('cache'):  # для закешированных значений
                        continue
                    LBoard.AppendByte(3)  # field string
                    LBoard.WriteStr(field_name)
                trace(field_name)
                self.save_simple(_val)
                _test_count += 1
        if _count != _test_count:
            trace('==> Serialize ERROR <==', _count, _test_count)
            if ser_name != '':
                trace('    ', ser_name)
            elif 'ser_name' in obj:
                trace('    ', obj.ser_name)
            mbox('Serialize ERROR. Wrong fields count: ' + str(_count) + '!=' + str(_test_count))
# ============================================================
    _skip_tp_types = {'fnc':0, 'method':0, 'data':0}
    def calc_save_list_len(self, _list):
        _count = 0
        _skip = self._skip_tp_types
        for item in _list:
            _t = gettype(item)
            if _t not in _skip:
                _count += 1
        return _count
# ============================================================
    def save_simple(self, val):
        _t = gettype(val)
        _skip = self._skip_tp_types
        if _t == 'object':
            uiid = self.save_object(val)
            #LBoard.AppendByte(self.types['uiid'])
            LBoard.AppendByte(self.t_uiid)
            LBoard.AppendInt(uiid)
            return
        elif _t == 'dict_simple':
            self.save_dict(val)
            return
        elif _t == 'list':
            #LBoard.AppendByte(self.types['list'])
            LBoard.AppendByte(self.t_list)
            _list_len = self.calc_save_list_len(val)
            LBoard.SaveCount(_list_len)
            for i in range(_list_len):
                _val = val[i]
                _val_t = gettype(_val)
                if _val_t not in _skip:
                    self.save_simple(_val)
            return
        elif _t in _skip:
            return
        #if _t == 'data':
        #    return    # don't know what to do...
        #if _t == 'fnc':
        #    return    # skipping functions
        #if _t == 'method':
        #    return    # skipping methods
        LBoard.AppendByte(self.t_simple)
        LBoard.SaveSimple(val)
# ============================================================
    def save_dict(self, val_dict):
        _has_objects = False
        for key in val_dict:
            val = val_dict[key]
            _t = gettype(val)
            if _t == 'object':
                _has_objects = True
                break
            elif _t == 'dict_simple':
                _has_objects = True
                break
            elif _t == 'list':
                _has_objects = True
                break
        if not _has_objects:
            #LBoard.AppendByte(self.types['simple'])
            LBoard.AppendByte(self.t_simple)
            LBoard.SaveSimple(val_dict)
        else:
            #val_dict.ser_name = 'dict'
            uiid = self.save_object(val_dict, 'dict')
            #LBoard.AppendByte(self.types['uiid'])
            LBoard.AppendByte(self.t_uiid)
            LBoard.AppendInt(uiid)
# ============================================================
    skip_fields = {'Signals':0, 'SM':0, 'FSM':0, 'Drawer':0, 'cdata':0, 'drawer':0, 'signaler':0, 'widgets':0, 'cpp_uiid':0}    #, 'ser_name':0}
    res_fields = {'res_action_cost':0, 'completeGivesRes':0, 'next_res':0, 'action_cost_res':0, 'resources_need':0, 'resource':0 }
    def save_object(self, val_object, ser_name = ''):
        uiid = 0
        if 'ser_name' not in val_object and ser_name == '':
            mbox('No "ser_name".')
            trace(val_object)
            return uiid
        if ser_name == '':
            ser_name = val_object['ser_name']
        _id = str(val_object)
        if _id in self.total_save_items:
            uiid = self.total_save_items[_id]
        elif _id in self.save_items:
            uiid = self.save_items[_id]
        else:
            uiid = self.get_next_uiid()
            self.save_items[_id] = uiid
            self.save_items_tagged[_id] = (val_object, ser_name)
            self.total_save_items[_id] = uiid
            self.total_save_items_tagged[_id] = (val_object, ser_name)
        return uiid
# ============================================================
    def iterate_saved_items(self):
        _begin = LBoard.GetAppendPos()
        LBoard.AppendInt(0) # кол-во элементов
        _int = self.t_int
        _spec = self.t_spec
        #_uiid = self.t_uiid
        while True:
            _save_items = self.save_items
            _save_items_tagged = self.save_items_tagged
            self.save_items = {}
            self.save_items_tagged = {}
            for obj in _save_items:
                uiid = _save_items[obj]
                #self.total_save_items[obj] = uiid
                #self.total_save_items_tagged[obj] = _save_items_tagged[obj]
                LBoard.AppendByte(_int)    # в самом начале записи только
                LBoard.AppendInt(uiid)
                cpp_uiid = 0
                if uiid in self.save_uiids: cpp_uiid = self.save_uiids[uiid]
                LBoard.AppendInt(cpp_uiid)
                LBoard.AppendByte(_spec)    # special
                _pos = LBoard.GetAppendPos()
                LBoard.AppendInt(0)
                _item, _ser_name = _save_items_tagged[obj]
                self.save(_item, _ser_name)
                _end = LBoard.GetAppendPos()
                _size = _end - _pos - 4#sizeof(int)
                LBoard.WriteIntAt(_pos, _size)
            if len(self.save_items) == 0:
                break
            trace('ITERATION NEXT')
        _items_count = len(self.total_save_items)
        LBoard.WriteIntAt(_begin, _items_count)
# ============================================================
    def load_saved_items(self):
        _count = LBoard.ReadInt() # кол-во элементов
        #_int = self.t_int
        #_spec = self.t_spec
        for i in range(_count):
            _int_type = LBoard.ReadByte()
            #@perf if _int_type != _int: mbox('tp: Not an integer: ' + str(_int_type) )
            _uiid = LBoard.ReadInt()
            _cpp_uiid = LBoard.ReadInt()
            _spec_type = LBoard.ReadByte()
            #@perf if _spec_type != _spec: mbox('tp: Not an Special type: '+ str(_spec_type))
            _size = LBoard.ReadInt()
            #trace('UIIDs,Size:', _uiid, _cpp_uiid, _size)
            self.offsets[_uiid] = LBoard.GetReadPos()
            self.load_uiids[_uiid] = _cpp_uiid
            LBoard.MovePos(_size)
# ============================================================
# ============================================================
    post_load_init = {'GardenBuilding':0, 'FarmField':0, 'SilvermineBuilding':0, 'ForesterField':0,
                        'GameUI':0, 'BuildingsMgr':0, 'UnitWorker':0, 'TutHelper':0, 'UnitIndianSit':0,
                        'TaskDiffItem':0}
    def load(self, uiid):
        #trace('UIID:', uiid)
        if uiid in self.loaded_items:
            #trace('== found')
            return self.loaded_items[uiid]
        #trace('== not found')
        _offset = self.offsets[uiid]
        _restore = LBoard.GetReadPos()
        #trace('== offset:', _offset)
        LBoard.SetOffset(_offset)   # выставляем смещение для чтения данных объекта
        _ser_name = LBoard.LoadClassname()
        #trace('== clasname:', _ser_name)
        _obj = None
        if _ser_name == 'dict':
            _obj = {}
        elif _ser_name == '__None__':
            LBoard.SetOffset(_restore)
            #trace('== restore', _restore)
            return _obj
        elif _ser_name == '__undefined__':
            mbox('Error when saving')
        else:
            cpp_uiid = 0
            if uiid in self.load_uiids: cpp_uiid = self.load_uiids[uiid]
            #trace('== cpp_uiid', cpp_uiid)
            cdata = LBoard.GetCDataByUIID(cpp_uiid)
            if cdata:
                #trace('== creation cdata >')
                _obj = self.ser_classes[_ser_name](cdata)
                #trace('== creation <')
            else:
                #trace('== creation >')
                _obj = self.ser_classes[_ser_name]()
                #trace('== creation <')

        self.loaded_items[uiid] = _obj

        _count = LBoard.LoadCount()
        for i in range(_count):
            _field_type = LBoard.ReadByte()
            field = None
            if _field_type == 1:    # number
                field = LBoard.ReadInt()
                #trace('== nfield: ', field)
            elif _field_type == 3:  # string
                field = LBoard.ReadStr()
                #trace('== field: ', field)
                if field in self.res_fields:    # если это ресурс
                    _val = None
                    _r = LBoard.ReadByte()
                    if _r == 1:
                        _val = LBoard.DoRes()
                    _obj[field] = _val
                    continue
            else:
                mbox('Unknown field type: ' + str(_field_type))
                #trace('_obj', _obj)
            _val = self.load_simple()
            _obj[field] = _val
            #trace('--T--', field, _val)
        if _ser_name in self.post_load_init:
            _obj.deserialize_init()
        if 'need_deserialize_init_extra' in _obj:   # пока для anim_helper
            if _obj.need_deserialize_init_extra:
                _obj.deserialize_init_extra()
        LBoard.SetOffset(_restore)
        #trace('== restore2', _restore)
        return _obj
# ============================================================
    def load_simple(self):
        _type = LBoard.ReadByte()
        #if _type == self.types['simple']:
        if _type == self.t_simple:
            return LBoard.LoadSimple()
        #elif _type == self.types['spec']:
        #    return self.load_obj()
        #elif _type == self.types['uiid']:
        elif _type == self.t_uiid:
            return self.load_obj()
        #elif _type == self.types['list']:
        elif _type == self.t_list:
            return self.load_list()
        else:
            mbox('Error load_simple: ' + str(_type))
# ============================================================
    def load_obj(self):
        uiid = LBoard.ReadInt()
        return self.load( uiid )
# ============================================================
    def load_list(self):
        _list = []
        _count = LBoard.LoadCount()
        #trace('load_list count: ' + str(_count))
        for i in range(_count):
            _list.append( self.load_simple() )
        return _list
# ============================================================
# ============================================================
def initialize(is_loading):
    Serializer.Instance = Serializer()
    if is_loading:
        Serializer.Instance.load_saved_items()
# ============================================================
def dispose():
    Serializer.Instance = None
# ============================================================
def save(item, cpp_uiid):
    uiid = Serializer.Instance.save_object(item)
    Serializer.Instance.save_uiids[uiid] = cpp_uiid
    return uiid
# ============================================================
def save_lboard():
    return level_board.serialize(Serializer.Instance)
# ============================================================
def load_lboard(uiid):
    level_board.deserialize(Serializer.Instance, uiid)
# ============================================================
def load(uiid):
    _new_obj = Serializer.Instance.load(uiid)
    return _new_obj
# ============================================================
def save_objects():
    Serializer.Instance.iterate_saved_items()
# ============================================================