# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

# ============================================================
# ============================================================
class SubMgr(object):
    def __init__(self, prefix):
        self.ser_name = '__none_submgr__'
        self.prefix = prefix
        self.prefix_len = len(prefix)
# ============================================================
# ============================================================
    def on_msg(self, msg_type, msg_param1='', msg_param2='', msg_dict={}):
        if msg_type == 'signal_msg':
            self.on_signal(msg_param1)
# ============================================================
    def on_signal(self, signal):
        pass
# ============================================================
    def on_create(self):
        trace('BonusSubMgr on_create')
# ============================================================
    def on_global_event(self, event, param):
        pass
# ============================================================
    def on_update(self, ms):                # данный метод должен вызываться из C++ каждый квант
        pass
# ============================================================
    def on_rare_update(self, ms):
        pass
# ============================================================
# ============================================================
    def restart_signal(self, signal, time):
        BMgr.Signals.Restart(self.prefix+signal, time)
# ============================================================
    def cancel_signal(self, signal):
        BMgr.Signals.Cancel(self.prefix+signal)
# ============================================================
    def add_signal(self, signal, time):
        BMgr.Signals.Add(self.prefix+signal, time)
# ============================================================
    def has_signal(self, signal):
        return BMgr.Signals.Has(self.prefix+signal)
# ============================================================
    def get_signal_progress(self, signal):
        return BMgr.Signals.Progress(self.prefix+signal)
# ============================================================
