# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import smgr

# ============================================================
# ============================================================
class BonusMgr(smgr.SubMgr):
    bonus_vars = {  'runspeed': 'BONUS_RUN_SPEED',  # добавить бар генерала
                    'time': 'BONUS_TIME',           # добавить в бар времени заглушку
                    #'gen_speed': 'BONUS_GENERATE_SPEED',    # не готово
                    'gen_double': 'BONUS_GENERATE_DOUBLE',
                    'restore_eff': 'BONUS_RESTORE_EFF', }
    start_snd = {  'runspeed': 'SND_ALTAR_SPEED',
                    'time': 'SND_ALTAR_TIME',
                    'gen_double': 'SND_ALTAR_PRODUCTION',
                    'restore_eff': 'SND_ALTAR_EFFICIENCY', }
    stop_snd = {  'runspeed': 'SND_ALTAR_SPEED_END',
                    'time': 'SND_ALTAR_TIME_END',
                    'gen_double': 'SND_ALTAR_PRODUCTION_END',
                    'restore_eff': 'SND_ALTAR_EFFICIENCY_END', }

    def __init__(self, prefix = 'BM_'):
        smgr.SubMgr.__init__(self, prefix)
        self.ser_name = 'BonusMgr'
        self.bonuses_started = []
# ============================================================
    def reset(self):
        for bonus in self.bonuses_started:
            self.stop_bonus(bonus)
        del self.bonuses_started[:]
# ============================================================
# ============================================================
    def on_msg(self, msg_type, msg_param1="", msg_param2="", msg_dict={}):
        smgr.SubMgr.on_msg(self, msg_type, msg_param1, msg_param2, msg_dict)
# ============================================================
    def on_signal(self, signal):
        _cut_signal = ''
        _len = len(signal)
        if _len > 6: _cut_signal = signal[:-6]
        if _cut_signal in self.bonuses_started:
            self.on_bonus_complete(_cut_signal)
# ============================================================
    def on_create(self):
        trace('SubMgr on_create')
# ============================================================
    def on_global_event(self, event, param):
        pass
# ============================================================
    def on_update(self, ms):                # данный метод должен вызываться из C++ каждый квант
        pass
# ============================================================
    def on_rare_update(self, ms):
        pass
# ============================================================
# ============================================================
    def start_bonus(self, name, time, _value = 1):
        _can_start_bonus = self.can_start_bonus(name)
        if _can_start_bonus:
            _global_var = self.bonus_vars[name]
            _cur_value = UStats.GetLevelValue(_global_var)
            if _cur_value > _value:
                return  # текущий бонус лучше... Хотя это и невероятная ситуация...
            self.restart_signal(name+'_timer', time)
            self.bonuses_started.append(name)
            UStats.SetLevelValue(_global_var, _value)     # выставим значение, что бонус активен
            TMgr.SendGlobalMsg('bonus_start', name)
            EMgr.send_event('bonus_used', None)
            if name in self.start_snd:
                tools.PlaySound(self.start_snd[name])
            #if name == 'gen_speed':
            #    for b in BMgr.all_levels_buildings:
            #        b.Signals.SetTimeMul('resource_generated', 2)
# ============================================================
    def stop_bonus(self, name):
        self.cancel_signal(name+'_timer')
        self.bonuses_started.remove(name)
        UStats.SetLevelValue(self.bonus_vars[name], 0)     # сбросим значение бонуса
        TMgr.SendGlobalMsg('bonus_stop', name)
        if name in self.stop_snd:
            tools.PlaySound(self.stop_snd[name])
# ============================================================
    def get_bonuses_count(self):
        return len(self.bonuses_started)
# ============================================================
    def can_start_bonus(self, name):
        _count = self.get_bonuses_count()
        if _count >= 3: # одновременно не более 3 бонусов
            return False
        if name in self.bonuses_started:
            return False
        return True
# ============================================================
    def on_bonus_complete(self, name):
        self.stop_bonus(name)
# ============================================================
