# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import task_classes

# #######################################################
# #######################################################
#class ExtinguishSubtask(task_classes.Subtask):
#    def __init__(self, parent_task = None, actor = None):
#        task_classes.Subtask.__init__(self, parent_task, actor)
#        self.ser_name = 'ExtinguishSubtask'
#    # ============================================================
#    def start_action(self, item):
#        self.actor.stop_walk()
#        #self.actor.sick_unit = item
#        self.actor.FSM.HandleEvent('start_extinguish_event', True)
#        #item.set_check(False)
#        item.Signals.Restart('extinguish_process', 2000) # <-    # чтобы отобразить прогрессбар лечения
#        #self.actor.action_hit_item(item)
#        return True
# ============================================================
# ============================================================
class FirefighterTask(task_classes.Task):
    def __init__(self, burning_building = None):
        type = 'run_firefighter'
        task_classes.Task.__init__(self, type)
        self.ser_name = 'FirefighterTask'
        self.priority = 1000
        self.burning_building = burning_building
        self.from_map_index = -1
        self.to_map_index = -1
        self.firefighter = None
        self.is_event_task = False
        if burning_building:
            self.extra = burning_building.get('name')
        self.is_extinguishing_started = False
        #self.is_event_task = True   # EVENT ONLY
        #self._event_triggers.append("free_unit") # триггеры, которые отрабатывает данный таск
# ============================================================
    def do_pre_action(self):    # <-
        _has_firefighter = UMgr.has_firefighter()
        if not _has_firefighter:
            trace('FirefighterTask do_pre_action (no firefighter) False')
            return False
        # - нужно проверить наличие рабочего здания с доктором
        if self.burning_building:
            self.burning_building.task = self   # <-
            #self.burning_building.set_check(True) #???
            b = self.burning_building
            _is_next_level_possible = b.is_next_level_possible()
            if _is_next_level_possible:
                b.show_clock()  # песочные часы ожидания
                next_level_name = b.get_next_level_name()   # название варианта следующего уровня
                self.resources_need = b.GetNeedsRes(next_level_name)   # необходимые ресурсы
                UStats.SubRes(self.resources_need)      # вычитаем затраченные ресурсы
                #b.on_before_building_complete()
                b.start_task_participation(self)
                #b.SM.SetState('awaiting_action')
                _firefighter = UMgr.get_nearest_firefighter(b)
                self.firefighter = _firefighter
                trace('FirefighterTask do_pre_action True')
                return True
        trace('FirefighterTask do_pre_action False 2')
        return False
# ============================================================
    def try_do_action(self):
        if not self.firefighter or not self.burning_building:
            #mbox(str(self.unit) + str(self.stone))   #@test
            trace('No firefighter or burning_building')
            return False
        if self.firefighter.task:
            trace('Firefighter already has a task:', self.firefighter.task)
            trace('Task UID:', self.uid, 'Prev task:', self.firefighter.task.uid)
            return False
        # - нужно проверить наличие рабочего здания с доктором

        _firefighter = self.firefighter
        self.from_map_index = _firefighter.get('locind')
        self.to_map_index = self.burning_building.get('locind')
        # u.show()    # нужно показать юнита перед началом действия
        if _firefighter.parent_home:
            _unit_unused = _firefighter.parent_home.pop_firefighter() #если заняли юнита делом, то удалим его из списка свободных
        success = False
        if self.from_map_index != self.to_map_index:
            # get transition points
            _points = BMgr.get_submap_exit(self.to_map_index, self.from_map_index)
            _len = len(_points)
            if _len == 0:
                mbox('No submap exits found')
            trace('Submap exits count =', _len)
            _transition_obj = _points[0]
            _transition_start_cell = _firefighter.get('cell')
            BMgr.transfer_unit(_firefighter, self.to_map_index)
            _cell = _transition_obj.GetAttrCellFixed('action_cell')
            _firefighter.set('cell', _cell)
            _firefighter.transition_start_cell = _transition_start_cell
            _firefighter.transition_object = _transition_obj
        _firefighter.SetNeedToTeleport()
        success = _firefighter.run_to_target(self.burning_building, None, self.burning_building.get_firefight_cell_name())
        if success:
            _ff_cell_name = self.burning_building.get_firefight_cell_name()
            self.burning_building.reserve_action_cell(_ff_cell_name)
            self.apply_start_task(_firefighter)
            trace('FirefightTask: started try_do_action', _firefighter.get('name'), self.burning_building.get('name'))
            return True
            #_subtask = self.burning_building.get_subtask(self, _firefighter)
            #self.apply_start_task(_firefighter, _subtask)
            #trace('task "FirefighterTask" started')
            #return True
        return False
# ============================================================
    def _complete_task(self):
        self.is_complete = True
        self.is_extinguishing_started = False
        trace("task 'FirefighterTask' completed")
        self.firefighter.apply_stop_task()
        self.firefighter.FSM.HandleEvent('complete_extinguishing_event')
        _firefighter = self.firefighter
        self.firefighter = None
        #>>>> UMgr.add_free_unit(_unit)
        _firefighter.append_self_to_parent_home()
        self.burning_building.FSM.HandleEvent('extinguished_event')
        self.burning_building.task = None   # <-
        self.burning_building = None
        _firefighter.go_home() # отправим юнита домой
# ============================================================
    def target_reached(self, sender):
        '''Вызывается юнитом при достижении цели'''
        if not self.is_extinguishing_started:
            b = self.burning_building
            _fsm_state = b.FSM.GetStateID()
            #if _fsm_state == 'firefighter_wait':
            b.FSM.HandleEvent('extinguishing_event', True)
        self.is_extinguishing_started = True
        sender.FSM.HandleEvent('unit_extinguishing_event') # юнита переключаем в режим молотка
        #sender.Drawer.PlayAnimationOnce('action_extinguish', 'extinguish_hit_complete', '', 50, 'hit_moment')        # ударим еще раз
# ============================================================
    def on_update(self, ms):
        if self.is_extinguishing_started: # если тушение уже началось, то:
            # нужно готовность здания увеличивать пропорционально кол-ву работающих юнитов
            b = self.burning_building
            quant = ms  # * b.get_boost_multiplier()
            b.firefight_progress += quant
            if b.firefight_progress >= b.firefight_time:
                self.complete_task()
# ============================================================
    def cancel(self, force=False):
        '''Нужно вызывать при отмене задания'''
        self.is_complete = True
        trace("task 'FirefighterTask' canceled")
        if not self.is_extinguishing_started:        # если юнит еще не начал действие, то
            UStats.AddRes(self.resources_need)  # нужно возвращать стоимость апгрейда
        if self.burning_building:
            self.burning_building.show_clock(False)  # песочные часы ожидания
            self.burning_building.unreserve_action_cells()
            self.burning_building.stop_task_participation(self)
            #self.burning_building.set_check(False)        #???
            self.burning_building.task = None   # <-
        self.burning_building = None
        # нельзя напрямую отменять действие генерала, если сейчас данный таск не обрабатывается!
        if self.is_started:
            self.firefighter.apply_stop_task(False)
            _firefighter = self.firefighter
            _firefighter.go_home()
            #self.doctor = None
# ============================================================
#    def on_callback(self, result, extra_dict):
#        if self.subtask != None:
#            self.subtask.on_callback(result, extra_dict)
# ============================================================
#    def process_removing_item(self, r_uid, r_mi):
#        if self.firefighter:
#            _item = self.firefighter.parent_home
#            if _item:
#                _uid = _item.get('uid')
#                _mi = _item.get('locind')
#                if _uid == r_uid and _mi == r_mi:
#                    trace('_PRI_', _uid, _mi)
#                    self.cancel()
# ============================================================
# #######################################################
# #######################################################
# #######################################################
