# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import task_classes

# #######################################################
# #######################################################
class WalkEnemyTask(task_classes.Task):
    def __init__(self, item = None, unit = None):
        type = 'walk_enemy'
        task_classes.Task.__init__(self, type)
        self.ser_name = 'WalkEnemyTask'
        self.priority = 50
        self.item = item
        self.unit = unit
        self.is_event_task = False  #!
        self.non_canceleable = False
        #! self._event_triggers.append('free_unit') # триггеры, которые отрабатывает данный таск
# ============================================================
    def do_pre_action(self):
        return True
# ============================================================
    def try_do_action(self):
        _action_cell_name = ''
        _target_is_cell = False
        if 'col' not in self.item or 'row' not in self.item:
            _action_cell_name = self.item.get_action_cell_name()
        else:
            _target_is_cell = True
        if _action_cell_name == None: return False
        unit = self.unit
        success = unit.run_to_target(self.item, None, _action_cell_name)
        if not success:
            if self.item:
                trace('WalkEnemyTask::try_call_unit: run_to_target failed 1', unit.get('uid'), self.item, _action_cell_name)
            else:
                trace('WalkEnemyTask::try_call_unit: run_to_target failed 1', unit.get('uid'), _action_cell_name)
            return False
        self.apply_start_task(unit)
        #_subtask = self.item.get_subtask(self, unit)    #???
        #self.subtask = _subtask
        if not _target_is_cell:
            trace('WalkEnemyTask: started', unit.get('name'), self.item.get('name'))
        else:
            trace('WalkEnemyTask: started', unit.get('name'), self.item)
        return True
# ============================================================
    def _complete_task(self):
        self.is_complete = True
        trace('task "WalkEnemy" completed')
        if self.unit:
            self.unit.apply_stop_task()
            self.unit = None
        if self.item:
            #@! опасный код, объекта может уже не быть, а ссылка останется!!!
            #self.item.task = None
            self.item = None
# ============================================================
    #@override
    def on_subtask_started(self):
        EMgr.SendGlobalMsg('action_started')
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
    def cancel(self, force=False):
        '''Нужно вызывать при отмене задания'''
        pass
# ============================================================
    def on_callback(self, result, extra_dict):
        if self.subtask != None:
            self.subtask.on_callback(result, extra_dict)
# #######################################################
# #######################################################
# #######################################################
