# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import task_classes

# #######################################################
# #######################################################
class WoodCutterTask(task_classes.Task):
    def __init__(self, tree = None, unit = None, path = None):
        type = 'walk_woodcutter'
        task_classes.Task.__init__(self, type)
        self.ser_name = 'WoodCutterTask'
        self.priority = 1000
        self.tree = tree
        self.unit = unit
        if unit:
            unit.SetNextPath(path)
        #self.path = path
        self.is_event_task = False
        #self.is_event_task = True   # EVENT ONLY
        #self._event_triggers.append("free_unit") # триггеры, которые отрабатывает данный таск
# ============================================================
    def do_pre_action(self):
        if self.tree:
            self.tree.task = self
            self.tree.set_check(True)
        return True
# ============================================================
    def try_do_action(self):
        if not self.unit or not self.tree:
            #mbox(str(self.unit) + str(self.tree))   #@test
            return False
        #_action_cell_name = self.tree.get_action_cell_name()       # у дерева всеравно ее нет
        u = self.unit
        # u.show()    # нужно показать юнита перед началом действия
        _unit_unused = u.parent_home._internal_free_units.pop(0) #если заняли юнита делом, то удалим его из списка свободных
        u.start_work()      # 'run_by_path' его не вызывает, в отличии от 'run_to_target'
        u.run_by_path(self.tree)     # бежим к объекту по указанному пути
        _subtask = self.tree.get_subtask(self, u)
        self.apply_start_task(u, _subtask)
        trace("WoodCutterTask: started", u.get('name'))
        return True
# ============================================================
    def _complete_task(self):
        self.is_complete = True
        trace("task 'WoodCutterTask' completed")
        self.unit.apply_stop_task()
        _unit = self.unit
        self.unit = None
        #>>>> UMgr.add_free_unit(_unit)
        _unit.append_self_to_parent_home()
        self.tree.task = None
        self.tree = None
        #_unit.go_home() # отправим юнита домой
# ============================================================
    def target_reached(self, sender):
        '''Вызывается юнитом-строителем при достижении цели'''
        if self.subtask != None:
            self.subtask.start_action(self.tree)
        else:
            self.complete_task()
# ============================================================
    def on_update(self, ms):
        #if self.is_subtask_started:
        pass
# ============================================================
    def cancel(self, force=False):
        '''Нужно вызывать при отмене задания'''
        self.is_complete = True
        trace("task 'WoodCutterTask' canceled")
        if self.tree:
            self.tree.set_check(False)
            self.tree.task = None
        self.tree = None
        # нельзя напрямую отменять действие генерала, если сейчас данный таск не обрабатывается!
        if self.is_started:
            #self.unit.stop_walk()
            self.unit.apply_stop_task(False)
            _unit = self.unit
            _unit.parent_home._internal_free_units.remove(_unit)
            _unit.parent_home = None # чтобы юнит бежал в штаб/домик
            UMgr.add_free_unit(_unit)
            self.unit = None
            #_unit.append_self_to_parent_home()
# ============================================================
    def on_callback(self, result, extra_dict):
        if self.subtask != None:
            self.subtask.on_callback(result, extra_dict)
# ============================================================
    def process_removing_item(self, r_uid, r_mi):
        if self.unit:
            _item = self.unit.parent_home
            if _item:
                _uid = _item.get('uid')
                _mi = _item.get('locind')
                if _uid == r_uid and _mi == r_mi:
                    trace('_PRI_', _uid, _mi)
                    self.cancel()
# ============================================================
# #######################################################
# #######################################################
# #######################################################
