# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

class Tools(object):
# ============================================================
    def __init__(self):
        pass
# ============================================================
    def get_tip_position(item, tip_size, camera_pos, window_rect, rect_attr_name = 'notip_rect'):
        '''Возвращает координаты типса от левого-верхнего угла картинки типса'''
        rects = [ {'x':window_rect.x, 'y':window_rect.y + 80, 'w':window_rect.w, 'h':window_rect.h} ]
        #rects.append( {'x':0, 'y':87, 'w':1024, 'h':511} )

        pnt = {'x':0, 'y':0}
        nrect = item.GetAttrRect(rect_attr_name)
        pos = item.get('position')
        nrect.x += pos.x            # смещаем nrect по текущим координатам объекта
        nrect.y += pos.y
        nrect.x -= camera_pos.x     # переходит в С.К. экрана
        nrect.y -= camera_pos.y

        new_positions = []
        # невыровненное положение на экране:
        old_pos = {'x':nrect.x, 'y':nrect.y}
        old_pos.y -= tip_size.h
        old_pos.x += (nrect.w - tip_size.w)/2
        for wrect in rects:
            raw_rect = copy(nrect)
            pnt, bottom = Tools._calc_tip_pos_in_rect(raw_rect, tip_size, wrect)
            new_positions.append( [pnt, bottom] )
        # найдем наименьшее смещение типса:
        min_dist = 100000000
        min_pnt = pnt
        _is_bottom = False
        for pair in new_positions:
            np, bottom = pair
            dx = np.x - old_pos.x
            dy = np.y - old_pos.y
            dist = dx*dx + dy*dy
            if dist < min_dist:
                min_pnt = np
                min_dist = dist
                _is_bottom = bottom
        return min_pnt, _is_bottom
# ============================================================
    def _calc_tip_pos_in_rect(raw_rect, tip_size, window_rect):
        '''Вмещает типс в указанный прямоугольник экрана'''
        nrect = raw_rect
        pnt = {'x':0, 'y':0}
        _is_bottom = False

        nrect.x -= window_rect.x
        nrect.y -= window_rect.y
        diff_top = nrect.y
        if diff_top >= tip_size.h:  # если типс влазит сверху
            pnt.y = diff_top - tip_size.h
        else:
            pnt.y = nrect.y + nrect.h
            pnt.y = max(window_rect.y, pnt.y)
            _is_bottom = True
        pnt.x = nrect.x + (nrect.w - tip_size.w)/2  #  центрируем X-координатну относительно notip_rect
        if (pnt.x + tip_size.w) >= window_rect.w:   # если типс выходит за правую границу
            pnt.x = window_rect.w - tip_size.w
        elif pnt.x < 0:                             # если типс выходит за левую границу
            pnt.x = 0
        #if (pnt.y + tip_size.h) > window_rect.h:    # фиксим типс по нижней границе
        #    pnt.y = window_rect.h-tip_size.h
        pnt.y = min(window_rect.h-tip_size.h, pnt.y)   # фиксим типс по нижней границе
        pnt.x += window_rect.x
        pnt.y += window_rect.y
        return pnt, _is_bottom
# ============================================================
    def get_ui_tip_position(cur_pos, tip_size):
        '''Возвращает координаты типса от левого-верхнего угла картинки типса'''
        rects = []
        rects.append( {'x':88, 'y':44, 'w':847, 'h':610} )
        rects.append( {'x':20, 'y':87, 'w':954, 'h':511} )
        rects.append( {'x':568, 'y':443, 'w':456, 'h':208} )
        #rects.append( {'x':60, 'y':0, 'w':500, 'h':590} )

        pnt = {'x':0, 'y':0}
        #pos = cur_pos

        new_positions = []
        # невыровненное положение на экране:
        old_pos = {'x':cur_pos.x-tip_size.w/2, 'y':cur_pos.y-tip_size.h/2}
        nrect = {'x':old_pos.x, 'y':old_pos.y,
                'w':tip_size.w, 'h':tip_size.h}
        for wrect in rects:
            raw_rect = copy(nrect)
            new_positions.append(Tools._calc_ui_tip_pos_in_rect(raw_rect, wrect))
        # найдем наименьшее смещение типса:
        min_dist = 100000000
        min_pnt = pnt
        for np in new_positions:
            dx = np.x - old_pos.x
            dy = np.y - old_pos.y
            dist = dx*dx + dy*dy
            if dist < min_dist:
                min_pnt = np
                min_dist = dist
        return min_pnt
# ============================================================
    def _calc_ui_tip_pos_in_rect(tip_rect, window_rect):
        '''Вмещает типс в указанный прямоугольник экрана'''
        pnt = {'x':tip_rect.x, 'y':tip_rect.y}

        if tip_rect.x < window_rect.x: pnt.x = window_rect.x
        if tip_rect.y < window_rect.y: pnt.y = window_rect.y

        if tip_rect.x+tip_rect.w > window_rect.x+window_rect.w:
            pnt.x = window_rect.x + window_rect.w - tip_rect.w
        if tip_rect.y+tip_rect.h > window_rect.y+window_rect.h:
            pnt.y = window_rect.y + window_rect.h - tip_rect.h

        return pnt
# ============================================================
# ============================================================
    def get_ui_tip_position_r(cur_pos, tip_size, rects):
        '''Возвращает координаты типса от левого-верхнего угла картинки типса'''
        pnt = {"x":0, "y":0}
        #pos = cur_pos

        new_positions = []
        # невыровненное положение на экране:
        old_pos = {'x':cur_pos.x-tip_size.w/2, 'y':cur_pos.y-tip_size.h/2}
        nrect = {'x':old_pos.x, 'y':old_pos.y,
                'w':tip_size.w, 'h':tip_size.h}
        for wrect in rects:
            raw_rect = copy(nrect)
            new_positions.append(Tools._calc_ui_tip_pos_in_rect(raw_rect, wrect))
        # найдем наименьшее смещение типса:
        min_dist = 100000000
        min_pnt = pnt
        for np in new_positions:
            dx = np.x - old_pos.x
            dy = np.y - old_pos.y
            dist = dx*dx + dy*dy
            if dist < min_dist:
                min_pnt = np
                min_dist = dist
        return min_pnt
# ============================================================
    def get_popup_position(cur_pos, tip_size):
        '''Возвращает координаты типса от левого-верхнего угла картинки типса'''
        rects = []
        rects.append( {'x':88, 'y':44, 'w':847, 'h':610} )
        rects.append( {'x':20, 'y':87, 'w':954, 'h':511} )
        #rects.append( {'x':568, 'y':443, 'w':456, 'h':208} )

        pnt = {'x':0, 'y':0}
        #pos = cur_pos

        new_positions = []
        # невыровненное положение на экране:
        old_pos = {'x':cur_pos.x, 'y':cur_pos.y}
        nrect = {'x':old_pos.x, 'y':old_pos.y,
                'w':tip_size.w, 'h':tip_size.h}
        for wrect in rects:
            raw_rect = copy(nrect)
            new_positions.append(Tools._calc_ui_tip_pos_in_rect(raw_rect, wrect))
        # найдем наименьшее смещение типса:
        min_dist = 100000000
        min_pnt = pnt
        for np in new_positions:
            dx = np.x - old_pos.x
            dy = np.y - old_pos.y
            dist = dx*dx + dy*dy
            if dist < min_dist:
                min_pnt = np
                min_dist = dist
        return min_pnt
# ============================================================
# ============================================================
# ============================================================
