# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import smgr_bonus
import toolz

# ============================================================
class PanelItem(object):
    def __init__(self):
        self.ser_name = 'PanelItem'
        self.is_hidden = True
        self.is_hiding = False
        self.is_task_complete = False

    def started_hiding(self):
        self.is_hiding = True
# ============================================================
# ============================================================
class TipsZone(object):
    def __init__(self, _x = 0, _y = 0, _w = 0, _h = 0, _tips_x = 0, _tips_y = 0, _text = 0, widget_id = ''):
        self.ser_name = 'TipsZone'
        self.x = _x
        self.y = _y
        self.w = _w
        self.h = _h
        self.tips_x = _tips_x
        self.tips_y = _tips_y
        self.text = _text
        self.widget_id = widget_id
# ============================================================
# ============================================================
class GameUI(UI_class):
    res_names = ['res_food', 'res_boards', 'res_bricks', 'res_coins']
    binded_res_names = ['food', 'boards', 'bricks', 'coins']
    res_to_subres_widget_names = {'res_food':'res_subfood', 'res_boards':'res_wood',
                                    'res_bricks':'res_stones', 'res_coins':'res_ore'}
    subres_names = ['res_wood', 'res_stones', 'res_ore']    # + res_subfood
    binded_subres_names = ['_wood', '_granite', '_ore']
    tasks_names = ['task_1', 'task_2', 'task_3']
    units_names = ['unit_'+str(i) for i in range(1,8+1)]
    bonus_names = ['bonus_'+str(i) for i in range(1,3+1)]
    bonus_frames = {'runspeed':3, 'time':0, 'gen_double':1, 'restore_eff':2}
    bonus_tips = {'runspeed':'BONUS_RUN_TIPS', 'time':'BONUS_TIME_TIPS', 'gen_double':'BONUS_GEN_DOUBLE_TIPS', 'restore_eff':'BONUS_RESTORE_EFF_TIPS'}
    move_zones_order = ['workers_count', 'workers', 'food', 'boards', 'bricks',
                        'coins', 'gold1', 'gold2', 'chest', 'letter',
                        'general_params', 'general', 'shop', 'help',
                        'time', 'inventory1', 'inventory2', 'inventory4',
                        'task_3', 'task_2', 'task_1',
                        'unit_1','unit_2','unit_3','unit_4','unit_5','unit_6','unit_7','unit_8',
                        'bonus_1', 'bonus_2', 'bonus_3',
                        'bonus_time_1', 'bonus_time_2', 'bonus_time_3',
                        'competitor', ]
    move_zones = {
                    'workers': TipsZone(0, 0, 86, 86, 60, 80, '', 'workers_bar'),
                    'workers_count': TipsZone(27, 53, 35, 35, 60, 115, '', 'workers_bar'),

                    'food': TipsZone(274, 0, 112, 68, 331, 85, '', 'res_food'),
                    'boards': TipsZone(395, 0, 112, 68, 452, 85, '', 'res_boards'),
                    'bricks': TipsZone(516, 0, 112, 68, 573, 85, '', 'res_bricks'),
                    'coins': TipsZone(637, 0, 112, 68, 694, 85, '', 'res_coins'),

                    'gold1': TipsZone(832, 0, 192, 37, 898, 55, 'GTIPS_GOLD', 'gold_bar'),
                    'gold2': TipsZone(938, 32, 86, 56, 895, 55, 'GTIPS_GOLD', 'gold_bar'),
                    'chest': TipsZone(759, 0, 66, 40, 791, 55, 'GTIPS_CHEST', 'chest_bar'),
                    'letter': TipsZone(201, 0, 66, 40, 231, 55, 'GTIPS_LETTER', 'news_bar'),
                    'general_params': TipsZone(135, 662, 166, 106, 221, 649, 'GTIPS_GENERAL_PARAMS', 'general_bar'),
                    'general': TipsZone(0, 614, 137, 154, 62, 600, '', 'general_bar'),
                    'shop': TipsZone(303, 670, 42, 40, 324, 660, 'GTIPS_SHOP', 'general_bar'),
                    'help': TipsZone(352, 670, 42, 40, 373, 660, 'GTIPS_HELP', 'general_bar'),
                    'time': TipsZone(86, 0, 108, 35, 132, 55, 'GTIPS_TIME', 'time_bar'),
                    #'face': TipsZone(86, 0, 108, 35, 132, 55, '', 'face_bar'),
                    'competitor': TipsZone(0, 0, 512, 294, 0, 0, '', 'competitor_slide'),
                    'inventory1': TipsZone(446, 669, 106, 99, 500, 660, 'GTIPS_INVENTORY', 'inventory'),
                    'inventory2': TipsZone(426, 669, 146, 99, 500, 660, 'GTIPS_INVENTORY', 'inventory'),
                    'inventory4': TipsZone(426, 605, 146, 163, 500, 560, 'GTIPS_INVENTORY', 'inventory'),
                    'task_3': TipsZone(873, 656, 122, 112, 936, 650, '', 'task_3'),
                    'task_2': TipsZone(744, 656, 122, 112, 807, 650, '', 'task_2'),
                    'task_1': TipsZone(615, 656, 122, 112, 678, 650, '', 'task_1'),
                    'unit_1': TipsZone(967+5, 96+6, 55, 55, 925, 126, '', 'unit_1'),
                    'unit_2': TipsZone(967+5, 164+6, 55, 55, 925, 194, '', 'unit_2'),
                    'unit_3': TipsZone(967+5, 232+6, 55, 55, 925, 262, '', 'unit_3'),
                    'unit_4': TipsZone(967+5, 300+6, 55, 55, 925, 330, '', 'unit_4'),
                    'unit_5': TipsZone(967+5, 368+6, 55, 55, 925, 398, '', 'unit_5'),
                    'unit_6': TipsZone(967+5, 436+6, 55, 55, 925, 466, '', 'unit_6'),
                    'unit_7': TipsZone(967+5, 504+6, 55, 55, 925, 534, '', 'unit_7'),
                    'unit_8': TipsZone(967+5, 572+6, 55, 55, 925, 602, '', 'unit_8'),
                    'bonus_1': TipsZone(0, 95, 60, 60, 30, 185, '', 'bonus_1'),
                    'bonus_2': TipsZone(0, 265, 60, 60, 30, 355, '', 'bonus_2'),
                    'bonus_3': TipsZone(0, 435, 60, 60, 30, 525, '', 'bonus_3'),
                    'bonus_time_1': TipsZone(0, 154, 30, 94, 95, 204, '', 'bonus_1'),
                    'bonus_time_2': TipsZone(0, 324, 30, 94, 95, 374, '', 'bonus_2'),
                    'bonus_time_3': TipsZone(0, 494, 30, 94, 95, 544, '', 'bonus_3'),
                    }
    max_progress = {'0_0': 5,
                    '1_1': 1,   # zeroes not allowed
                    '1_2': 15,
                    '1_3': 17,
                    '1_4': 20,
                    '1_5': 22,  # last real value. Issue #533

                    '2_1': 20,
                    '2_2': 23,
                    '2_3': 22,
                    '2_4': 22,
                    '2_5': 18,
                    '2_6': 12,
                    }
# ============================================================
    def __init__(self, cdata):
        UI_class.__init__(self, cdata)
        self.ser_name = 'GameUI'
        self.is_first_call = False
        self.cur_lev_settings = None
        self.tasks_shown = [None, None, None]
        self.tasks_empty = [True, True, True]
        self.units = [None, None, None, None, None, None, None, None] # ссылки на самих юнитов (чьи лица отображены)
        self.unit_uids = ['', '', '', '', '', '', '', '']
        self.units_texts = ['', '', '', '', '', '', '', '']
        self.bonus_types = ['', '', '']
        self.bonus_tip_text = [None, None, None]
        self.tasks_tips_text = ['', '', '']
        self.widgets = {}
        self.ticks = 0
        self.last_zone = ''
        self.tips_text = []
        self.tips_x, self.tips_y = (0,0)
        self.tips_green = True
        self.buildings_res_counts = {}
        self.faces_noclick_time = 0     # сколько времени игрок не кликал по юнитам
        self.general_texts = []     # буфер туториальных текстов для отображения
        self.general_text_id_shown = ''    # text_id который сейчас на экране
        self.workers_texts = []
        self.workers_text_id_shown = ''
        self.chest_texts = []
        self.chest_text_id_shown = ''
        self.general_tip_shown = False
        self.workers_tip_shown = False
        self.chest_tip_shown = False
        self.units_names_units = {}     # здесь хранятся связки units_names и самих юнитов
        self.prev_time_info = {'time':0, 'level_time':0, 'norm_left_time':1.0}
        self.has_waiting_indian = False     # есть ли индеец, который готов дать квест
        self.has_waiting_survived = False     # есть ли выжившие, который готовы поговорить
        self.survived_task_complete = False
        self.main_tasks_complete = False
        self.territory_complete = False
        self.main_tasks_and_terr_complete = False
        self.has_waiting_precomplete = False
        self.on_create_complete = False
        self.enemy_face_shown = False
        self.was_tutorial_events = {}
        #self.disabled_zones = {}
        self.AddSelfToGlobal('UI')
# ============================================================
    def deserialize_init(self):
        '''Чтобы обновить аватарки спава'''
        self.units = [None, None, None, None, None, None, None, None] # ссылки на самих юнитов (чьи лица отображены)
        self.unit_uids = ['', '', '', '', '', '', '', '']
        self.units_texts = ['', '', '', '', '', '', '', '']
        self.init_listeners()
# ============================================================
    def Prepare_to_serialize(self):
        self.tips_text = []
        self.ShowTips([], 0, 0)
# ============================================================
    def on_msg(self, msg_type, msg_param1='', msg_param2='', msg_dict={}):
        if msg_type == 'on_zone':
            self.on_zone(msg_param1)
        elif msg_type == 'global_event':
            self.on_global_event(msg_param1, msg_param2)
        elif msg_type == 'state_machine':
            self.on_state_machine(msg_param1, msg_param2, msg_dict)
        elif msg_type == 'signal_msg':
            self.on_signal(msg_param1)
        elif msg_type == 'on_cloud_hidden':
            self.on_cloud_hidden(msg_param1)
        elif msg_type == 'on_button':
            self.on_button(msg_param1)
        elif msg_type == 'on_dlg_closed':
            self.on_dlg_closed(msg_param1)
        elif msg_type == 'on_create':
            self.on_create()
        elif msg_type == 'on_create_widgets':
            self.on_create_widgets()
        elif msg_type == 'escape_pressed':
            dlg.Open('GameMenu', 'dlg_gamemenu', {'single_mode':'1'})
        elif msg_type == 'tab_pressed':
            self.on_button('idBuildings')
        elif msg_type == 'show_enemy_face':
            self.enemy_face_shown = True
            UI.SetFaceBarInfo(self.widgets['enemy_bar'], msg_param1, msg_param2, True)
            UI.ShowSlide(self.widgets['enemy_bar'], True)
            UI.ForceGeneralView(True)
        elif msg_type == 'hide_enemy_face':
            self.enemy_face_shown = False
            UI.ShowSlide(self.widgets['enemy_bar'], False)
            UI.ForceGeneralView(False)
        #elif msg_type == 'tasks_refresh':
            #self.add_game_tasks(False)
# ============================================================
    _level_events = {'first_slide_inventory':0, 'first_slide':0, 'first_slide_letter':0,
                        'first_slide_task':0, 'general_params':0, 'first_slide_food':0,
                        'first_slide_boards':0, 'first_slide_bricks':0, 'first_slide_coins':0,
                        'show_build_button':0, 'first_slide_gold':0,
                        'first_slide_avatar':0, 'first_slide_timebar':0}
    def on_global_event(self, event_id, param):
        if event_id == 'task_info_change':
            self.refresh_tasks_info()
        #elif event_id == 'barbarian_attack':
        #    tools.PlaySound('SND_BARBARIAN_APPEAR')
        #    self.workers_texts = [] # обрубаем все сообщения
        #    self.HideTopText()
        #    self.show_top_text('BARBARIAN_ATTACK', param, True)
        elif event_id == 'unit_clicked':
            self.faces_noclick_time = 0
        elif event_id == 'all_tasks_complete':
            self.Signals.Restart('all_tasks_complete_signal', 600)
            #self.show_tut_text('CHEST_MSG_ALL_TASKS_COMPLETE')
        elif event_id in ['task_added', 'tasks_refresh']:
            self.add_game_tasks(event_id == 'task_added')
        elif event_id == 'bonus_start':
            _free_index = self.get_free_bonus_slot_index()
            self.bonus_types[_free_index] = param
            _frame = self.bonus_frames[param]
            w_id = self.bonus_names[_free_index]
            _timer_event_name = BMgr.bonus_mgr.prefix + param + '_timer'
            _time = BMgr.Signals.GetTimeLeft(_timer_event_name)
            _text_array = [('text', 'COLOR_LINES')]
            _text_array.append( ('text', self.bonus_tips[param]) )
            self.bonus_tip_text[_free_index] = _text_array
            self.SetBonusInfo(w_id, _frame, [], _timer_event_name)
            self.Slide(w_id, 200)
        elif event_id == 'bonus_stop':
            _index = self.get_bonus_slot_index(param)
            if _index >= 0:
                w_id = self.bonus_names[_index]
                self.bonus_types[_index] = ''
                self.bonus_tip_text[_index] = None
                self.SetBonusInfo(w_id, -1, [], '')
                self.SlideBack(w_id, 200)
        elif event_id == 'location_switched':
            self.on_location_switched(int(param))
        elif event_id == 'new_location_loading':
            self.on_new_location_loading(int(param))
        # --------
        episode, level = self.GetLevelIndex()
        if event_id == 'tutorial_msg':
            pass
        sub = BMgr.GetCurMapIndex()
        if event_id in self._level_events:  # если событие зависящее от уровня/подуровня (не забывать туда его добавлять)
            if episode == 1 and level == 1 and sub == 0:
                _save_id = event_id+param
                if event_id == 'first_slide_avatar':
                    _save_id = event_id
                if _save_id not in self.was_tutorial_events:    # защита от повторных сообщений
                    self.was_tutorial_events[_save_id] = 0
                    if event_id == 'first_slide_inventory':
                        self.show_help_text('LEVEL_TUT_INVENTORY', 482, 567, 0)
                    elif event_id == 'first_slide':
                        if param in ['task_1', 'task_2', 'task_3']:
                            #LBoard.AddXmlOverEffect('arrow_down', {'x':935, 'y':622})
                            #self.show_tut_text('LEVEL_TUT_FIRST_TASK')
                            x = 645
                            x = x + self.GetIphoneGapSize()
                            self.show_help_text('LEVEL_TUT_FIRST_TASK', x, 567, 1)
                    elif event_id == 'first_slide_letter':
                        x = 216
                        if self.IsIphone():
                            x = x - 4
                        self.show_help_text('LEVEL_TUT_LETTER', x, 28, 2)
                    elif event_id == 'first_slide_task':
                        pass
                    elif event_id == 'general_params':
                        x = 205
                        y = 567
                        if self.IsIphone() == True:
                            x = 186
                            y = 525
                        self.show_help_text('LEVEL_TUT_GENERAL_PARAMS', x, y, 0)
                        self.Signals.Add('SHOW_chest_help', 8000)
                    elif event_id == 'first_slide_food':
                        self.show_tut_text('LEVEL_TUT_RES_FOOD')
                    elif event_id == 'first_slide_boards':
                        self.show_tut_text('LEVEL_TUT_RES_BOARDS')
                    elif event_id == 'first_slide_bricks':
                        self.show_tut_text('LEVEL_TUT_RES_BRICKS')
                    elif event_id == 'first_slide_coins':
                        self.show_tut_text('LEVEL_TUT_RES_COINS')
                    elif event_id == 'show_build_button':
                        x = 306
                        y = 567
                        if self.IsIphone() == True:
                            x = x * 1.3
                            x -= self.GetIphoneGapSize()
                            x += 12
                            y = y - 20
                        self.show_help_text('LEVEL_TUT_SHOP', x, y, 0)
                    elif event_id == 'first_slide_avatar':
                        self.show_help_text('LEVEL_TUT_AVATAR', 706 + self.GetIphoneGapSize(), 167, 3)
            elif episode == 1 and level == 2 and sub == 0:
                if event_id not in self.was_tutorial_events:
                    self.was_tutorial_events[event_id] = 0
                    #if event_id == 'first_slide_gold':
                       #self.show_help_text('LEVEL_TUT_GOLD', 601, 28, 3)
                    if event_id == 'first_slide_timebar':
                        _mode = LBoard.GetUserInfo('game_mode')
                        if _mode != 'relax':
                            self.Signals.Add('SHOW_timebar_help', 8000)
# ============================================================
    def on_location_switched(self, subindex):
        self.cur_lev_settings = BMgr.GetLevelSettings(subindex)
        _s = self.cur_lev_settings
        if _s:
            if 'level_type' in _s:
                self.ShowWidget('idUnitsCountText', _s.level_type != 'underlevel')
            else:
                self.ShowWidget('idUnitsCountText', True)
# ============================================================
    def on_new_location_loading(self, subindex):
        #self.clusters[subindex] = LevelCluster()
        pass
# ============================================================
    def on_signal(self, signal):
        if signal == 'show_tips':
            #if self.tips_text:
            #    self.ShowTips(self.tips_text, self.tips_x, self.tips_y, self.tips_green)
            #else:
            #    self.ShowTips([], 0, 0)
            #self.Signals.Restart('show_tips', 300)
            pass
        elif signal == 'show_competitor':
            self.ShowCompetitorSlide(True)
            self.tips_text = []
            self.ShowTips([], 0, 0) # типсы убираем
        elif signal == 'general_cloud_signal':
            self.show_next_tip('general_cloud')
        elif signal == 'workers_cloud_signal':
            self.show_next_tip('workers_cloud')
        elif signal == 'hide_popup_menu':   # генерируется в C++, чтобы закрыть меню здания, если над ним нет курсора 3000ms
            self.HidePopup()
        elif signal == 'chest_cloud_signal':
            self.show_next_tip('chest_cloud')
        #elif signal in ['tut_task_1', 'tut_task_2', 'tut_task_3']:
        #    for _s in ['tut_task_1', 'tut_task_2', 'tut_task_3']:
        #        self.Signals.Cancel(_s) # сбросим все сигналы
        #    self.show_tut_text('TUT_HELP_05')
        elif signal == 'show_start_dlg':
            self.show_start_dlg(self.is_first_call)
        elif signal == 'remind_about_indians':
            self.show_tut_text('TUT_HELP_04')
            self.Signals.Restart('remind_about_indians', 60000)
        elif signal == 'remind_about_survived':
            self.show_chest_text('CHEST_MSG_SURVIVED_FOUND')
            self.Signals.Restart('remind_about_survived', 30000)
        elif signal == 'remind_about_precomplete':
            self.show_tut_text('TUT_HELP_05')
            self.Signals.Restart('remind_about_precomplete', 60000)
        elif signal == 'SHOW_timebar_help':
            self.show_help_text('LEVEL_TUT_TIME', 115 - self.GetIphoneGapSize(), 28, 2)
            self.Signals.Restart('show_competitor_help', 4000)
        elif signal == 'show_competitor_help':
            self.ShowCompetitorSlide(True)
            self.ShowTips([], 0, 0) # типсы убираем
            #@! как-то нужно панельку на 5 секунд... И чтобы она не уехала...
            self.Signals.Restart( 'hide_competitor_help', 5000 )    # через 5 секунд спрячем
        elif signal == 'hide_competitor_help':
            self.ShowCompetitorSlide(False)
        elif signal == 'SHOW_chest_help':
            x = 500
            if self.IsIphone():
                x = x + 4
            self.show_help_text('LEVEL_TUT_CHEST', x, 28, 3)
        elif signal == 'all_tasks_complete_signal':
            self.show_tut_text('CHEST_MSG_ALL_TASKS_COMPLETE')
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == "enter":
            pass
        elif type == "exit":
            pass
        elif type == "change":
            self.on_state_change(additional.prev_state, additional.next_state)
        pass
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def init_listeners(self):
        EMgr.add_concrete_event_listener('need_barbarian_text', self.on_need_barbarian_text)
        EMgr.add_concrete_event_listener('need_raptor_text', self.on_need_raptor_text)
# ============================================================
    def on_create(self):
        self.init_listeners()
        self.create_widgets()
        self.cur_lev_settings = BMgr.GetLevelSettings(0)
        self.Signals.Restart('show_tips', 300)
        _s = self.cur_lev_settings
        if _s:
            if 'level_type' in _s:
                self.ShowWidget('idUnitsCountText', _s.level_type != 'underlevel')
            else:
                self.ShowWidget('idUnitsCountText', True)
        episode, level = self.GetLocationInfo()
        if episode == 1 and level == 1:
            if not LBoard.GetUserSetting('help_button_clicked'):
                self.StartBlinkingHelp()
        for key in self.move_zones_order:
            if episode == 2 and level == 6:
                if key == 'competitor':
                    continue    # skipping competition bar on last level
            mz = self.move_zones[key]
            self.AddMoveZone(key, mz.x, mz.y, mz.w, mz.h)
        #self.set_competitor_half(True)
        self.on_create_complete = True
        #if LBoard.Core.episode > 1 or LBoard.Core.level != 1:
        #if LBoard.Core.subindex == 0:   # на подгружаемых не выводим
        #    self.Signals.Add('show_start_dlg', 20)
# ============================================================
    def on_create_widgets(self):
        self.create_widgets(True)
# ============================================================
    def set_face_bar_info(self, img_and_frame, uid = '__skip__'):
        UI.SetFaceBarInfo(self.widgets['face_bar'], img_and_frame, uid)
# ============================================================
    def show_face_bar(self, show):
        UI.ShowSlide(self.widgets['face_bar'], show)
# ============================================================
    def show_start_dlg(self, is_first_call):
        if not LBoard: return
        if 'Core' not in LBoard: return  # это хак, работает для подуровней - им всеравно диалог показывать не нужно
        _cur_map_index = BMgr.GetCurMapIndex()
        if _cur_map_index == 0 or is_first_call:   # на подгружаемых не выводим
            if self.on_create_complete:             # уже все инициализировали?
                dlg.Open('StartMenu', 'dlg_start')  # тогда покажем стартовый диалог
            else:
                self.is_first_call = is_first_call
                self.Signals.Add('show_start_dlg', 20)  # подождем еще немного
# ============================================================
    def on_cloud_hidden(self, cloud_id):
        if cloud_id == 'general_cloud':
            self.general_tip_shown = False
            self.Signals.Restart('general_cloud_signal', 1000)
        elif cloud_id == 'workers_cloud':
            self.workers_tip_shown = False
            self.Signals.Restart('workers_cloud_signal', 1000)
        elif cloud_id == 'chest_cloud':
            self.chest_tip_shown = False
            self.Signals.Restart('chest_cloud_signal', 1000)
# ============================================================
    def show_next_tip(self, cloud_id):
        '''Показывает следующий типс, если таковой имеется и его можно показать'''
        if cloud_id == 'general_cloud':
            if not self.general_tip_shown:
                if self.general_texts:
                    _info = self.general_texts.pop(0)
                    self.show_tut_text_raw(_info.text, _info.uid, _info.is_important, _info.extra)
        elif cloud_id == 'workers_cloud':
            if not self.workers_tip_shown:
                if self.workers_texts:
                    _info = self.workers_texts.pop(0)
                    self.show_top_text_raw(_info.text, _info.uid, _info.is_important)
        elif cloud_id == 'chest_cloud':
            if not self.chest_tip_shown:
                if self.chest_texts:
                    _info = self.chest_texts.pop(0)
                    self.show_chest_text_raw(_info.text, _info.uid, _info.is_important)
# ============================================================
    def on_zone(self, zone_name):
        #if zone_name in self.disabled_zones:
        #    if self.disabled_zones[zone_name]:
        #        return
        prev_zone = self.last_zone
        self.last_zone = zone_name
        if prev_zone in ['inventory1', 'inventory2', 'inventory4']:
            if UStats.Inventory.GetQuestItemsCount() > 2:
                if zone_name not in ['inventory1', 'inventory2', 'inventory4']:
                    self.ShowInventoryExtra(False)
            elif zone_name not in ['inventory1', 'inventory2']:
                self.ShowInventoryExtra(False)
        if not zone_name:
            if prev_zone != zone_name:
                self.tips_text = []
                self.Signals.Cancel('show_competitor')
                self.ShowCompetitorSlide(False)
                self.ShowTips([], 0, 0)
                #self.ShowInventoryExtra(False)
        elif zone_name in self.move_zones:
            episode, level = self.GetLevelIndex()
            if zone_name == 'competitor':
                if episode == 1:
                    if level == 2:
                        self.Signals.Cancel( 'hide_competitor_help' )
#                elif episode == 2:
#                    if level == 6:
#                        self.tips_text = []
#                        self.ShowTips([], 0, 0)
#                        self.Signals.Cancel('show_competitor')
#                        self.ShowCompetitorSlide(False)
#                        return
            mz = self.move_zones[zone_name]
            _is_hidden = self.IsTotalHidden(mz.widget_id)
            if _is_hidden:
                self.tips_text = []
                self.Signals.Cancel('show_competitor')
                self.ShowTips([], 0, 0)
                return
            _is_workers_cloud_shown = self.IsWorkersCloudShown()
            if _is_workers_cloud_shown:
                if zone_name in ['workers', 'workers_count', 'competitor']:
                    self.tips_text = []
                    self.ShowTips([], 0, 0)
                    self.Signals.Cancel('show_competitor')
                    self.ShowCompetitorSlide(False)
                    return
            _is_general_cloud_shown = self.IsGeneralCloudShown()
            if _is_general_cloud_shown:
                if zone_name in ['shop', 'general', 'general_params', 'help', 'enemy']:
                    self.tips_text = []
                    self.ShowTips([], 0, 0)
                    return

# пока не знаю как и что тут делать
            _is_barbarian_face_shown = False
            if _is_barbarian_face_shown:
                if zone_name in ['workers', 'workers_count', 'competitor']:
                    self.tips_text = []
                    self.ShowTips([], 0, 0)
                    return

            if zone_name == 'shop': # затычка для магазина
                _is_shop_visible = self.IsWidgetVisible('idBuildings')
                if not _is_shop_visible:
                    self.tips_text = []
                    self.ShowTips([], 0, 0)
                    return
            self.tips_text, self.tips_green = self.get_tips_text(zone_name, mz)
            self.tips_x, self.tips_y = (mz.tips_x, mz.tips_y)
            if zone_name in ['food','boards','bricks','coins']:
                _is_hidden = self.IsTotalHidden(self.res_to_subres_widget_names[mz.widget_id])
                if _is_hidden:
                    self.tips_y -= 30   # всеравно не поможет...
            if zone_name == 'inventory1':
                _items_count = UStats.Inventory.GetQuestItemsCount()
                self.tips_x, self.tips_y = self.get_inventory_tips_pos(_items_count)
                if _items_count == 0: self.ShowTips([], 0, 0)
                elif _items_count > 2: self.ShowInventoryExtra(True)
                return
            if zone_name == 'inventory2':
                _items_count = UStats.Inventory.GetQuestItemsCount()
                self.tips_x, self.tips_y = self.get_inventory_tips_pos(_items_count)
                if _items_count > 2: self.ShowInventoryExtra(True)
                elif _items_count < 2: self.ShowTips([], 0, 0)
                return
            elif zone_name == 'inventory4':
                _items_count = UStats.Inventory.GetQuestItemsCount()
                self.tips_x, self.tips_y = self.get_inventory_tips_pos(_items_count)
                if self.IsInventoryExtraShown():
                    if _items_count > 2: return
                self.tips_text = []
                self.ShowTips([], 0, 0)
                return
            if zone_name == 'time':
                if episode == 2 and level == 6:
                    return
                else:
                    _has = self.Signals.Has('show_competitor')
                    if not _has:
                        self.Signals.Restart('show_competitor', 20)
            else:
                self.Signals.Cancel('show_competitor')
                #self.ShowCompetitorSlide(True)
            if prev_zone == zone_name:
                if zone_name != 'competitor':
                    return  # чтобы не накосячить с панелью соревнований
            self.ShowTips([], 0, 0) # убрать старый типс
            #self.ShowTips(text, mz.tips_x, mz.tips_y)
# ============================================================
    def get_inventory_tips_pos(self, _items_count):
        if _items_count == 0:
            self.tips_text = []
            return self.tips_x,self.tips_y
        if _items_count <= 2:
            return 500,660
        elif _items_count > 2:
            return 500,560
# ============================================================
    def get_tips_text(self, zone_name, zone):
        tips_is_green = True
        map_index = UMgr.GetCurMapIndex()
        result = []
        _text_len = len(zone.text)
        if _text_len > 0:
            result.append(['text', 'COLOR_HEADER'])
            result.append(['text', zone.text])
        else:
            if zone_name == 'task_1':
                result = self.tasks_tips_text[0]
            elif zone_name == 'task_2':
                result = self.tasks_tips_text[1]
            elif zone_name == 'task_3':
                result = self.tasks_tips_text[2]
            elif zone_name in self.units_names:
                index = 0
                for u in self.units_names:
                    if u == zone_name:      # zone_name и units_names должны совпадать!
                        result = self.units_texts[index]
                        _unit = self.units[index]
                        if _unit:
                            _under_text_list, _is_green = _unit.get_ui_subtext()
                            _under_text = '#newline#' + tools.ListToStr(_under_text_list)
                            result = result + _under_text
                            tips_is_green = _is_green
                    index += 1
            elif zone_name in ['food','boards','bricks','coins']:
                result = self.gen_tips_res_text(zone_name)
            elif zone_name == 'workers':
                _s = self.cur_lev_settings
                if 'level_type' in _s:
                    if _s.level_type == 'underlevel':
                        result.append(['text', 'COLOR_HEADER'])
                        result.append(['text', 'NO_WORKERS_INFO'])
                        return result, tips_is_green
                _is_critical = UMgr.Is_units_count_critical(UMgr.GetCurMapIndex())
                _available_count = UMgr.get_free_real_units_count(map_index)
                if not _is_critical:
                    _free_count = UMgr.get_units_at_home_count(map_index)
                    result.append(['text', 'COLOR_HEADER'])
                    result.append(['text', 'WORKERS_FREE'])
                    result.append('space')
                    result.append(['digit', _free_count])
                    result.append('space')
                    result.append(['text', 'WORKERS_FREE_FROM'])
                    result.append('space')
                    result.append(['digit', _available_count])
                    result.extend(['newline','newline'])
                    result.append(['text', 'WORKERS_TEXT_1'])
                else:
                    tips_is_green = False
                    result.append(['text', 'COLOR_RED2'])
                    if _available_count > 1:
                        result.append(['text', 'WORKERS_TEXT_2'])
                    else:
                        result.append(['text', 'WORKERS_TEXT_3'])
            elif zone_name == 'workers_count':
                _s = self.cur_lev_settings
                if 'level_type' in _s:
                    if _s.level_type == 'underlevel':
                        result.append(['text', 'COLOR_HEADER'])
                        result.append(['text', 'NO_WORKERS_INFO'])
                        return result, tips_is_green
                _is_critical = UMgr.Is_units_count_critical(UMgr.GetCurMapIndex())
                _text = 'WORKERS_COUNT_TEXT_1'
                if not _is_critical:
                    result.append(['text', 'COLOR_HEADER'])
                else:
                    tips_is_green = False
                    result.append(['text', 'COLOR_RED2'])
                    _available_count = UMgr.get_free_real_units_count(map_index)
                    _text = ('WORKERS_COUNT_TEXT_2','WORKERS_COUNT_TEXT_3')[_available_count <= 1]
                result.append(['text', _text ])
            elif zone_name == 'general':
                tips_is_green = True
                result = [('text', 'COLOR_HEADER')]
                result.append( ('text', ['COMPETITOR_ENEMY_NAME','GTIPS_GENERAL'][self.enemy_face_shown == False]) )
            elif zone_name in ['bonus_time_1', 'bonus_time_2', 'bonus_time_3']:
                _index = int(zone_name[-1])-1
                _timer_event_name = BMgr.bonus_mgr.prefix + self.bonus_types[_index] + '_timer'
                _time = int(BMgr.Signals.GetTimeLeft(_timer_event_name)/1000)
                if _time <= 0:
                    pass
                else:
                    result.append( ('text', 'COLOR_LINES') )
                    result.append( ('text', 'TIME_LASTS') )
                    result.append( ('newline') )
                    result.append( ('digit', _time) )
                    result.append( ('text', 'TIME_SECOND') )
            elif zone_name in self.bonus_names:
                _index = int(zone_name[-1])-1
                _tip_text = self.bonus_tip_text[_index]
                if _tip_text:
                    result.append( ('text', 'COLOR_LINES') )
                    result.extend( _tip_text )
        return result, tips_is_green
# ============================================================
    res_images = {'food':'IMG_I_TIP_FOOD',
                'boards':'IMG_I_TIP_BOARDS',
                'bricks':'IMG_I_TIP_BRICKS',
                'coins':'IMG_I_TIP_COINS',
                '_wood':'IMG_I_TIP_WOOD',
                '_fish':'IMG_I_TIP_FISH',
                '_flour':'IMG_I_TIP_BAG',
                '_ore':'IMG_I_TIP_ORE',
                '_stones':'IMG_I_TIP_STONE',
                '_granite':'IMG_I_TIP_STONE',
                }
# ============================================================
    def gen_tips_res_text(self, res_name):
        '''Генерирует типс для ресурса'''
        result = []
        _res = UStats.GetCurRes()
        _img_res = self.res_images[res_name]
        _count = 0
        result.insert( 0, ('text', 'COLOR_HEADER') )
        _has_res = False
        if res_name == 'food':
            _has_res = self.get_res_imgcount(_res, res_name, ['_fish', '_flour'], ['smokery','bakery'], result)
        elif res_name == 'boards':
            _has_res = self.get_res_imgcount(_res, res_name, '_wood', 'sawmill', result)
        elif res_name == 'bricks':
            _has_res = self.get_res_imgcount(_res, res_name, '_granite', 'stonecutter', result)
        elif res_name == 'coins':
            _has_res = self.get_res_imgcount(_res, res_name, '_ore', 'mint', result)
        if not _has_res:
            return [('text', 'COLOR_HEADER'), ('text', 'TIPS_RES')]
        return result
# ============================================================
    def get_res_imgcount(self, _res, main_res_name, res_name, stype, result, need_space = False):
        '''Генерирует картинку и кол-во ресурса'''
        preresult = []
        if istype(res_name, 'list'):
            _need_space = False
            _count = 0
            _counts = []
            for _res_name in res_name:
                if _need_space: preresult.append('space')
                _precount = _res.Get(_res_name)
                _counts.append(_precount)
                if _precount > 0:
                    preresult.append( ('digit', _precount) )
                    preresult.append( ('image', self.res_images[_res_name]) )
                    _count += _precount
                    _need_space = True
            _gen_count = 0
            if _count == 0:
                return False
            index = 0
            for _stype in stype:
                if _stype in self.buildings_res_counts:
                    _cur_precount = _counts[index]
                    _gen_count += _cur_precount * self.buildings_res_counts[_stype]
                index += 1
            if _gen_count > 0:
                preresult.append( ('image', 'IMG_I_TIP_ARROW') )
                preresult.append( ('text', 'PLUS') )
                preresult.append( ('digit', _gen_count) )
                preresult.append( ('image', self.res_images[main_res_name]) )
            if _gen_count > 0:
                result.extend(preresult)
            else:
                result.extend( [('text', 'COLOR_HEADER'), ('text', 'TIPS_NO_MANUFACTURE')] )
            return True
        else:
            _count = _res.Get(res_name)
            if need_space: preresult.append('space')
            _gen_count = -1
            if _count == 0:
                return False
            else:
                preresult.append( ('digit', _count) )
                preresult.append( ('image', self.res_images[res_name]) )
            if stype in self.buildings_res_counts:
                _gen_count = _count * self.buildings_res_counts[stype]
                if _gen_count:
                    preresult.append( ('image', 'IMG_I_TIP_ARROW') )
                    preresult.append( ('text', 'PLUS') )
                    preresult.append( ('digit', _gen_count) )
                    preresult.append( ('image', self.res_images[main_res_name]) )
            if _gen_count > 0:
                result.extend(preresult)
            else:
                result.extend( [('text', 'COLOR_HEADER'), ('text', 'TIPS_NO_MANUFACTURE')] )
            return True
# ============================================================
    def _get_building_resgen_count(self, bname):
        '''Возвращает коэффициент для указанного типа зданий'''
        if bname in self.buildings_res_counts:
            return self.buildings_res_counts[bname]
        else:
            return -1
# ============================================================
    def Get_tip_position(self, cur_pos, tip_size):
        '''Возвращает координаты типса от левого-верхнего угла картинки типса'''
        rects = []
        rects.append( {'x':88, 'y':78, 'w':847, 'h':576} )
        if self.last_zone in self.bonus_names or self.last_zone in ['bonus_time_1', 'bonus_time_2', 'bonus_time_3']:
            rects.append( {'x':30, 'y':87, 'w':500, 'h':590} )
        if self.last_zone in self.units_names:
            rects.append( {'x':60, 'y':87, 'w':895, 'h':550} )  # w:954
        if self.last_zone in self.tasks_names:
            rects.append( {'x':568, 'y':443, 'w':456, 'h':208} )
        return toolz.Tools.get_ui_tip_position_r(cur_pos, tip_size, rects)
# ============================================================
# ============================================================
    def on_need_barbarian_text(self, event):
        tools.PlaySound('SND_BARBARIAN_APPEAR')
        self.workers_texts = [] # обрубаем все сообщения
        self.HideTopText()
        self.show_top_text('BARBARIAN_ATTACK', event.obj.get('uid'), True)
# ============================================================
    def on_need_raptor_text(self, event):
        tools.PlaySound('SND_BARBARIAN_APPEAR')
        self.workers_texts = [] # обрубаем все сообщения
        self.HideTopText()
        self.show_top_text('DINO_ATTACK', event.obj.get('uid'), True)
# ============================================================
# ============================================================
    def create_widgets(self, is_deserialization = False):
        '''Инициализация виджетов интерфейса'''
        slide_time = 200

        i = 0
        for id in self.tasks_names:
            w = self.GetWidget(id)
            height = self.GetHeight(w)
            if not is_deserialization:
                self.InitSlide(w, 611 + i*129, 768-height, "up", slide_time, "quart", "out")
            #self.Slide(w, slide_time, "quart", "out")
            i += 1
            self.widgets[id] = w

        i = 0
        for id in self.units_names:
            w = self.GetWidget(id)
            width = self.GetWidth(w)
            if not is_deserialization:
                self.InitSlide(w, 1024 - width, 92 + i*68, 'left', 200, 'quart', 'out')
            #self.Slide(w, slide_time, "quart", "out")
            i += 1
            self.widgets[id] = w

        i = 0
        for id in self.bonus_names:
            w = self.GetWidget(id)
            width = self.GetWidth(w)
            if not is_deserialization:
                self.InitSlide(w, 0, 92 + i*170, 'right', 200, 'quart', 'out')
            #self.Slide(w, slide_time, "quart", "out")
            i += 1
            self.widgets[id] = w

        w = self.GetWidget('gold_bar')
        self.BindResName(w, 'gold')
        self.widgets['gold_bar'] = w
        width = self.GetWidth(w)
        if not is_deserialization:
            self.InitSlide(w, 1024-width, 0, 'down', slide_time, 'quart', 'out')
        #self.Slide(w, slide_time, "quart", "out")

        w = self.GetWidget('workers_bar')
        self.widgets['workers_bar'] = w
        if not is_deserialization:
            self.InitSlide(w, 0, 0, 'down', slide_time, 'quart', 'out')
        #self.Slide(w, slide_time, "quart", "out")

        w = self.GetWidget('face_bar')
        self.widgets['face_bar'] = w
        if not is_deserialization:
            self.InitSlide(w, -self.GetIphoneGapSize(), 0, 'down', slide_time, 'quart', 'out')

        w = self.GetWidget('time_bar')
        self.widgets['time_bar'] = w
        if not is_deserialization:
            self.InitSlide(w, 44, 0, 'down', slide_time, 'quart', 'out')

        w = self.GetWidget('news_bar')
        self.widgets['news_bar'] = w
        if not is_deserialization:
            self.InitSlide(w, 196, 0, 'down', slide_time, 'quart', 'out')
        #self.Slide(w, slide_time, "quart", "out")   #@ ###

        w = self.GetWidget('chest_bar')
        self.widgets['chest_bar'] = w
        if not is_deserialization:
            self.InitSlide(w, 753, 0, 'down', slide_time, 'quart', 'out')
        #self.Slide(w, slide_time, "quart", "out")

        w = self.GetWidget('inventory')
        self.widgets['inventory'] = w
        height = self.GetHeight(w)
        if not is_deserialization:
            self.InitSlide(w, 426, 768-height, "up", slide_time, "quart", "out")
        #self.Slide(w, slide_time, "quart", "out")

        w = self.GetWidget('general_bar')
        self.widgets['general_bar'] = w
        height = self.GetHeight(w)
        if not is_deserialization:
            self.InitSlide(w, 0, 768-height, 'up', slide_time, 'quart', 'out')
        #self.Slide(w, slide_time, "quart", "out")

        w = self.GetWidget('enemy_bar')
        self.widgets['enemy_bar'] = w
        UI.SetFaceBarInfo(self.widgets['enemy_bar'], 'IMG_I_COMPETITOR_PORT', '-1')
        height = self.GetHeight(w)
        if not is_deserialization:
            self.InitSlide(w, -self.GetIphoneGapSize(), 768-height, 'up', slide_time, 'quart', 'out')

        i = 0
        for id in self.subres_names:
            w = self.GetWidget(id)
            self.BindSubResName(w, self.binded_subres_names[i])
            if not is_deserialization:
                self.InitSlide(w, 390 + i*121, 0, 'down', slide_time, 'quart', 'out')
            #self.Slide(w, slide_time, "quart", "out")
            i += 1
            self.widgets[id] = w

        i = 0
        for id in self.res_names:
            w = self.GetWidget(id)
            self.BindResName(w, self.binded_res_names[i])
            if not is_deserialization:
                self.InitSlide(w, 269 + i*121, 0, 'down', slide_time, 'quart', 'out')
            #self.Slide(w, slide_time, "quart", "out")
            i += 1
            self.widgets[id] = w

        w = self.GetWidget('res_subfood')
        if not is_deserialization:
            self.InitSlide(w, 269, 0, 'down', slide_time, 'quart', 'out')
        self.widgets['res_subfood'] = w

        w = self.GetWidget('competitor_slide')
        self.widgets['competitor_slide'] = w
        if not is_deserialization:
            self.InitSlide(w, 0, 0, 'down', slide_time, 'quart', 'out')

        self.show()

# ============================================================
    def hide(self):
        for w in self.widgets:
            #self.SetSlideHidden(w, True)
            self.SlideBackH(w, 0)
# ============================================================
    def show(self):
        for w in self.widgets:
            self.SlideH(w, 200)
            self.Slide(w, 200)
            #self.SetSlideHidden(w, False)  # в C++ само разблокируется
# ============================================================
    helpdlg_names = {   0: 'HelpMenu',
                        1: 'HelpMenu_0',
                        2: 'HelpMenu_1',
                        3: 'HelpMenu_2',
                        4: 'HelpMenu_3',
                        5: 'HelpMenu_4',
                        6: 'HelpMenu_5',
                        7: 'HelpMenu_6',
                        8: 'HelpMenu_7',
                        9: 'HelpMenu_8',
                        10: 'HelpMenu_9',
                        11: 'HelpMenu_10',
                        12: 'HelpMenu_11',
                        13: 'HelpMenu_12',
                        14: 'HelpMenu_13',
                        15: 'HelpMenu_14',
                        16: 'HelpMenu_15',
                        17: 'HelpMenu_16',
                        18: 'HelpMenu_17',
                        19: 'HelpMenu_18',
                        20:'HelpMenu_19' }
    def on_button(self, id):
        if id == 'idMenu':
            self.HideTips()
            dlg.Open('GameMenu', 'dlg_gamemenu', {'single_mode':'1'})
        elif id == 'idBuildings':
            for id in self.res_names:
                w = self.GetWidget(id)
                self.EnableResUpdates(w, False)
            w = self.GetWidget('gold_bar')
            self.EnableResUpdates(w, False)
            self.HideTips()
            dlg.Open('BuildingsMenu', 'dlg_buildings')
            #_params = {}
            #_params['imageid'] = 'AVATAR_INDIAN_10'
            #_params['res_give'] = 'wood'
            #_params['res_give_count'] = str(37)
            #_params['res_receive'] = 'boat'
            #_params['res_receive_count'] = str(1)
            #dlg.Open('TradeMenu', 'dlg_trade', _params)
        elif id == 'idLetter':
            self.HideTips()
            dlg.Open('LetterMenu', 'dlg_letter')
        elif id == 'idHelp':
            self.open_help()
        elif id == 'idChest':
            self.HideTips()
            dlg.Open('ChestMenu', 'dlg_chest')
# ============================================================
    def open_help(self, help_number = -1):  # second fix
        if help_number > 0:
            #help_shown = LBoard.GetUserSetting('help_shown')
            #LBoard.SetUserSetting('help_shown', help_shown+1)
            LBoard.SetUserSetting('help_shown', help_number)    # second fix
        self.HideTips()
        _help_shown = LBoard.GetUserSetting('help_shown')
        #_name = self.helpdlg_names[_help_shown] # чтобы запустить "последний" доступный экран хелпа
        trace('UI.open_help:', help_number, _help_shown)
        if _help_shown == 0:
            dlg.Open('HelpMenu', 'dlg_help', {'single_mode':'1', 'help_number':str(0)})
        else:
            dlg.Open('HelpMenu_X', 'dlg_help', {'single_mode':'1', 'help_number':str(_help_shown)})
# ============================================================
    def on_dlg_closed(self, name):
        if name == 'dlg_buildings':
            for id in self.res_names:
                w = self.GetWidget(id)
                self.EnableResUpdates(w, True)
            w = self.GetWidget('gold_bar')
            self.EnableResUpdates(w, True)
# ============================================================
    def on_update(self, ms):
        #self.hide_completed_tasks()
        self.remove_completed_tasks()
        self.ticks += 1
        if not (self.ticks%50): #! раз в секунду (25)
            self.update_progress()
        if not (self.ticks%26): # раз в полсекунды
            self.update_unit_faces()
        if not (self.ticks%27): # примерно раз в полсекунды
            self._get_other_levels_info()
        #if not (self.ticks%21):
        #    self.check_main_tasks()
        self.faces_noclick_time += ms
        if self.faces_noclick_time >= 10000:
            self.blink_faces()
            self.faces_noclick_time = 0
# ============================================================
    def _get_other_levels_info(self):
        '''Обновляем данные для типсов базовых ресурсов'''
        self.buildings_res_counts = {}  # почистим
        generating_dict = TMgr.get_ui_tips_data()
        for name in generating_dict:
            count = generating_dict[name]
            if count > 0:
                if name in self.buildings_res_counts:
                    k = self.buildings_res_counts[name]
                    if k < 0:
                        self.buildings_res_counts[name] = count
                    elif count < k:
                        self.buildings_res_counts[name] = count
                else:
                    self.buildings_res_counts[name] = count
# ============================================================
    def calc_cur_progress(self):
        episode, level = self.GetLevelIndex()
        _val = UStats.GetLevelValue('progress')
        _index = str(episode) + '_' + str(level)
        _max = self.max_progress[_index]
        _progress = _val / _max
        if _progress < 0: _progress = 0
        if _progress > 1: _progress = 1
        return _progress
# ============================================================
    def check_main_tasks(self):
        '''Проверяет - не выполнились ли основные задачи игры'''
        _is_main_level = LBoard.Core.is_main_level()
        if _is_main_level:
            # проверка выполнения задания на открытие территории:
            if not self.territory_complete:
                _is_territory_complete = UStats.GetLevelValue('territory_complete') > 0
                if not _is_territory_complete:  # территории проверяем независимо от подуровня
                    _territory = UStats.GetLevelValue('territory')
                    _need_territory = int(LBoard.Core.get_setting('total_territory'))
                    if _need_territory > 0:
                        if _territory >= _need_territory:
                            self.territory_complete = True
                            TMgr.SendGlobalMsg('territory_completed')
                            UStats.AddLevelValue('territory_complete', 1)
                            tools.PlaySound('SND_TARGET_COMPLETE')
                            dlg.Open('ChestMenu', 'dlg_chest', {'showin_effect':'chest_fly_in', 'task':'TERRITORY', 'single_mode':'1'})
            if not self.main_tasks_complete:
                #_progress = UStats.GetLevelValue('progress')
                _survived = UStats.GetLevelValue('survived')
                _gold_complete = UStats.GetLevelValue('gold_ship_complete')
                _need_gold = int(LBoard.Core.get_setting('need_gold'))
                if _need_gold == 0: _gold_complete = True   # если золота не нужно - значит задания нет
                # получить список заданий и кол-ва
                #_index = str(LBoard.Core.episode) + '_' + str(LBoard.Core.level)
                #_max = self.max_progress[_index]
                #_need_progress = _max
                _need_survived = int(LBoard.Core.get_setting('total_survived'))
                if _need_survived > 0:
                    if not self.survived_task_complete:
                        if _need_survived <= _survived:
                            tools.PlaySound('SND_TARGET_COMPLETE')
                            self.survived_task_complete = True
                            UStats.AddLevelValue('survived_complete', 1)
                            TMgr.SendGlobalMsg('survived_saved')
                            dlg.Open('ChestMenu', 'dlg_chest', {'showin_effect':'chest_fly_in', 'task':'SURVIVED', 'single_mode':'1'})
                # проверять что уже выполнилось, если все выполнилось - выставить флаг
                #if _need_progress <= _progress:
                if _gold_complete:
                    if _need_survived <= _survived:
                        #if self.territory_complete:
                            UStats.AddLevelValue('main_tasks_complete', 1)  # все главные задачи выполнены
                            EMgr.SendGlobalMsg('main_tasks_complete')
                            self.main_tasks_complete = True
            if not self.main_tasks_and_terr_complete:
                if self.main_tasks_complete:
                    if self.territory_complete:
                        self.main_tasks_and_terr_complete = True
                        #self.Signals.Restart('all_tasks_complete', 500)
                        EMgr.SendGlobalMsg('all_tasks_complete')
# ============================================================
    def update_progress(self):
        '''Показ типсов, указывающих на прошедшее игровое время'''
        episode, level = self.GetLevelIndex()
        _progress = self.calc_cur_progress()
        self.SetOurProgress(_progress)
        _mode = LBoard.GetUserInfo('game_mode')
        if _mode != 'relax':
            if episode > 1 or level > 1:    # на первом уровне нет времени
                _time_info = UStats.GetTimeInfo()
                _time = _time_info.norm_left_time
                _prev_time = self.prev_time_info.norm_left_time
                if _prev_time > 0.75 and _time <= 0.75: # четверть времени прошла
                    _has_25 = UStats.GetLevelValue('time_25_gone')
                    if _has_25 == 0:
                        self.show_top_text('TIME_25_GONE')
                        UStats.AddLevelValue('time_25_gone', 1)
                        EMgr.SendGlobalMsg('time_event')
                elif _prev_time > 0.5 and _time <= 0.5:
                    _has_50 = UStats.GetLevelValue('time_50_gone')
                    if _has_50 == 0:
                        self.show_top_text('TIME_50_GONE')
                        UStats.AddLevelValue('time_50_gone', 1)
                        EMgr.SendGlobalMsg('time_event')
                elif _prev_time > 0.25 and _time <= 0.25:
                    _has_75 = UStats.GetLevelValue('time_75_gone')
                    if _has_75 == 0:
                        #self.show_top_text('TIME_50_GONE')
                        UStats.AddLevelValue('time_75_gone', 1)
                        EMgr.SendGlobalMsg('time_event')
                #_diff = (_time_info.level_time - _time_info.time)
                #_prev_diff = (self.prev_time_info.level_time - self.prev_time_info.time)
                if _time_info.time <= 30000 and self.prev_time_info.time > 30000:
                    _has_30s = UStats.GetLevelValue('time_30s')
                    if _has_30s == 0:
                        self.show_top_text('TIME_30S_LEFT')
                        UStats.AddLevelValue('time_30s', 1)
                        EMgr.SendGlobalMsg('time_event')
                self.prev_time_info = _time_info
# ============================================================
    def blink_faces(self):
        for face_widget_name in self.units_names:
            if face_widget_name in self.units_names_units:
                _unit = self.units_names_units[face_widget_name]
                text, is_green = _unit.get_ui_subtext() # по другому никак...
                if is_green:
                    _stype = _unit.get('stype')
                    if _stype != 'trader':
                        self.BlinkFace(face_widget_name, 3)
# ============================================================
    def hide_all_unit_faces(self):
        '''прячем все аватарки юнитов'''
        index = 0
        self.Signals.Cancel('remind_about_indians')
        self.has_waiting_indian = False
        self.Signals.Cancel('remind_about_survived')
        self.has_waiting_survived = False
        self.Signals.Cancel('remind_about_precomplete')
        self.has_waiting_precomplete = False
        for uid in self.unit_uids:
            self.unit_uids[index] = ''
            self.units[index] = None
            self.units_texts[index] = ''
            u_name = self.units_names[index]
            if u_name in self.units_names_units:
                del self.units_names_units[u_name]
            w = self.widgets[u_name]
            self.SetUnitInfo(w, '', 0, '', False, [])
            self.SlideBack(w)
            index += 1
# ============================================================
    def update_waiting_units(self):
        '''Обработка напоминаний об ожидающих юнитах'''
        #_has_indians = UMgr.has_indians_with_quests()
        _indians, _precomplete, _survived = UMgr.has_ready_units()
        _has_indians = len(_indians) > 0
        _has_precomplete = len(_precomplete) > 0
        _has_survived = len(_survived) > 0
        if not self.has_waiting_indian:     # если до этого ожидающих индейцев не было
            if _has_indians:
                self.has_waiting_indian = True
                self.Signals.Restart('remind_about_indians', 60000) # напомним через 60 сек
        elif not _has_indians:        # если индейцы "закончились"
                self.Signals.Cancel('remind_about_indians')
                self.has_waiting_indian = False
        if not self.has_waiting_survived:     # если до этого ожидающих выживших не было
            if _has_survived:
                self.has_waiting_survived = True
                self.Signals.Restart('remind_about_survived', 30000) # напомним через 20 сек
        elif not _has_survived:        # если индейцы "закончились"
                self.Signals.Cancel('remind_about_survived')
                self.has_waiting_survived = False
        if not self.has_waiting_precomplete:     # если до этого ожидающих выживших не было
            if _has_precomplete:
                self.has_waiting_precomplete = True
                self.Signals.Restart('remind_about_precomplete', 60000) # напомним через 10 сек
        elif not _has_precomplete:        # если индейцы "закончились"
                self.Signals.Cancel('remind_about_precomplete')
                self.has_waiting_precomplete = False
# ============================================================
    def update_unit_faces(self):
        # - get units faces list
        _item_faces = UMgr.get_units_for_faces()
        self.update_waiting_units()
        _new_uids = [unit.get('uid') for unit in _item_faces]
        #trace('new_uids:', _new_uids)
        #trace('old_uids:', self.unit_uids)
        _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
        if _has_barbarians:     # если есть дикарь на поле, то прячем все аватарки
            self.hide_all_unit_faces()
            return
        # сначала проверяем uid, которые "ушли" и убираем их:
        index = 0
        for uid in self.unit_uids:
            if uid and uid not in _new_uids:    # если данного UID нет в новом списке отображаемых юнитов
                self.unit_uids[index] = ''
                self.units[index] = None
                self.units_texts[index] = ''
                u_name = self.units_names[index]
                if u_name in self.units_names_units:
                    del self.units_names_units[u_name]
                w = self.widgets[u_name]
                self.SetUnitInfo(w, '', 0, '', False, [])  # то убираем панельку данного юнита
                #self.SlideBackFast(w)
                self.SlideBack(w)
            index += 1
        if not _item_faces:
            return
        for unit in _item_faces:
            if unit.is_busy():      # если хотя бы один из юнитов занят, т.е. на него был клик, то не показываем никаких аватарок
                self.hide_all_unit_faces()
                return
        # теперь заполним свободные панельки юнитами:
        _has_free = self.has_free_units_slots() # остались ли свободные слоты под аватарки
        #if _has_free:
        if True:
            _skip_widgets = []
            for unit in _item_faces:                 # для каждого юнита,
                uid = unit.get('uid')
                if uid not in self.unit_uids:   # который еще не отображен
                    if not _has_free:
                        continue
                    _free_index = self.get_free_unit_slot_index(_skip_widgets)
                    if _free_index >= 0:        # для которого есть слот
                        self.unit_uids[_free_index] = uid   # запомним UID
                        self.units[_free_index] = unit
                        w_name = self.units_names[_free_index]
                        # передадим инфу по юниту:
                        _unit_frame = unit.GetAttrInt('slide_avatar_frame')
                        tips_text = []
                        tips_text.append( ('text', 'COLOR_HEADER') )
                        tips_text.append( ('text', unit.GetAttrStr('item_name')) )
                        self.units_texts[_free_index] = tools.ListToStr(tips_text)
                        _under_text_list, _is_green = unit.get_ui_subtext() # как вариант - need_red_sign проверять
                        _is_red = not _is_green
                        self.SetUnitInfo(w_name, 'IMG_I_AVATARS_R', _unit_frame, uid, _is_red, tips_text )
                        self.units_names_units[w_name] = unit
                        self.Slide(w_name, 500)
                        _skip_widgets.append(w_name)
                    else:
                    #    return  # больше свободных панелек нет
                        _has_free = False
                else:   # если юнит уже отображен
                    _unit_index = self.get_unit_slot_index(uid)
                    if _unit_index >= 0:        # для которого есть слот
                        w_name = self.units_names[_unit_index]
                        # передадим инфу по юниту:
                        _under_text_list, _is_green = unit.get_ui_subtext() # как вариант - need_red_sign проверять
                        _is_red = not _is_green
                        self.SetUnitSlideColorInfo(w_name, _is_red)
# ============================================================
    def has_free_units_slots(self):
        return (self.get_free_unit_slot_index() >= 0)
# ============================================================
    def get_free_unit_slot_index(self, _skip_widgets = []):
        if '' in self.unit_uids:
            index = -1
            for w_id in self.units_names:
                index += 1
                if w_id not in _skip_widgets:
                    if self.IsTotalHidden(w_id):
                        return index
        return -1
# ============================================================
    def get_unit_slot_index(self, uid):
        _places_count = len(self.unit_uids)
        for i in range(_places_count):
            if uid == self.unit_uids[i]:
                return i
        return -1
# ============================================================
    def has_free_bonus_slots(self):
        return (self.get_free_bonus_slot_index() >= 0)
# ============================================================
    def get_free_bonus_slot_index(self):
        if '' in self.bonus_types:
            index = -1
            for w_id in self.bonus_names:
                index += 1
                if self.IsTotalHidden(w_id):
                    return index
        return -1
# ============================================================
    def get_bonus_slot_index(self, name):
        if name in self.bonus_types:
            index = -1
            for t in self.bonus_types:
                index += 1
                if name == t:
                    return index
        return -1
# ============================================================
# ============================================================
    def get_free_slot_index(self):
        '''Возвращает индекс первого незантяого слота для заданий'''
        for i in range(len(self.tasks_shown)-1, -1, -1):
            if not self.tasks_shown[i]:
                return i
        return -1
# ============================================================
    def hide_task(self, slot):
        '''Прячет указанное задание'''
        panel = self.tasks_shown[slot]
        if panel:
            panel.started_hiding()
        w = self.widgets[ self.tasks_names[slot] ]
        self.SlideBack(w, 1000)
# ============================================================
    def hide_completed_tasks(self):
        '''Прячет выполненные задания'''
        i = 0
        for panel in self.tasks_shown:
            if panel:
                if panel.is_task_complete and not panel.is_hiding:
                    panel.started_hiding()
                    w = self.widgets[ self.tasks_names[i] ]
                    self.SlideBack(w, 1000)
            i += 1
        pass
# ============================================================
    def remove_completed_tasks(self):
        '''Освободождает слоты от уже скрытых заданий'''
        i = 0
        for panel in self.tasks_shown:
            if panel:
                if panel.is_hiding:
                    w = self.widgets[ self.tasks_names[i] ]
                    self.SetSlideHasContent(w, False)
                    if self.IsTotalHidden(w):
                        self.tasks_shown[i] = None  # прячем таск
                        self.FreeTaskSlot(i)
                        self.tasks_empty[i] = True
            i += 1
        pass
# ============================================================
# ============================================================
# ============================================================
    def show_tut_text(self, text_id, is_important = 0, uid = '', extra={}):
        '''Показывает туториальный текст'''
        if text_id:
            #episode, level = self.GetLevelIndex()
            #if episode == 2 and level == 6: # 2_6 - не показываем с 1 по 38 включительно
            #    if text_id.startswith('TUT_HELP_0'):
            #        return
            for item in self.general_texts:
                if item.text == text_id:    # одинаковые сообщения не добавляем
                    return
            if self.general_tip_shown and self.general_text_id_shown == text_id:    # если сейчас показано такой же текст, то скипуем
                return
            if is_important == 0:
                self.general_texts.append({'text':text_id, 'is_important':is_important, 'uid':uid, 'extra':extra})
            else:
                self.general_texts.insert(0, {'text':text_id, 'is_important':is_important, 'uid':uid, 'extra':extra})
            self.show_next_tip('general_cloud')
# ============================================================
    def show_tut_text_raw(self, text_id, uid, is_important, extra):
        '''Показывает туториальный текст'''
        if text_id:
            _cur_map_index = TMgr.GetCurMapIndex()
            _is_cave = TMgr.tutHelper.is_cave(_cur_map_index)
            if _is_cave:        # в подземельях не показывем то, что...
                if 'id' in extra:
                    if extra['id'] >= 6:    #@ ...относится к зданиями
                        return
            trace('UI TutText:', text_id)
            self.general_text_id_shown = text_id
            self.ShowTutorialText(106, 668, text_id, 4000, is_important, uid)
            self.general_tip_shown = True
            if 'blink_build_button' in extra:
                if extra.blink_build_button == True:
                    UI.ButtonStartBlink('idBuildings', 3)
# ============================================================
    def remove_tut_text(self, text_id):
        result = []
        for _tmp in self.general_texts:
            if _tmp.text != text_id:
                result.append(_tmp)
        self.general_texts = result
# ============================================================
    def show_top_text(self, text_id, uid = '', is_important = 0):
        '''Показывает туториальный текст'''
        if text_id:
            for item in self.general_texts:
                if item.text == text_id:    # одинаковые сообщения не добавляем
                    return
            if self.workers_tip_shown and self.workers_text_id_shown == text_id:    # если сейчас показан такой же текст, то скипуем
                return
            if is_important == 0:
                self.workers_texts.append({'text':text_id, 'is_important':is_important, 'uid':uid})
            elif is_important == 1:
                self.workers_texts.insert(0, {'text':text_id, 'is_important':is_important, 'uid':uid})
            elif is_important > 1:
                self.workers_texts.insert(0, {'text':text_id, 'is_important':is_important, 'uid':uid})
            self.show_next_tip('workers_cloud')
# ============================================================
    def show_top_text2(self, text_id, loc_index, uid = '', is_important = 0):
        '''Показывает туториальный текст (отличается пока только передаваемыми параметрами)'''
        if text_id:
            for item in self.general_texts:
                if item.text == text_id:    # одинаковые сообщения не добавляем
                    return
            if self.workers_tip_shown and self.workers_text_id_shown == text_id:    # если сейчас показан такой же текст, то скипуем
                return
            if is_important == 0:
                self.workers_texts.append({'text':text_id, 'is_important':is_important, 'uid':uid})
            elif is_important == 1:
                self.workers_texts.insert(0, {'text':text_id, 'is_important':is_important, 'uid':uid})
            elif is_important > 1:
                self.workers_texts.insert(0, {'text':text_id, 'is_important':is_important, 'uid':uid})
            self.show_next_tip('workers_cloud')
# ============================================================
    def show_top_text_raw(self, text_id, uid, is_important):
        '''Показывает туториальный текст'''
        if text_id:
            trace('UI TopText:', text_id, uid, is_important)
            self.workers_text_id_shown = text_id
            self.ShowTopText(54 - self.GetIphoneGapSize(), 66, text_id, 4000, uid, is_important)
            self.workers_tip_shown = True
# ============================================================
    def show_chest_text(self, text_id, uid = '', is_important = False):
        '''Показывает сундуковый текст'''
        if text_id:
            for item in self.chest_texts:
                if item.text == text_id:    # одинаковые сообщения не добавляем
                    return
            if self.chest_tip_shown and self.chest_text_id_shown == text_id:    # если сейчас показано такой же текст, то скипуем
                return
            if not is_important:
                self.chest_texts.append({'text':text_id, 'is_important':is_important, 'uid':uid})
            else:
                self.chest_texts.insert(0, {'text':text_id, 'is_important':is_important, 'uid':uid})
            self.show_next_tip('chest_cloud')
# ============================================================
    def show_chest_text_raw(self, text_id, uid, is_important):
        '''Показывает сундуковый текст'''
        if text_id:
            trace('UI TutText:', text_id)
            self.chest_text_id_shown = text_id
            self.ShowChestText(502, 42, text_id, 6000, uid, is_important)
            self.chest_tip_shown = True
# ============================================================
    def show_help_text(self, text_id, x, y, frame):
        '''Показывает подсказку
            frame: кадр в изображении'''
        if text_id:
            self.ShowHelpText(x, y, text_id, 4000, frame)
# ============================================================
    def add_game_tasks(self, task_added = False):
        if task_added:
            tools.PlaySound('SND_TASK_GET')
        i = 0
        for panel in self.tasks_shown:
            if self.tasks_empty[i]: # пустая ячейка
                _dinfo = self.GetTaskSlotDefaultInfo(i)
                _einfo = self.GetTaskSlotExtraInfo(i)
                if _dinfo.is_empty: # нет задания
                    i += 1
                    continue
                #@ надеюсь нигде меня не подведет:
                #if _dinfo.count == 0:
                #    i += 1
                #    continue
                if not panel:   # если задания здесь еще никогда не было
                    self.tasks_shown[i] = PanelItem()
                    panel = self.tasks_shown[i]
                self.tasks_empty[i] = False
                w = self.widgets[ self.tasks_names[i] ]
                self.SetTaskImage(w, _dinfo.image_name, _dinfo.image_frame)
                self.SetTaskInfo(w, 'template', _dinfo.template_name, 'task')
                if 'uid' in _einfo:
                    self.SetTaskInfo( w, 'uid', _einfo['uid'] )
                if 'npc_uid' in _einfo:
                    self.SetTaskInfo( w, 'npc_uid', _einfo['npc_uid'] )
                self.SetTaskInfo( w, 'location_index', _dinfo.location_index )
                self.SetTaskInfo( w, 'count', _dinfo.count )
                self.SetTaskInfo( w, 'text', _dinfo.text_id )
                if 'tips' in _einfo:
                    self.tasks_tips_text[i] = '#text#COLOR_HEADER#text#TIPS_TASKS_TASK#newline' + _einfo.tips
                if _dinfo.is_complete:
                    self.SetTaskInfo( w, 'count', 0 )
                #mbox(self.tasks_names[index])
                self.SetSlideHasContent(w, True)
                self.Slide(w, 200, 'quart', 'out')
            i += 1
        i = 0
        for panel in self.tasks_shown:
            if not self.tasks_empty[i]:
                _dinfo = self.GetTaskSlotDefaultInfo(i)
                if _dinfo.is_empty: # or _dinfo.is_hiding
                    w = self.widgets[ self.tasks_names[i] ]
                    self.SlideBackFast(w)
                    self.tasks_shown[i] = None
                    self.tasks_empty[i] = True
            #else:
            #    _dinfo = self.GetTaskSlotDefaultInfo(i)
            #    if _dinfo.is_empty:
            #        w = self.widgets[ self.tasks_names[i] ]
            #        self.SlideBackFast(w)
            #        self.tasks_shown[i] = None
            #        self.tasks_empty[i] = True
            i += 1
# ============================================================
    def refresh_tasks_info(self):
        i = 0
        _has_completed_task = False
        for panel in self.tasks_shown:
            if panel:
                if not panel.is_hiding:
                    _dinfo = self.GetTaskSlotDefaultInfo(i)
                    _einfo = self.GetTaskSlotExtraInfo(i)
                    w = self.widgets[ self.tasks_names[i] ]
                    self.SetTaskImage(w, _dinfo.image_name, _dinfo.image_frame)
                    self.SetTaskInfo(w, 'template', _dinfo.template_name, 'task')
                    if 'uid' in _einfo:
                        self.SetTaskInfo( w, 'uid', _einfo['uid'] )
                    if 'npc_uid' in _einfo:
                        self.SetTaskInfo( w, 'npc_uid', _einfo['npc_uid'] )
                    self.SetTaskInfo( w, 'location_index', _dinfo.location_index )
                    self.SetTaskInfo( w, 'count_ne', _dinfo.count )
                    self.SetTaskInfo( w, 'text', _dinfo.text_id )
                    if 'tips' in _einfo:
                        self.tasks_tips_text[i] = '#text#COLOR_HEADER#text#TIPS_TASKS_TASK#newline' + _einfo.tips
                    if _dinfo.is_complete:
                        self.SetTaskInfo( w, 'count', 0 )
                        _has_completed_task = True
                        self.Signals.Restart('tut_' + self.tasks_names[i], 10000)   # tut_task_1, tut_task_2, tut_task_3
            i += 1
        #if _has_completed_task:
        #    EMgr.send_event('has_completed_event', None, {})
# ============================================================
    def On_external_msg(self, slot, msg_id, msg_param):
        '''Передача сообщений таскам, извне VM'''
        trace(msg_id, 'slot:', slot, 'Param:', msg_param)
        if msg_id == 'task_complete':
            if self.tasks_shown[slot]:
                self.tasks_shown[slot].is_task_complete = True
                w = self.widgets[ self.tasks_names[slot] ]
                self.SetTaskInfo(w, 'count', 0)
                tools.PlaySound('SND_TASK_END')
                self.Signals.Restart('tut_' + self.tasks_names[slot], 10000)    # tut_task_1, tut_task_2, tut_task_3
                # EMgr.send_event('has_completed_event', None, {})
        elif msg_id == 'task_remove':
            self.hide_task(slot)
            self.tasks_tips_text[slot] = ''
            tools.PlaySound('SND_TASK_COMPLETE')
            self.Signals.Cancel('tut_' + self.tasks_names[slot])
        elif msg_id == 'set_task_text':
            w = self.widgets[ self.tasks_names[slot] ]
            self.SetTaskInfo(w, 'text', msg_param)
        elif msg_id == 'set_task_count':
            w = self.widgets[ self.tasks_names[slot] ]
            self.SetTaskInfo(w, 'count', int(msg_param))
            #tools.PlaySound('SND_TASK_END')
        elif msg_id == 'set_task_tips_text':
            #w = self.widgets[ self.tasks_names[slot] ]
            #self.SetTaskInfo(w, 'text', msg_param)
            self.tasks_tips_text[slot] = '#text#COLOR_HEADER#text#TIPS_TASKS_TASK#newline' + msg_param
        elif msg_id == 'set_uids':
            w = self.widgets[ self.tasks_names[slot] ]
            self.SetTaskInfo(w, 'click_uids', msg_param)
# ============================================================
    def Open_game_menu(self):
        dlg.Open('GameMenu', 'dlg_gamemenu')#, {'single_mode':'1'})
# ============================================================
    def set_competitor_half(self, half):
        self.SlideBackFast('competitor_slide')
        self.SetCompetitorHalf(half)
        mz = self.move_zones['competitor']
        if half:
            self.ReplaceMoveZone('competitor', mz.x, mz.y, mz.w, mz.h/2)
        else:
            self.ReplaceMoveZone('competitor', mz.x, mz.y, mz.w, mz.h)
# ============================================================
    #def complete_task(self, task):
    #    '''Отмечает задание как выполненное'''
    #    pass
# ============================================================
    def is_iphone(self):
        return self.IsIphone()
# ============================================================
    def get_iphone_gap_size(self):
        return self.GetIphoneGapSize()
# ============================================================



