# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_unit
import task_walkg
import task_classes


class QuestmanQuestDlgTask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'QuestmanQuestDlgTask'
# ============================================================
    def start_action(self, item):
        self.indian = item
        indian = item
        if indian.quest:
            _uid = self.parent_task.uid
            if indian.quest.is_start_possible():
                _dlg_settings = indian.get_dlg_settings(indian.quest.text, _uid)
                TMgr.cancel_general_tasks()
                Camera.MoveTo(indian)
                dlg.Open('QuestMenu', 'dlg_quest', _dlg_settings)
                return True
            else:
                return False
        else:
            #self.on_action_complete()
            return False
# ============================================================
    def on_callback(self, result, extra_dict):
        '''Обработка данных от диалога (диалог у нас в другой VM)'''
        if result == 'agree':
            UStats.AddLevelValue('gold_ship_complete')   # вот так хитро отмечаем сдачу уровня/золота
            tools.PlaySound('SND_TARGET_COMPLETE')
            BMgr.SendGlobalMsg('gold_task_complete')
            #UStats.AddLevelValue('gold_task_complete')  # золото погружено
            QMgr.start_quest(self.indian.quest) #  нужно запустить квест на выполнение
            self.parent_task.complete_task()    # таск по взятию квеста выполнен - теперь нужно выполнять сам квест и все управление переходит на него
            EMgr.SendGlobalMsg('npc_interacted')
            dlg.Open('ChestMenu', 'dlg_chest', {'showin_effect':'chest_fly_in', 'task':'GOLD', 'single_mode':'1'})
        elif result == 'postpone':
            self.parent_task.cancel()
        # отведем генерала от юнита:
        if self.indian:
            UMgr.step_aside_general(self.indian.get('locind'))
# ============================================================
# ============================================================
class QuestmanCompleteQuestDlgTask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'QuestmanCompleteQuestDlgTask'
# ============================================================
    def start_action(self, item):
        self.indian = item
        indian = item
        if indian.quest:
            _uid = self.parent_task.uid
            _dlg_settings = indian.get_dlg_settings(indian.quest.text_complete, _uid, True)
            TMgr.cancel_general_tasks()
            Camera.MoveTo(indian)
            dlg.Open('QuestMenuOk', 'dlg_quest_ok', _dlg_settings )
            return True
        else:
            #self.on_action_complete()
            return False
# ============================================================
    def on_callback(self, result, extra_dict):
        '''Обработка данных от диалога (диалог у нас в другой VM)'''
        if result == 'ok':      # а других и быть не должно
            if self.indian.quest:
                _q = self.indian.quest
                _q.complete()
                self.parent_task.complete_task()
                self.indian.switch_animation()
                self.indian.on_quest_complete_all()
            else:
                mbox('on_callback: no quest')
            EMgr.SendGlobalMsg('npc_interacted')
        # отведем генерала от юнита:
        if self.indian:
            UMgr.step_aside_general(self.indian.get('locind'))
# ============================================================
# ============================================================
# ============================================================
class UnitQuestmanBoat(base_unit.BaseUnit):
    def __init__(self, cdata):
        base_unit.BaseUnit.__init__(self, cdata)
        self.ser_name = 'UnitQuestmanBoat'
        self.quest = None
        self.quests = []
        self.caller_building = None
        EMgr.add_event_listener(self)
# ============================================================
    def extra_init(self):
        base_unit.BaseUnit.extra_init(self)
        self.switch_animation()
# ============================================================
    # @override
    def dispose(self):
        EMgr.remove_event_listener(self)
# ============================================================
    #@override
    def on_signal(self, signal):
        base_unit.BaseUnit.on_signal(self, signal)
        if signal == 'offscreen':
            self.try_to_show()
        elif signal == 'try_to_show':   # чтобы отслеживать offscreen здания, а не только юнита
            self.try_to_show()
        elif signal == 'face_to_screen':
            self.set_face_direction()   # чтобы лицом к экрану стоял
        elif signal == 'need_activate_next_quest':
            self.activate_next_quest()
# ============================================================
    def on_message(self, msg_type, msg_param1='', msg_param2='', msg_dict={}):
        if msg_type == 'quest_start':
            self.on_quest_start(msg_param1, int(msg_param2))
        elif msg_type == 'quest_complete':
            self.on_quest_complete(msg_param1, int(msg_param2))
        elif msg_type == 'at_target':
            self.FSM.HandleEvent('attarget_stay_event')
        elif msg_type == 'your_quest_complete':
            EMgr.send_event( 'questman_complete', self )
            #self.activate_next_quest()
            #self.quest = None
            self.switch_animation()
# ============================================================
    def on_click(self, btn_name):
        '''Вызывается при клике по объекту'''
        _is_active = self.is_active()
        if _is_active:
            if self.is_enough_params():
                if self.quest:
                    if self.quest.is_only_res_not_enough_to_start():
                        #LBoard.MoveCameraToLastClick()
                        return
                if not self.task:
                    #if UMgr.general and not UMgr.general.task:
                        _is_general_ok = UMgr.is_general_ok()
                        if not _is_general_ok:
                            LBoard.CrossNoToLastClick()
                            return
                        self.task = task_walkg.WalkGeneralTask(self)
                        TMgr.add_task( self.task )
                        if self.has_check:      # если галка установилась
                            TMgr.add_quest_unit_to_queue(self.uid)
                            Camera.MoveTo(self) # при установке галки - камеру на индейца
                            BMgr.SendGlobalMsg('unit_clicked', self.get('uid'))
                        self.show_arrow(False)
                else:
                    self.task.cancel()
                    self.task = None
                    BMgr.SendGlobalMsg('unit_clicked', self.get('uid'))
                    self.show_arrow(False)
        else:
            LBoard.CrossNoToLastClick()
# ============================================================
# ============================================================
# ============================================================
    def on_create(self):
        self.init_fsm()
        self.switch_animation()
# ============================================================
    def __str__(self):
        return base_unit.BaseUnit.__str__(self)
# ============================================================
    def on_event(self, name, obj, extra_dict):
        '''Обработчик игровых событий'''
        if name == 'resources_changed':            # изменилось кол-во ресурсов у игрока
            self.switch_animation()     # чтобы знак над индейцем обновить
        elif name == 'quest_unit_added':
            if self.uid != extra_dict['uid']:   # если событие другого объекта
                self.is_another_unit_in_queue = True
                self.switch_animation()     # чтобы знак над индейцем обновить
        elif name == 'quest_unit_removed':
            self.is_another_unit_in_queue = False
            self.switch_animation()     # чтобы знак над индейцем обновить
        elif name in ['barbarian_attack_started', 'barbarian_attack_completed', 'barbarian_attack_canceled']:
            self.switch_animation()
# ============================================================
    def ready_to_show(self, caller_building, force = False):
        self.caller_building = caller_building
        self.try_to_show(force)
# ============================================================
    def try_to_show(self, force = False):
        _need_show = False
        if self.caller_building and self.caller_building.is_offscreen and self.is_offscreen:
            _need_show = True
        if force: _need_show = True
        if _need_show:
            self.show_now()
            self.caller_building.hide_unit()
            self.caller_building = None
            self.send_extra_event()     # когда юнит стал виден
# ============================================================
# ============================================================
    def need_sign_red(self):
        '''Нужно ли показать красное облако'''
        if not self.non_selectable and not self.is_deactivated and self.is_shown:
            _is_enough_params = self.is_enough_params()
            if not _is_enough_params:
                return True
            if self.quest:
                _is_only_res_not_enough_to_start = self.quest.is_only_res_not_enough_to_start()
                if _is_only_res_not_enough_to_start:
                    return True
                _has_tut_quest = QMgr.has_tutorial_quests()
                if not _has_tut_quest:        # туториальных больше нет
                    if not self.is_another_unit_in_queue:
                        if not self.is_another_quest_started:   # других не запущено
                            _is_start_possible = self.quest.is_start_possible()
                            return not _is_start_possible
                        elif self.quest and self.quest.parent_quest_name:   # если родительский квест
                            if self.quest.is_start_possible():
                                return False
                            #_is_only_res_not_enough_to_start = self.quest.is_only_res_not_enough_to_start()
                            #if _is_only_res_not_enough_to_start:
                            #    return True
        return False
# ============================================================
    indian_animation_dict = {'run' : 'run', 'idle' : 'default'}
# ============================================================
    def switch_animation(self):
        drawer = self.Drawer
        _is_partial_fog = drawer.IsPartiallyInFog()
        if _is_partial_fog:
            drawer.ShowImages('', False)
            return
        drawer.ShowImages('', False)
        if not self.is_shown:
            return
        state_name = self.FSM.GetStateID()
        new_animation_name = 'default'
        if state_name in self.indian_animation_dict:
            new_animation_name = self.indian_animation_dict[state_name]
        drawer.ShowImages([new_animation_name,'shadow'], True)
        drawer.ShowImages('select', self.is_mouse_over and not self.is_deactivated)
        drawer.ShowImages('check', self.has_check)
        drawer.ShowImages('arrow', self.arrow_shown)
        _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
        if not _has_barbarians:
            _has_access = self.has_access()
            if _has_access:
                _is_active = self.is_active()
                if self.quest and _is_active:
                    _need_sign_red = self.need_sign_red()
                    drawer.ShowImages('sign_e', not _need_sign_red)
                    drawer.ShowImages('sign_red', _need_sign_red)
# ============================================================
    def has_sign(self):
        return ( self.quest and self.is_active() )
# ============================================================
    # @override
    def is_active(self):
        '''Возможны ли действия над объектом в данный момент. ПЕРЕОПРЕДЕЛЯЕМ'''
        if not self.non_selectable and self.is_shown:
            if not self.is_deactivated:
                if self.is_quest_precomplete(): # если сдача квеста
                    return True
                elif not QMgr.has_tutorial_quests():        # туториальных больше нет
                    if not self.is_another_unit_in_queue:
                        if not self.is_another_quest_started:   # других не запущено
                            if self.quest:
                                if self.quest.is_start_possible():
                                    return True
                                elif self.quest.is_only_res_not_enough_to_start():
                                    return True     # чтобы при нехватке ресурсов для квеста воскл. знак над индейцем показывался
                        elif self.quest and self.quest.parent_quest_name:   # если родительский квест
                            if self.quest.is_start_possible():
                                return True
                            elif self.quest.is_only_res_not_enough_to_start():
                                return True
        return False
# ============================================================
    def is_enough_params(self):
        '''Достаточно ли красноречия и силы'''
        _need_power = self.GetAttrInt('need_power') - 1
        _need_oratory = self.GetAttrInt('need_oratory') - 1
        _cur_res = UStats.GetCurRes()
        _have_oratory = _cur_res.Get('gem_green')
        _have_power = _cur_res.Get('gem_blue')
        if _have_oratory < _need_oratory or _have_power < _need_power:
            return False
        else:
            return True
# ============================================================
    def set_quest(self, quest):
        self.quest = quest
        self.is_deactivated = False
        #self.non_selectable = False
        #self.switch_animation()    #@? нужно ли оно здесь???
# ============================================================
    def assign_quest(self, quest):
        if self.quest:
            self.quests.append(quest)
        else:
            self.quest = quest
        self.is_deactivated = False
# ============================================================
    def try_activate_next_quest(self):
        '''Текущий квест сбрасывает и запускает таймер для смены квеста'''
        self.quest = None
        self.is_deactivated = True
        if self.quests:
            self.Signals.Restart('need_activate_next_quest', 3000)
# ============================================================
    def activate_next_quest(self):
        self.quest = None
        self.is_deactivated = True
        if self.quests:
            self.is_deactivated = False
            self.quest = self.quests.pop(0)
# ============================================================
    def deactivate(self):
        '''Деактивирует объект - он перестает быть доступным для взаимодействия и соответственно обновляет изображения'''
        base_unit.BaseUnit.deactivate(self)
        _has_postpoined_quests = self.Signals.Has('need_activate_next_quest')
        if _has_postpoined_quests:
            self.Signals.Cancel('need_activate_next_quest')
    def activate(self):
        base_unit.BaseUnit.activate(self)
        if not self.quest and self.quests:
            self.activate_next_quest()
            self.switch_animation()
# ============================================================
    def on_quest_start(self, quest_name):
        if not self.quest:
            return
        quest = QMgr.get_quest(quest_name, self.get('locind'))
        if self.quest != quest:     #! здесь добавить проверку на 'parent' квест
            self.is_another_quest_started = True
        else:
            self.is_another_quest_started = False
            self.is_quest_started = True
        self.switch_animation()
# ============================================================
    def on_quest_complete(self, quest_name):
        '''Вызывается при завершении того или иного квеста.
        Но логику этого вызова теперь нужно менять, т.к.
        квест должен завершаться после сдачи квеста'''
        if not self.quest:
            return
        self.is_another_quest_started = False
        quest = QMgr.get_quest(quest_name, self.get('locind'))
        if self.quest == quest:
            self.is_quest_started = False
        self.switch_animation()
# ============================================================
    def is_action_complete(self):
        if not self.quest:
            return True
        else:
            return False
# ============================================================
    def is_quest_precomplete(self):
        '''Квест выполнен, его нужно сдать'''
        if self.quest and self.quest.is_quest_precomplete(): # нужно сдать квест
            return True
        return False
# ============================================================
    def get_subtask(self, parent_task, actor):
        if self.is_quest_precomplete(): # если сдача квеста
            return QuestmanCompleteQuestDlgTask(parent_task, actor)
        if not self.is_action_complete():
            return QuestmanQuestDlgTask(parent_task, actor)
        else:
            return base_unit.BaseUnit.get_subtask(self, parent_task, actor)
# ============================================================
    def on_quest_complete_all(self):
        '''Вызывается "OK"-диалогом, когда квест уже полностью завершен'''
        self.try_step_aside_quest_complete()
        self.try_hide_after_quest_complete()
        self.is_quest_complete = True   # завершили квест, запомним это
        #@!!! здесь нужно делать отметку об отправке золота
# ============================================================
    def try_hide_after_quest_complete(self):
        '''Готовит юнита к исчезновению по окончании квеста, если у юнита есть такая необходимость'''
        hide_items_str = self.GetAttrStr('qc_hide_items')
        if hide_items_str:
            hide_items = BMgr.get_items(hide_items_str, self.get('locind'))
            if hide_items:
                for item in hide_items:
                    item.need_to_remove_offscreen = True
        if self.GetAttrBool('qc_hide'):     # если нужно спрятать юнита
            self.need_to_remove_offscreen = True
            if self.is_offscreen:   # если уже за экраном, то удалим его
                BMgr.RemoveItemFromMap(self)    # удалим юнита
# ============================================================
    def try_step_aside_quest_complete(self):
        '''Отводит индейца в сторону, после того, как квест выполнен'''
        if self.GetAttrBool('qc_step_aside'):
            LBoard.RemoveItemPassability(self)
            _destCell = UMgr.GetStepAsideCell( self, self.get('cell'), 5 )
            if _destCell:
                self.run_to_target(_destCell)
# ============================================================
# ============================================================
    #@override
    def get_dlg_settings(self, text, _uid = 0, complete = False):
        if self.quest:
            _tasks = self.quest.get_tasks_text(complete)
            _dlg_settings = {'imageid': self.GetAttrStr('dlg_avatar'),
                            'nameid': self.GetAttrStr('dlg_name'),
                            'textid': text,
                            'tasks_text': _tasks,
                            'task_uid':str(_uid),
                            'single_mode':str(True),
                            'showin_effect':'task_fly_in',
                            'pause':str(400),
                            }
            return _dlg_settings
        return None
# ============================================================
# ============================================================
# ============================================================
    #@override
    def is_green_state(self):
        '''Цвет типса/селекта'''
        _has_access = self.has_access()
        if self.is_deactivated:
            if _has_access: return True
            else:           return False
        if not _has_access: return False
        if not self.is_enough_params():
            return False
        _is_active = self.is_active()
        if _is_active:
            if self.quest:
                _is_only_res_not_enough_to_start = self.quest.is_only_res_not_enough_to_start()
                if _is_only_res_not_enough_to_start:
                    return False    # если не хватает только ресурсов
        #if self.res_action_cost:
        #    _is_res_enough = UStats.IsResEnough(self.res_action_cost)
        #    if not _is_res_enough:   # если хватает ресурсов на действие над объектом
        #        return False
        return base_unit.BaseUnit.is_green_state(self)
# ============================================================
    def Get_tip_text(self, by_click = False):
        '''Возвращает LIST, содержащий текстовые ID'''
        # нужно писать что нужно индейцу, например: красноречие, сила, ресурсы
        result = []
        if not self.is_shown:
            return result
        item_name = self.GetAttrStr("item_name")
        if not item_name:
            return result
        if not by_click:
            result.append( ("text", "COLOR_HEADER") )
            result.append( ("text", item_name) )
            self.get_params_not_enough_text(result, \
                [('text', 'COLOR_LINES'), 'newline', ('text', 'TO_SPEAK'), 'space'])
            if self.quest and self.need_quest_text:
                _r, _ne_r = self.quest.get_tips_extra_text()
                if _r:
                    result.append( 'newline' )
                if not _ne_r:
                    result.append( ('text', 'COLOR_LINES') )
                    result.append( ('text', 'NEED_FOR_ACTION') )
                    result.append( 'space' )
                    result.extend( _r )
                else:
                    result.append( ('text', 'COLOR_LINES') )
                    result.append( ('text', 'NEED_FOR_ACTION') )
                    result.append( 'space' )
                    result.extend( _r )
                    result.append( 'newline' )
                    result.append( ('text', 'COLOR_RED') )
                    result.append( ('text', 'NOT_ENOUGH') )
                    result.append( 'space' )
                    result.extend( _ne_r )
            _has_access = self.has_access()
            if not self.is_deactivated or not _has_access:
                if self._append_sick_general(result):
                    return result
        else:   # by click:
            if self.is_quest_complete:
                result.append( ('text', 'COLOR_LINES') )
                result.append( ('text', 'NOTHING_TO_TALK') )
                return result
            _has_access = self.has_access()
            _no_time_to_talk = False
            if self.is_another_quest_started: _no_time_to_talk = True
            _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
            if _has_barbarians: _no_time_to_talk = True
            if _has_access:
                if not self.is_deactivated:
                    if self._append_sick_general(result, True):
                        return result
                if _no_time_to_talk:
                    result.append( ('text', 'COLOR_LINES') )
                    result.append( ('text', 'YOU_HAVE_NO_TIME_TO_TALK') )
                    return result
                elif self.quest:
                    if self.is_quest_started:
                        result.append( ('text', 'COLOR_LINES') )
                        result.append( ('text', 'NOT_READY_TO_TALK') )
                        return result
            if not self.is_active():
                result = []
                if not _has_access:
                    result.append( ('text', 'COLOR_RED') )
                    result.append( ('text', 'NO_PATH') )
                    return result
            #if self.quest.is_only_res_not_enough_to_start():    # если не хватает только ресурсов
                # ##
                #return
            if self.quest and self.need_quest_text:
                _result = self.quest.get_tips_click_text()
                if _result:
                    result.append( ('text', 'COLOR_RED') )
                    result.append( ('text', 'NOT_ENOUGH') )
                    result.append('space')
                    result.extend(_result)
                    return result
            self.get_params_not_enough_text(result, \
                [('text', 'COLOR_RED'), 'newline', ('text', 'ATTR_NOT_ENOUGH'), 'space'], True)
            if not result:
                return self.Get_tip_text(False) # если по клику нет типса, то вернем его как без клика
        return result
# ============================================================
    #@override
    def get_ui_subtext(self):
        '''Текст, который должен быть написан в типсе возле панели с
        лицом персонажа второй строкой'''
        if not self.non_selectable and not self.is_deactivated and self.is_shown:
            if self.quest:
                _is_quest_precomplete = self.is_quest_precomplete()
                if _is_quest_precomplete: # если сдача квеста
                    return ([('text', 'FACES_READY_TO_COMPLETE')], True)
                #_is_enough_params = self.is_enough_params()

                #if not _is_enough_params:
                #    result = [('text', 'FACES_NOT_ENOGH_GEMS_TO_SPEAK')]
                #    result.append( 'space' )
                #    self.get_params_not_enough_text(result, [('text', 'COLOR_RED')], True)
                #    return (result, False)

                _is_start_possible = self.quest.is_start_possible()
                if _is_start_possible:
                    return ([('text', 'FACES_READY_TO_SPEAK')], True)

                if self.quest.is_only_res_not_enough_to_start():
                    result = [('text', 'FACES_NOT_ENOUGH_RES_TO_SPEAK'), 'space']
                    result_need_res, result_ne_res = self.quest.get_tips_extra_text()
                    result.extend(result_ne_res)
                    return (result, False)

            _is_active = self.is_active()
            if (self.unique_name and _is_active):
                return ([('text', 'FACES_READY_TO_SPEAK')], True)
        return [[], True]
# ============================================================
# ============================================================
# ============================================================
