# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_unit
import task_walkg
import task_classes


class TradingDlgTask(task_classes.Subtask):
    def __init__(self, parent_task = None, actor = None):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.ser_name = 'TradingDlgTask'
# ============================================================
    def start_action(self, item):
        self.indian = item
        indian = item
        _uid = self.parent_task.uid
        _dlg_settings = indian.get_dlg_settings_trade(_uid)
        #TMgr.cancel_general_tasks()
        Camera.MoveTo(indian)
        _enough_res = UStats.GetResCount(self.indian.res_need_name) >= self.indian.res_need_count
        if _enough_res:
            dlg.Open('TradeMenu', 'dlg_trade', _dlg_settings)
            return True
        else:
            return False
# ============================================================
    def on_callback(self, result, extra_dict):
        '''Обработка данных от диалога (диалог у нас в другой VM)'''
        if result == 'agree':
            trace('TradeDialog "agree" pressed')
            #QMgr.start_quest(self.indian.quest) #  нужно запустить квест на выполнение
            self.parent_task.complete_task()    # таск по обмену выполнен
            EMgr.SendGlobalMsg('npc_interacted')
            ind = self.indian
            UStats.SubResValue(ind.res_need_name, ind.res_need_count)
            if ind.res_gives_name in ['boat', 'teleport']:
                _boat = BMgr.get_item(ind.boat_uid, ind.get('locind'))
                if _boat:
                    _boat.activate()
                    Camera.MoveTo(_boat)
                    if True:
                        letter = []
                        if ind.res_gives_name == 'boat':
                            letter.append( ('text', 'MSG_BOAT_BOUGHT') )
                        elif ind.res_gives_name == 'teleport':
                            letter.append( ('text', 'MSG_TELEPORT_BOUGHT') )
                        letter.append( 'space' )
                        _loc_ind = ind.get('locind')
                        EMgr.AppendLetter(letter, _boat.get('uid'), _loc_ind)
                ind.deactivate()
                ind.trade_complete = True
            elif ind.res_gives_name.startswith('inventory:'):   # для продажи артефактов
                _template = ind.res_gives_name[len('inventory:'):]
                _comet_effect_name = BMgr.GetTemplateAttr(_template, 'comet_name')
                ind.start_comet(_comet_effect_name)
                ind.deactivate()
                ind.trade_complete = True
            else:
                UStats.AddResValue(ind.res_gives_name, ind.res_gives_count)
                _g = UMgr.get_general()
                LBoard.FlyResCount(_g, ind.res_images[ind.res_gives_name], ind.res_gives_count)
            EMgr.send_event( 'trade_complete', self )
            ind.PlaySound('SND_EXCHANGE')
        elif result == 'cancel':
            trace('TradeDialog "cancel" pressed')
            self.parent_task.cancel()
        # отведем генерала от юнита:
        if self.indian:
            UMgr.step_aside_general(self.indian.get('locind'))
# ============================================================
# ============================================================
# ============================================================
class UnitTrader(base_unit.BaseUnit):
    def __init__(self, cdata):
        base_unit.BaseUnit.__init__(self, cdata)
        self.ser_name = 'UnitTrader'
        self.is_indian = True       # чтобы отличать индейцев от не индейцев
        self.res_need_name = self.GetAttrStr('res_need_name')
        self.res_gives_name = self.GetAttrStr('res_gives_name')
        self.res_need_count = self.GetAttrInt('res_need_count')
        self.res_gives_count = self.GetAttrInt('res_gives_count')
        self.boat_uid = self.GetAttrStr('boat_uid')
        self.trade_complete = False
        EMgr.add_event_listener(self)
# ============================================================
    # @override
    def dispose(self):
        EMgr.remove_event_listener(self)
# ============================================================
    #@override
    def on_signal(self, signal):
        base_unit.BaseUnit.on_signal(self, signal)
        if signal == 'face_to_screen':
            self.set_face_direction()   # чтобы лицом к экрану стоял
        elif signal == 'comet_fly_complete':
            _template = self.res_gives_name[len('inventory:'):]
            _id = BMgr.GetTemplateAttr(_template, 'inventory_image')
            _frame = BMgr.GetTemplateAttr(_template, 'inventory_frame')
            inventory_item = {'name':_template,
                          'image':_id,
                          'frame':str(_frame)}
            UStats.Inventory.AddQuestItem(inventory_item)
            self.PlaySoundG('SND_ITEM_BAG')

            #item_info = {'type':'different', 'subtype':'inventory'}
            #EMgr.send_event( 'do_action_complete', self, item_info )
# ============================================================
    def on_message(self, msg_type, msg_param1='', msg_param2='', msg_dict={}):
        pass
# ============================================================
    def on_click(self, btn_name):
        '''Вызывается при клике по объекту'''
        #@b если есть варвары на поле, то клики отменяем, квесты не сдаем
        _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
        if _has_barbarians:        # если есть варвары, то не даем кликать по индейцам, чтобы ни взять, ни сдать квест
            LBoard.CrossNoToLastClick()
            return
        _is_active = self.is_active()
        if _is_active:
            _is_enough_params = self.is_enough_params()
            if _is_enough_params:
                if not self.task:
                    _enough_res = UStats.GetResCount(self.res_need_name) >= self.res_need_count
                    if _enough_res:
                        _is_general_ok = UMgr.is_general_ok()
                        if not _is_general_ok:
                            LBoard.CrossNoToLastClick()
                            return
                        self.task = task_walkg.WalkGeneralTask(self)
                        TMgr.add_task( self.task )
                        if self.has_check:      # если галка установилась
                            Camera.MoveTo(self) # при установке галки - камеру на индейца
                            BMgr.SendGlobalMsg('unit_clicked', self.get('uid'))
                        return
                else:
                    self.task.cancel()
                    self.task = None
                    BMgr.SendGlobalMsg('unit_clicked', self.get('uid'))
                    return
            else:
                _param_name = self.get_not_enough_param()
                UI.BlinkGem(3, _param_name)     # подмигнем параметром
                return
        LBoard.CrossNoToLastClick()
# ============================================================
# ============================================================
    def on_create(self):
        self.init_fsm()
        self.switch_animation()
# ============================================================
    def __str__(self):
        return base_unit.BaseUnit.__str__(self)
# ============================================================
    def on_event(self, name, obj, extra_dict):
        '''Обработчик игровых событий'''
        if name == 'resources_changed':            # изменилось кол-во ресурсов у игрока
            self.switch_animation()     # чтобы знак над индейцем обновить
        #elif name in ['barbarian_attack_started', 'barbarian_attack_completed', 'barbarian_attack_canceled']:
        #    self.switch_animation()
# ============================================================
# ============================================================
    indian_animation_dict = {'run' : 'run', 'idle' : 'default', 'talk':'speak'}
# ============================================================
    def switch_animation(self):
        drawer = self.Drawer
        _is_partial_fog = drawer.IsPartiallyInFog()
        if _is_partial_fog:
            drawer.ShowImages('', False)
            return
        if not self.is_shown:
            drawer.ShowImages('', False)
            return
        state_name = self.FSM.GetStateID()
        drawer.ShowImages('', False)
        new_animation_name = 'default'
        if state_name in self.indian_animation_dict:
            new_animation_name = self.indian_animation_dict[state_name]
        drawer.ShowImages([new_animation_name,'shadow'], True)
        drawer.ShowImages('select', self.is_mouse_over and not self.is_deactivated)
        drawer.ShowImages('check', self.has_check)
        drawer.ShowImages('arrow', self.arrow_shown)
        _has_access = self.has_access()
        if _has_access:
            _is_active = self.is_active()
            if _is_active:
                drawer.ShowImages('sign_money', self.has_sign())
            drawer.ShowImages('sign_red', self.need_sign_red())
# ============================================================
    # @override
    def is_active(self):
        '''Возможны ли действия над объектом в данный момент. ПЕРЕОПРЕДЕЛЯЕМ'''
        if not self.non_selectable:
            if not self.is_deactivated:
                if self.is_shown:
                    return True
        return False
# ============================================================
    def need_sign_red(self):
        '''Нужно ли показать красное облако над индейцем'''
        if not self.non_selectable:
            if not self.is_deactivated:
                if self.is_shown:
                    _is_enough_params = self.is_enough_params()
                    if not _is_enough_params:
                        return True
                    _not_enough_res = UStats.GetResCount(self.res_need_name) < self.res_need_count
                    return _not_enough_res
        return False
# ============================================================
    def has_sign(self):
        if not self.non_selectable:
            if not self.is_deactivated:
                if self.is_shown:
                    _is_enough_params = self.is_enough_params()
                    if not _is_enough_params:
                        return False
                    _enough_res = UStats.GetResCount(self.res_need_name) >= self.res_need_count
                    return _enough_res
        return False
# ============================================================
    def is_enough_params(self):
        '''Достаточно ли красноречия и силы'''
        _need_power = self.GetAttrInt('need_power') - 1
        _need_oratory = self.GetAttrInt('need_oratory') - 1
        _cur_res = UStats.GetCurRes()
        _have_oratory = _cur_res.Get('gem_green')
        _have_power = _cur_res.Get('gem_blue')
        if _have_oratory < _need_oratory or _have_power < _need_power:
            return False
        else:
            return True
# ============================================================
    def get_not_enough_param(self):
        '''Возвращает имя параметра, которого недостаточно'''
        _need_power = self.GetAttrInt('need_power') - 1
        _need_oratory = self.GetAttrInt('need_oratory') - 1
        _cur_res = UStats.GetCurRes()
        _have_oratory = _cur_res.Get('gem_green')
        _have_power = _cur_res.Get('gem_blue')
        if _have_oratory < _need_oratory:
            return 'oratory'
        elif _have_power < _need_power:
            return 'power'
        else:
            return ''
# ============================================================
#    def is_action_complete(self):
#        if not self.quest:
#            return True
#        else:
#            return False
# ============================================================
    def get_subtask(self, parent_task, actor):
        return TradingDlgTask(parent_task, actor)
        #else:
        #    return base_unit.BaseUnit.get_subtask(self, parent_task, actor)
# ============================================================
# ============================================================
    #@override
    def get_dlg_settings_trade(self, _uid = 0):
        _dlg_settings = {'imageid': self.GetAttrStr('dlg_avatar'),
                        'nameid': self.GetAttrStr('dlg_name'),
                        'res_give': self.res_need_name,
                        'res_give_count': str(self.res_need_count),
                        'res_receive': self.res_gives_name,
                        'res_receive_count': str(self.res_gives_count),
                        'task_uid':str(_uid),
                        'single_mode':str(True),
                        'showin_effect': 'trade_fly_in',
                        'pause':str(400),
                        }
        return _dlg_settings
# ============================================================
# ============================================================
    #@override
    def is_green_state(self):
        '''Цвет типса/селекта'''
        _has_access = self.has_access()
        if self.is_deactivated:
            if _has_access: return True
            else:           return False
        if not _has_access: return False
        _is_enough_params = self.is_enough_params()
        if not _is_enough_params:
            return False
        _is_general_ok = UMgr.is_general_ok()
        if not _is_general_ok:
            return False
        _is_active = self.is_active()
        if _is_active:
            if self.has_sign():
                return True    # если не хватает только ресурсов
            else:
                return False
        return base_unit.BaseUnit.is_green_state(self)
# ============================================================
    def Get_tip_text(self, by_click = False):
        '''Возвращает LIST, содержащий текстовые ID'''
        # нужно писать что нужно индейцу, например: красноречие, сила, ресурсы
        result = []
        if not self.is_shown:
            return result
        item_name = self.GetAttrStr('item_name')
        if not item_name:
            return result
        if not by_click:
            result.append( ('text', 'COLOR_HEADER') )
            result.append( ('text', item_name) )
            _gives_text = True
            if self.trade_complete:
                if self.res_gives_name in ['boat', 'teleport']:
                    _gives_text = False
                if self.res_gives_name.startswith('inventory:'):
                    _gives_text = False
            if _gives_text:
                result.append('newline')
                result.append( ('text', 'COLOR_LINES') )
                result.append( ('text', 'TRADER_INFO') )
                result.append( 'space' )
                result.extend( self._get_res_gives() )

            _is_active = self.is_active()
            if not _is_active:
                #result.append('newline')
                #result.append( ('text', ('NOTHING_TO_TALK','NOTHING_TO_TALK_W')[self.is_woman == True]) )
                return result

            res_need = self._get_res_need()
            res_need_ne = self._get_res_need(True)
            # дальше хитрое шаманство недостающих параметров и ресурсов:
            result_params = []
            self.get_params_not_enough_text(result_params, [('text', 'COLOR_LINES')])
            parts = []
            parts.append(res_need)
            parts.append(result_params)
            needs_combined = self._combine_not_enough_texts(parts)
            if needs_combined:
                result.append('newline')
                result.append( ('text', 'COLOR_LINES') )
                result.append( ('text', 'NEED_FOR_ACTION') )
                result.extend(needs_combined)

            result_params = []
            self.get_params_not_enough_text(result_params,\
                                            [('text', 'COLOR_RED')], True )
            parts = []
            parts.append(res_need_ne)
            parts.append(result_params)
            not_enough_combined = self._combine_not_enough_texts(parts)
            if not_enough_combined:
                result.extend( ['newline', ('text', 'COLOR_RED'), ('text', 'NOT_ENOUGH')] )
                result.extend(not_enough_combined)
            if self._append_sick_general(result):
                return result
        else:   # by click:
            _has_access = self.has_access()
            _is_active = self.is_active()
            if not _is_active:
                result.append( ('text', 'COLOR_LINES') )
                result.append( ('text', ('NOTHING_TO_TALK','NOTHING_TO_TALK_W')[self.is_woman == True]) )
                return result
            #_skip_extra_tips = False
            #if _is_active:
            #    if self.task:
            #        _skip_extra_tips = True
            if True:
                result = []
                if not _has_access:
                    result.append( ('text', 'COLOR_RED') )
                    result.append( ('text', 'NO_PATH') )
                    return result
            if self._append_sick_general(result, True):
                return result
            res_need_ne = self._get_res_need(True)
            result_params = []
            self.get_params_not_enough_text(result_params,\
                                            [('text', 'COLOR_RED')], True )
            parts = []
            parts.append(res_need_ne)
            parts.append( result_params )
            combined = self._combine_not_enough_texts(parts)
            result = []
            if not combined:
                return self.Get_tip_text(False)
            else:
                #result.append('newline')
                result.extend( [('text', 'COLOR_RED'), ('text', 'NOT_ENOUGH')] )
                result.extend( combined )
        return result
# ============================================================
    def _get_res_not_enough_text(self, result, show_red = False):
        res = self.res_action_cost
        _is_res_enough = UStats.IsResEnough(res)
        if not _is_res_enough:
            diff_res = UStats.GetNotEnoughRes(res)
            if diff_res:
                if show_red:     result.append( ('text', 'COLOR_RED') )
                result.append( ('text', 'NOT_ENOUGH') )
                result.append( 'space' )
                res_numbers = self._append_res_values(diff_res)
                result.extend( res_numbers )
                return True
        return False
# ============================================================
    #@override
    def get_ui_subtext(self):
        '''Текст, который должен быть написан в типсе возле панели с
        лицом персонажа второй строкой'''
        if not self.non_selectable and not self.is_deactivated and self.is_shown:
            _is_active = self.is_active()
            if _is_active:
                return (self._tips_FACES_READY_TO_SPEAK_array[self.is_woman == True], True)
        return self._tips_EMPTY_True
# ============================================================
    def _combine_not_enough_texts(self, parts):
        _len = 0
        filtered_parts = []
        for part in parts:
            if part:    # учитываем только не пустые записи
                _len += 1
                filtered_parts.append(part)
        result = []
        if _len == 1:
            result.append('space')  # пробел-разделитель после двоеточия
            result.extend( filtered_parts[0] )
        else:
            for part in filtered_parts:
                result.append('newline')  # перевод строки-разделитель после двоеточия и после предыдущего пункта
                result.extend( part )
        return result
# ============================================================
    def _get_res_need(self, get_not_enough = False):
        result = []
        if not get_not_enough:
            result.append( ('digit', self.res_need_count) )
            result.append( ('image', self.res_images[self.res_need_name]) )
        else:
            _enough_res = UStats.GetResCount(self.res_need_name) >= self.res_need_count
            if not _enough_res:
                _has_res = UStats.GetResCount(self.res_need_name)
                if _has_res < self.res_need_count:
                    result.append( ('digit', self.res_need_count - _has_res) )
                    result.append( ('image', self.res_images[self.res_need_name]) )
        return result
# ============================================================
    def _get_res_gives(self):
        result = []
        if self.trade_complete:
            return result
        _gives_not_res = False
        if self.res_gives_name in ['boat', 'teleport']:
            _gives_not_res = True
        if self.res_gives_name.startswith('inventory:'):
            _gives_not_res = True

        if not _gives_not_res:
            result.append( ('digit', self.res_gives_count) )
            result.append( ('image', self.res_images[self.res_gives_name]) )
        else:
            if self.res_gives_name == 'boat':
                result.append( ('text', 'GIVES_BOAT') )
            elif self.res_gives_name == 'teleport':
                result.append( ('text', 'GIVES_TELEPORT') )
            else:   # inventory
                _template = self.res_gives_name[len('inventory:'):]
                _name = BMgr.GetTemplateAttr(_template, 'item_name')
                result.append( ('text', _name) )
        return result
# ============================================================
# ============================================================
